
if init == 1;
   i = 1;
   init = 0;
end

time_vect(i) = time;

eta_sim_vect(i,:) = eta;
nu_sim_vect(i,:) = nu;
nu_d_sim_vect(i,:) = nu_d;

tau_vect(i,:) = [tau(1) tau(2) tau(6)];
tau_c_vect(i,:) = tau_c;

eta_e_vect_AFF(i,:) = eta_e_AFF;
nu_e_vect_AFF(i,:) = nu_e_AFF;
d_e_vect_AFF(i,:) = d_e_AFF;

eta_e_vect_NL(i,:) = eta_e_NL;
nu_e_vect_NL(i,:) = nu_e_NL;
d_e_vect_NL(i,:) = d_e_NL;

eta_e_vect_HB(i,:) = eta_e_HB;
nu_e_vect_HB(i,:) = nu_e_HB;
d_e_vect_HB(i,:) = d_e_HB;

eta_m_vect(i,:) = y_m(1:3);
frc_m_vect(i,:) = y_m(4:6);

theta_v_hat_m_vect(i,:) = theta_v_hat(1:3);
theta_v_hat_d_vect(i,:) = theta_v_hat(4:6);
theta_e_hat_m_vect(i,:) = theta_e_hat(1:3);
theta_e_hat_d_vect(i,:) = theta_e_hat(4:6);

%% Calc d

d_vect(i,:) = diag([2535 2535 8485])*nu_d' - tau_vect(i,:)';

%%

if i <=30
    start_window = 1;
else
    start_window=i-30;
end
    end_window = i;
  
% update counter
i = i + 1;
    
%% Plotting

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   eta_e
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

f = figure(1);
%set(f,'Position',[265 565 1400 480]);
set(f,'Position',[210 510 1600 600]);
subplot(3,8,1)
plot(time_vect(start_window:end_window),eta_sim_vect(start_window:end_window,1),'r')
hold on;
plot(time,eta(1),'*r');
plot(time_vect(start_window:end_window),eta_e_vect_AFF(start_window:end_window,1),'color',[0 0 0.2])
plot(time_vect(start_window:end_window),eta_m_vect(start_window:end_window,1),'g');
plot(time_vect(end),eta_m_vect(end,1),'g-o');
plot(time,eta_e_AFF(1),'x');

% plot(time_vect(start_window:end_window),eta_e_vect_NL(start_window:end_window,1),'color',[0 0 1])
% plot(time,eta_e_NL(1),'x');
% plot(time_vect(start_window:end_window),eta_e_vect_HB(start_window:end_window,1),'color',[0 1 0])
% plot(time,eta_e_HB(1),'xg');
hold off;
xlim([time_vect(start_window) time+2])

if max([max(eta_e_vect_AFF(start_window:end_window,1)) max(eta_e_vect_NL(start_window:end_window,1)) max(eta_e_vect_HB(start_window:end_window,1))]) > 0.08
    eta_e1_max = 1.25*max([max(eta_e_vect_AFF(start_window:end_window,1)) max(eta_e_vect_NL(start_window:end_window,1)) max(eta_e_vect_HB(start_window:end_window,1))]);
else
    eta_e1_max = 0.1;
end

if min([min(eta_e_vect_AFF(start_window:end_window,1)) min(eta_e_vect_NL(start_window:end_window,1)) min(eta_e_vect_HB(start_window:end_window,1))]) < -0.08
    eta_e1_min = 1.25*min([min(eta_e_vect_AFF(start_window:end_window,1)) min(eta_e_vect_NL(start_window:end_window,1)) min(eta_e_vect_HB(start_window:end_window,1))]);
else
    eta_e1_min = -0.1;
end
ylim([eta_e1_min eta_e1_max]);
ylabel('N [m]');
title('Position and heading')

subplot(3,8,9)
plot(time_vect(start_window:end_window),eta_sim_vect(start_window:end_window,2),'r')
hold on;
plot(time,eta(2),'*r');
plot(time_vect(start_window:end_window),eta_e_vect_AFF(start_window:end_window,2),'color',[0 0 0.2])
plot(time_vect(start_window:end_window),eta_m_vect(start_window:end_window,2),'g');
plot(time_vect(end),eta_m_vect(end,2),'g-o');
plot(time,eta_e_AFF(2),'x');
% plot(time_vect(start_window:end_window),eta_e_vect_NL(start_window:end_window,2),'color',[0 0 1])
% plot(time,eta_e_NL(2),'x');
% plot(time_vect(start_window:end_window),eta_e_vect_HB(start_window:end_window,2),'color',[0 1 0])
% plot(time,eta_e_HB(2),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(eta_e_vect_AFF(start_window:end_window,2)) max(eta_e_vect_NL(start_window:end_window,2)) max(eta_e_vect_HB(start_window:end_window,2))]) > 0.08
    eta_e2_max = 1.25*max([max(eta_e_vect_AFF(start_window:end_window,2)) max(eta_e_vect_NL(start_window:end_window,2)) max(eta_e_vect_HB(start_window:end_window,2))]);
else
    eta_e2_max = 0.1;
end

if min([min(eta_e_vect_AFF(start_window:end_window,2)) min(eta_e_vect_NL(start_window:end_window,2)) min(eta_e_vect_HB(start_window:end_window,2))]) < -0.08
    eta_e2_min = 1.25*min([min(eta_e_vect_AFF(start_window:end_window,2)) min(eta_e_vect_NL(start_window:end_window,2)) min(eta_e_vect_HB(start_window:end_window,2))]);
else
    eta_e2_min = -0.1;
end
ylim([eta_e2_min eta_e2_max]);
ylabel('E [m]');

subplot(3,8,17)
plot(time_vect(start_window:end_window),(180/pi)*eta_sim_vect(start_window:end_window,3),'r')
hold on;
plot(time,(180/pi)*eta(3),'*r');
plot(time_vect(start_window:end_window),(180/pi)*eta_e_vect_AFF(start_window:end_window,3),'color',[0 0 0.2])
plot(time_vect(start_window:end_window),eta_m_vect(start_window:end_window,3),'g');
plot(time_vect(end),eta_m_vect(end,3),'g-o');
plot(time,(180/pi)*eta_e_AFF(3),'x');
% plot(time_vect(start_window:end_window),(180/pi)*eta_e_vect_NL(start_window:end_window,3),'color',[0 0 1])
% plot(time,(180/pi)*eta_e_NL(3),'x');
% plot(time_vect(start_window:end_window),(180/pi)*eta_e_vect_HB(start_window:end_window,3),'color',[0 1 0])
% plot(time,(180/pi)*eta_e_HB(3),'xg');
hold off;
xlim([time_vect(start_window) time+2])

if (180/pi)*max([max(eta_e_vect_AFF(start_window:end_window,3)) max(eta_e_vect_NL(start_window:end_window,3)) max(eta_e_vect_HB(start_window:end_window,3))]) > 0.8
    eta_e3_max = 1.25*(180/pi)*max([max(eta_e_vect_AFF(start_window:end_window,3)) max(eta_e_vect_NL(start_window:end_window,3)) max(eta_e_vect_HB(start_window:end_window,3))]);
else
    eta_e3_max = 1;
end

if (180/pi)*min([min(eta_e_vect_AFF(start_window:end_window,3)) min(eta_e_vect_NL(start_window:end_window,3)) min(eta_e_vect_HB(start_window:end_window,3))]) < -0.8;
    eta_e3_min = 1.25*(180/pi)*min([min(eta_e_vect_AFF(start_window:end_window,3)) min(eta_e_vect_NL(start_window:end_window,3)) min(eta_e_vect_HB(start_window:end_window,3))]);
else
    eta_e3_min = -1;
end
ylim([eta_e3_min eta_e3_max]);
ylabel('Psi [deg]');
xlabel('Time [s]');
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   Nu
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(3,8,2)
plot(time_vect(start_window:end_window),nu_sim_vect(start_window:end_window,1),'r')
hold on;
plot(time,nu(1),'*r');
plot(time_vect(start_window:end_window),nu_e_vect_AFF(start_window:end_window,1),'color',[0 0 0.2])
plot(time,nu_e_AFF(1),'x');
% plot(time_vect(start_window:end_window),nu_e_vect_NL(start_window:end_window,1),'color',[0 0 1])
% plot(time,nu_e_NL(1),'x');
% plot(time_vect(start_window:end_window),nu_e_vect_HB(start_window:end_window,1),'color',[0 1 0])
% plot(time,nu_e_HB(1),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(nu_e_vect_AFF(start_window:end_window,1)) max(nu_e_vect_NL(start_window:end_window,1)) max(nu_e_vect_HB(start_window:end_window,1))]) > 0.016
    nu_e1_max = 1.25*max([max(nu_e_vect_AFF(start_window:end_window,1)) max(nu_e_vect_NL(start_window:end_window,1)) max(nu_e_vect_HB(start_window:end_window,1))]);
else
    nu_e1_max = 0.02;
end

if min([min(nu_e_vect_AFF(start_window:end_window,1)) min(nu_e_vect_NL(start_window:end_window,1)) min(nu_e_vect_HB(start_window:end_window,1))]) < -0.016
    nu_e1_min = 1.25*min([min(nu_e_vect_AFF(start_window:end_window,1)) min(nu_e_vect_NL(start_window:end_window,1)) min(nu_e_vect_HB(start_window:end_window,1))]);
else
    nu_e1_min = -0.02;
end
ylim([nu_e1_min nu_e1_max]);
ylabel('u [m/s]');
title('Velocity and yaw-rate')

subplot(3,8,10)
plot(time_vect(start_window:end_window),nu_sim_vect(start_window:end_window,2),'r')
hold on;
plot(time,nu(2),'*r');
plot(time_vect(start_window:end_window),nu_e_vect_AFF(start_window:end_window,2),'color',[0 0 0.2])
plot(time,nu_e_AFF(2),'x');
% plot(time_vect(start_window:end_window),nu_e_vect_NL(start_window:end_window,2),'color',[0 0 1])
% plot(time,nu_e_NL(2),'x');
% plot(time_vect(start_window:end_window),nu_e_vect_HB(start_window:end_window,2),'color',[0 1 0])
% plot(time,nu_e_HB(2),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(nu_e_vect_AFF(start_window:end_window,2)) max(nu_e_vect_NL(start_window:end_window,2)) max(nu_e_vect_HB(start_window:end_window,2))]) > 0.016
    nu_e2_max = 1.25*max([max(nu_e_vect_AFF(start_window:end_window,2)) max(nu_e_vect_NL(start_window:end_window,2)) max(nu_e_vect_HB(start_window:end_window,2))]);
else
    nu_e2_max = 0.02;
end

if min([min(nu_e_vect_AFF(start_window:end_window,2)) min(nu_e_vect_NL(start_window:end_window,2)) min(nu_e_vect_HB(start_window:end_window,2))]) < -0.016
    nu_e2_min = 1.25*min([min(nu_e_vect_AFF(start_window:end_window,2)) min(nu_e_vect_NL(start_window:end_window,2)) min(nu_e_vect_HB(start_window:end_window,2))]);
else
    nu_e2_min = -0.02;
end
ylim([nu_e2_min nu_e2_max]);
ylabel('v [m/s]');

subplot(3,8,18)
plot(time_vect(start_window:end_window),nu_sim_vect(start_window:end_window,3),'r')
hold on;
plot(time,nu(3),'*r');
plot(time_vect(start_window:end_window),nu_e_vect_AFF(start_window:end_window,3),'color',[0 0 0.2])
plot(time,nu_e_AFF(3),'x');
% plot(time_vect(start_window:end_window),nu_e_vect_NL(start_window:end_window,3),'color',[0 0 1])
% plot(time,nu_e_NL(3),'x');
% plot(time_vect(start_window:end_window),nu_e_vect_HB(start_window:end_window,3),'color',[0 1 0])
% plot(time,nu_e_HB(3),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(nu_e_vect_AFF(start_window:end_window,3)) max(nu_e_vect_NL(start_window:end_window,3)) max(nu_e_vect_HB(start_window:end_window,3))]) > 0.016
    nu_e3_max = 1.25*max([max(nu_e_vect_AFF(start_window:end_window,3)) max(nu_e_vect_NL(start_window:end_window,3)) max(nu_e_vect_HB(start_window:end_window,3))]);
else
    nu_e3_max = 0.02;
end

if min([min(nu_e_vect_AFF(start_window:end_window,3)) min(nu_e_vect_NL(start_window:end_window,3)) min(nu_e_vect_HB(start_window:end_window,3))]) < -0.016
    nu_e3_min = 1.25*min([min(nu_e_vect_AFF(start_window:end_window,3)) min(nu_e_vect_NL(start_window:end_window,3)) min(nu_e_vect_HB(start_window:end_window,3))]);
else
    nu_e3_min = -0.02;
end
ylim([nu_e3_min nu_e3_max]);
ylabel('r [m/s]');
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   D_e
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
subplot(3,8,3)
plot(time_vect(start_window:end_window),d_vect(start_window:end_window,1),'r')
hold on;
plot(time,d_vect(end,1),'*r');
plot(time_vect(start_window:end_window),d_e_vect_AFF(start_window:end_window,1),'color',[0 0 0.2])
plot(time,d_e_AFF(1),'x');
% plot(time_vect(start_window:end_window),d_e_vect_NL(start_window:end_window,1),'color',[0 0 1])
% plot(time,d_e_NL(1),'x');
% plot(time_vect(start_window:end_window),d_e_vect_HB(start_window:end_window,1),'color',[0 1 0])
% plot(time,d_e_HB(1),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(d_e_vect_AFF(start_window:end_window,1)) max(d_e_vect_NL(start_window:end_window,1)) max(d_e_vect_HB(start_window:end_window,1))]) > 4
    d_e1_max = 1.25*max([max(d_e_vect_AFF(start_window:end_window,1)) max(d_e_vect_NL(start_window:end_window,1)) max(d_e_vect_HB(start_window:end_window,1))]);
else
    d_e1_max = 5;
end

if min([min(d_e_vect_AFF(start_window:end_window,1)) min(d_e_vect_NL(start_window:end_window,1)) min(d_e_vect_HB(start_window:end_window,1))]) < -4
    d_e1_min = 1.25*min([min(d_e_vect_AFF(start_window:end_window,1)) min(d_e_vect_NL(start_window:end_window,1)) min(d_e_vect_HB(start_window:end_window,1))]);
else
    d_e1_min = -5;
end
ylim([d_e1_min d_e1_max]);
ylabel('Fx [N]');
title('External load')

subplot(3,8,11)
plot(time_vect(start_window:end_window),d_vect(start_window:end_window,2),'r')
hold on;
plot(time,d_vect(end,2),'*r');
plot(time_vect(start_window:end_window),d_e_vect_AFF(start_window:end_window,2),'color',[0 0 0.2])
plot(time,d_e_AFF(2),'x');
% plot(time_vect(start_window:end_window),d_e_vect_NL(start_window:end_window,2),'color',[0 0 1])
% plot(time,d_e_NL(2),'x');
% plot(time_vect(start_window:end_window),d_e_vect_HB(start_window:end_window,2),'color',[0 1 0])
% plot(time,d_e_HB(2),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(d_e_vect_AFF(start_window:end_window,2)) max(d_e_vect_NL(start_window:end_window,2)) max(d_e_vect_HB(start_window:end_window,2))]) > 4
    d_e2_max = 1.25*max([max(d_e_vect_AFF(start_window:end_window,2)) max(d_e_vect_NL(start_window:end_window,2)) max(d_e_vect_HB(start_window:end_window,2))]);
else
    d_e2_max = 5;
end

if min([min(d_e_vect_AFF(start_window:end_window,2)) min(d_e_vect_NL(start_window:end_window,2)) min(d_e_vect_HB(start_window:end_window,2))]) < -4
    d_e2_min = 1.25*min([min(d_e_vect_AFF(start_window:end_window,2)) min(d_e_vect_NL(start_window:end_window,2)) min(d_e_vect_HB(start_window:end_window,2))]);
else
    d_e2_min = -5;
end
ylim([d_e2_min d_e2_max]);
ylabel('Fy [N]');

subplot(3,8,19)
plot(time_vect(start_window:end_window),d_vect(start_window:end_window,3),'r')
hold on;
plot(time,d_vect(end,3),'*r');
plot(time_vect(start_window:end_window),d_e_vect_AFF(start_window:end_window,3),'color',[0 0 0.2])
plot(time,d_e_AFF(3),'x');
% plot(time_vect(start_window:end_window),d_e_vect_NL(start_window:end_window,3),'color',[0 0 1])
% plot(time,d_e_NL(3),'x');
% plot(time_vect(start_window:end_window),d_e_vect_HB(start_window:end_window,3),'color',[0 1 0])
% plot(time,d_e_HB(3),'xg');
hold off;
xlim([time_vect(start_window) time+2])
if max([max(d_e_vect_AFF(start_window:end_window,3)) max(d_e_vect_NL(start_window:end_window,3)) max(d_e_vect_HB(start_window:end_window,3))]) > 4
    d_e3_max = 1.25*max([max(d_e_vect_AFF(start_window:end_window,3)) max(d_e_vect_NL(start_window:end_window,3)) max(d_e_vect_HB(start_window:end_window,3))]);
else
    d_e3_max = 5;
end

if min([min(d_e_vect_AFF(start_window:end_window,3)) min(d_e_vect_NL(start_window:end_window,3)) min(d_e_vect_HB(start_window:end_window,3))]) < -4
    d_e3_min = 1.25*min([min(d_e_vect_AFF(start_window:end_window,3)) min(d_e_vect_NL(start_window:end_window,3)) min(d_e_vect_HB(start_window:end_window,3))]);
else
    d_e3_min = -5;
end
ylim([d_e3_min d_e3_max]);
ylabel('Nz [Nm]');
xlabel('Time [s]');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   TAU
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
subplot(3,8,4)
plot(time_vect(start_window:end_window),tau_c_vect(start_window:end_window,1),'r')
hold on;
plot(time,tau_c(1),'*r');
plot(time_vect(start_window:end_window),tau_vect(start_window:end_window,1),'color',[0 0 0.2])
plot(time,tau(1),'x');
plot(time_vect(start_window:end_window),frc_m_vect(start_window:end_window,1),'g');
plot(time_vect(end),frc_m_vect(end,1),'g-o')
hold off;
xlim([time_vect(start_window) time+2])
if 1.25*max(tau_vect(start_window:end_window,1)) > 40
    tau1_max = 1.25*max(tau_vect(start_window:end_window,1));
else
    tau1_max = 50;
end

if 1.25*min(tau_vect(start_window:end_window,1)) < -40
    tau1_min = 1.25*min(tau_vect(start_window:end_window,1));
else
    tau1_min = -50;
end
ylim([tau1_min tau1_max]);
ylabel('Fx [N]');
title('Actuation');

subplot(3,8,12)
plot(time_vect(start_window:end_window),tau_c_vect(start_window:end_window,2),'r');
hold on;
plot(time,tau_c(2),'*r');
plot(time_vect(start_window:end_window),tau_vect(start_window:end_window,2),'color',[0 0 0.2])
plot(time,tau(2),'x');
plot(time_vect(start_window:end_window),frc_m_vect(start_window:end_window,2),'g');
plot(time_vect(end),frc_m_vect(end,2),'g-o')
hold off;
xlim([time_vect(start_window) time+2])
if 1.25*max(tau_vect(start_window:end_window,2)) > 40
    tau2_max = 1.25*max(tau_vect(start_window:end_window,2));
else
    tau2_max = 50;
end

if 1.25*min(tau_vect(start_window:end_window,2)) < -40
    tau2_min = 1.25*min(tau_vect(start_window:end_window,2));
else
    tau2_min = -50;
end
ylim([tau2_min tau2_max]);
ylabel('Fy [N]');

subplot(3,8,20)
plot(time_vect(start_window:end_window),tau_c_vect(start_window:end_window,3),'r')
hold on;
plot(time,tau_c(3),'*r');
plot(time_vect(start_window:end_window),tau_vect(start_window:end_window,3),'color',[0 0 0.2])
plot(time,tau(6),'x');
plot(time_vect(start_window:end_window),frc_m_vect(start_window:end_window,3),'g');
plot(time_vect(end),frc_m_vect(end,3),'g-o')
hold off;
xlim([time_vect(start_window) time+2])
if 1.25*max(tau_vect(start_window:end_window,3)) > 40
    tau3_max = 1.25*max(tau_vect(start_window:end_window,3));
else
    tau3_max = 50;
end

if 1.25*min(tau_vect(start_window:end_window,3)) < -40
    tau3_min = 1.25*min(tau_vect(start_window:end_window,3));
else
    tau3_min = -50;
end
ylim([tau3_min tau3_max]);
ylabel('Nz [Nm]');
xlabel('Time [s]');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   THETA_V_M_HAT
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(3,8,5)
plot(time_vect(1:end_window),theta_v_hat_m_vect(1:end_window,1),'r')
hold on;
plot(time,theta_v_hat_m_vect(end,1),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_v_hat_m_vect(1:end_window,1)) > 40
    theta_v1_max = 1.25*max(theta_v_hat_m_vect(1:end_window,1));
else
    theta_v1_max = 50;
end

if 1.25*min(theta_v_hat_m_vect(1:end_window,1)) < -40
    theta_v1_min = 1.25*min(theta_v_hat_m_vect(1:end_window,1));
else
    theta_v1_min = -50;
end
ylim([theta_v1_min theta_v1_max]);
title('M estimates');

subplot(3,8,13)
plot(time_vect(1:end_window),theta_v_hat_m_vect(1:end_window,2),'r');
hold on;
plot(time,theta_v_hat_m_vect(end,2),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_v_hat_m_vect(1:end_window,2)) > 40
    theta_v2_max = 1.25*max(theta_v_hat_m_vect(1:end_window,2));
else
    theta_v2_max = 50;
end

if 1.25*min(theta_v_hat_m_vect(1:end_window,2)) < -40
    theta_v2_min = 1.25*min(theta_v_hat_m_vect(1:end_window,2));
else
    theta_v2_min = -50;
end
ylim([theta_v2_min theta_v2_max]);

subplot(3,8,21)
plot(time_vect(1:end_window),theta_v_hat_m_vect(1:end_window,3),'r');
hold on;
plot(time,theta_v_hat_m_vect(end,3),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_v_hat_m_vect(1:end_window,3)) > 40
    theta_v3_max = 1.25*max(theta_v_hat_m_vect(1:end_window,3));
else
    theta_v3_max = 50;
end

if 1.25*min(theta_v_hat_m_vect(1:end_window,2)) < -40
    theta_v3_min = 1.25*min(theta_v_hat_m_vect(1:end_window,3));
else
    theta_v3_min = -50;
end
ylim([theta_v3_min theta_v3_max]);
xlabel('Time [s]');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   THETA_V_D_HAT
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(3,8,6)
plot(time_vect(1:end_window),theta_v_hat_d_vect(1:end_window,1),'r')
hold on;
plot(time,theta_v_hat_d_vect(end,1),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_v_hat_d_vect(1:end_window,1)) > 40
    theta_v1_max = 1.25*max(theta_v_hat_d_vect(1:end_window,1));
else
    theta_v1_max = 50;
end

if 1.25*min(theta_v_hat_d_vect(1:end_window,1)) < -40
    theta_v1_min = 1.25*min(theta_v_hat_d_vect(1:end_window,1));
else
    theta_v1_min = -50;
end
ylim([theta_v1_min theta_v1_max]);
title('D estimates');

subplot(3,8,14)
plot(time_vect(1:end_window),theta_v_hat_d_vect(1:end_window,2),'r');
hold on;
plot(time,theta_v_hat_d_vect(end,2),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_v_hat_d_vect(1:end_window,2)) > 40
    theta_v2_max = 1.25*max(theta_v_hat_d_vect(1:end_window,2));
else
    theta_v2_max = 50;
end

if 1.25*min(theta_v_hat_d_vect(1:end_window,2)) < -40
    theta_v2_min = 1.25*min(theta_v_hat_d_vect(1:end_window,2));
else
    theta_v2_min = -50;
end
ylim([theta_v2_min theta_v2_max]);

subplot(3,8,22)
plot(time_vect(1:end_window),theta_v_hat_d_vect(1:end_window,3),'r');
hold on;
plot(time,theta_v_hat_d_vect(end,3),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_v_hat_d_vect(1:end_window,3)) > 40
    theta_v3_max = 1.25*max(theta_v_hat_d_vect(1:end_window,3));
else
    theta_v3_max = 50;
end

if 1.25*min(theta_v_hat_d_vect(1:end_window,2)) < -40
    theta_v3_min = 1.25*min(theta_v_hat_d_vect(1:end_window,3));
else
    theta_v3_min = -50;
end
ylim([theta_v3_min theta_v3_max]);
xlabel('Time [s]');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   THETA_E_M_HAT
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(3,8,7)
plot(time_vect(1:end_window),theta_e_hat_m_vect(1:end_window,1),'r')
hold on;
plot(time,theta_e_hat_m_vect(end,1),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_e_hat_m_vect(1:end_window,1)) > 40
    theta_e1_max = 1.25*max(theta_e_hat_m_vect(1:end_window,1));
else
    theta_e1_max = 50;
end

if 1.25*min(theta_e_hat_m_vect(1:end_window,1)) < -40
    theta_e1_min = 1.25*min(theta_e_hat_m_vect(1:end_window,1));
else
    theta_e1_min = -50;
end
ylim([theta_e1_min theta_e1_max]);
title('M_e estimates');

subplot(3,8,15)
plot(time_vect(1:end_window),theta_e_hat_m_vect(1:end_window,2),'r');
hold on;
plot(time,theta_e_hat_m_vect(end,2),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_e_hat_m_vect(1:end_window,2)) > 40
    theta_e2_max = 1.25*max(theta_e_hat_m_vect(1:end_window,2));
else
    theta_e2_max = 50;
end

if 1.25*min(theta_e_hat_m_vect(1:end_window,2)) < -40
    theta_e2_min = 1.25*min(theta_e_hat_m_vect(1:end_window,2));
else
    theta_e2_min = -50;
end
ylim([theta_e2_min theta_e2_max]);

subplot(3,8,23)
plot(time_vect(1:end_window),theta_e_hat_m_vect(1:end_window,3),'r');
hold on;
plot(time,theta_e_hat_m_vect(end,3),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_e_hat_m_vect(1:end_window,3)) > 40
    theta_e3_max = 1.25*max(theta_e_hat_m_vect(1:end_window,3));
else
    theta_e3_max = 50;
end

if 1.25*min(theta_e_hat_m_vect(1:end_window,2)) < -40
    theta_e3_min = 1.25*min(theta_e_hat_m_vect(1:end_window,3));
else
    theta_e3_min = -50;
end
ylim([theta_e3_min theta_e3_max]);
xlabel('Time [s]');

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %
% %   THETA_E_D_HAT
% %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(3,8,8)
plot(time_vect(1:end_window),theta_e_hat_d_vect(1:end_window,1),'r')
hold on;
plot(time,theta_e_hat_d_vect(end,1),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_e_hat_d_vect(1:end_window,1)) > 40
    theta_e1_max = 1.25*max(theta_e_hat_d_vect(1:end_window,1));
else
    theta_e1_max = 50;
end

if 1.25*min(theta_e_hat_d_vect(1:end_window,1)) < -40
    theta_e1_min = 1.25*min(theta_e_hat_d_vect(1:end_window,1));
else
    theta_e1_min = -50;
end
ylim([theta_e1_min theta_e1_max]);
title('D_e estimates');

subplot(3,8,16)
plot(time_vect(1:end_window),theta_e_hat_d_vect(1:end_window,2),'r');
hold on;
plot(time,theta_e_hat_d_vect(end,2),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_e_hat_d_vect(1:end_window,2)) > 40
    theta_e2_max = 1.25*max(theta_e_hat_d_vect(1:end_window,2));
else
    theta_e2_max = 50;
end

if 1.25*min(theta_e_hat_d_vect(1:end_window,2)) < -40
    theta_e2_min = 1.25*min(theta_e_hat_d_vect(1:end_window,2));
else
    theta_e2_min = -50;
end
ylim([theta_e2_min theta_e2_max]);

subplot(3,8,24)
plot(time_vect(1:end_window),theta_e_hat_d_vect(1:end_window,3),'r');
hold on;
plot(time,theta_e_hat_d_vect(end,3),'*r');
hold off;
%xlim([time_vect(start_window) time+2])
if 1.25*max(theta_e_hat_d_vect(1:end_window,3)) > 40
    theta_e3_max = 1.25*max(theta_e_hat_d_vect(1:end_window,3));
else
    theta_e3_max = 50;
end

if 1.25*min(theta_e_hat_d_vect(1:end_window,2)) < -40
    theta_e3_min = 1.25*min(theta_e_hat_d_vect(1:end_window,3));
else
    theta_e3_min = -50;
end
ylim([theta_e3_min theta_e3_max]);
xlabel('Time [s]');


%% Drawnow

drawnow;
