#ifndef __c2_dp_mod_1_h__
#define __c2_dp_mod_1_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c2_ResolvedFunctionInfo
#define typedef_c2_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c2_ResolvedFunctionInfo;

#endif                                 /*typedef_c2_ResolvedFunctionInfo*/

#ifndef typedef_SFc2_dp_mod_1InstanceStruct
#define typedef_SFc2_dp_mod_1InstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c2_sfEvent;
  boolean_T c2_isStable;
  boolean_T c2_doneDoubleBufferReInit;
  uint8_T c2_is_active_c2_dp_mod_1;
  real_T c2_first;
  boolean_T c2_first_not_empty;
  real_T c2_delta_0;
  boolean_T c2_delta_0_not_empty;
  boolean_T c2_dz0_not_empty;
  real_T c2_dphi01[6];
  boolean_T c2_dphi01_not_empty;
  real_T c2_dphi02[6];
  boolean_T c2_dphi02_not_empty;
  real_T c2_dphi03[6];
  boolean_T c2_dphi03_not_empty;
  real_T c2_dphi04[6];
  boolean_T c2_dphi04_not_empty;
  real_T c2_dphi05[6];
  boolean_T c2_dphi05_not_empty;
  real_T c2_z;
  boolean_T c2_z_not_empty;
  real_T c2_phi1[3];
  boolean_T c2_phi1_not_empty;
  real_T c2_phi2[3];
  boolean_T c2_phi2_not_empty;
  real_T c2_phi3[3];
  boolean_T c2_phi3_not_empty;
  real_T c2_phi4[3];
  boolean_T c2_phi4_not_empty;
  real_T c2_phi5[3];
  boolean_T c2_phi5_not_empty;
  real_T c2_phi_1[6];
  boolean_T c2_phi_1_not_empty;
  real_T c2_phi_2[6];
  boolean_T c2_phi_2_not_empty;
  real_T c2_dM[9];
  boolean_T c2_dM_not_empty;
  real_T c2_dD[9];
  boolean_T c2_dD_not_empty;
} SFc2_dp_mod_1InstanceStruct;

#endif                                 /*typedef_SFc2_dp_mod_1InstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c2_dp_mod_1_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c2_dp_mod_1_get_check_sum(mxArray *plhs[]);
extern void c2_dp_mod_1_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
