#ifndef __c4_dp_mod_1_h__
#define __c4_dp_mod_1_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c4_ResolvedFunctionInfo
#define typedef_c4_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c4_ResolvedFunctionInfo;

#endif                                 /*typedef_c4_ResolvedFunctionInfo*/

#ifndef typedef_SFc4_dp_mod_1InstanceStruct
#define typedef_SFc4_dp_mod_1InstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c4_sfEvent;
  boolean_T c4_isStable;
  boolean_T c4_doneDoubleBufferReInit;
  uint8_T c4_is_active_c4_dp_mod_1;
  real_T c4_first;
  boolean_T c4_first_not_empty;
  real_T c4_Z_p_hat[3];
  boolean_T c4_Z_p_hat_not_empty;
  real_T c4_Z_p_bar_hat[3];
  boolean_T c4_Z_p_bar_hat_not_empty;
  real_T c4_R_p_hat[9];
  boolean_T c4_R_p_hat_not_empty;
  real_T c4_Lambda_0[2];
  boolean_T c4_Lambda_0_not_empty;
  real_T c4_Q[6];
  boolean_T c4_Q_not_empty;
} SFc4_dp_mod_1InstanceStruct;

#endif                                 /*typedef_SFc4_dp_mod_1InstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c4_dp_mod_1_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c4_dp_mod_1_get_check_sum(mxArray *plhs[]);
extern void c4_dp_mod_1_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif
