/* Include files */

#include "blascompat32.h"
#include "dp_mod_1_sfun.h"
#include "c6_dp_mod_1.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "dp_mod_1_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c6_debug_family_names[32] = { "zeta", "omega_0", "alpha",
  "M_d", "D", "D_d", "K_d", "K", "K_p", "C_m", "A_m", "B_m", "xm", "Fm",
  "nargin", "nargout", "y0", "F0", "r", "D_e", "M_e", "F_C", "xm_dot", "Fm_dot",
  "ym", "Z_m", "R_m", "k_m_r", "k_m_fc", "M", "first", "flag" };

/* Function Declarations */
static void initialize_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void initialize_params_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct
  *chartInstance);
static void enable_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void disable_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void c6_update_debugger_state_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct
  *chartInstance);
static void set_sim_state_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_st);
static void finalize_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void sf_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void c6_chartstep_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void initSimStructsc6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c6_machineNumber, uint32_T
  c6_chartNumber);
static const mxArray *c6_sf_marshallOut(void *chartInstanceVoid, void *c6_inData);
static void c6_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_b_flag, const char_T *c6_identifier, real_T c6_y[3]);
static void c6_b_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[3]);
static void c6_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_b_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static real_T c6_c_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_b_first, const char_T *c6_identifier);
static real_T c6_d_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void c6_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_c_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static const mxArray *c6_d_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static void c6_e_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_k_m_fc, const char_T *c6_identifier, real_T c6_y[3]);
static void c6_f_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[3]);
static void c6_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static void c6_g_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_R_m, const char_T *c6_identifier, real_T c6_y[9]);
static void c6_h_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[9]);
static void c6_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_e_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static void c6_i_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_Fm_dot, const char_T *c6_identifier, real_T c6_y[6]);
static void c6_j_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[6]);
static void c6_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_f_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static real_T c6_k_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void c6_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_g_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static void c6_l_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[2]);
static void c6_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static const mxArray *c6_h_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static const mxArray *c6_i_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static void c6_m_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[2]);
static void c6_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static void c6_info_helper(c6_ResolvedFunctionInfo c6_info[42]);
static void c6_check_forloop_overflow_error(SFc6_dp_mod_1InstanceStruct
  *chartInstance);
static real_T c6_mpower(SFc6_dp_mod_1InstanceStruct *chartInstance, real_T c6_a);
static real_T c6_abs(SFc6_dp_mod_1InstanceStruct *chartInstance, real_T c6_x);
static void c6_eml_scalar_eg(SFc6_dp_mod_1InstanceStruct *chartInstance);
static void c6_b_eml_scalar_eg(SFc6_dp_mod_1InstanceStruct *chartInstance);
static const mxArray *c6_j_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData);
static int32_T c6_n_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void c6_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData);
static uint8_T c6_o_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_b_is_active_c6_dp_mod_1, const char_T *c6_identifier);
static uint8_T c6_p_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId);
static void init_dsm_address_info(SFc6_dp_mod_1InstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
  chartInstance->c6_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c6_first_not_empty = FALSE;
  chartInstance->c6_flag_not_empty = FALSE;
  chartInstance->c6_is_active_c6_dp_mod_1 = 0U;
}

static void initialize_params_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct
  *chartInstance)
{
}

static void enable_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c6_update_debugger_state_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct
  *chartInstance)
{
  const mxArray *c6_st;
  const mxArray *c6_y = NULL;
  int32_T c6_i0;
  real_T c6_u[6];
  const mxArray *c6_b_y = NULL;
  int32_T c6_i1;
  real_T c6_b_u[9];
  const mxArray *c6_c_y = NULL;
  int32_T c6_i2;
  real_T c6_c_u[9];
  const mxArray *c6_d_y = NULL;
  int32_T c6_i3;
  real_T c6_d_u[3];
  const mxArray *c6_e_y = NULL;
  int32_T c6_i4;
  real_T c6_e_u[3];
  const mxArray *c6_f_y = NULL;
  int32_T c6_i5;
  real_T c6_f_u[3];
  const mxArray *c6_g_y = NULL;
  int32_T c6_i6;
  real_T c6_g_u[6];
  const mxArray *c6_h_y = NULL;
  int32_T c6_i7;
  real_T c6_h_u[3];
  const mxArray *c6_i_y = NULL;
  real_T c6_hoistedGlobal;
  real_T c6_i_u;
  const mxArray *c6_j_y = NULL;
  int32_T c6_i8;
  real_T c6_j_u[3];
  const mxArray *c6_k_y = NULL;
  uint8_T c6_b_hoistedGlobal;
  uint8_T c6_k_u;
  const mxArray *c6_l_y = NULL;
  real_T (*c6_ym)[3];
  real_T (*c6_xm_dot)[6];
  real_T (*c6_k_m_r)[3];
  real_T (*c6_k_m_fc)[3];
  real_T (*c6_Z_m)[3];
  real_T (*c6_R_m)[9];
  real_T (*c6_M)[9];
  real_T (*c6_Fm_dot)[6];
  c6_M = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 8);
  c6_k_m_fc = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c6_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 6);
  c6_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 5);
  c6_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c6_ym = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c6_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c6_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c6_st = NULL;
  c6_st = NULL;
  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_createcellarray(11), FALSE);
  for (c6_i0 = 0; c6_i0 < 6; c6_i0++) {
    c6_u[c6_i0] = (*c6_Fm_dot)[c6_i0];
  }

  c6_b_y = NULL;
  sf_mex_assign(&c6_b_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 2, 2, 3), FALSE);
  sf_mex_setcell(c6_y, 0, c6_b_y);
  for (c6_i1 = 0; c6_i1 < 9; c6_i1++) {
    c6_b_u[c6_i1] = (*c6_M)[c6_i1];
  }

  c6_c_y = NULL;
  sf_mex_assign(&c6_c_y, sf_mex_create("y", c6_b_u, 0, 0U, 1U, 0U, 2, 3, 3),
                FALSE);
  sf_mex_setcell(c6_y, 1, c6_c_y);
  for (c6_i2 = 0; c6_i2 < 9; c6_i2++) {
    c6_c_u[c6_i2] = (*c6_R_m)[c6_i2];
  }

  c6_d_y = NULL;
  sf_mex_assign(&c6_d_y, sf_mex_create("y", c6_c_u, 0, 0U, 1U, 0U, 2, 3, 3),
                FALSE);
  sf_mex_setcell(c6_y, 2, c6_d_y);
  for (c6_i3 = 0; c6_i3 < 3; c6_i3++) {
    c6_d_u[c6_i3] = (*c6_Z_m)[c6_i3];
  }

  c6_e_y = NULL;
  sf_mex_assign(&c6_e_y, sf_mex_create("y", c6_d_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c6_y, 3, c6_e_y);
  for (c6_i4 = 0; c6_i4 < 3; c6_i4++) {
    c6_e_u[c6_i4] = (*c6_k_m_fc)[c6_i4];
  }

  c6_f_y = NULL;
  sf_mex_assign(&c6_f_y, sf_mex_create("y", c6_e_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c6_y, 4, c6_f_y);
  for (c6_i5 = 0; c6_i5 < 3; c6_i5++) {
    c6_f_u[c6_i5] = (*c6_k_m_r)[c6_i5];
  }

  c6_g_y = NULL;
  sf_mex_assign(&c6_g_y, sf_mex_create("y", c6_f_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c6_y, 5, c6_g_y);
  for (c6_i6 = 0; c6_i6 < 6; c6_i6++) {
    c6_g_u[c6_i6] = (*c6_xm_dot)[c6_i6];
  }

  c6_h_y = NULL;
  sf_mex_assign(&c6_h_y, sf_mex_create("y", c6_g_u, 0, 0U, 1U, 0U, 2, 2, 3),
                FALSE);
  sf_mex_setcell(c6_y, 6, c6_h_y);
  for (c6_i7 = 0; c6_i7 < 3; c6_i7++) {
    c6_h_u[c6_i7] = (*c6_ym)[c6_i7];
  }

  c6_i_y = NULL;
  sf_mex_assign(&c6_i_y, sf_mex_create("y", c6_h_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c6_y, 7, c6_i_y);
  c6_hoistedGlobal = chartInstance->c6_first;
  c6_i_u = c6_hoistedGlobal;
  c6_j_y = NULL;
  if (!chartInstance->c6_first_not_empty) {
    sf_mex_assign(&c6_j_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c6_j_y, sf_mex_create("y", &c6_i_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c6_y, 8, c6_j_y);
  for (c6_i8 = 0; c6_i8 < 3; c6_i8++) {
    c6_j_u[c6_i8] = chartInstance->c6_flag[c6_i8];
  }

  c6_k_y = NULL;
  if (!chartInstance->c6_flag_not_empty) {
    sf_mex_assign(&c6_k_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c6_k_y, sf_mex_create("y", c6_j_u, 0, 0U, 1U, 0U, 2, 1, 3),
                  FALSE);
  }

  sf_mex_setcell(c6_y, 9, c6_k_y);
  c6_b_hoistedGlobal = chartInstance->c6_is_active_c6_dp_mod_1;
  c6_k_u = c6_b_hoistedGlobal;
  c6_l_y = NULL;
  sf_mex_assign(&c6_l_y, sf_mex_create("y", &c6_k_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c6_y, 10, c6_l_y);
  sf_mex_assign(&c6_st, c6_y, FALSE);
  return c6_st;
}

static void set_sim_state_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_st)
{
  const mxArray *c6_u;
  real_T c6_dv0[6];
  int32_T c6_i9;
  real_T c6_dv1[9];
  int32_T c6_i10;
  real_T c6_dv2[9];
  int32_T c6_i11;
  real_T c6_dv3[3];
  int32_T c6_i12;
  real_T c6_dv4[3];
  int32_T c6_i13;
  real_T c6_dv5[3];
  int32_T c6_i14;
  real_T c6_dv6[6];
  int32_T c6_i15;
  real_T c6_dv7[3];
  int32_T c6_i16;
  real_T c6_dv8[3];
  int32_T c6_i17;
  real_T (*c6_Fm_dot)[6];
  real_T (*c6_M)[9];
  real_T (*c6_R_m)[9];
  real_T (*c6_Z_m)[3];
  real_T (*c6_k_m_fc)[3];
  real_T (*c6_k_m_r)[3];
  real_T (*c6_xm_dot)[6];
  real_T (*c6_ym)[3];
  c6_M = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 8);
  c6_k_m_fc = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c6_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 6);
  c6_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 5);
  c6_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c6_ym = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c6_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c6_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c6_doneDoubleBufferReInit = TRUE;
  c6_u = sf_mex_dup(c6_st);
  c6_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 0)),
                        "Fm_dot", c6_dv0);
  for (c6_i9 = 0; c6_i9 < 6; c6_i9++) {
    (*c6_Fm_dot)[c6_i9] = c6_dv0[c6_i9];
  }

  c6_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 1)), "M",
                        c6_dv1);
  for (c6_i10 = 0; c6_i10 < 9; c6_i10++) {
    (*c6_M)[c6_i10] = c6_dv1[c6_i10];
  }

  c6_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 2)),
                        "R_m", c6_dv2);
  for (c6_i11 = 0; c6_i11 < 9; c6_i11++) {
    (*c6_R_m)[c6_i11] = c6_dv2[c6_i11];
  }

  c6_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 3)),
                        "Z_m", c6_dv3);
  for (c6_i12 = 0; c6_i12 < 3; c6_i12++) {
    (*c6_Z_m)[c6_i12] = c6_dv3[c6_i12];
  }

  c6_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 4)),
                        "k_m_fc", c6_dv4);
  for (c6_i13 = 0; c6_i13 < 3; c6_i13++) {
    (*c6_k_m_fc)[c6_i13] = c6_dv4[c6_i13];
  }

  c6_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 5)),
                        "k_m_r", c6_dv5);
  for (c6_i14 = 0; c6_i14 < 3; c6_i14++) {
    (*c6_k_m_r)[c6_i14] = c6_dv5[c6_i14];
  }

  c6_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 6)),
                        "xm_dot", c6_dv6);
  for (c6_i15 = 0; c6_i15 < 6; c6_i15++) {
    (*c6_xm_dot)[c6_i15] = c6_dv6[c6_i15];
  }

  c6_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 7)), "ym",
                        c6_dv7);
  for (c6_i16 = 0; c6_i16 < 3; c6_i16++) {
    (*c6_ym)[c6_i16] = c6_dv7[c6_i16];
  }

  chartInstance->c6_first = c6_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c6_u, 8)), "first");
  c6_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c6_u, 9)), "flag",
                      c6_dv8);
  for (c6_i17 = 0; c6_i17 < 3; c6_i17++) {
    chartInstance->c6_flag[c6_i17] = c6_dv8[c6_i17];
  }

  chartInstance->c6_is_active_c6_dp_mod_1 = c6_o_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c6_u, 10)), "is_active_c6_dp_mod_1");
  sf_mex_destroy(&c6_u);
  c6_update_debugger_state_c6_dp_mod_1(chartInstance);
  sf_mex_destroy(&c6_st);
}

static void finalize_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
}

static void sf_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
  int32_T c6_i18;
  int32_T c6_i19;
  int32_T c6_i20;
  int32_T c6_i21;
  int32_T c6_i22;
  int32_T c6_i23;
  int32_T c6_i24;
  int32_T c6_i25;
  int32_T c6_i26;
  int32_T c6_i27;
  int32_T c6_i28;
  int32_T c6_i29;
  int32_T c6_i30;
  int32_T c6_i31;
  real_T (*c6_M)[9];
  real_T (*c6_k_m_fc)[3];
  real_T (*c6_k_m_r)[3];
  real_T (*c6_R_m)[9];
  real_T (*c6_Z_m)[3];
  real_T (*c6_ym)[3];
  real_T (*c6_F_C)[3];
  real_T (*c6_M_e)[9];
  real_T (*c6_D_e)[9];
  real_T (*c6_r)[3];
  real_T (*c6_F0)[6];
  real_T (*c6_y0)[6];
  real_T (*c6_Fm_dot)[6];
  real_T (*c6_xm_dot)[6];
  c6_M = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 8);
  c6_k_m_fc = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c6_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 6);
  c6_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 5);
  c6_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c6_ym = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c6_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c6_M_e = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 4);
  c6_D_e = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 3);
  c6_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c6_F0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c6_y0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  c6_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c6_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 5U, chartInstance->c6_sfEvent);
  for (c6_i18 = 0; c6_i18 < 6; c6_i18++) {
    _SFD_DATA_RANGE_CHECK((*c6_xm_dot)[c6_i18], 0U);
  }

  for (c6_i19 = 0; c6_i19 < 6; c6_i19++) {
    _SFD_DATA_RANGE_CHECK((*c6_Fm_dot)[c6_i19], 1U);
  }

  for (c6_i20 = 0; c6_i20 < 6; c6_i20++) {
    _SFD_DATA_RANGE_CHECK((*c6_y0)[c6_i20], 2U);
  }

  for (c6_i21 = 0; c6_i21 < 6; c6_i21++) {
    _SFD_DATA_RANGE_CHECK((*c6_F0)[c6_i21], 3U);
  }

  for (c6_i22 = 0; c6_i22 < 3; c6_i22++) {
    _SFD_DATA_RANGE_CHECK((*c6_r)[c6_i22], 4U);
  }

  for (c6_i23 = 0; c6_i23 < 9; c6_i23++) {
    _SFD_DATA_RANGE_CHECK((*c6_D_e)[c6_i23], 5U);
  }

  for (c6_i24 = 0; c6_i24 < 9; c6_i24++) {
    _SFD_DATA_RANGE_CHECK((*c6_M_e)[c6_i24], 6U);
  }

  for (c6_i25 = 0; c6_i25 < 3; c6_i25++) {
    _SFD_DATA_RANGE_CHECK((*c6_F_C)[c6_i25], 7U);
  }

  for (c6_i26 = 0; c6_i26 < 3; c6_i26++) {
    _SFD_DATA_RANGE_CHECK((*c6_ym)[c6_i26], 8U);
  }

  for (c6_i27 = 0; c6_i27 < 3; c6_i27++) {
    _SFD_DATA_RANGE_CHECK((*c6_Z_m)[c6_i27], 9U);
  }

  for (c6_i28 = 0; c6_i28 < 9; c6_i28++) {
    _SFD_DATA_RANGE_CHECK((*c6_R_m)[c6_i28], 10U);
  }

  for (c6_i29 = 0; c6_i29 < 3; c6_i29++) {
    _SFD_DATA_RANGE_CHECK((*c6_k_m_r)[c6_i29], 11U);
  }

  for (c6_i30 = 0; c6_i30 < 3; c6_i30++) {
    _SFD_DATA_RANGE_CHECK((*c6_k_m_fc)[c6_i30], 12U);
  }

  for (c6_i31 = 0; c6_i31 < 9; c6_i31++) {
    _SFD_DATA_RANGE_CHECK((*c6_M)[c6_i31], 13U);
  }

  chartInstance->c6_sfEvent = CALL_EVENT;
  c6_chartstep_c6_dp_mod_1(chartInstance);
  sf_debug_check_for_state_inconsistency(_dp_mod_1MachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c6_chartstep_c6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
  int32_T c6_i32;
  real_T c6_y0[6];
  int32_T c6_i33;
  real_T c6_F0[6];
  int32_T c6_i34;
  real_T c6_r[3];
  int32_T c6_i35;
  real_T c6_D_e[9];
  int32_T c6_i36;
  real_T c6_M_e[9];
  int32_T c6_i37;
  real_T c6_F_C[3];
  uint32_T c6_debug_family_var_map[32];
  real_T c6_zeta;
  real_T c6_omega_0;
  real_T c6_alpha;
  real_T c6_M_d[9];
  real_T c6_D[9];
  real_T c6_D_d[9];
  real_T c6_K_d[9];
  real_T c6_K[9];
  real_T c6_K_p[9];
  real_T c6_C_m[2];
  real_T c6_A_m[4];
  real_T c6_B_m[2];
  real_T c6_xm[2];
  real_T c6_Fm[2];
  real_T c6_nargin = 6.0;
  real_T c6_nargout = 8.0;
  real_T c6_xm_dot[6];
  real_T c6_Fm_dot[6];
  real_T c6_ym[3];
  real_T c6_Z_m[3];
  real_T c6_R_m[9];
  real_T c6_k_m_r[3];
  real_T c6_k_m_fc[3];
  real_T c6_M[9];
  int32_T c6_i38;
  int32_T c6_i39;
  static real_T c6_dv9[9] = { 3060.0, 0.0, 0.0, 0.0, 3060.0, 0.0, 0.0, 0.0,
    320.0 };

  int32_T c6_i40;
  int32_T c6_i41;
  static real_T c6_dv10[9] = { 2142.0, 0.0, 0.0, 0.0, 2142.0, 0.0, 0.0, 0.0,
    224.0 };

  int32_T c6_i42;
  int32_T c6_i43;
  real_T c6_b[9];
  int32_T c6_i44;
  int32_T c6_i45;
  static real_T c6_dv11[9] = { 1499.3999999999999, 0.0, 0.0, 0.0,
    1499.3999999999999, 0.0, 0.0, 0.0, 156.79999999999998 };

  int32_T c6_i46;
  int32_T c6_i47;
  int32_T c6_i48;
  int32_T c6_i49;
  int32_T c6_i50;
  int32_T c6_i51;
  int32_T c6_i52;
  int32_T c6_i53;
  int32_T c6_i54;
  int32_T c6_i;
  real_T c6_b_i;
  int32_T c6_i55;
  static real_T c6_a[4] = { -0.7, -0.48999999999999994, 1.0, 0.0 };

  int32_T c6_i56;
  int32_T c6_i57;
  int32_T c6_c_i;
  int32_T c6_i58;
  int32_T c6_d_i;
  int32_T c6_i59;
  int32_T c6_i60;
  real_T c6_b_b[2];
  int32_T c6_i61;
  real_T c6_y[2];
  int32_T c6_i62;
  int32_T c6_i63;
  real_T c6_c_b;
  int32_T c6_i64;
  int32_T c6_e_i;
  int32_T c6_i65;
  int32_T c6_i66;
  real_T c6_b_y;
  int32_T c6_k;
  int32_T c6_b_k;
  int32_T c6_f_i;
  real_T c6_d0;
  int32_T c6_i67;
  int32_T c6_i68;
  int32_T c6_i69;
  int32_T c6_i70;
  real_T c6_d_b;
  int32_T c6_i71;
  int32_T c6_g_i;
  int32_T c6_i72;
  int32_T c6_i73;
  real_T c6_c_y;
  int32_T c6_c_k;
  int32_T c6_d_k;
  int32_T c6_h_i;
  real_T c6_d1;
  int32_T c6_i74;
  int32_T c6_i75;
  int32_T c6_i76;
  int32_T c6_i77;
  real_T c6_e_b;
  int32_T c6_i78;
  int32_T c6_i_i;
  int32_T c6_i79;
  int32_T c6_i80;
  real_T c6_d_y;
  int32_T c6_e_k;
  int32_T c6_f_k;
  int32_T c6_j_i;
  real_T c6_d2;
  int32_T c6_i81;
  int32_T c6_i82;
  int32_T c6_i83;
  int32_T c6_i84;
  real_T c6_f_b;
  int32_T c6_i85;
  int32_T c6_k_i;
  int32_T c6_i86;
  int32_T c6_i87;
  real_T c6_e_y;
  int32_T c6_g_k;
  int32_T c6_h_k;
  int32_T c6_l_i;
  real_T c6_d3;
  int32_T c6_m_i;
  int32_T c6_i88;
  int32_T c6_i89;
  int32_T c6_i90;
  int32_T c6_i91;
  int32_T c6_i92;
  real_T c6_g_b;
  int32_T c6_i93;
  int32_T c6_n_i;
  int32_T c6_i94;
  int32_T c6_i95;
  real_T c6_f_y;
  int32_T c6_i_k;
  int32_T c6_j_k;
  real_T c6_A;
  real_T c6_B;
  real_T c6_x;
  real_T c6_g_y;
  real_T c6_b_x;
  real_T c6_h_y;
  real_T c6_i_y;
  real_T c6_b_A;
  real_T c6_b_B;
  real_T c6_c_x;
  real_T c6_j_y;
  real_T c6_d_x;
  real_T c6_k_y;
  real_T c6_l_y;
  int32_T c6_o_i;
  real_T c6_c_A;
  real_T c6_c_B;
  real_T c6_e_x;
  real_T c6_m_y;
  real_T c6_f_x;
  real_T c6_n_y;
  real_T c6_o_y;
  int32_T c6_i96;
  int32_T c6_i97;
  int32_T c6_i98;
  int32_T c6_i99;
  int32_T c6_i100;
  int32_T c6_i101;
  int32_T c6_i102;
  int32_T c6_i103;
  real_T (*c6_b_xm_dot)[6];
  real_T (*c6_b_Fm_dot)[6];
  real_T (*c6_b_ym)[3];
  real_T (*c6_b_Z_m)[3];
  real_T (*c6_b_R_m)[9];
  real_T (*c6_b_k_m_r)[3];
  real_T (*c6_b_k_m_fc)[3];
  real_T (*c6_b_M)[9];
  real_T (*c6_b_F_C)[3];
  real_T (*c6_b_M_e)[9];
  real_T (*c6_b_D_e)[9];
  real_T (*c6_b_r)[3];
  real_T (*c6_b_F0)[6];
  real_T (*c6_b_y0)[6];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  c6_b_M = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 8);
  c6_b_k_m_fc = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c6_b_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 6);
  c6_b_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 5);
  c6_b_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c6_b_ym = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c6_b_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c6_b_M_e = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 4);
  c6_b_D_e = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 3);
  c6_b_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c6_b_F0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c6_b_y0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  c6_b_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c6_b_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 5U, chartInstance->c6_sfEvent);
  for (c6_i32 = 0; c6_i32 < 6; c6_i32++) {
    c6_y0[c6_i32] = (*c6_b_y0)[c6_i32];
  }

  for (c6_i33 = 0; c6_i33 < 6; c6_i33++) {
    c6_F0[c6_i33] = (*c6_b_F0)[c6_i33];
  }

  for (c6_i34 = 0; c6_i34 < 3; c6_i34++) {
    c6_r[c6_i34] = (*c6_b_r)[c6_i34];
  }

  for (c6_i35 = 0; c6_i35 < 9; c6_i35++) {
    c6_D_e[c6_i35] = (*c6_b_D_e)[c6_i35];
  }

  for (c6_i36 = 0; c6_i36 < 9; c6_i36++) {
    c6_M_e[c6_i36] = (*c6_b_M_e)[c6_i36];
  }

  for (c6_i37 = 0; c6_i37 < 3; c6_i37++) {
    c6_F_C[c6_i37] = (*c6_b_F_C)[c6_i37];
  }

  sf_debug_symbol_scope_push_eml(0U, 32U, 32U, c6_debug_family_names,
    c6_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c6_zeta, 0U, c6_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c6_omega_0, 1U, c6_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c6_alpha, 2U, c6_f_sf_marshallOut,
    c6_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_M_d, 3U, c6_c_sf_marshallOut,
    c6_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_D, 4U, c6_c_sf_marshallOut,
    c6_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_D_d, 5U, c6_c_sf_marshallOut,
    c6_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_K_d, 6U, c6_c_sf_marshallOut,
    c6_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c6_K, 7U, c6_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c6_K_p, 8U, c6_c_sf_marshallOut,
    c6_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_C_m, 9U, c6_i_sf_marshallOut,
    c6_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c6_A_m, 10U, c6_h_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_B_m, 11U, c6_g_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c6_xm, 12U, c6_g_sf_marshallOut,
    c6_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_Fm, 13U, c6_g_sf_marshallOut,
    c6_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_nargin, 14U, c6_f_sf_marshallOut,
    c6_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c6_nargout, 15U, c6_f_sf_marshallOut,
    c6_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c6_y0, 16U, c6_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_F0, 17U, c6_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_r, 18U, c6_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_D_e, 19U, c6_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_M_e, 20U, c6_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c6_F_C, 21U, c6_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c6_xm_dot, 22U, c6_e_sf_marshallOut,
    c6_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_Fm_dot, 23U, c6_e_sf_marshallOut,
    c6_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_ym, 24U, c6_d_sf_marshallOut,
    c6_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_Z_m, 25U, c6_d_sf_marshallOut,
    c6_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_R_m, 26U, c6_c_sf_marshallOut,
    c6_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_k_m_r, 27U, c6_d_sf_marshallOut,
    c6_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c6_k_m_fc, 28U, c6_d_sf_marshallOut,
    c6_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c6_M, 29U, c6_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c6_first, 30U,
    c6_b_sf_marshallOut, c6_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c6_flag, 31U,
    c6_sf_marshallOut, c6_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 8);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 10);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c6_first_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 11);
    chartInstance->c6_first = 0.0;
    chartInstance->c6_first_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 14);
    for (c6_i38 = 0; c6_i38 < 3; c6_i38++) {
      chartInstance->c6_flag[c6_i38] = 0.0;
    }

    chartInstance->c6_flag_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 17);
  c6_zeta = 0.5;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 18);
  c6_omega_0 = 0.7;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 19);
  c6_alpha = 0.1;
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 22);
  for (c6_i39 = 0; c6_i39 < 9; c6_i39++) {
    c6_M[c6_i39] = c6_dv9[c6_i39];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 23);
  for (c6_i40 = 0; c6_i40 < 9; c6_i40++) {
    c6_M_d[c6_i40] = c6_M[c6_i40] - c6_M_e[c6_i40];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 24);
  for (c6_i41 = 0; c6_i41 < 9; c6_i41++) {
    c6_D[c6_i41] = c6_dv10[c6_i41];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 25);
  for (c6_i42 = 0; c6_i42 < 9; c6_i42++) {
    c6_D_d[c6_i42] = c6_D[c6_i42] - c6_D_e[c6_i42];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 26);
  for (c6_i43 = 0; c6_i43 < 9; c6_i43++) {
    c6_b[c6_i43] = c6_M_d[c6_i43];
  }

  for (c6_i44 = 0; c6_i44 < 9; c6_i44++) {
    c6_K_d[c6_i44] = 0.48999999999999994 * c6_b[c6_i44];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 27);
  for (c6_i45 = 0; c6_i45 < 9; c6_i45++) {
    c6_K[c6_i45] = c6_dv11[c6_i45];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 29);
  for (c6_i46 = 0; c6_i46 < 9; c6_i46++) {
    c6_K_p[c6_i46] = c6_dv11[c6_i46];
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 35);
  for (c6_i47 = 0; c6_i47 < 2; c6_i47++) {
    c6_C_m[c6_i47] = 1.0 - (real_T)c6_i47;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 38);
  for (c6_i48 = 0; c6_i48 < 3; c6_i48++) {
    c6_ym[c6_i48] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 40);
  for (c6_i49 = 0; c6_i49 < 6; c6_i49++) {
    c6_xm_dot[c6_i49] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 41);
  for (c6_i50 = 0; c6_i50 < 6; c6_i50++) {
    c6_Fm_dot[c6_i50] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 44);
  for (c6_i51 = 0; c6_i51 < 3; c6_i51++) {
    c6_Z_m[c6_i51] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 45);
  for (c6_i52 = 0; c6_i52 < 9; c6_i52++) {
    c6_R_m[c6_i52] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 46);
  for (c6_i53 = 0; c6_i53 < 3; c6_i53++) {
    c6_k_m_r[c6_i53] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 47);
  for (c6_i54 = 0; c6_i54 < 3; c6_i54++) {
    c6_k_m_fc[c6_i54] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 52);
  c6_i = 0;
  while (c6_i < 3) {
    c6_b_i = 1.0 + (real_T)c6_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 54);
    for (c6_i55 = 0; c6_i55 < 4; c6_i55++) {
      c6_A_m[c6_i55] = c6_a[c6_i55];
    }

    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 56);
    for (c6_i56 = 0; c6_i56 < 2; c6_i56++) {
      c6_B_m[c6_i56] = 0.48999999999999994 * (real_T)c6_i56;
    }

    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 57);
    for (c6_i57 = 0; c6_i57 < 2; c6_i57++) {
      c6_C_m[c6_i57] = 1.0 - (real_T)c6_i57;
    }

    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 59);
    c6_c_i = _SFD_EML_ARRAY_BOUNDS_CHECK("y0", (int32_T)_SFD_INTEGER_CHECK("i",
      c6_b_i), 1, 3, 2, 0) - 1;
    for (c6_i58 = 0; c6_i58 < 2; c6_i58++) {
      c6_xm[c6_i58] = c6_y0[c6_i58 + (c6_c_i << 1)];
    }

    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 60);
    c6_d_i = _SFD_EML_ARRAY_BOUNDS_CHECK("F0", (int32_T)_SFD_INTEGER_CHECK("i",
      c6_b_i), 1, 3, 2, 0) - 1;
    for (c6_i59 = 0; c6_i59 < 2; c6_i59++) {
      c6_Fm[c6_i59] = c6_F0[c6_i59 + (c6_d_i << 1)];
    }

    _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 62);
    if (CV_EML_IF(0, 1, 1, c6_b_i != 3.0)) {
      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 63);
      if (CV_EML_IF(0, 1, 2, c6_abs(chartInstance,
            c6_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
             _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1]) > 20.0)) {
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 65);
        for (c6_i60 = 0; c6_i60 < 2; c6_i60++) {
          c6_b_b[c6_i60] = c6_Fm[c6_i60];
        }

        c6_eml_scalar_eg(chartInstance);
        c6_eml_scalar_eg(chartInstance);
        for (c6_i61 = 0; c6_i61 < 2; c6_i61++) {
          c6_y[c6_i61] = 0.0;
          c6_i62 = 0;
          for (c6_i63 = 0; c6_i63 < 2; c6_i63++) {
            c6_y[c6_i61] += c6_a[c6_i62 + c6_i61] * c6_b_b[c6_i63];
            c6_i62 += 2;
          }
        }

        c6_c_b = c6_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
          _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1];
        for (c6_i64 = 0; c6_i64 < 2; c6_i64++) {
          c6_b_b[c6_i64] = 0.48999999999999994 * (real_T)c6_i64 * c6_c_b;
        }

        c6_e_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Fm_dot", (int32_T)
          _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1;
        for (c6_i65 = 0; c6_i65 < 2; c6_i65++) {
          c6_Fm_dot[c6_i65 + (c6_e_i << 1)] = c6_y[c6_i65] + c6_b_b[c6_i65];
        }

        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 67);
        for (c6_i66 = 0; c6_i66 < 2; c6_i66++) {
          c6_b_b[c6_i66] = c6_Fm[c6_i66];
        }

        c6_b_eml_scalar_eg(chartInstance);
        c6_b_eml_scalar_eg(chartInstance);
        c6_b_y = 0.0;
        c6_check_forloop_overflow_error(chartInstance);
        for (c6_k = 1; c6_k < 3; c6_k++) {
          c6_b_k = c6_k;
          c6_b_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c6_b_k), 1, 2, 1, 0) - 1)) *
            c6_b_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
            "", (real_T)c6_b_k), 1, 2, 1, 0) - 1];
        }

        c6_ym[_SFD_EML_ARRAY_BOUNDS_CHECK("ym", (int32_T)_SFD_INTEGER_CHECK("i",
          c6_b_i), 1, 3, 1, 0) - 1] = c6_b_y;
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 69);
        c6_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m", (int32_T)_SFD_INTEGER_CHECK(
          "i", c6_b_i), 1, 3, 1, 0) - 1] = 1.0;
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 70);
        c6_f_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)_SFD_INTEGER_CHECK(
          "i", c6_b_i), 1, 3, 1, 0) - 1;
        c6_d0 = c6_mpower(chartInstance, 0.7);
        c6_R_m[c6_f_i] = 1.0;
        c6_R_m[3 + c6_f_i] = 0.7;
        c6_R_m[6 + c6_f_i] = c6_d0;
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 71);
        c6_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)
          _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 0.0;
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 72);
        c6_k_m_fc[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_fc", (int32_T)
          _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = c6_mpower
          (chartInstance, 0.7);
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 74);
        chartInstance->c6_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
          _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 1.0;
      } else {
        _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 76);
        guard1 = FALSE;
        if (CV_EML_COND(0, 1, 0, c6_abs(chartInstance,
              c6_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
               _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1]) < 0.1)) {
          if (CV_EML_COND(0, 1, 1, chartInstance->
                          c6_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] == 1.0)) {
            CV_EML_MCDC(0, 1, 0, TRUE);
            CV_EML_IF(0, 1, 3, TRUE);
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 79);
            for (c6_i67 = 0; c6_i67 < 2; c6_i67++) {
              c6_b_b[c6_i67] = c6_xm[c6_i67];
            }

            c6_eml_scalar_eg(chartInstance);
            c6_eml_scalar_eg(chartInstance);
            for (c6_i68 = 0; c6_i68 < 2; c6_i68++) {
              c6_y[c6_i68] = 0.0;
              c6_i69 = 0;
              for (c6_i70 = 0; c6_i70 < 2; c6_i70++) {
                c6_y[c6_i68] += c6_a[c6_i69 + c6_i68] * c6_b_b[c6_i70];
                c6_i69 += 2;
              }
            }

            c6_d_b = c6_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1];
            for (c6_i71 = 0; c6_i71 < 2; c6_i71++) {
              c6_b_b[c6_i71] = 0.48999999999999994 * (real_T)c6_i71 * c6_d_b;
            }

            c6_g_i = _SFD_EML_ARRAY_BOUNDS_CHECK("xm_dot", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1;
            for (c6_i72 = 0; c6_i72 < 2; c6_i72++) {
              c6_xm_dot[c6_i72 + (c6_g_i << 1)] = c6_y[c6_i72] + c6_b_b[c6_i72];
            }

            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 81);
            for (c6_i73 = 0; c6_i73 < 2; c6_i73++) {
              c6_b_b[c6_i73] = c6_xm[c6_i73];
            }

            c6_b_eml_scalar_eg(chartInstance);
            c6_b_eml_scalar_eg(chartInstance);
            c6_c_y = 0.0;
            c6_check_forloop_overflow_error(chartInstance);
            for (c6_c_k = 1; c6_c_k < 3; c6_c_k++) {
              c6_d_k = c6_c_k;
              c6_c_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                _SFD_INTEGER_CHECK("", (real_T)c6_d_k), 1, 2, 1, 0) - 1)) *
                c6_b_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                _SFD_INTEGER_CHECK("", (real_T)c6_d_k), 1, 2, 1, 0) - 1];
            }

            c6_ym[_SFD_EML_ARRAY_BOUNDS_CHECK("ym", (int32_T)_SFD_INTEGER_CHECK(
              "i", c6_b_i), 1, 3, 1, 0) - 1] = c6_c_y;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 83);
            c6_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 1.0;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 84);
            c6_h_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1;
            c6_d1 = c6_mpower(chartInstance, 0.7);
            c6_R_m[c6_h_i] = 1.0;
            c6_R_m[3 + c6_h_i] = 0.7;
            c6_R_m[6 + c6_h_i] = c6_d1;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 85);
            c6_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = c6_mpower
              (chartInstance, 0.7);
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 86);
            c6_k_m_fc[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_fc", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 0.0;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 88);
            chartInstance->c6_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 0.0;
          } else {
            guard1 = TRUE;
          }
        } else {
          guard1 = TRUE;
        }

        if (guard1 == TRUE) {
          CV_EML_MCDC(0, 1, 0, FALSE);
          CV_EML_IF(0, 1, 3, FALSE);
          _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 90);
          guard2 = FALSE;
          if (CV_EML_COND(0, 1, 2, c6_abs(chartInstance,
                c6_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
                 _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1]) < 20.0)) {
            if (CV_EML_COND(0, 1, 3, chartInstance->
                            c6_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
                  _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] == 1.0)) {
              CV_EML_MCDC(0, 1, 1, TRUE);
              CV_EML_IF(0, 1, 4, TRUE);
              _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 92);
              for (c6_i74 = 0; c6_i74 < 2; c6_i74++) {
                c6_b_b[c6_i74] = c6_Fm[c6_i74];
              }

              c6_eml_scalar_eg(chartInstance);
              c6_eml_scalar_eg(chartInstance);
              for (c6_i75 = 0; c6_i75 < 2; c6_i75++) {
                c6_y[c6_i75] = 0.0;
                c6_i76 = 0;
                for (c6_i77 = 0; c6_i77 < 2; c6_i77++) {
                  c6_y[c6_i75] += c6_a[c6_i76 + c6_i75] * c6_b_b[c6_i77];
                  c6_i76 += 2;
                }
              }

              c6_e_b = c6_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1];
              for (c6_i78 = 0; c6_i78 < 2; c6_i78++) {
                c6_b_b[c6_i78] = 0.48999999999999994 * (real_T)c6_i78 * c6_e_b;
              }

              c6_i_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Fm_dot", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1;
              for (c6_i79 = 0; c6_i79 < 2; c6_i79++) {
                c6_Fm_dot[c6_i79 + (c6_i_i << 1)] = c6_y[c6_i79] + c6_b_b[c6_i79];
              }

              _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 94);
              for (c6_i80 = 0; c6_i80 < 2; c6_i80++) {
                c6_b_b[c6_i80] = c6_Fm[c6_i80];
              }

              c6_b_eml_scalar_eg(chartInstance);
              c6_b_eml_scalar_eg(chartInstance);
              c6_d_y = 0.0;
              c6_check_forloop_overflow_error(chartInstance);
              for (c6_e_k = 1; c6_e_k < 3; c6_e_k++) {
                c6_f_k = c6_e_k;
                c6_d_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("",
                  (int32_T)_SFD_INTEGER_CHECK("", (real_T)c6_f_k), 1, 2, 1, 0) -
                            1)) * c6_b_b[_SFD_EML_ARRAY_BOUNDS_CHECK("",
                  (int32_T)_SFD_INTEGER_CHECK("", (real_T)c6_f_k), 1, 2, 1, 0) -
                  1];
              }

              c6_ym[_SFD_EML_ARRAY_BOUNDS_CHECK("ym", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = c6_d_y;
              _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 96);
              c6_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 1.0;
              _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 97);
              c6_j_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1;
              c6_d2 = c6_mpower(chartInstance, 0.7);
              c6_R_m[c6_j_i] = 1.0;
              c6_R_m[3 + c6_j_i] = 0.7;
              c6_R_m[6 + c6_j_i] = c6_d2;
              _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 98);
              c6_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 0.0;
              _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 99);
              c6_k_m_fc[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_fc", (int32_T)
                _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = c6_mpower
                (chartInstance, 0.7);
            } else {
              guard2 = TRUE;
            }
          } else {
            guard2 = TRUE;
          }

          if (guard2 == TRUE) {
            CV_EML_MCDC(0, 1, 1, FALSE);
            CV_EML_IF(0, 1, 4, FALSE);
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 104);
            for (c6_i81 = 0; c6_i81 < 2; c6_i81++) {
              c6_b_b[c6_i81] = c6_xm[c6_i81];
            }

            c6_eml_scalar_eg(chartInstance);
            c6_eml_scalar_eg(chartInstance);
            for (c6_i82 = 0; c6_i82 < 2; c6_i82++) {
              c6_y[c6_i82] = 0.0;
              c6_i83 = 0;
              for (c6_i84 = 0; c6_i84 < 2; c6_i84++) {
                c6_y[c6_i82] += c6_a[c6_i83 + c6_i82] * c6_b_b[c6_i84];
                c6_i83 += 2;
              }
            }

            c6_f_b = c6_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1];
            for (c6_i85 = 0; c6_i85 < 2; c6_i85++) {
              c6_b_b[c6_i85] = 0.48999999999999994 * (real_T)c6_i85 * c6_f_b;
            }

            c6_k_i = _SFD_EML_ARRAY_BOUNDS_CHECK("xm_dot", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1;
            for (c6_i86 = 0; c6_i86 < 2; c6_i86++) {
              c6_xm_dot[c6_i86 + (c6_k_i << 1)] = c6_y[c6_i86] + c6_b_b[c6_i86];
            }

            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 106);
            for (c6_i87 = 0; c6_i87 < 2; c6_i87++) {
              c6_b_b[c6_i87] = c6_xm[c6_i87];
            }

            c6_b_eml_scalar_eg(chartInstance);
            c6_b_eml_scalar_eg(chartInstance);
            c6_e_y = 0.0;
            c6_check_forloop_overflow_error(chartInstance);
            for (c6_g_k = 1; c6_g_k < 3; c6_g_k++) {
              c6_h_k = c6_g_k;
              c6_e_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                _SFD_INTEGER_CHECK("", (real_T)c6_h_k), 1, 2, 1, 0) - 1)) *
                c6_b_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                _SFD_INTEGER_CHECK("", (real_T)c6_h_k), 1, 2, 1, 0) - 1];
            }

            c6_ym[_SFD_EML_ARRAY_BOUNDS_CHECK("ym", (int32_T)_SFD_INTEGER_CHECK(
              "i", c6_b_i), 1, 3, 1, 0) - 1] = c6_e_y;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 108);
            c6_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 1.0;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 109);
            c6_l_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1;
            c6_d3 = c6_mpower(chartInstance, 0.7);
            c6_R_m[c6_l_i] = 1.0;
            c6_R_m[3 + c6_l_i] = 0.7;
            c6_R_m[6 + c6_l_i] = c6_d3;
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 110);
            c6_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = c6_mpower
              (chartInstance, 0.7);
            _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 111);
            c6_k_m_fc[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_fc", (int32_T)
              _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 0.0;
          }
        }
      }
    } else {
      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 116);
      c6_m_i = _SFD_EML_ARRAY_BOUNDS_CHECK("y0", (int32_T)_SFD_INTEGER_CHECK("i",
        c6_b_i), 1, 3, 2, 0) - 1;
      for (c6_i88 = 0; c6_i88 < 2; c6_i88++) {
        c6_xm[c6_i88] = c6_y0[c6_i88 + (c6_m_i << 1)];
      }

      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 118);
      for (c6_i89 = 0; c6_i89 < 2; c6_i89++) {
        c6_b_b[c6_i89] = c6_xm[c6_i89];
      }

      c6_eml_scalar_eg(chartInstance);
      c6_eml_scalar_eg(chartInstance);
      for (c6_i90 = 0; c6_i90 < 2; c6_i90++) {
        c6_y[c6_i90] = 0.0;
        c6_i91 = 0;
        for (c6_i92 = 0; c6_i92 < 2; c6_i92++) {
          c6_y[c6_i90] += c6_a[c6_i91 + c6_i90] * c6_b_b[c6_i92];
          c6_i91 += 2;
        }
      }

      c6_g_b = c6_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)_SFD_INTEGER_CHECK
        ("i", c6_b_i), 1, 3, 1, 0) - 1];
      for (c6_i93 = 0; c6_i93 < 2; c6_i93++) {
        c6_b_b[c6_i93] = 0.48999999999999994 * (real_T)c6_i93 * c6_g_b;
      }

      c6_n_i = _SFD_EML_ARRAY_BOUNDS_CHECK("xm_dot", (int32_T)_SFD_INTEGER_CHECK
        ("i", c6_b_i), 1, 3, 2, 0) - 1;
      for (c6_i94 = 0; c6_i94 < 2; c6_i94++) {
        c6_xm_dot[c6_i94 + (c6_n_i << 1)] = c6_y[c6_i94] + c6_b_b[c6_i94];
      }

      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 120);
      for (c6_i95 = 0; c6_i95 < 2; c6_i95++) {
        c6_b_b[c6_i95] = c6_xm[c6_i95];
      }

      c6_b_eml_scalar_eg(chartInstance);
      c6_b_eml_scalar_eg(chartInstance);
      c6_f_y = 0.0;
      c6_check_forloop_overflow_error(chartInstance);
      for (c6_i_k = 1; c6_i_k < 3; c6_i_k++) {
        c6_j_k = c6_i_k;
        c6_f_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c6_j_k), 1, 2, 1, 0) - 1)) *
          c6_b_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c6_j_k), 1, 2, 1, 0) - 1];
      }

      c6_ym[_SFD_EML_ARRAY_BOUNDS_CHECK("ym", (int32_T)_SFD_INTEGER_CHECK("i",
        c6_b_i), 1, 3, 1, 0) - 1] = c6_f_y;
      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 122);
      c6_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m", (int32_T)_SFD_INTEGER_CHECK("i",
        c6_b_i), 1, 3, 1, 0) - 1] = 1.0;
      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 123);
      c6_A = c6_D[(_SFD_EML_ARRAY_BOUNDS_CHECK("D", (int32_T)_SFD_INTEGER_CHECK(
        "i", c6_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("D",
        (int32_T)_SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1)) - 1];
      c6_B = c6_M[(_SFD_EML_ARRAY_BOUNDS_CHECK("M", (int32_T)_SFD_INTEGER_CHECK(
        "i", c6_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("M",
        (int32_T)_SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1)) - 1];
      c6_x = c6_A;
      c6_g_y = c6_B;
      c6_b_x = c6_x;
      c6_h_y = c6_g_y;
      c6_i_y = c6_b_x / c6_h_y;
      c6_b_A = c6_K[(_SFD_EML_ARRAY_BOUNDS_CHECK("K", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) + 3 *
                     (_SFD_EML_ARRAY_BOUNDS_CHECK("K", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1)) - 1];
      c6_b_B = c6_M[(_SFD_EML_ARRAY_BOUNDS_CHECK("M", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) + 3 *
                     (_SFD_EML_ARRAY_BOUNDS_CHECK("M", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1)) - 1];
      c6_c_x = c6_b_A;
      c6_j_y = c6_b_B;
      c6_d_x = c6_c_x;
      c6_k_y = c6_j_y;
      c6_l_y = c6_d_x / c6_k_y;
      c6_o_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)_SFD_INTEGER_CHECK(
        "i", c6_b_i), 1, 3, 1, 0) - 1;
      c6_R_m[c6_o_i] = 1.0;
      c6_R_m[3 + c6_o_i] = c6_i_y;
      c6_R_m[6 + c6_o_i] = c6_l_y;
      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 124);
      c6_c_A = c6_K_p[(_SFD_EML_ARRAY_BOUNDS_CHECK("K_p", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) + 3 *
                       (_SFD_EML_ARRAY_BOUNDS_CHECK("K_p", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1)) - 1];
      c6_c_B = c6_M[(_SFD_EML_ARRAY_BOUNDS_CHECK("M", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) + 3 *
                     (_SFD_EML_ARRAY_BOUNDS_CHECK("M", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 2, 0) - 1)) - 1];
      c6_e_x = c6_c_A;
      c6_m_y = c6_c_B;
      c6_f_x = c6_e_x;
      c6_n_y = c6_m_y;
      c6_o_y = c6_f_x / c6_n_y;
      c6_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)_SFD_INTEGER_CHECK(
        "i", c6_b_i), 1, 3, 1, 0) - 1] = c6_o_y;
      _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, 125);
      c6_k_m_fc[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_fc", (int32_T)
        _SFD_INTEGER_CHECK("i", c6_b_i), 1, 3, 1, 0) - 1] = 0.0;
    }

    c6_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c6_sfEvent, -125);
  sf_debug_symbol_scope_pop();
  for (c6_i96 = 0; c6_i96 < 6; c6_i96++) {
    (*c6_b_xm_dot)[c6_i96] = c6_xm_dot[c6_i96];
  }

  for (c6_i97 = 0; c6_i97 < 6; c6_i97++) {
    (*c6_b_Fm_dot)[c6_i97] = c6_Fm_dot[c6_i97];
  }

  for (c6_i98 = 0; c6_i98 < 3; c6_i98++) {
    (*c6_b_ym)[c6_i98] = c6_ym[c6_i98];
  }

  for (c6_i99 = 0; c6_i99 < 3; c6_i99++) {
    (*c6_b_Z_m)[c6_i99] = c6_Z_m[c6_i99];
  }

  for (c6_i100 = 0; c6_i100 < 9; c6_i100++) {
    (*c6_b_R_m)[c6_i100] = c6_R_m[c6_i100];
  }

  for (c6_i101 = 0; c6_i101 < 3; c6_i101++) {
    (*c6_b_k_m_r)[c6_i101] = c6_k_m_r[c6_i101];
  }

  for (c6_i102 = 0; c6_i102 < 3; c6_i102++) {
    (*c6_b_k_m_fc)[c6_i102] = c6_k_m_fc[c6_i102];
  }

  for (c6_i103 = 0; c6_i103 < 9; c6_i103++) {
    (*c6_b_M)[c6_i103] = c6_M[c6_i103];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 5U, chartInstance->c6_sfEvent);
}

static void initSimStructsc6_dp_mod_1(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c6_machineNumber, uint32_T
  c6_chartNumber)
{
}

static const mxArray *c6_sf_marshallOut(void *chartInstanceVoid, void *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i104;
  real_T c6_b_inData[3];
  int32_T c6_i105;
  real_T c6_u[3];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  for (c6_i104 = 0; c6_i104 < 3; c6_i104++) {
    c6_b_inData[c6_i104] = (*(real_T (*)[3])c6_inData)[c6_i104];
  }

  for (c6_i105 = 0; c6_i105 < 3; c6_i105++) {
    c6_u[c6_i105] = c6_b_inData[c6_i105];
  }

  c6_y = NULL;
  if (!chartInstance->c6_flag_not_empty) {
    sf_mex_assign(&c6_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  }

  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static void c6_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_b_flag, const char_T *c6_identifier, real_T c6_y[3])
{
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_flag), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_b_flag);
}

static void c6_b_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[3])
{
  real_T c6_dv12[3];
  int32_T c6_i106;
  if (mxIsEmpty(c6_u)) {
    chartInstance->c6_flag_not_empty = FALSE;
  } else {
    chartInstance->c6_flag_not_empty = TRUE;
    sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv12, 1, 0, 0U, 1, 0U, 2, 1,
                  3);
    for (c6_i106 = 0; c6_i106 < 3; c6_i106++) {
      c6_y[c6_i106] = c6_dv12[c6_i106];
    }
  }

  sf_mex_destroy(&c6_u);
}

static void c6_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_b_flag;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[3];
  int32_T c6_i107;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_b_flag = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_flag), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_b_flag);
  for (c6_i107 = 0; c6_i107 < 3; c6_i107++) {
    (*(real_T (*)[3])c6_outData)[c6_i107] = c6_y[c6_i107];
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_b_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  real_T c6_u;
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_u = *(real_T *)c6_inData;
  c6_y = NULL;
  if (!chartInstance->c6_first_not_empty) {
    sf_mex_assign(&c6_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c6_y, sf_mex_create("y", &c6_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static real_T c6_c_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_b_first, const char_T *c6_identifier)
{
  real_T c6_y;
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_first), &c6_thisId);
  sf_mex_destroy(&c6_b_first);
  return c6_y;
}

static real_T c6_d_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  real_T c6_y;
  real_T c6_d4;
  if (mxIsEmpty(c6_u)) {
    chartInstance->c6_first_not_empty = FALSE;
  } else {
    chartInstance->c6_first_not_empty = TRUE;
    sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_d4, 1, 0, 0U, 0, 0U, 0);
    c6_y = c6_d4;
  }

  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void c6_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_b_first;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_b_first = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_first), &c6_thisId);
  sf_mex_destroy(&c6_b_first);
  *(real_T *)c6_outData = c6_y;
  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_c_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i108;
  int32_T c6_i109;
  int32_T c6_i110;
  real_T c6_b_inData[9];
  int32_T c6_i111;
  int32_T c6_i112;
  int32_T c6_i113;
  real_T c6_u[9];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_i108 = 0;
  for (c6_i109 = 0; c6_i109 < 3; c6_i109++) {
    for (c6_i110 = 0; c6_i110 < 3; c6_i110++) {
      c6_b_inData[c6_i110 + c6_i108] = (*(real_T (*)[9])c6_inData)[c6_i110 +
        c6_i108];
    }

    c6_i108 += 3;
  }

  c6_i111 = 0;
  for (c6_i112 = 0; c6_i112 < 3; c6_i112++) {
    for (c6_i113 = 0; c6_i113 < 3; c6_i113++) {
      c6_u[c6_i113 + c6_i111] = c6_b_inData[c6_i113 + c6_i111];
    }

    c6_i111 += 3;
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static const mxArray *c6_d_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i114;
  real_T c6_b_inData[3];
  int32_T c6_i115;
  real_T c6_u[3];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  for (c6_i114 = 0; c6_i114 < 3; c6_i114++) {
    c6_b_inData[c6_i114] = (*(real_T (*)[3])c6_inData)[c6_i114];
  }

  for (c6_i115 = 0; c6_i115 < 3; c6_i115++) {
    c6_u[c6_i115] = c6_b_inData[c6_i115];
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static void c6_e_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_k_m_fc, const char_T *c6_identifier, real_T c6_y[3])
{
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_k_m_fc), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_k_m_fc);
}

static void c6_f_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[3])
{
  real_T c6_dv13[3];
  int32_T c6_i116;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv13, 1, 0, 0U, 1, 0U, 1, 3);
  for (c6_i116 = 0; c6_i116 < 3; c6_i116++) {
    c6_y[c6_i116] = c6_dv13[c6_i116];
  }

  sf_mex_destroy(&c6_u);
}

static void c6_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_k_m_fc;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[3];
  int32_T c6_i117;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_k_m_fc = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_k_m_fc), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_k_m_fc);
  for (c6_i117 = 0; c6_i117 < 3; c6_i117++) {
    (*(real_T (*)[3])c6_outData)[c6_i117] = c6_y[c6_i117];
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

static void c6_g_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_R_m, const char_T *c6_identifier, real_T c6_y[9])
{
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_R_m), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_R_m);
}

static void c6_h_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[9])
{
  real_T c6_dv14[9];
  int32_T c6_i118;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv14, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c6_i118 = 0; c6_i118 < 9; c6_i118++) {
    c6_y[c6_i118] = c6_dv14[c6_i118];
  }

  sf_mex_destroy(&c6_u);
}

static void c6_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_R_m;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[9];
  int32_T c6_i119;
  int32_T c6_i120;
  int32_T c6_i121;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_R_m = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_R_m), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_R_m);
  c6_i119 = 0;
  for (c6_i120 = 0; c6_i120 < 3; c6_i120++) {
    for (c6_i121 = 0; c6_i121 < 3; c6_i121++) {
      (*(real_T (*)[9])c6_outData)[c6_i121 + c6_i119] = c6_y[c6_i121 + c6_i119];
    }

    c6_i119 += 3;
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_e_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i122;
  int32_T c6_i123;
  int32_T c6_i124;
  real_T c6_b_inData[6];
  int32_T c6_i125;
  int32_T c6_i126;
  int32_T c6_i127;
  real_T c6_u[6];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_i122 = 0;
  for (c6_i123 = 0; c6_i123 < 3; c6_i123++) {
    for (c6_i124 = 0; c6_i124 < 2; c6_i124++) {
      c6_b_inData[c6_i124 + c6_i122] = (*(real_T (*)[6])c6_inData)[c6_i124 +
        c6_i122];
    }

    c6_i122 += 2;
  }

  c6_i125 = 0;
  for (c6_i126 = 0; c6_i126 < 3; c6_i126++) {
    for (c6_i127 = 0; c6_i127 < 2; c6_i127++) {
      c6_u[c6_i127 + c6_i125] = c6_b_inData[c6_i127 + c6_i125];
    }

    c6_i125 += 2;
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 2, 2, 3), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static void c6_i_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_Fm_dot, const char_T *c6_identifier, real_T c6_y[6])
{
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_Fm_dot), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_Fm_dot);
}

static void c6_j_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[6])
{
  real_T c6_dv15[6];
  int32_T c6_i128;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv15, 1, 0, 0U, 1, 0U, 2, 2, 3);
  for (c6_i128 = 0; c6_i128 < 6; c6_i128++) {
    c6_y[c6_i128] = c6_dv15[c6_i128];
  }

  sf_mex_destroy(&c6_u);
}

static void c6_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_Fm_dot;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[6];
  int32_T c6_i129;
  int32_T c6_i130;
  int32_T c6_i131;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_Fm_dot = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_Fm_dot), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_Fm_dot);
  c6_i129 = 0;
  for (c6_i130 = 0; c6_i130 < 3; c6_i130++) {
    for (c6_i131 = 0; c6_i131 < 2; c6_i131++) {
      (*(real_T (*)[6])c6_outData)[c6_i131 + c6_i129] = c6_y[c6_i131 + c6_i129];
    }

    c6_i129 += 2;
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_f_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  real_T c6_u;
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_u = *(real_T *)c6_inData;
  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", &c6_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static real_T c6_k_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  real_T c6_y;
  real_T c6_d5;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_d5, 1, 0, 0U, 0, 0U, 0);
  c6_y = c6_d5;
  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void c6_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_nargout;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_nargout = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_k_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_nargout), &c6_thisId);
  sf_mex_destroy(&c6_nargout);
  *(real_T *)c6_outData = c6_y;
  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_g_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i132;
  real_T c6_b_inData[2];
  int32_T c6_i133;
  real_T c6_u[2];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  for (c6_i132 = 0; c6_i132 < 2; c6_i132++) {
    c6_b_inData[c6_i132] = (*(real_T (*)[2])c6_inData)[c6_i132];
  }

  for (c6_i133 = 0; c6_i133 < 2; c6_i133++) {
    c6_u[c6_i133] = c6_b_inData[c6_i133];
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static void c6_l_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[2])
{
  real_T c6_dv16[2];
  int32_T c6_i134;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv16, 1, 0, 0U, 1, 0U, 1, 2);
  for (c6_i134 = 0; c6_i134 < 2; c6_i134++) {
    c6_y[c6_i134] = c6_dv16[c6_i134];
  }

  sf_mex_destroy(&c6_u);
}

static void c6_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_Fm;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[2];
  int32_T c6_i135;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_Fm = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_Fm), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_Fm);
  for (c6_i135 = 0; c6_i135 < 2; c6_i135++) {
    (*(real_T (*)[2])c6_outData)[c6_i135] = c6_y[c6_i135];
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

static const mxArray *c6_h_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i136;
  int32_T c6_i137;
  int32_T c6_i138;
  real_T c6_b_inData[4];
  int32_T c6_i139;
  int32_T c6_i140;
  int32_T c6_i141;
  real_T c6_u[4];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_i136 = 0;
  for (c6_i137 = 0; c6_i137 < 2; c6_i137++) {
    for (c6_i138 = 0; c6_i138 < 2; c6_i138++) {
      c6_b_inData[c6_i138 + c6_i136] = (*(real_T (*)[4])c6_inData)[c6_i138 +
        c6_i136];
    }

    c6_i136 += 2;
  }

  c6_i139 = 0;
  for (c6_i140 = 0; c6_i140 < 2; c6_i140++) {
    for (c6_i141 = 0; c6_i141 < 2; c6_i141++) {
      c6_u[c6_i141 + c6_i139] = c6_b_inData[c6_i141 + c6_i139];
    }

    c6_i139 += 2;
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static const mxArray *c6_i_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_i142;
  real_T c6_b_inData[2];
  int32_T c6_i143;
  real_T c6_u[2];
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  for (c6_i142 = 0; c6_i142 < 2; c6_i142++) {
    c6_b_inData[c6_i142] = (*(real_T (*)[2])c6_inData)[c6_i142];
  }

  for (c6_i143 = 0; c6_i143 < 2; c6_i143++) {
    c6_u[c6_i143] = c6_b_inData[c6_i143];
  }

  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", c6_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static void c6_m_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId, real_T c6_y[2])
{
  real_T c6_dv17[2];
  int32_T c6_i144;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), c6_dv17, 1, 0, 0U, 1, 0U, 2, 1, 2);
  for (c6_i144 = 0; c6_i144 < 2; c6_i144++) {
    c6_y[c6_i144] = c6_dv17[c6_i144];
  }

  sf_mex_destroy(&c6_u);
}

static void c6_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_C_m;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  real_T c6_y[2];
  int32_T c6_i145;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_C_m = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_m_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_C_m), &c6_thisId, c6_y);
  sf_mex_destroy(&c6_C_m);
  for (c6_i145 = 0; c6_i145 < 2; c6_i145++) {
    (*(real_T (*)[2])c6_outData)[c6_i145] = c6_y[c6_i145];
  }

  sf_mex_destroy(&c6_mxArrayInData);
}

const mxArray *sf_c6_dp_mod_1_get_eml_resolved_functions_info(void)
{
  const mxArray *c6_nameCaptureInfo;
  c6_ResolvedFunctionInfo c6_info[42];
  const mxArray *c6_m0 = NULL;
  int32_T c6_i146;
  c6_ResolvedFunctionInfo *c6_r0;
  c6_nameCaptureInfo = NULL;
  c6_nameCaptureInfo = NULL;
  c6_info_helper(c6_info);
  sf_mex_assign(&c6_m0, sf_mex_createstruct("nameCaptureInfo", 1, 42), FALSE);
  for (c6_i146 = 0; c6_i146 < 42; c6_i146++) {
    c6_r0 = &c6_info[c6_i146];
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c6_r0->context)), "context", "nameCaptureInfo",
                    c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c6_r0->name)), "name", "nameCaptureInfo", c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c6_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", c6_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c6_r0->resolved)), "resolved", "nameCaptureInfo",
                    c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c6_i146);
    sf_mex_addfield(c6_m0, sf_mex_create("nameCaptureInfo", &c6_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c6_i146);
  }

  sf_mex_assign(&c6_nameCaptureInfo, c6_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c6_nameCaptureInfo);
  return c6_nameCaptureInfo;
}

static void c6_info_helper(c6_ResolvedFunctionInfo c6_info[42])
{
  c6_info[0].context = "";
  c6_info[0].name = "diag";
  c6_info[0].dominantType = "double";
  c6_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c6_info[0].fileTimeLo = 1286818686U;
  c6_info[0].fileTimeHi = 0U;
  c6_info[0].mFileTimeLo = 0U;
  c6_info[0].mFileTimeHi = 0U;
  c6_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c6_info[1].name = "eml_index_class";
  c6_info[1].dominantType = "";
  c6_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[1].fileTimeLo = 1323170578U;
  c6_info[1].fileTimeHi = 0U;
  c6_info[1].mFileTimeLo = 0U;
  c6_info[1].mFileTimeHi = 0U;
  c6_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c6_info[2].name = "eml_index_plus";
  c6_info[2].dominantType = "coder.internal.indexInt";
  c6_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c6_info[2].fileTimeLo = 1286818778U;
  c6_info[2].fileTimeHi = 0U;
  c6_info[2].mFileTimeLo = 0U;
  c6_info[2].mFileTimeHi = 0U;
  c6_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c6_info[3].name = "eml_index_class";
  c6_info[3].dominantType = "";
  c6_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[3].fileTimeLo = 1323170578U;
  c6_info[3].fileTimeHi = 0U;
  c6_info[3].mFileTimeLo = 0U;
  c6_info[3].mFileTimeHi = 0U;
  c6_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c6_info[4].name = "eml_scalar_eg";
  c6_info[4].dominantType = "double";
  c6_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[4].fileTimeLo = 1286818796U;
  c6_info[4].fileTimeHi = 0U;
  c6_info[4].mFileTimeLo = 0U;
  c6_info[4].mFileTimeHi = 0U;
  c6_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c6_info[5].name = "eml_int_forloop_overflow_check";
  c6_info[5].dominantType = "";
  c6_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c6_info[5].fileTimeLo = 1332168672U;
  c6_info[5].fileTimeHi = 0U;
  c6_info[5].mFileTimeLo = 0U;
  c6_info[5].mFileTimeHi = 0U;
  c6_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c6_info[6].name = "intmax";
  c6_info[6].dominantType = "char";
  c6_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c6_info[6].fileTimeLo = 1311255316U;
  c6_info[6].fileTimeHi = 0U;
  c6_info[6].mFileTimeLo = 0U;
  c6_info[6].mFileTimeHi = 0U;
  c6_info[7].context = "";
  c6_info[7].name = "mtimes";
  c6_info[7].dominantType = "double";
  c6_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[7].fileTimeLo = 1289519692U;
  c6_info[7].fileTimeHi = 0U;
  c6_info[7].mFileTimeLo = 0U;
  c6_info[7].mFileTimeHi = 0U;
  c6_info[8].context = "";
  c6_info[8].name = "mpower";
  c6_info[8].dominantType = "double";
  c6_info[8].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c6_info[8].fileTimeLo = 1286818842U;
  c6_info[8].fileTimeHi = 0U;
  c6_info[8].mFileTimeLo = 0U;
  c6_info[8].mFileTimeHi = 0U;
  c6_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c6_info[9].name = "power";
  c6_info[9].dominantType = "double";
  c6_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c6_info[9].fileTimeLo = 1336522096U;
  c6_info[9].fileTimeHi = 0U;
  c6_info[9].mFileTimeLo = 0U;
  c6_info[9].mFileTimeHi = 0U;
  c6_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c6_info[10].name = "eml_scalar_eg";
  c6_info[10].dominantType = "double";
  c6_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[10].fileTimeLo = 1286818796U;
  c6_info[10].fileTimeHi = 0U;
  c6_info[10].mFileTimeLo = 0U;
  c6_info[10].mFileTimeHi = 0U;
  c6_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c6_info[11].name = "eml_scalexp_alloc";
  c6_info[11].dominantType = "double";
  c6_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c6_info[11].fileTimeLo = 1330608434U;
  c6_info[11].fileTimeHi = 0U;
  c6_info[11].mFileTimeLo = 0U;
  c6_info[11].mFileTimeHi = 0U;
  c6_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c6_info[12].name = "floor";
  c6_info[12].dominantType = "double";
  c6_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c6_info[12].fileTimeLo = 1286818742U;
  c6_info[12].fileTimeHi = 0U;
  c6_info[12].mFileTimeLo = 0U;
  c6_info[12].mFileTimeHi = 0U;
  c6_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c6_info[13].name = "eml_scalar_floor";
  c6_info[13].dominantType = "double";
  c6_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c6_info[13].fileTimeLo = 1286818726U;
  c6_info[13].fileTimeHi = 0U;
  c6_info[13].mFileTimeLo = 0U;
  c6_info[13].mFileTimeHi = 0U;
  c6_info[14].context = "";
  c6_info[14].name = "abs";
  c6_info[14].dominantType = "double";
  c6_info[14].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c6_info[14].fileTimeLo = 1286818694U;
  c6_info[14].fileTimeHi = 0U;
  c6_info[14].mFileTimeLo = 0U;
  c6_info[14].mFileTimeHi = 0U;
  c6_info[15].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c6_info[15].name = "eml_scalar_abs";
  c6_info[15].dominantType = "double";
  c6_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c6_info[15].fileTimeLo = 1286818712U;
  c6_info[15].fileTimeHi = 0U;
  c6_info[15].mFileTimeLo = 0U;
  c6_info[15].mFileTimeHi = 0U;
  c6_info[16].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[16].name = "eml_index_class";
  c6_info[16].dominantType = "";
  c6_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[16].fileTimeLo = 1323170578U;
  c6_info[16].fileTimeHi = 0U;
  c6_info[16].mFileTimeLo = 0U;
  c6_info[16].mFileTimeHi = 0U;
  c6_info[17].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[17].name = "eml_scalar_eg";
  c6_info[17].dominantType = "double";
  c6_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[17].fileTimeLo = 1286818796U;
  c6_info[17].fileTimeHi = 0U;
  c6_info[17].mFileTimeLo = 0U;
  c6_info[17].mFileTimeHi = 0U;
  c6_info[18].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[18].name = "eml_xgemm";
  c6_info[18].dominantType = "char";
  c6_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c6_info[18].fileTimeLo = 1299076772U;
  c6_info[18].fileTimeHi = 0U;
  c6_info[18].mFileTimeLo = 0U;
  c6_info[18].mFileTimeHi = 0U;
  c6_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c6_info[19].name = "eml_blas_inline";
  c6_info[19].dominantType = "";
  c6_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c6_info[19].fileTimeLo = 1299076768U;
  c6_info[19].fileTimeHi = 0U;
  c6_info[19].mFileTimeLo = 0U;
  c6_info[19].mFileTimeHi = 0U;
  c6_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c6_info[20].name = "mtimes";
  c6_info[20].dominantType = "double";
  c6_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[20].fileTimeLo = 1289519692U;
  c6_info[20].fileTimeHi = 0U;
  c6_info[20].mFileTimeLo = 0U;
  c6_info[20].mFileTimeHi = 0U;
  c6_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c6_info[21].name = "eml_index_class";
  c6_info[21].dominantType = "";
  c6_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[21].fileTimeLo = 1323170578U;
  c6_info[21].fileTimeHi = 0U;
  c6_info[21].mFileTimeLo = 0U;
  c6_info[21].mFileTimeHi = 0U;
  c6_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c6_info[22].name = "eml_scalar_eg";
  c6_info[22].dominantType = "double";
  c6_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[22].fileTimeLo = 1286818796U;
  c6_info[22].fileTimeHi = 0U;
  c6_info[22].mFileTimeLo = 0U;
  c6_info[22].mFileTimeHi = 0U;
  c6_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c6_info[23].name = "eml_refblas_xgemm";
  c6_info[23].dominantType = "char";
  c6_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c6_info[23].fileTimeLo = 1299076774U;
  c6_info[23].fileTimeHi = 0U;
  c6_info[23].mFileTimeLo = 0U;
  c6_info[23].mFileTimeHi = 0U;
  c6_info[24].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c6_info[24].name = "eml_xdotu";
  c6_info[24].dominantType = "double";
  c6_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c6_info[24].fileTimeLo = 1299076772U;
  c6_info[24].fileTimeHi = 0U;
  c6_info[24].mFileTimeLo = 0U;
  c6_info[24].mFileTimeHi = 0U;
  c6_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c6_info[25].name = "eml_blas_inline";
  c6_info[25].dominantType = "";
  c6_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c6_info[25].fileTimeLo = 1299076768U;
  c6_info[25].fileTimeHi = 0U;
  c6_info[25].mFileTimeLo = 0U;
  c6_info[25].mFileTimeHi = 0U;
  c6_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c6_info[26].name = "eml_xdot";
  c6_info[26].dominantType = "double";
  c6_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c6_info[26].fileTimeLo = 1299076772U;
  c6_info[26].fileTimeHi = 0U;
  c6_info[26].mFileTimeLo = 0U;
  c6_info[26].mFileTimeHi = 0U;
  c6_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c6_info[27].name = "eml_blas_inline";
  c6_info[27].dominantType = "";
  c6_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c6_info[27].fileTimeLo = 1299076768U;
  c6_info[27].fileTimeHi = 0U;
  c6_info[27].mFileTimeLo = 0U;
  c6_info[27].mFileTimeHi = 0U;
  c6_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c6_info[28].name = "eml_index_class";
  c6_info[28].dominantType = "";
  c6_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[28].fileTimeLo = 1323170578U;
  c6_info[28].fileTimeHi = 0U;
  c6_info[28].mFileTimeLo = 0U;
  c6_info[28].mFileTimeHi = 0U;
  c6_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c6_info[29].name = "eml_refblas_xdot";
  c6_info[29].dominantType = "double";
  c6_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c6_info[29].fileTimeLo = 1299076772U;
  c6_info[29].fileTimeHi = 0U;
  c6_info[29].mFileTimeLo = 0U;
  c6_info[29].mFileTimeHi = 0U;
  c6_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c6_info[30].name = "eml_refblas_xdotx";
  c6_info[30].dominantType = "char";
  c6_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[30].fileTimeLo = 1299076774U;
  c6_info[30].fileTimeHi = 0U;
  c6_info[30].mFileTimeLo = 0U;
  c6_info[30].mFileTimeHi = 0U;
  c6_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[31].name = "eml_scalar_eg";
  c6_info[31].dominantType = "double";
  c6_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c6_info[31].fileTimeLo = 1286818796U;
  c6_info[31].fileTimeHi = 0U;
  c6_info[31].mFileTimeLo = 0U;
  c6_info[31].mFileTimeHi = 0U;
  c6_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[32].name = "eml_index_class";
  c6_info[32].dominantType = "";
  c6_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[32].fileTimeLo = 1323170578U;
  c6_info[32].fileTimeHi = 0U;
  c6_info[32].mFileTimeLo = 0U;
  c6_info[32].mFileTimeHi = 0U;
  c6_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[33].name = "eml_index_minus";
  c6_info[33].dominantType = "double";
  c6_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c6_info[33].fileTimeLo = 1286818778U;
  c6_info[33].fileTimeHi = 0U;
  c6_info[33].mFileTimeLo = 0U;
  c6_info[33].mFileTimeHi = 0U;
  c6_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c6_info[34].name = "eml_index_class";
  c6_info[34].dominantType = "";
  c6_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[34].fileTimeLo = 1323170578U;
  c6_info[34].fileTimeHi = 0U;
  c6_info[34].mFileTimeLo = 0U;
  c6_info[34].mFileTimeHi = 0U;
  c6_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[35].name = "eml_index_times";
  c6_info[35].dominantType = "coder.internal.indexInt";
  c6_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c6_info[35].fileTimeLo = 1286818780U;
  c6_info[35].fileTimeHi = 0U;
  c6_info[35].mFileTimeLo = 0U;
  c6_info[35].mFileTimeHi = 0U;
  c6_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c6_info[36].name = "eml_index_class";
  c6_info[36].dominantType = "";
  c6_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c6_info[36].fileTimeLo = 1323170578U;
  c6_info[36].fileTimeHi = 0U;
  c6_info[36].mFileTimeLo = 0U;
  c6_info[36].mFileTimeHi = 0U;
  c6_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[37].name = "eml_index_plus";
  c6_info[37].dominantType = "coder.internal.indexInt";
  c6_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c6_info[37].fileTimeLo = 1286818778U;
  c6_info[37].fileTimeHi = 0U;
  c6_info[37].mFileTimeLo = 0U;
  c6_info[37].mFileTimeHi = 0U;
  c6_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c6_info[38].name = "eml_int_forloop_overflow_check";
  c6_info[38].dominantType = "";
  c6_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c6_info[38].fileTimeLo = 1332168672U;
  c6_info[38].fileTimeHi = 0U;
  c6_info[38].mFileTimeLo = 0U;
  c6_info[38].mFileTimeHi = 0U;
  c6_info[39].context = "";
  c6_info[39].name = "mrdivide";
  c6_info[39].dominantType = "double";
  c6_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c6_info[39].fileTimeLo = 1342810944U;
  c6_info[39].fileTimeHi = 0U;
  c6_info[39].mFileTimeLo = 1319729966U;
  c6_info[39].mFileTimeHi = 0U;
  c6_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c6_info[40].name = "rdivide";
  c6_info[40].dominantType = "double";
  c6_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c6_info[40].fileTimeLo = 1286818844U;
  c6_info[40].fileTimeHi = 0U;
  c6_info[40].mFileTimeLo = 0U;
  c6_info[40].mFileTimeHi = 0U;
  c6_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c6_info[41].name = "eml_div";
  c6_info[41].dominantType = "double";
  c6_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c6_info[41].fileTimeLo = 1313347810U;
  c6_info[41].fileTimeHi = 0U;
  c6_info[41].mFileTimeLo = 0U;
  c6_info[41].mFileTimeHi = 0U;
}

static void c6_check_forloop_overflow_error(SFc6_dp_mod_1InstanceStruct
  *chartInstance)
{
}

static real_T c6_mpower(SFc6_dp_mod_1InstanceStruct *chartInstance, real_T c6_a)
{
  real_T c6_b_a;
  real_T c6_c_a;
  real_T c6_ak;
  c6_b_a = c6_a;
  c6_c_a = c6_b_a;
  c6_ak = c6_c_a;
  return muDoubleScalarPower(c6_ak, 2.0);
}

static real_T c6_abs(SFc6_dp_mod_1InstanceStruct *chartInstance, real_T c6_x)
{
  real_T c6_b_x;
  c6_b_x = c6_x;
  return muDoubleScalarAbs(c6_b_x);
}

static void c6_eml_scalar_eg(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
}

static void c6_b_eml_scalar_eg(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
}

static const mxArray *c6_j_sf_marshallOut(void *chartInstanceVoid, void
  *c6_inData)
{
  const mxArray *c6_mxArrayOutData = NULL;
  int32_T c6_u;
  const mxArray *c6_y = NULL;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_mxArrayOutData = NULL;
  c6_u = *(int32_T *)c6_inData;
  c6_y = NULL;
  sf_mex_assign(&c6_y, sf_mex_create("y", &c6_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c6_mxArrayOutData, c6_y, FALSE);
  return c6_mxArrayOutData;
}

static int32_T c6_n_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  int32_T c6_y;
  int32_T c6_i147;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_i147, 1, 6, 0U, 0, 0U, 0);
  c6_y = c6_i147;
  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void c6_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c6_mxArrayInData, const char_T *c6_varName, void *c6_outData)
{
  const mxArray *c6_b_sfEvent;
  const char_T *c6_identifier;
  emlrtMsgIdentifier c6_thisId;
  int32_T c6_y;
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)chartInstanceVoid;
  c6_b_sfEvent = sf_mex_dup(c6_mxArrayInData);
  c6_identifier = c6_varName;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c6_b_sfEvent),
    &c6_thisId);
  sf_mex_destroy(&c6_b_sfEvent);
  *(int32_T *)c6_outData = c6_y;
  sf_mex_destroy(&c6_mxArrayInData);
}

static uint8_T c6_o_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_b_is_active_c6_dp_mod_1, const char_T *c6_identifier)
{
  uint8_T c6_y;
  emlrtMsgIdentifier c6_thisId;
  c6_thisId.fIdentifier = c6_identifier;
  c6_thisId.fParent = NULL;
  c6_y = c6_p_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c6_b_is_active_c6_dp_mod_1), &c6_thisId);
  sf_mex_destroy(&c6_b_is_active_c6_dp_mod_1);
  return c6_y;
}

static uint8_T c6_p_emlrt_marshallIn(SFc6_dp_mod_1InstanceStruct *chartInstance,
  const mxArray *c6_u, const emlrtMsgIdentifier *c6_parentId)
{
  uint8_T c6_y;
  uint8_T c6_u0;
  sf_mex_import(c6_parentId, sf_mex_dup(c6_u), &c6_u0, 1, 3, 0U, 0, 0U, 0);
  c6_y = c6_u0;
  sf_mex_destroy(&c6_u);
  return c6_y;
}

static void init_dsm_address_info(SFc6_dp_mod_1InstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c6_dp_mod_1_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2308030277U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3318010017U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(448380891U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1808005799U);
}

mxArray *sf_c6_dp_mod_1_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("c2xiVrEwx5aXa6Ryhv1MxF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,8,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c6_dp_mod_1(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x10'type','srcId','name','auxInfo'{{M[1],M[28],T\"Fm_dot\",},{M[1],M[31],T\"M\",},{M[1],M[18],T\"R_m\",},{M[1],M[17],T\"Z_m\",},{M[1],M[23],T\"k_m_fc\",},{M[1],M[19],T\"k_m_r\",},{M[1],M[11],T\"xm_dot\",},{M[1],M[10],T\"ym\",},{M[4],M[0],T\"first\",S'l','i','p'{{M1x2[238 243],M[0],}}},{M[4],M[0],T\"flag\",S'l','i','p'{{M1x2[244 248],M[0],}}}}",
    "100 S'type','srcId','name','auxInfo'{{M[8],M[0],T\"is_active_c6_dp_mod_1\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 11, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c6_dp_mod_1_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc6_dp_mod_1InstanceStruct *chartInstance;
    chartInstance = (SFc6_dp_mod_1InstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_dp_mod_1MachineNumber_,
          6,
          1,
          1,
          14,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_dp_mod_1MachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_dp_mod_1MachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_dp_mod_1MachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"xm_dot");
          _SFD_SET_DATA_PROPS(1,2,0,1,"Fm_dot");
          _SFD_SET_DATA_PROPS(2,1,1,0,"y0");
          _SFD_SET_DATA_PROPS(3,1,1,0,"F0");
          _SFD_SET_DATA_PROPS(4,1,1,0,"r");
          _SFD_SET_DATA_PROPS(5,1,1,0,"D_e");
          _SFD_SET_DATA_PROPS(6,1,1,0,"M_e");
          _SFD_SET_DATA_PROPS(7,1,1,0,"F_C");
          _SFD_SET_DATA_PROPS(8,2,0,1,"ym");
          _SFD_SET_DATA_PROPS(9,2,0,1,"Z_m");
          _SFD_SET_DATA_PROPS(10,2,0,1,"R_m");
          _SFD_SET_DATA_PROPS(11,2,0,1,"k_m_r");
          _SFD_SET_DATA_PROPS(12,2,0,1,"k_m_fc");
          _SFD_SET_DATA_PROPS(13,2,0,1,"M");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,5,0,0,0,1,0,4,2);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,3035);
        _SFD_CV_INIT_EML_IF(0,1,0,258,275,-1,383);
        _SFD_CV_INIT_EML_IF(0,1,1,1337,1348,2732,3022);
        _SFD_CV_INIT_EML_IF(0,1,2,1361,1380,1732,2723);
        _SFD_CV_INIT_EML_IF(0,1,3,1732,1772,2090,2723);
        _SFD_CV_INIT_EML_IF(0,1,4,2090,2129,2435,2723);
        _SFD_CV_INIT_EML_FOR(0,1,0,1130,1142,3031);

        {
          static int condStart[] = { 1739, 1760 };

          static int condEnd[] = { 1756, 1772 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,1739,1772,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 2097, 2117 };

          static int condEnd[] = { 2113, 2129 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,2097,2129,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_e_sf_marshallOut,(MexInFcnForType)
            c6_e_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_e_sf_marshallOut,(MexInFcnForType)
            c6_e_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_e_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_e_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)
            c6_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)
            c6_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)
            c6_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)
            c6_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_d_sf_marshallOut,(MexInFcnForType)
            c6_c_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c6_c_sf_marshallOut,(MexInFcnForType)
            c6_d_sf_marshallIn);
        }

        {
          real_T (*c6_xm_dot)[6];
          real_T (*c6_Fm_dot)[6];
          real_T (*c6_y0)[6];
          real_T (*c6_F0)[6];
          real_T (*c6_r)[3];
          real_T (*c6_D_e)[9];
          real_T (*c6_M_e)[9];
          real_T (*c6_F_C)[3];
          real_T (*c6_ym)[3];
          real_T (*c6_Z_m)[3];
          real_T (*c6_R_m)[9];
          real_T (*c6_k_m_r)[3];
          real_T (*c6_k_m_fc)[3];
          real_T (*c6_M)[9];
          c6_M = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 8);
          c6_k_m_fc = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
          c6_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 6);
          c6_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 5);
          c6_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
          c6_ym = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
          c6_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
          c6_M_e = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 4);
          c6_D_e = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 3);
          c6_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
          c6_F0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
          c6_y0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          c6_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
          c6_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, *c6_xm_dot);
          _SFD_SET_DATA_VALUE_PTR(1U, *c6_Fm_dot);
          _SFD_SET_DATA_VALUE_PTR(2U, *c6_y0);
          _SFD_SET_DATA_VALUE_PTR(3U, *c6_F0);
          _SFD_SET_DATA_VALUE_PTR(4U, *c6_r);
          _SFD_SET_DATA_VALUE_PTR(5U, *c6_D_e);
          _SFD_SET_DATA_VALUE_PTR(6U, *c6_M_e);
          _SFD_SET_DATA_VALUE_PTR(7U, *c6_F_C);
          _SFD_SET_DATA_VALUE_PTR(8U, *c6_ym);
          _SFD_SET_DATA_VALUE_PTR(9U, *c6_Z_m);
          _SFD_SET_DATA_VALUE_PTR(10U, *c6_R_m);
          _SFD_SET_DATA_VALUE_PTR(11U, *c6_k_m_r);
          _SFD_SET_DATA_VALUE_PTR(12U, *c6_k_m_fc);
          _SFD_SET_DATA_VALUE_PTR(13U, *c6_M);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_dp_mod_1MachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "o6C6xDYBfOysPmrLz8jLrE";
}

static void sf_opaque_initialize_c6_dp_mod_1(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
  initialize_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c6_dp_mod_1(void *chartInstanceVar)
{
  enable_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c6_dp_mod_1(void *chartInstanceVar)
{
  disable_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c6_dp_mod_1(void *chartInstanceVar)
{
  sf_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c6_dp_mod_1(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c6_dp_mod_1();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c6_dp_mod_1(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c6_dp_mod_1();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c6_dp_mod_1(SimStruct* S)
{
  return sf_internal_get_sim_state_c6_dp_mod_1(S);
}

static void sf_opaque_set_sim_state_c6_dp_mod_1(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c6_dp_mod_1(S, st);
}

static void sf_opaque_terminate_c6_dp_mod_1(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_dp_mod_1_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c6_dp_mod_1(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c6_dp_mod_1((SFc6_dp_mod_1InstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c6_dp_mod_1(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_dp_mod_1_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      6);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,6,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,6,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,6,6);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,6,8);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,6);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2371537243U));
  ssSetChecksum1(S,(2880992927U));
  ssSetChecksum2(S,(1317528482U));
  ssSetChecksum3(S,(232908787U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c6_dp_mod_1(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c6_dp_mod_1(SimStruct *S)
{
  SFc6_dp_mod_1InstanceStruct *chartInstance;
  chartInstance = (SFc6_dp_mod_1InstanceStruct *)malloc(sizeof
    (SFc6_dp_mod_1InstanceStruct));
  memset(chartInstance, 0, sizeof(SFc6_dp_mod_1InstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c6_dp_mod_1;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c6_dp_mod_1;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c6_dp_mod_1;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c6_dp_mod_1;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c6_dp_mod_1;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c6_dp_mod_1;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c6_dp_mod_1;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c6_dp_mod_1;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c6_dp_mod_1;
  chartInstance->chartInfo.mdlStart = mdlStart_c6_dp_mod_1;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c6_dp_mod_1;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c6_dp_mod_1_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c6_dp_mod_1(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c6_dp_mod_1(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c6_dp_mod_1(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c6_dp_mod_1_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
