/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c10_Controller.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c10_debug_family_names[25] = { "theta_1", "theta_2",
  "theta_3", "c_0", "omega1_dot", "omega2_dot", "omega3_dot", "nu_c", "D_e_hat",
  "theta", "omega", "nargin", "nargout", "frc_ctrl", "eta_p", "F_C", "r", "F",
  "g", "F_R", "theta_e_hat", "theta_ctrl_r_hat", "omega0", "F_T", "omega0_dot" };

/* Function Declarations */
static void initialize_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance);
static void enable_c10_Controller(SFc10_ControllerInstanceStruct *chartInstance);
static void disable_c10_Controller(SFc10_ControllerInstanceStruct *chartInstance);
static void c10_update_debugger_state_c10_Controller
  (SFc10_ControllerInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c10_Controller
  (SFc10_ControllerInstanceStruct *chartInstance);
static void set_sim_state_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_st);
static void finalize_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance);
static void sf_c10_Controller(SFc10_ControllerInstanceStruct *chartInstance);
static void c10_chartstep_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance);
static void initSimStructsc10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber);
static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_omega0_dot, const char_T *c10_identifier, real_T c10_y[9]);
static void c10_b_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[9]);
static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_c_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_F_T, const char_T *c10_identifier, real_T c10_y[3]);
static void c10_d_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[3]);
static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static const mxArray *c10_d_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static const mxArray *c10_e_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static const mxArray *c10_f_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static real_T c10_e_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static const mxArray *c10_g_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static void c10_f_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[4]);
static void c10_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static void c10_g_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[3]);
static void c10_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static void c10_info_helper(c10_ResolvedFunctionInfo c10_info[22]);
static void c10_eml_scalar_eg(SFc10_ControllerInstanceStruct *chartInstance);
static void c10_check_forloop_overflow_error(SFc10_ControllerInstanceStruct
  *chartInstance);
static const mxArray *c10_h_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData);
static int32_T c10_h_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void c10_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData);
static uint8_T c10_i_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_b_is_active_c10_Controller, const char_T
  *c10_identifier);
static uint8_T c10_j_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId);
static void init_dsm_address_info(SFc10_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c10_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c10_is_active_c10_Controller = 0U;
}

static void initialize_params_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c10_Controller(SFc10_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c10_Controller(SFc10_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c10_update_debugger_state_c10_Controller
  (SFc10_ControllerInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c10_Controller
  (SFc10_ControllerInstanceStruct *chartInstance)
{
  const mxArray *c10_st;
  const mxArray *c10_y = NULL;
  int32_T c10_i0;
  real_T c10_u[3];
  const mxArray *c10_b_y = NULL;
  int32_T c10_i1;
  real_T c10_b_u[9];
  const mxArray *c10_c_y = NULL;
  uint8_T c10_hoistedGlobal;
  uint8_T c10_c_u;
  const mxArray *c10_d_y = NULL;
  real_T (*c10_omega0_dot)[9];
  real_T (*c10_F_T)[3];
  c10_omega0_dot = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_F_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_st = NULL;
  c10_st = NULL;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_createcellarray(3), FALSE);
  for (c10_i0 = 0; c10_i0 < 3; c10_i0++) {
    c10_u[c10_i0] = (*c10_F_T)[c10_i0];
  }

  c10_b_y = NULL;
  sf_mex_assign(&c10_b_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c10_y, 0, c10_b_y);
  for (c10_i1 = 0; c10_i1 < 9; c10_i1++) {
    c10_b_u[c10_i1] = (*c10_omega0_dot)[c10_i1];
  }

  c10_c_y = NULL;
  sf_mex_assign(&c10_c_y, sf_mex_create("y", c10_b_u, 0, 0U, 1U, 0U, 2, 3, 3),
                FALSE);
  sf_mex_setcell(c10_y, 1, c10_c_y);
  c10_hoistedGlobal = chartInstance->c10_is_active_c10_Controller;
  c10_c_u = c10_hoistedGlobal;
  c10_d_y = NULL;
  sf_mex_assign(&c10_d_y, sf_mex_create("y", &c10_c_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c10_y, 2, c10_d_y);
  sf_mex_assign(&c10_st, c10_y, FALSE);
  return c10_st;
}

static void set_sim_state_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_st)
{
  const mxArray *c10_u;
  real_T c10_dv0[3];
  int32_T c10_i2;
  real_T c10_dv1[9];
  int32_T c10_i3;
  real_T (*c10_F_T)[3];
  real_T (*c10_omega0_dot)[9];
  c10_omega0_dot = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_F_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c10_doneDoubleBufferReInit = TRUE;
  c10_u = sf_mex_dup(c10_st);
  c10_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 0)),
    "F_T", c10_dv0);
  for (c10_i2 = 0; c10_i2 < 3; c10_i2++) {
    (*c10_F_T)[c10_i2] = c10_dv0[c10_i2];
  }

  c10_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 1)),
                       "omega0_dot", c10_dv1);
  for (c10_i3 = 0; c10_i3 < 9; c10_i3++) {
    (*c10_omega0_dot)[c10_i3] = c10_dv1[c10_i3];
  }

  chartInstance->c10_is_active_c10_Controller = c10_i_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c10_u, 2)),
     "is_active_c10_Controller");
  sf_mex_destroy(&c10_u);
  c10_update_debugger_state_c10_Controller(chartInstance);
  sf_mex_destroy(&c10_st);
}

static void finalize_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance)
{
}

static void sf_c10_Controller(SFc10_ControllerInstanceStruct *chartInstance)
{
  int32_T c10_i4;
  int32_T c10_i5;
  int32_T c10_i6;
  int32_T c10_i7;
  int32_T c10_i8;
  int32_T c10_i9;
  int32_T c10_i10;
  int32_T c10_i11;
  int32_T c10_i12;
  int32_T c10_i13;
  real_T *c10_F;
  real_T *c10_g;
  real_T (*c10_omega0_dot)[9];
  real_T (*c10_omega0)[9];
  real_T (*c10_theta_ctrl_r_hat)[12];
  real_T (*c10_theta_e_hat)[18];
  real_T (*c10_F_R)[3];
  real_T (*c10_r)[3];
  real_T (*c10_F_T)[3];
  real_T (*c10_F_C)[3];
  real_T (*c10_eta_p)[3];
  real_T (*c10_frc_ctrl)[3];
  c10_omega0_dot = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_omega0 = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 9);
  c10_theta_ctrl_r_hat = (real_T (*)[12])ssGetInputPortSignal(chartInstance->S,
    8);
  c10_theta_e_hat = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S, 7);
  c10_F_R = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c10_g = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c10_F = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c10_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c10_F_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c10_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c10_frc_ctrl = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 8U, chartInstance->c10_sfEvent);
  for (c10_i4 = 0; c10_i4 < 3; c10_i4++) {
    _SFD_DATA_RANGE_CHECK((*c10_frc_ctrl)[c10_i4], 0U);
  }

  for (c10_i5 = 0; c10_i5 < 3; c10_i5++) {
    _SFD_DATA_RANGE_CHECK((*c10_eta_p)[c10_i5], 1U);
  }

  for (c10_i6 = 0; c10_i6 < 3; c10_i6++) {
    _SFD_DATA_RANGE_CHECK((*c10_F_C)[c10_i6], 2U);
  }

  for (c10_i7 = 0; c10_i7 < 3; c10_i7++) {
    _SFD_DATA_RANGE_CHECK((*c10_F_T)[c10_i7], 3U);
  }

  for (c10_i8 = 0; c10_i8 < 3; c10_i8++) {
    _SFD_DATA_RANGE_CHECK((*c10_r)[c10_i8], 4U);
  }

  _SFD_DATA_RANGE_CHECK(*c10_F, 5U);
  _SFD_DATA_RANGE_CHECK(*c10_g, 6U);
  for (c10_i9 = 0; c10_i9 < 3; c10_i9++) {
    _SFD_DATA_RANGE_CHECK((*c10_F_R)[c10_i9], 7U);
  }

  for (c10_i10 = 0; c10_i10 < 18; c10_i10++) {
    _SFD_DATA_RANGE_CHECK((*c10_theta_e_hat)[c10_i10], 8U);
  }

  for (c10_i11 = 0; c10_i11 < 12; c10_i11++) {
    _SFD_DATA_RANGE_CHECK((*c10_theta_ctrl_r_hat)[c10_i11], 9U);
  }

  for (c10_i12 = 0; c10_i12 < 9; c10_i12++) {
    _SFD_DATA_RANGE_CHECK((*c10_omega0)[c10_i12], 10U);
  }

  for (c10_i13 = 0; c10_i13 < 9; c10_i13++) {
    _SFD_DATA_RANGE_CHECK((*c10_omega0_dot)[c10_i13], 11U);
  }

  chartInstance->c10_sfEvent = CALL_EVENT;
  c10_chartstep_c10_Controller(chartInstance);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c10_chartstep_c10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance)
{
  real_T c10_hoistedGlobal;
  real_T c10_b_hoistedGlobal;
  int32_T c10_i14;
  real_T c10_frc_ctrl[3];
  int32_T c10_i15;
  real_T c10_eta_p[3];
  int32_T c10_i16;
  real_T c10_F_C[3];
  int32_T c10_i17;
  real_T c10_r[3];
  real_T c10_F;
  real_T c10_g;
  int32_T c10_i18;
  real_T c10_F_R[3];
  int32_T c10_i19;
  real_T c10_theta_e_hat[18];
  int32_T c10_i20;
  real_T c10_theta_ctrl_r_hat[12];
  int32_T c10_i21;
  real_T c10_omega0[9];
  uint32_T c10_debug_family_var_map[25];
  real_T c10_theta_1[3];
  real_T c10_theta_2[3];
  real_T c10_theta_3[3];
  real_T c10_c_0[3];
  real_T c10_omega1_dot[3];
  real_T c10_omega2_dot[3];
  real_T c10_omega3_dot[3];
  real_T c10_nu_c;
  real_T c10_D_e_hat[9];
  real_T c10_theta[4];
  real_T c10_omega[4];
  real_T c10_nargin = 10.0;
  real_T c10_nargout = 2.0;
  real_T c10_F_T[3];
  real_T c10_omega0_dot[9];
  int32_T c10_i22;
  int32_T c10_i23;
  int32_T c10_i24;
  int32_T c10_i25;
  int32_T c10_i26;
  int32_T c10_i27;
  int32_T c10_i28;
  int32_T c10_i29;
  int32_T c10_i30;
  int32_T c10_i31;
  int32_T c10_i32;
  int32_T c10_i;
  real_T c10_b_i;
  real_T c10_b_theta_1[4];
  int32_T c10_i33;
  real_T c10_x[4];
  real_T c10_y;
  real_T c10_b_y;
  int32_T c10_i34;
  real_T c10_b_omega0[4];
  int32_T c10_i35;
  real_T c10_c_theta_1[4];
  int32_T c10_i36;
  real_T c10_c_omega0[4];
  int32_T c10_i37;
  int32_T c10_i38;
  real_T c10_a[4];
  int32_T c10_i39;
  real_T c10_c_y;
  int32_T c10_k;
  int32_T c10_b_k;
  int32_T c10_c_i;
  real_T c10_b_a;
  real_T c10_b;
  real_T c10_d_y;
  real_T c10_b_b;
  real_T c10_e_y;
  real_T c10_c_a;
  real_T c10_c_b;
  real_T c10_f_y;
  real_T c10_d_a;
  real_T c10_d_b;
  real_T c10_g_y;
  real_T c10_e_a;
  real_T c10_e_b;
  real_T c10_h_y;
  real_T c10_f_a;
  real_T c10_f_b;
  real_T c10_i_y;
  real_T c10_g_a;
  real_T c10_g_b;
  real_T c10_j_y;
  real_T c10_h_a;
  real_T c10_h_b;
  real_T c10_k_y;
  real_T c10_i_a;
  real_T c10_i_b;
  real_T c10_l_y;
  int32_T c10_i40;
  int32_T c10_i41;
  int32_T c10_i42;
  int32_T c10_i43;
  int32_T c10_i44;
  int32_T c10_i45;
  int32_T c10_i46;
  int32_T c10_i47;
  real_T *c10_b_F;
  real_T *c10_b_g;
  real_T (*c10_b_F_T)[3];
  real_T (*c10_b_omega0_dot)[9];
  real_T (*c10_d_omega0)[9];
  real_T (*c10_b_theta_ctrl_r_hat)[12];
  real_T (*c10_b_theta_e_hat)[18];
  real_T (*c10_b_F_R)[3];
  real_T (*c10_b_r)[3];
  real_T (*c10_b_F_C)[3];
  real_T (*c10_b_eta_p)[3];
  real_T (*c10_b_frc_ctrl)[3];
  c10_b_omega0_dot = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 2);
  c10_d_omega0 = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 9);
  c10_b_theta_ctrl_r_hat = (real_T (*)[12])ssGetInputPortSignal(chartInstance->S,
    8);
  c10_b_theta_e_hat = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S, 7);
  c10_b_F_R = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c10_b_g = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c10_b_F = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c10_b_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c10_b_F_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c10_b_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c10_b_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c10_b_frc_ctrl = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 8U, chartInstance->c10_sfEvent);
  c10_hoistedGlobal = *c10_b_F;
  c10_b_hoistedGlobal = *c10_b_g;
  for (c10_i14 = 0; c10_i14 < 3; c10_i14++) {
    c10_frc_ctrl[c10_i14] = (*c10_b_frc_ctrl)[c10_i14];
  }

  for (c10_i15 = 0; c10_i15 < 3; c10_i15++) {
    c10_eta_p[c10_i15] = (*c10_b_eta_p)[c10_i15];
  }

  for (c10_i16 = 0; c10_i16 < 3; c10_i16++) {
    c10_F_C[c10_i16] = (*c10_b_F_C)[c10_i16];
  }

  for (c10_i17 = 0; c10_i17 < 3; c10_i17++) {
    c10_r[c10_i17] = (*c10_b_r)[c10_i17];
  }

  c10_F = c10_hoistedGlobal;
  c10_g = c10_b_hoistedGlobal;
  for (c10_i18 = 0; c10_i18 < 3; c10_i18++) {
    c10_F_R[c10_i18] = (*c10_b_F_R)[c10_i18];
  }

  for (c10_i19 = 0; c10_i19 < 18; c10_i19++) {
    c10_theta_e_hat[c10_i19] = (*c10_b_theta_e_hat)[c10_i19];
  }

  for (c10_i20 = 0; c10_i20 < 12; c10_i20++) {
    c10_theta_ctrl_r_hat[c10_i20] = (*c10_b_theta_ctrl_r_hat)[c10_i20];
  }

  for (c10_i21 = 0; c10_i21 < 9; c10_i21++) {
    c10_omega0[c10_i21] = (*c10_d_omega0)[c10_i21];
  }

  sf_debug_symbol_scope_push_eml(0U, 25U, 25U, c10_debug_family_names,
    c10_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c10_theta_1, 0U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_theta_2, 1U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_theta_3, 2U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_c_0, 3U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_omega1_dot, 4U,
    c10_f_sf_marshallOut, c10_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_omega2_dot, 5U,
    c10_f_sf_marshallOut, c10_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_omega3_dot, 6U,
    c10_f_sf_marshallOut, c10_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c10_nu_c, 7U, c10_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c10_D_e_hat, 8U, c10_sf_marshallOut,
    c10_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_theta, 9U, c10_g_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_omega, 10U, c10_g_sf_marshallOut,
    c10_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargin, 11U,
    c10_e_sf_marshallOut, c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c10_nargout, 12U,
    c10_e_sf_marshallOut, c10_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c10_frc_ctrl, 13U, c10_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_eta_p, 14U, c10_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_F_C, 15U, c10_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_r, 16U, c10_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c10_F, 17U, c10_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c10_g, 18U, c10_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_F_R, 19U, c10_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_theta_e_hat, 20U, c10_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_theta_ctrl_r_hat, 21U, c10_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c10_omega0, 22U, c10_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c10_F_T, 23U, c10_b_sf_marshallOut,
    c10_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c10_omega0_dot, 24U,
    c10_sf_marshallOut, c10_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 4);
  for (c10_i22 = 0; c10_i22 < 3; c10_i22++) {
    c10_theta_1[c10_i22] = c10_theta_ctrl_r_hat[c10_i22];
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 5);
  for (c10_i23 = 0; c10_i23 < 3; c10_i23++) {
    c10_theta_2[c10_i23] = c10_theta_ctrl_r_hat[c10_i23 + 3];
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 6);
  for (c10_i24 = 0; c10_i24 < 3; c10_i24++) {
    c10_theta_3[c10_i24] = c10_theta_ctrl_r_hat[c10_i24 + 6];
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 7);
  for (c10_i25 = 0; c10_i25 < 3; c10_i25++) {
    c10_c_0[c10_i25] = c10_theta_ctrl_r_hat[c10_i25 + 9];
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 9);
  for (c10_i26 = 0; c10_i26 < 3; c10_i26++) {
    c10_F_T[c10_i26] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 10);
  for (c10_i27 = 0; c10_i27 < 3; c10_i27++) {
    c10_omega1_dot[c10_i27] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 11);
  for (c10_i28 = 0; c10_i28 < 3; c10_i28++) {
    c10_omega2_dot[c10_i28] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 12);
  for (c10_i29 = 0; c10_i29 < 3; c10_i29++) {
    c10_omega3_dot[c10_i29] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 15);
  c10_nu_c = -0.1;
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 16);
  c10_i30 = 0;
  for (c10_i31 = 0; c10_i31 < 3; c10_i31++) {
    for (c10_i32 = 0; c10_i32 < 3; c10_i32++) {
      c10_D_e_hat[c10_i32 + c10_i30] = c10_theta_e_hat[(c10_i32 + c10_i30) + 9];
    }

    c10_i30 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 19);
  c10_i = 0;
  while (c10_i < 3) {
    c10_b_i = 1.0 + (real_T)c10_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 21);
    if (CV_EML_IF(0, 1, 0, c10_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl",
          (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1] == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 24);
      c10_b_theta_1[0] = c10_theta_1[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_1",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_b_theta_1[1] = c10_theta_2[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_2",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_b_theta_1[2] = c10_theta_3[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_3",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_b_theta_1[3] = c10_c_0[_SFD_EML_ARRAY_BOUNDS_CHECK("c_0", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      for (c10_i33 = 0; c10_i33 < 4; c10_i33++) {
        c10_x[c10_i33] = c10_b_theta_1[c10_i33];
      }

      c10_y = c10_c_0[_SFD_EML_ARRAY_BOUNDS_CHECK("c_0", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_b_y = c10_y;
      for (c10_i34 = 0; c10_i34 < 4; c10_i34++) {
        c10_theta[c10_i34] = c10_x[c10_i34] / c10_b_y;
      }

      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 25);
      c10_b_omega0[0] = c10_omega0[3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
      c10_b_omega0[1] = c10_omega0[2 + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
      c10_b_omega0[2] = c10_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_b_omega0[3] = c10_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      for (c10_i35 = 0; c10_i35 < 4; c10_i35++) {
        c10_omega[c10_i35] = c10_b_omega0[c10_i35];
      }
    } else {
      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 30);
      c10_c_theta_1[0] = c10_theta_1[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_1",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_c_theta_1[1] = c10_theta_2[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_2",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_c_theta_1[2] = c10_theta_3[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_3",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_c_theta_1[3] = c10_c_0[_SFD_EML_ARRAY_BOUNDS_CHECK("c_0", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      for (c10_i36 = 0; c10_i36 < 4; c10_i36++) {
        c10_theta[c10_i36] = c10_c_theta_1[c10_i36];
      }

      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 31);
      c10_c_omega0[0] = c10_omega0[3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
      c10_c_omega0[1] = c10_omega0[1 + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0",
        (int32_T)_SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
      c10_c_omega0[2] = c10_eta_p[_SFD_EML_ARRAY_BOUNDS_CHECK("eta_p", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_c_omega0[3] = c10_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      for (c10_i37 = 0; c10_i37 < 4; c10_i37++) {
        c10_omega[c10_i37] = c10_c_omega0[c10_i37];
      }
    }

    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 35);
    for (c10_i38 = 0; c10_i38 < 4; c10_i38++) {
      c10_a[c10_i38] = c10_theta[c10_i38];
    }

    for (c10_i39 = 0; c10_i39 < 4; c10_i39++) {
      c10_x[c10_i39] = c10_omega[c10_i39];
    }

    c10_eml_scalar_eg(chartInstance);
    c10_eml_scalar_eg(chartInstance);
    c10_c_y = 0.0;
    c10_check_forloop_overflow_error(chartInstance);
    for (c10_k = 1; c10_k < 5; c10_k++) {
      c10_b_k = c10_k;
      c10_c_y += c10_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
        _SFD_INTEGER_CHECK("", (real_T)c10_b_k), 1, 4, 1, 0) - 1] *
        c10_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c10_b_k), 1, 4, 1, 0) - 1];
    }

    c10_F_T[_SFD_EML_ARRAY_BOUNDS_CHECK("F_T", (int32_T)_SFD_INTEGER_CHECK("i",
      c10_b_i), 1, 3, 1, 0) - 1] = c10_c_y;
    c10_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 40);
  c10_c_i = 0;
  while (c10_c_i < 3) {
    c10_b_i = 1.0 + (real_T)c10_c_i;
    CV_EML_FOR(0, 1, 1, 1);
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 43);
    if (CV_EML_IF(0, 1, 1, c10_b_i == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 45);
      c10_b_a = c10_F;
      c10_b = c10_omega0[3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
      c10_d_y = c10_b_a * c10_b;
      c10_b_b = c10_D_e_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("D_e_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) + 3 *
        (_SFD_EML_ARRAY_BOUNDS_CHECK("D_e_hat", (int32_T)_SFD_INTEGER_CHECK("i",
        c10_b_i), 1, 3, 2, 0) - 1)) - 1];
      c10_e_y = -0.1 * c10_b_b;
      c10_c_a = c10_g;
      c10_c_b = c10_F_T[_SFD_EML_ARRAY_BOUNDS_CHECK("F_T", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1] + c10_e_y;
      c10_f_y = c10_c_a * c10_c_b;
      c10_omega1_dot[_SFD_EML_ARRAY_BOUNDS_CHECK("omega1_dot", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1] = c10_d_y + c10_f_y;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 47);
      c10_d_a = c10_F;
      c10_d_b = c10_omega0[3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
      c10_g_y = c10_d_a * c10_d_b;
      c10_e_a = c10_g;
      c10_e_b = c10_F_T[_SFD_EML_ARRAY_BOUNDS_CHECK("F_T", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
      c10_h_y = c10_e_a * c10_e_b;
      c10_omega1_dot[_SFD_EML_ARRAY_BOUNDS_CHECK("omega1_dot", (int32_T)
        _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1] = c10_g_y + c10_h_y;
    }

    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 51);
    c10_f_a = c10_F;
    c10_f_b = c10_omega0[1 + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0", (int32_T)
      _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
    c10_i_y = c10_f_a * c10_f_b;
    c10_g_a = c10_g;
    c10_g_b = c10_eta_p[_SFD_EML_ARRAY_BOUNDS_CHECK("eta_p", (int32_T)
      _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
    c10_j_y = c10_g_a * c10_g_b;
    c10_omega2_dot[_SFD_EML_ARRAY_BOUNDS_CHECK("omega2_dot", (int32_T)
      _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1] = c10_i_y + c10_j_y;
    _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 54);
    c10_h_a = c10_F;
    c10_h_b = c10_omega0[2 + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("omega0", (int32_T)
      _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 2, 0) - 1)];
    c10_k_y = c10_h_a * c10_h_b;
    c10_i_a = c10_g;
    c10_i_b = c10_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
      _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1];
    c10_l_y = c10_i_a * c10_i_b;
    c10_omega3_dot[_SFD_EML_ARRAY_BOUNDS_CHECK("omega3_dot", (int32_T)
      _SFD_INTEGER_CHECK("i", c10_b_i), 1, 3, 1, 0) - 1] = c10_k_y + c10_l_y;
    c10_c_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 1, 0);
  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, 58);
  c10_i40 = 0;
  for (c10_i41 = 0; c10_i41 < 3; c10_i41++) {
    c10_omega0_dot[c10_i40] = c10_omega1_dot[c10_i41];
    c10_i40 += 3;
  }

  c10_i42 = 0;
  for (c10_i43 = 0; c10_i43 < 3; c10_i43++) {
    c10_omega0_dot[c10_i42 + 1] = c10_omega2_dot[c10_i43];
    c10_i42 += 3;
  }

  c10_i44 = 0;
  for (c10_i45 = 0; c10_i45 < 3; c10_i45++) {
    c10_omega0_dot[c10_i44 + 2] = c10_omega3_dot[c10_i45];
    c10_i44 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c10_sfEvent, -58);
  sf_debug_symbol_scope_pop();
  for (c10_i46 = 0; c10_i46 < 3; c10_i46++) {
    (*c10_b_F_T)[c10_i46] = c10_F_T[c10_i46];
  }

  for (c10_i47 = 0; c10_i47 < 9; c10_i47++) {
    (*c10_b_omega0_dot)[c10_i47] = c10_omega0_dot[c10_i47];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 8U, chartInstance->c10_sfEvent);
}

static void initSimStructsc10_Controller(SFc10_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c10_machineNumber, uint32_T
  c10_chartNumber)
{
}

static const mxArray *c10_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i48;
  int32_T c10_i49;
  int32_T c10_i50;
  real_T c10_b_inData[9];
  int32_T c10_i51;
  int32_T c10_i52;
  int32_T c10_i53;
  real_T c10_u[9];
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_i48 = 0;
  for (c10_i49 = 0; c10_i49 < 3; c10_i49++) {
    for (c10_i50 = 0; c10_i50 < 3; c10_i50++) {
      c10_b_inData[c10_i50 + c10_i48] = (*(real_T (*)[9])c10_inData)[c10_i50 +
        c10_i48];
    }

    c10_i48 += 3;
  }

  c10_i51 = 0;
  for (c10_i52 = 0; c10_i52 < 3; c10_i52++) {
    for (c10_i53 = 0; c10_i53 < 3; c10_i53++) {
      c10_u[c10_i53 + c10_i51] = c10_b_inData[c10_i53 + c10_i51];
    }

    c10_i51 += 3;
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_omega0_dot, const char_T *c10_identifier, real_T c10_y[9])
{
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_omega0_dot), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_omega0_dot);
}

static void c10_b_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[9])
{
  real_T c10_dv2[9];
  int32_T c10_i54;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv2, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c10_i54 = 0; c10_i54 < 9; c10_i54++) {
    c10_y[c10_i54] = c10_dv2[c10_i54];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_omega0_dot;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[9];
  int32_T c10_i55;
  int32_T c10_i56;
  int32_T c10_i57;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_omega0_dot = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_omega0_dot), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_omega0_dot);
  c10_i55 = 0;
  for (c10_i56 = 0; c10_i56 < 3; c10_i56++) {
    for (c10_i57 = 0; c10_i57 < 3; c10_i57++) {
      (*(real_T (*)[9])c10_outData)[c10_i57 + c10_i55] = c10_y[c10_i57 + c10_i55];
    }

    c10_i55 += 3;
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_b_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i58;
  real_T c10_b_inData[3];
  int32_T c10_i59;
  real_T c10_u[3];
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i58 = 0; c10_i58 < 3; c10_i58++) {
    c10_b_inData[c10_i58] = (*(real_T (*)[3])c10_inData)[c10_i58];
  }

  for (c10_i59 = 0; c10_i59 < 3; c10_i59++) {
    c10_u[c10_i59] = c10_b_inData[c10_i59];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_c_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_F_T, const char_T *c10_identifier, real_T c10_y[3])
{
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_F_T), &c10_thisId, c10_y);
  sf_mex_destroy(&c10_F_T);
}

static void c10_d_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[3])
{
  real_T c10_dv3[3];
  int32_T c10_i60;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv3, 1, 0, 0U, 1, 0U, 1, 3);
  for (c10_i60 = 0; c10_i60 < 3; c10_i60++) {
    c10_y[c10_i60] = c10_dv3[c10_i60];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_F_T;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[3];
  int32_T c10_i61;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_F_T = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_F_T), &c10_thisId, c10_y);
  sf_mex_destroy(&c10_F_T);
  for (c10_i61 = 0; c10_i61 < 3; c10_i61++) {
    (*(real_T (*)[3])c10_outData)[c10_i61] = c10_y[c10_i61];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_c_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i62;
  int32_T c10_i63;
  int32_T c10_i64;
  real_T c10_b_inData[12];
  int32_T c10_i65;
  int32_T c10_i66;
  int32_T c10_i67;
  real_T c10_u[12];
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_i62 = 0;
  for (c10_i63 = 0; c10_i63 < 4; c10_i63++) {
    for (c10_i64 = 0; c10_i64 < 3; c10_i64++) {
      c10_b_inData[c10_i64 + c10_i62] = (*(real_T (*)[12])c10_inData)[c10_i64 +
        c10_i62];
    }

    c10_i62 += 3;
  }

  c10_i65 = 0;
  for (c10_i66 = 0; c10_i66 < 4; c10_i66++) {
    for (c10_i67 = 0; c10_i67 < 3; c10_i67++) {
      c10_u[c10_i67 + c10_i65] = c10_b_inData[c10_i67 + c10_i65];
    }

    c10_i65 += 3;
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static const mxArray *c10_d_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i68;
  int32_T c10_i69;
  int32_T c10_i70;
  real_T c10_b_inData[18];
  int32_T c10_i71;
  int32_T c10_i72;
  int32_T c10_i73;
  real_T c10_u[18];
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_i68 = 0;
  for (c10_i69 = 0; c10_i69 < 6; c10_i69++) {
    for (c10_i70 = 0; c10_i70 < 3; c10_i70++) {
      c10_b_inData[c10_i70 + c10_i68] = (*(real_T (*)[18])c10_inData)[c10_i70 +
        c10_i68];
    }

    c10_i68 += 3;
  }

  c10_i71 = 0;
  for (c10_i72 = 0; c10_i72 < 6; c10_i72++) {
    for (c10_i73 = 0; c10_i73 < 3; c10_i73++) {
      c10_u[c10_i73 + c10_i71] = c10_b_inData[c10_i73 + c10_i71];
    }

    c10_i71 += 3;
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 2, 3, 6), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static const mxArray *c10_e_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  real_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(real_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static const mxArray *c10_f_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i74;
  real_T c10_b_inData[3];
  int32_T c10_i75;
  real_T c10_u[3];
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i74 = 0; c10_i74 < 3; c10_i74++) {
    c10_b_inData[c10_i74] = (*(real_T (*)[3])c10_inData)[c10_i74];
  }

  for (c10_i75 = 0; c10_i75 < 3; c10_i75++) {
    c10_u[c10_i75] = c10_b_inData[c10_i75];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static real_T c10_e_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  real_T c10_y;
  real_T c10_d0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_d0, 1, 0, 0U, 0, 0U, 0);
  c10_y = c10_d0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_nargout;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_nargout = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_nargout),
    &c10_thisId);
  sf_mex_destroy(&c10_nargout);
  *(real_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static const mxArray *c10_g_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_i76;
  real_T c10_b_inData[4];
  int32_T c10_i77;
  real_T c10_u[4];
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  for (c10_i76 = 0; c10_i76 < 4; c10_i76++) {
    c10_b_inData[c10_i76] = (*(real_T (*)[4])c10_inData)[c10_i76];
  }

  for (c10_i77 = 0; c10_i77 < 4; c10_i77++) {
    c10_u[c10_i77] = c10_b_inData[c10_i77];
  }

  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", c10_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static void c10_f_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[4])
{
  real_T c10_dv4[4];
  int32_T c10_i78;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv4, 1, 0, 0U, 1, 0U, 1, 4);
  for (c10_i78 = 0; c10_i78 < 4; c10_i78++) {
    c10_y[c10_i78] = c10_dv4[c10_i78];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_omega;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[4];
  int32_T c10_i79;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_omega = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_omega), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_omega);
  for (c10_i79 = 0; c10_i79 < 4; c10_i79++) {
    (*(real_T (*)[4])c10_outData)[c10_i79] = c10_y[c10_i79];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

static void c10_g_emlrt_marshallIn(SFc10_ControllerInstanceStruct *chartInstance,
  const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId, real_T c10_y[3])
{
  real_T c10_dv5[3];
  int32_T c10_i80;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), c10_dv5, 1, 0, 0U, 1, 0U, 2, 1,
                3);
  for (c10_i80 = 0; c10_i80 < 3; c10_i80++) {
    c10_y[c10_i80] = c10_dv5[c10_i80];
  }

  sf_mex_destroy(&c10_u);
}

static void c10_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_omega3_dot;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  real_T c10_y[3];
  int32_T c10_i81;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_omega3_dot = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_omega3_dot), &c10_thisId,
    c10_y);
  sf_mex_destroy(&c10_omega3_dot);
  for (c10_i81 = 0; c10_i81 < 3; c10_i81++) {
    (*(real_T (*)[3])c10_outData)[c10_i81] = c10_y[c10_i81];
  }

  sf_mex_destroy(&c10_mxArrayInData);
}

const mxArray *sf_c10_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c10_nameCaptureInfo;
  c10_ResolvedFunctionInfo c10_info[22];
  const mxArray *c10_m0 = NULL;
  int32_T c10_i82;
  c10_ResolvedFunctionInfo *c10_r0;
  c10_nameCaptureInfo = NULL;
  c10_nameCaptureInfo = NULL;
  c10_info_helper(c10_info);
  sf_mex_assign(&c10_m0, sf_mex_createstruct("nameCaptureInfo", 1, 22), FALSE);
  for (c10_i82 = 0; c10_i82 < 22; c10_i82++) {
    c10_r0 = &c10_info[c10_i82];
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->context)), "context", "nameCaptureInfo",
                    c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c10_r0->name)), "name", "nameCaptureInfo",
                    c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      c10_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", c10_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c10_r0->resolved)), "resolved",
                    "nameCaptureInfo", c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo", &c10_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c10_i82);
    sf_mex_addfield(c10_m0, sf_mex_create("nameCaptureInfo",
      &c10_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c10_i82);
  }

  sf_mex_assign(&c10_nameCaptureInfo, c10_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c10_nameCaptureInfo);
  return c10_nameCaptureInfo;
}

static void c10_info_helper(c10_ResolvedFunctionInfo c10_info[22])
{
  c10_info[0].context = "";
  c10_info[0].name = "rdivide";
  c10_info[0].dominantType = "double";
  c10_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c10_info[0].fileTimeLo = 1286818844U;
  c10_info[0].fileTimeHi = 0U;
  c10_info[0].mFileTimeLo = 0U;
  c10_info[0].mFileTimeHi = 0U;
  c10_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c10_info[1].name = "eml_div";
  c10_info[1].dominantType = "double";
  c10_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c10_info[1].fileTimeLo = 1313347810U;
  c10_info[1].fileTimeHi = 0U;
  c10_info[1].mFileTimeLo = 0U;
  c10_info[1].mFileTimeHi = 0U;
  c10_info[2].context = "";
  c10_info[2].name = "mtimes";
  c10_info[2].dominantType = "double";
  c10_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[2].fileTimeLo = 1289519692U;
  c10_info[2].fileTimeHi = 0U;
  c10_info[2].mFileTimeLo = 0U;
  c10_info[2].mFileTimeHi = 0U;
  c10_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[3].name = "eml_index_class";
  c10_info[3].dominantType = "";
  c10_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[3].fileTimeLo = 1323170578U;
  c10_info[3].fileTimeHi = 0U;
  c10_info[3].mFileTimeLo = 0U;
  c10_info[3].mFileTimeHi = 0U;
  c10_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[4].name = "eml_scalar_eg";
  c10_info[4].dominantType = "double";
  c10_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c10_info[4].fileTimeLo = 1286818796U;
  c10_info[4].fileTimeHi = 0U;
  c10_info[4].mFileTimeLo = 0U;
  c10_info[4].mFileTimeHi = 0U;
  c10_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c10_info[5].name = "eml_xdotu";
  c10_info[5].dominantType = "double";
  c10_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c10_info[5].fileTimeLo = 1299076772U;
  c10_info[5].fileTimeHi = 0U;
  c10_info[5].mFileTimeLo = 0U;
  c10_info[5].mFileTimeHi = 0U;
  c10_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c10_info[6].name = "eml_blas_inline";
  c10_info[6].dominantType = "";
  c10_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c10_info[6].fileTimeLo = 1299076768U;
  c10_info[6].fileTimeHi = 0U;
  c10_info[6].mFileTimeLo = 0U;
  c10_info[6].mFileTimeHi = 0U;
  c10_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c10_info[7].name = "eml_xdot";
  c10_info[7].dominantType = "double";
  c10_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c10_info[7].fileTimeLo = 1299076772U;
  c10_info[7].fileTimeHi = 0U;
  c10_info[7].mFileTimeLo = 0U;
  c10_info[7].mFileTimeHi = 0U;
  c10_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c10_info[8].name = "eml_blas_inline";
  c10_info[8].dominantType = "";
  c10_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c10_info[8].fileTimeLo = 1299076768U;
  c10_info[8].fileTimeHi = 0U;
  c10_info[8].mFileTimeLo = 0U;
  c10_info[8].mFileTimeHi = 0U;
  c10_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c10_info[9].name = "eml_index_class";
  c10_info[9].dominantType = "";
  c10_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[9].fileTimeLo = 1323170578U;
  c10_info[9].fileTimeHi = 0U;
  c10_info[9].mFileTimeLo = 0U;
  c10_info[9].mFileTimeHi = 0U;
  c10_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c10_info[10].name = "eml_refblas_xdot";
  c10_info[10].dominantType = "double";
  c10_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c10_info[10].fileTimeLo = 1299076772U;
  c10_info[10].fileTimeHi = 0U;
  c10_info[10].mFileTimeLo = 0U;
  c10_info[10].mFileTimeHi = 0U;
  c10_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c10_info[11].name = "eml_refblas_xdotx";
  c10_info[11].dominantType = "char";
  c10_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[11].fileTimeLo = 1299076774U;
  c10_info[11].fileTimeHi = 0U;
  c10_info[11].mFileTimeLo = 0U;
  c10_info[11].mFileTimeHi = 0U;
  c10_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[12].name = "eml_scalar_eg";
  c10_info[12].dominantType = "double";
  c10_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c10_info[12].fileTimeLo = 1286818796U;
  c10_info[12].fileTimeHi = 0U;
  c10_info[12].mFileTimeLo = 0U;
  c10_info[12].mFileTimeHi = 0U;
  c10_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[13].name = "eml_index_class";
  c10_info[13].dominantType = "";
  c10_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[13].fileTimeLo = 1323170578U;
  c10_info[13].fileTimeHi = 0U;
  c10_info[13].mFileTimeLo = 0U;
  c10_info[13].mFileTimeHi = 0U;
  c10_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[14].name = "eml_index_minus";
  c10_info[14].dominantType = "double";
  c10_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c10_info[14].fileTimeLo = 1286818778U;
  c10_info[14].fileTimeHi = 0U;
  c10_info[14].mFileTimeLo = 0U;
  c10_info[14].mFileTimeHi = 0U;
  c10_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c10_info[15].name = "eml_index_class";
  c10_info[15].dominantType = "";
  c10_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[15].fileTimeLo = 1323170578U;
  c10_info[15].fileTimeHi = 0U;
  c10_info[15].mFileTimeLo = 0U;
  c10_info[15].mFileTimeHi = 0U;
  c10_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[16].name = "eml_index_times";
  c10_info[16].dominantType = "coder.internal.indexInt";
  c10_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c10_info[16].fileTimeLo = 1286818780U;
  c10_info[16].fileTimeHi = 0U;
  c10_info[16].mFileTimeLo = 0U;
  c10_info[16].mFileTimeHi = 0U;
  c10_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c10_info[17].name = "eml_index_class";
  c10_info[17].dominantType = "";
  c10_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[17].fileTimeLo = 1323170578U;
  c10_info[17].fileTimeHi = 0U;
  c10_info[17].mFileTimeLo = 0U;
  c10_info[17].mFileTimeHi = 0U;
  c10_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[18].name = "eml_index_plus";
  c10_info[18].dominantType = "coder.internal.indexInt";
  c10_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c10_info[18].fileTimeLo = 1286818778U;
  c10_info[18].fileTimeHi = 0U;
  c10_info[18].mFileTimeLo = 0U;
  c10_info[18].mFileTimeHi = 0U;
  c10_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c10_info[19].name = "eml_index_class";
  c10_info[19].dominantType = "";
  c10_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c10_info[19].fileTimeLo = 1323170578U;
  c10_info[19].fileTimeHi = 0U;
  c10_info[19].mFileTimeLo = 0U;
  c10_info[19].mFileTimeHi = 0U;
  c10_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c10_info[20].name = "eml_int_forloop_overflow_check";
  c10_info[20].dominantType = "";
  c10_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c10_info[20].fileTimeLo = 1332168672U;
  c10_info[20].fileTimeHi = 0U;
  c10_info[20].mFileTimeLo = 0U;
  c10_info[20].mFileTimeHi = 0U;
  c10_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c10_info[21].name = "intmax";
  c10_info[21].dominantType = "char";
  c10_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c10_info[21].fileTimeLo = 1311255316U;
  c10_info[21].fileTimeHi = 0U;
  c10_info[21].mFileTimeLo = 0U;
  c10_info[21].mFileTimeHi = 0U;
}

static void c10_eml_scalar_eg(SFc10_ControllerInstanceStruct *chartInstance)
{
}

static void c10_check_forloop_overflow_error(SFc10_ControllerInstanceStruct
  *chartInstance)
{
}

static const mxArray *c10_h_sf_marshallOut(void *chartInstanceVoid, void
  *c10_inData)
{
  const mxArray *c10_mxArrayOutData = NULL;
  int32_T c10_u;
  const mxArray *c10_y = NULL;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_mxArrayOutData = NULL;
  c10_u = *(int32_T *)c10_inData;
  c10_y = NULL;
  sf_mex_assign(&c10_y, sf_mex_create("y", &c10_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c10_mxArrayOutData, c10_y, FALSE);
  return c10_mxArrayOutData;
}

static int32_T c10_h_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  int32_T c10_y;
  int32_T c10_i83;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_i83, 1, 6, 0U, 0, 0U, 0);
  c10_y = c10_i83;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void c10_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c10_mxArrayInData, const char_T *c10_varName, void *c10_outData)
{
  const mxArray *c10_b_sfEvent;
  const char_T *c10_identifier;
  emlrtMsgIdentifier c10_thisId;
  int32_T c10_y;
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)chartInstanceVoid;
  c10_b_sfEvent = sf_mex_dup(c10_mxArrayInData);
  c10_identifier = c10_varName;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c10_b_sfEvent),
    &c10_thisId);
  sf_mex_destroy(&c10_b_sfEvent);
  *(int32_T *)c10_outData = c10_y;
  sf_mex_destroy(&c10_mxArrayInData);
}

static uint8_T c10_i_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_b_is_active_c10_Controller, const char_T
  *c10_identifier)
{
  uint8_T c10_y;
  emlrtMsgIdentifier c10_thisId;
  c10_thisId.fIdentifier = c10_identifier;
  c10_thisId.fParent = NULL;
  c10_y = c10_j_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c10_b_is_active_c10_Controller), &c10_thisId);
  sf_mex_destroy(&c10_b_is_active_c10_Controller);
  return c10_y;
}

static uint8_T c10_j_emlrt_marshallIn(SFc10_ControllerInstanceStruct
  *chartInstance, const mxArray *c10_u, const emlrtMsgIdentifier *c10_parentId)
{
  uint8_T c10_y;
  uint8_T c10_u0;
  sf_mex_import(c10_parentId, sf_mex_dup(c10_u), &c10_u0, 1, 3, 0U, 0, 0U, 0);
  c10_y = c10_u0;
  sf_mex_destroy(&c10_u);
  return c10_y;
}

static void init_dsm_address_info(SFc10_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c10_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(4136412222U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2362720852U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1647102503U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3295994832U);
}

mxArray *sf_c10_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("zd6vvhH2UsLC2Z5Fz2mnEE");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,10,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(6);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(4);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,9,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }

    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c10_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x3'type','srcId','name','auxInfo'{{M[1],M[32],T\"F_T\",},{M[1],M[17],T\"omega0_dot\",},{M[8],M[0],T\"is_active_c10_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 3, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c10_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc10_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc10_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           10,
           1,
           1,
           12,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"frc_ctrl");
          _SFD_SET_DATA_PROPS(1,1,1,0,"eta_p");
          _SFD_SET_DATA_PROPS(2,1,1,0,"F_C");
          _SFD_SET_DATA_PROPS(3,2,0,1,"F_T");
          _SFD_SET_DATA_PROPS(4,1,1,0,"r");
          _SFD_SET_DATA_PROPS(5,1,1,0,"F");
          _SFD_SET_DATA_PROPS(6,1,1,0,"g");
          _SFD_SET_DATA_PROPS(7,1,1,0,"F_R");
          _SFD_SET_DATA_PROPS(8,1,1,0,"theta_e_hat");
          _SFD_SET_DATA_PROPS(9,1,1,0,"theta_ctrl_r_hat");
          _SFD_SET_DATA_PROPS(10,1,1,0,"omega0");
          _SFD_SET_DATA_PROPS(11,2,0,1,"omega0_dot");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,2,0,0,0,2,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1682);
        _SFD_CV_INIT_EML_IF(0,1,0,549,568,815,990);
        _SFD_CV_INIT_EML_IF(0,1,1,1143,1152,1311,1379);
        _SFD_CV_INIT_EML_FOR(0,1,0,522,532,1043);
        _SFD_CV_INIT_EML_FOR(0,1,1,1054,1066,1620);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)
            c10_b_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_e_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c10_e_sf_marshallOut,(MexInFcnForType)NULL);

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c10_sf_marshallOut,(MexInFcnForType)
            c10_sf_marshallIn);
        }

        {
          real_T *c10_F;
          real_T *c10_g;
          real_T (*c10_frc_ctrl)[3];
          real_T (*c10_eta_p)[3];
          real_T (*c10_F_C)[3];
          real_T (*c10_F_T)[3];
          real_T (*c10_r)[3];
          real_T (*c10_F_R)[3];
          real_T (*c10_theta_e_hat)[18];
          real_T (*c10_theta_ctrl_r_hat)[12];
          real_T (*c10_omega0)[9];
          real_T (*c10_omega0_dot)[9];
          c10_omega0_dot = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S,
            2);
          c10_omega0 = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 9);
          c10_theta_ctrl_r_hat = (real_T (*)[12])ssGetInputPortSignal
            (chartInstance->S, 8);
          c10_theta_e_hat = (real_T (*)[18])ssGetInputPortSignal
            (chartInstance->S, 7);
          c10_F_R = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
          c10_g = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c10_F = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c10_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c10_F_T = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c10_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
          c10_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c10_frc_ctrl = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c10_frc_ctrl);
          _SFD_SET_DATA_VALUE_PTR(1U, *c10_eta_p);
          _SFD_SET_DATA_VALUE_PTR(2U, *c10_F_C);
          _SFD_SET_DATA_VALUE_PTR(3U, *c10_F_T);
          _SFD_SET_DATA_VALUE_PTR(4U, *c10_r);
          _SFD_SET_DATA_VALUE_PTR(5U, c10_F);
          _SFD_SET_DATA_VALUE_PTR(6U, c10_g);
          _SFD_SET_DATA_VALUE_PTR(7U, *c10_F_R);
          _SFD_SET_DATA_VALUE_PTR(8U, *c10_theta_e_hat);
          _SFD_SET_DATA_VALUE_PTR(9U, *c10_theta_ctrl_r_hat);
          _SFD_SET_DATA_VALUE_PTR(10U, *c10_omega0);
          _SFD_SET_DATA_VALUE_PTR(11U, *c10_omega0_dot);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "PQpxCgNkPjBCp0yGnYYNcH";
}

static void sf_opaque_initialize_c10_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc10_ControllerInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c10_Controller((SFc10_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c10_Controller((SFc10_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c10_Controller(void *chartInstanceVar)
{
  enable_c10_Controller((SFc10_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c10_Controller(void *chartInstanceVar)
{
  disable_c10_Controller((SFc10_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c10_Controller(void *chartInstanceVar)
{
  sf_c10_Controller((SFc10_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c10_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c10_Controller
    ((SFc10_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c10_Controller(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c10_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c10_Controller((SFc10_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c10_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c10_Controller(S);
}

static void sf_opaque_set_sim_state_c10_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c10_Controller(S, st);
}

static void sf_opaque_terminate_c10_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc10_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c10_Controller((SFc10_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc10_Controller((SFc10_ControllerInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c10_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c10_Controller((SFc10_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c10_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,10,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,10,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,10,10);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,10,2);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,10);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3574370174U));
  ssSetChecksum1(S,(2345079022U));
  ssSetChecksum2(S,(2253558707U));
  ssSetChecksum3(S,(3067567312U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c10_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c10_Controller(SimStruct *S)
{
  SFc10_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc10_ControllerInstanceStruct *)malloc(sizeof
    (SFc10_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc10_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c10_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c10_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c10_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c10_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c10_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c10_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c10_Controller;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c10_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c10_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c10_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c10_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c10_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c10_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
