/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c12_Controller.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c12_debug_family_names[6] = { "M", "D", "nargin", "nargout",
  "theta_v_hat_in", "theta_v_hat_out" };

/* Function Declarations */
static void initialize_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance);
static void enable_c12_Controller(SFc12_ControllerInstanceStruct *chartInstance);
static void disable_c12_Controller(SFc12_ControllerInstanceStruct *chartInstance);
static void c12_update_debugger_state_c12_Controller
  (SFc12_ControllerInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c12_Controller
  (SFc12_ControllerInstanceStruct *chartInstance);
static void set_sim_state_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_st);
static void finalize_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance);
static void sf_c12_Controller(SFc12_ControllerInstanceStruct *chartInstance);
static void initSimStructsc12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c12_machineNumber, uint32_T
  c12_chartNumber);
static const mxArray *c12_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData);
static void c12_emlrt_marshallIn(SFc12_ControllerInstanceStruct *chartInstance,
  const mxArray *c12_theta_v_hat_out, const char_T *c12_identifier, real_T
  c12_y[6]);
static void c12_b_emlrt_marshallIn(SFc12_ControllerInstanceStruct *chartInstance,
  const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId, real_T c12_y[6]);
static void c12_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData);
static const mxArray *c12_b_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData);
static const mxArray *c12_c_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData);
static real_T c12_c_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId);
static void c12_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData);
static const mxArray *c12_d_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData);
static void c12_d_emlrt_marshallIn(SFc12_ControllerInstanceStruct *chartInstance,
  const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId, real_T c12_y[9]);
static void c12_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData);
static void c12_info_helper(c12_ResolvedFunctionInfo c12_info[16]);
static void c12_diag(SFc12_ControllerInstanceStruct *chartInstance, real_T
                     c12_v[9], real_T c12_d[3]);
static const mxArray *c12_e_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData);
static int32_T c12_e_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId);
static void c12_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData);
static uint8_T c12_f_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_b_is_active_c12_Controller, const char_T
  *c12_identifier);
static uint8_T c12_g_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId);
static void init_dsm_address_info(SFc12_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c12_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c12_is_active_c12_Controller = 0U;
}

static void initialize_params_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c12_Controller(SFc12_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c12_Controller(SFc12_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c12_update_debugger_state_c12_Controller
  (SFc12_ControllerInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c12_Controller
  (SFc12_ControllerInstanceStruct *chartInstance)
{
  const mxArray *c12_st;
  const mxArray *c12_y = NULL;
  int32_T c12_i0;
  real_T c12_u[6];
  const mxArray *c12_b_y = NULL;
  uint8_T c12_hoistedGlobal;
  uint8_T c12_b_u;
  const mxArray *c12_c_y = NULL;
  real_T (*c12_theta_v_hat_out)[6];
  c12_theta_v_hat_out = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c12_st = NULL;
  c12_st = NULL;
  c12_y = NULL;
  sf_mex_assign(&c12_y, sf_mex_createcellarray(2), FALSE);
  for (c12_i0 = 0; c12_i0 < 6; c12_i0++) {
    c12_u[c12_i0] = (*c12_theta_v_hat_out)[c12_i0];
  }

  c12_b_y = NULL;
  sf_mex_assign(&c12_b_y, sf_mex_create("y", c12_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c12_y, 0, c12_b_y);
  c12_hoistedGlobal = chartInstance->c12_is_active_c12_Controller;
  c12_b_u = c12_hoistedGlobal;
  c12_c_y = NULL;
  sf_mex_assign(&c12_c_y, sf_mex_create("y", &c12_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c12_y, 1, c12_c_y);
  sf_mex_assign(&c12_st, c12_y, FALSE);
  return c12_st;
}

static void set_sim_state_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_st)
{
  const mxArray *c12_u;
  real_T c12_dv0[6];
  int32_T c12_i1;
  real_T (*c12_theta_v_hat_out)[6];
  c12_theta_v_hat_out = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c12_doneDoubleBufferReInit = TRUE;
  c12_u = sf_mex_dup(c12_st);
  c12_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c12_u, 0)),
                       "theta_v_hat_out", c12_dv0);
  for (c12_i1 = 0; c12_i1 < 6; c12_i1++) {
    (*c12_theta_v_hat_out)[c12_i1] = c12_dv0[c12_i1];
  }

  chartInstance->c12_is_active_c12_Controller = c12_f_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c12_u, 1)),
     "is_active_c12_Controller");
  sf_mex_destroy(&c12_u);
  c12_update_debugger_state_c12_Controller(chartInstance);
  sf_mex_destroy(&c12_st);
}

static void finalize_c12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance)
{
}

static void sf_c12_Controller(SFc12_ControllerInstanceStruct *chartInstance)
{
  int32_T c12_i2;
  int32_T c12_i3;
  int32_T c12_i4;
  real_T c12_theta_v_hat_in[18];
  uint32_T c12_debug_family_var_map[6];
  real_T c12_M[9];
  real_T c12_D[9];
  real_T c12_nargin = 1.0;
  real_T c12_nargout = 1.0;
  real_T c12_theta_v_hat_out[6];
  int32_T c12_i5;
  int32_T c12_i6;
  int32_T c12_i7;
  int32_T c12_i8;
  int32_T c12_i9;
  int32_T c12_i10;
  int32_T c12_i11;
  int32_T c12_i12;
  int32_T c12_i13;
  real_T c12_b_M[9];
  real_T c12_dv1[3];
  int32_T c12_i14;
  real_T c12_b_D[9];
  real_T c12_dv2[3];
  int32_T c12_i15;
  real_T c12_dv3[6];
  int32_T c12_i16;
  int32_T c12_i17;
  int32_T c12_i18;
  real_T (*c12_b_theta_v_hat_out)[6];
  real_T (*c12_b_theta_v_hat_in)[18];
  c12_b_theta_v_hat_out = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
    1);
  c12_b_theta_v_hat_in = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S,
    0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 10U, chartInstance->c12_sfEvent);
  for (c12_i2 = 0; c12_i2 < 18; c12_i2++) {
    _SFD_DATA_RANGE_CHECK((*c12_b_theta_v_hat_in)[c12_i2], 0U);
  }

  for (c12_i3 = 0; c12_i3 < 6; c12_i3++) {
    _SFD_DATA_RANGE_CHECK((*c12_b_theta_v_hat_out)[c12_i3], 1U);
  }

  chartInstance->c12_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 10U, chartInstance->c12_sfEvent);
  for (c12_i4 = 0; c12_i4 < 18; c12_i4++) {
    c12_theta_v_hat_in[c12_i4] = (*c12_b_theta_v_hat_in)[c12_i4];
  }

  sf_debug_symbol_scope_push_eml(0U, 6U, 6U, c12_debug_family_names,
    c12_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c12_M, 0U, c12_d_sf_marshallOut,
    c12_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c12_D, 1U, c12_d_sf_marshallOut,
    c12_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c12_nargin, 2U, c12_c_sf_marshallOut,
    c12_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c12_nargout, 3U,
    c12_c_sf_marshallOut, c12_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c12_theta_v_hat_in, 4U, c12_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c12_theta_v_hat_out, 5U,
    c12_sf_marshallOut, c12_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c12_sfEvent, 4);
  c12_i5 = 0;
  c12_i6 = 0;
  for (c12_i7 = 0; c12_i7 < 3; c12_i7++) {
    for (c12_i8 = 0; c12_i8 < 3; c12_i8++) {
      c12_M[c12_i8 + c12_i5] = c12_theta_v_hat_in[c12_i8 + c12_i6];
    }

    c12_i5 += 3;
    c12_i6 += 6;
  }

  _SFD_EML_CALL(0U, chartInstance->c12_sfEvent, 5);
  c12_i9 = 0;
  c12_i10 = 0;
  for (c12_i11 = 0; c12_i11 < 3; c12_i11++) {
    for (c12_i12 = 0; c12_i12 < 3; c12_i12++) {
      c12_D[c12_i12 + c12_i9] = c12_theta_v_hat_in[(c12_i12 + c12_i10) + 3];
    }

    c12_i9 += 3;
    c12_i10 += 6;
  }

  _SFD_EML_CALL(0U, chartInstance->c12_sfEvent, 7);
  for (c12_i13 = 0; c12_i13 < 9; c12_i13++) {
    c12_b_M[c12_i13] = c12_M[c12_i13];
  }

  c12_diag(chartInstance, c12_b_M, c12_dv1);
  for (c12_i14 = 0; c12_i14 < 9; c12_i14++) {
    c12_b_D[c12_i14] = c12_D[c12_i14];
  }

  c12_diag(chartInstance, c12_b_D, c12_dv2);
  for (c12_i15 = 0; c12_i15 < 3; c12_i15++) {
    c12_dv3[c12_i15] = c12_dv1[c12_i15];
  }

  for (c12_i16 = 0; c12_i16 < 3; c12_i16++) {
    c12_dv3[c12_i16 + 3] = c12_dv2[c12_i16];
  }

  for (c12_i17 = 0; c12_i17 < 6; c12_i17++) {
    c12_theta_v_hat_out[c12_i17] = c12_dv3[c12_i17];
  }

  _SFD_EML_CALL(0U, chartInstance->c12_sfEvent, -7);
  sf_debug_symbol_scope_pop();
  for (c12_i18 = 0; c12_i18 < 6; c12_i18++) {
    (*c12_b_theta_v_hat_out)[c12_i18] = c12_theta_v_hat_out[c12_i18];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 10U, chartInstance->c12_sfEvent);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc12_Controller(SFc12_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c12_machineNumber, uint32_T
  c12_chartNumber)
{
}

static const mxArray *c12_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData)
{
  const mxArray *c12_mxArrayOutData = NULL;
  int32_T c12_i19;
  real_T c12_b_inData[6];
  int32_T c12_i20;
  real_T c12_u[6];
  const mxArray *c12_y = NULL;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_mxArrayOutData = NULL;
  for (c12_i19 = 0; c12_i19 < 6; c12_i19++) {
    c12_b_inData[c12_i19] = (*(real_T (*)[6])c12_inData)[c12_i19];
  }

  for (c12_i20 = 0; c12_i20 < 6; c12_i20++) {
    c12_u[c12_i20] = c12_b_inData[c12_i20];
  }

  c12_y = NULL;
  sf_mex_assign(&c12_y, sf_mex_create("y", c12_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c12_mxArrayOutData, c12_y, FALSE);
  return c12_mxArrayOutData;
}

static void c12_emlrt_marshallIn(SFc12_ControllerInstanceStruct *chartInstance,
  const mxArray *c12_theta_v_hat_out, const char_T *c12_identifier, real_T
  c12_y[6])
{
  emlrtMsgIdentifier c12_thisId;
  c12_thisId.fIdentifier = c12_identifier;
  c12_thisId.fParent = NULL;
  c12_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c12_theta_v_hat_out),
    &c12_thisId, c12_y);
  sf_mex_destroy(&c12_theta_v_hat_out);
}

static void c12_b_emlrt_marshallIn(SFc12_ControllerInstanceStruct *chartInstance,
  const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId, real_T c12_y[6])
{
  real_T c12_dv4[6];
  int32_T c12_i21;
  sf_mex_import(c12_parentId, sf_mex_dup(c12_u), c12_dv4, 1, 0, 0U, 1, 0U, 1, 6);
  for (c12_i21 = 0; c12_i21 < 6; c12_i21++) {
    c12_y[c12_i21] = c12_dv4[c12_i21];
  }

  sf_mex_destroy(&c12_u);
}

static void c12_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData)
{
  const mxArray *c12_theta_v_hat_out;
  const char_T *c12_identifier;
  emlrtMsgIdentifier c12_thisId;
  real_T c12_y[6];
  int32_T c12_i22;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_theta_v_hat_out = sf_mex_dup(c12_mxArrayInData);
  c12_identifier = c12_varName;
  c12_thisId.fIdentifier = c12_identifier;
  c12_thisId.fParent = NULL;
  c12_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c12_theta_v_hat_out),
    &c12_thisId, c12_y);
  sf_mex_destroy(&c12_theta_v_hat_out);
  for (c12_i22 = 0; c12_i22 < 6; c12_i22++) {
    (*(real_T (*)[6])c12_outData)[c12_i22] = c12_y[c12_i22];
  }

  sf_mex_destroy(&c12_mxArrayInData);
}

static const mxArray *c12_b_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData)
{
  const mxArray *c12_mxArrayOutData = NULL;
  int32_T c12_i23;
  int32_T c12_i24;
  int32_T c12_i25;
  real_T c12_b_inData[18];
  int32_T c12_i26;
  int32_T c12_i27;
  int32_T c12_i28;
  real_T c12_u[18];
  const mxArray *c12_y = NULL;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_mxArrayOutData = NULL;
  c12_i23 = 0;
  for (c12_i24 = 0; c12_i24 < 3; c12_i24++) {
    for (c12_i25 = 0; c12_i25 < 6; c12_i25++) {
      c12_b_inData[c12_i25 + c12_i23] = (*(real_T (*)[18])c12_inData)[c12_i25 +
        c12_i23];
    }

    c12_i23 += 6;
  }

  c12_i26 = 0;
  for (c12_i27 = 0; c12_i27 < 3; c12_i27++) {
    for (c12_i28 = 0; c12_i28 < 6; c12_i28++) {
      c12_u[c12_i28 + c12_i26] = c12_b_inData[c12_i28 + c12_i26];
    }

    c12_i26 += 6;
  }

  c12_y = NULL;
  sf_mex_assign(&c12_y, sf_mex_create("y", c12_u, 0, 0U, 1U, 0U, 2, 6, 3), FALSE);
  sf_mex_assign(&c12_mxArrayOutData, c12_y, FALSE);
  return c12_mxArrayOutData;
}

static const mxArray *c12_c_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData)
{
  const mxArray *c12_mxArrayOutData = NULL;
  real_T c12_u;
  const mxArray *c12_y = NULL;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_mxArrayOutData = NULL;
  c12_u = *(real_T *)c12_inData;
  c12_y = NULL;
  sf_mex_assign(&c12_y, sf_mex_create("y", &c12_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c12_mxArrayOutData, c12_y, FALSE);
  return c12_mxArrayOutData;
}

static real_T c12_c_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId)
{
  real_T c12_y;
  real_T c12_d0;
  sf_mex_import(c12_parentId, sf_mex_dup(c12_u), &c12_d0, 1, 0, 0U, 0, 0U, 0);
  c12_y = c12_d0;
  sf_mex_destroy(&c12_u);
  return c12_y;
}

static void c12_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData)
{
  const mxArray *c12_nargout;
  const char_T *c12_identifier;
  emlrtMsgIdentifier c12_thisId;
  real_T c12_y;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_nargout = sf_mex_dup(c12_mxArrayInData);
  c12_identifier = c12_varName;
  c12_thisId.fIdentifier = c12_identifier;
  c12_thisId.fParent = NULL;
  c12_y = c12_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c12_nargout),
    &c12_thisId);
  sf_mex_destroy(&c12_nargout);
  *(real_T *)c12_outData = c12_y;
  sf_mex_destroy(&c12_mxArrayInData);
}

static const mxArray *c12_d_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData)
{
  const mxArray *c12_mxArrayOutData = NULL;
  int32_T c12_i29;
  int32_T c12_i30;
  int32_T c12_i31;
  real_T c12_b_inData[9];
  int32_T c12_i32;
  int32_T c12_i33;
  int32_T c12_i34;
  real_T c12_u[9];
  const mxArray *c12_y = NULL;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_mxArrayOutData = NULL;
  c12_i29 = 0;
  for (c12_i30 = 0; c12_i30 < 3; c12_i30++) {
    for (c12_i31 = 0; c12_i31 < 3; c12_i31++) {
      c12_b_inData[c12_i31 + c12_i29] = (*(real_T (*)[9])c12_inData)[c12_i31 +
        c12_i29];
    }

    c12_i29 += 3;
  }

  c12_i32 = 0;
  for (c12_i33 = 0; c12_i33 < 3; c12_i33++) {
    for (c12_i34 = 0; c12_i34 < 3; c12_i34++) {
      c12_u[c12_i34 + c12_i32] = c12_b_inData[c12_i34 + c12_i32];
    }

    c12_i32 += 3;
  }

  c12_y = NULL;
  sf_mex_assign(&c12_y, sf_mex_create("y", c12_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c12_mxArrayOutData, c12_y, FALSE);
  return c12_mxArrayOutData;
}

static void c12_d_emlrt_marshallIn(SFc12_ControllerInstanceStruct *chartInstance,
  const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId, real_T c12_y[9])
{
  real_T c12_dv5[9];
  int32_T c12_i35;
  sf_mex_import(c12_parentId, sf_mex_dup(c12_u), c12_dv5, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c12_i35 = 0; c12_i35 < 9; c12_i35++) {
    c12_y[c12_i35] = c12_dv5[c12_i35];
  }

  sf_mex_destroy(&c12_u);
}

static void c12_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData)
{
  const mxArray *c12_D;
  const char_T *c12_identifier;
  emlrtMsgIdentifier c12_thisId;
  real_T c12_y[9];
  int32_T c12_i36;
  int32_T c12_i37;
  int32_T c12_i38;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_D = sf_mex_dup(c12_mxArrayInData);
  c12_identifier = c12_varName;
  c12_thisId.fIdentifier = c12_identifier;
  c12_thisId.fParent = NULL;
  c12_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c12_D), &c12_thisId, c12_y);
  sf_mex_destroy(&c12_D);
  c12_i36 = 0;
  for (c12_i37 = 0; c12_i37 < 3; c12_i37++) {
    for (c12_i38 = 0; c12_i38 < 3; c12_i38++) {
      (*(real_T (*)[9])c12_outData)[c12_i38 + c12_i36] = c12_y[c12_i38 + c12_i36];
    }

    c12_i36 += 3;
  }

  sf_mex_destroy(&c12_mxArrayInData);
}

const mxArray *sf_c12_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c12_nameCaptureInfo;
  c12_ResolvedFunctionInfo c12_info[16];
  const mxArray *c12_m0 = NULL;
  int32_T c12_i39;
  c12_ResolvedFunctionInfo *c12_r0;
  c12_nameCaptureInfo = NULL;
  c12_nameCaptureInfo = NULL;
  c12_info_helper(c12_info);
  sf_mex_assign(&c12_m0, sf_mex_createstruct("nameCaptureInfo", 1, 16), FALSE);
  for (c12_i39 = 0; c12_i39 < 16; c12_i39++) {
    c12_r0 = &c12_info[c12_i39];
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo", c12_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c12_r0->context)), "context", "nameCaptureInfo",
                    c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo", c12_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c12_r0->name)), "name", "nameCaptureInfo",
                    c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo",
      c12_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c12_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo", c12_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c12_r0->resolved)), "resolved",
                    "nameCaptureInfo", c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo", &c12_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo", &c12_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo",
      &c12_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c12_i39);
    sf_mex_addfield(c12_m0, sf_mex_create("nameCaptureInfo",
      &c12_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c12_i39);
  }

  sf_mex_assign(&c12_nameCaptureInfo, c12_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c12_nameCaptureInfo);
  return c12_nameCaptureInfo;
}

static void c12_info_helper(c12_ResolvedFunctionInfo c12_info[16])
{
  c12_info[0].context = "";
  c12_info[0].name = "diag";
  c12_info[0].dominantType = "double";
  c12_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[0].fileTimeLo = 1286818686U;
  c12_info[0].fileTimeHi = 0U;
  c12_info[0].mFileTimeLo = 0U;
  c12_info[0].mFileTimeHi = 0U;
  c12_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[1].name = "eml_index_class";
  c12_info[1].dominantType = "";
  c12_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c12_info[1].fileTimeLo = 1323170578U;
  c12_info[1].fileTimeHi = 0U;
  c12_info[1].mFileTimeLo = 0U;
  c12_info[1].mFileTimeHi = 0U;
  c12_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[2].name = "eml_index_plus";
  c12_info[2].dominantType = "double";
  c12_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c12_info[2].fileTimeLo = 1286818778U;
  c12_info[2].fileTimeHi = 0U;
  c12_info[2].mFileTimeLo = 0U;
  c12_info[2].mFileTimeHi = 0U;
  c12_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c12_info[3].name = "eml_index_class";
  c12_info[3].dominantType = "";
  c12_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c12_info[3].fileTimeLo = 1323170578U;
  c12_info[3].fileTimeHi = 0U;
  c12_info[3].mFileTimeLo = 0U;
  c12_info[3].mFileTimeHi = 0U;
  c12_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[4].name = "eml_index_times";
  c12_info[4].dominantType = "coder.internal.indexInt";
  c12_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c12_info[4].fileTimeLo = 1286818780U;
  c12_info[4].fileTimeHi = 0U;
  c12_info[4].mFileTimeLo = 0U;
  c12_info[4].mFileTimeHi = 0U;
  c12_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c12_info[5].name = "eml_index_class";
  c12_info[5].dominantType = "";
  c12_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c12_info[5].fileTimeLo = 1323170578U;
  c12_info[5].fileTimeHi = 0U;
  c12_info[5].mFileTimeLo = 0U;
  c12_info[5].mFileTimeHi = 0U;
  c12_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[6].name = "eml_index_minus";
  c12_info[6].dominantType = "coder.internal.indexInt";
  c12_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c12_info[6].fileTimeLo = 1286818778U;
  c12_info[6].fileTimeHi = 0U;
  c12_info[6].mFileTimeLo = 0U;
  c12_info[6].mFileTimeHi = 0U;
  c12_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c12_info[7].name = "eml_index_class";
  c12_info[7].dominantType = "";
  c12_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c12_info[7].fileTimeLo = 1323170578U;
  c12_info[7].fileTimeHi = 0U;
  c12_info[7].mFileTimeLo = 0U;
  c12_info[7].mFileTimeHi = 0U;
  c12_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[8].name = "min";
  c12_info[8].dominantType = "coder.internal.indexInt";
  c12_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c12_info[8].fileTimeLo = 1311255318U;
  c12_info[8].fileTimeHi = 0U;
  c12_info[8].mFileTimeLo = 0U;
  c12_info[8].mFileTimeHi = 0U;
  c12_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c12_info[9].name = "eml_min_or_max";
  c12_info[9].dominantType = "char";
  c12_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c12_info[9].fileTimeLo = 1334071490U;
  c12_info[9].fileTimeHi = 0U;
  c12_info[9].mFileTimeLo = 0U;
  c12_info[9].mFileTimeHi = 0U;
  c12_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c12_info[10].name = "eml_scalar_eg";
  c12_info[10].dominantType = "coder.internal.indexInt";
  c12_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c12_info[10].fileTimeLo = 1286818796U;
  c12_info[10].fileTimeHi = 0U;
  c12_info[10].mFileTimeLo = 0U;
  c12_info[10].mFileTimeHi = 0U;
  c12_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c12_info[11].name = "eml_scalexp_alloc";
  c12_info[11].dominantType = "coder.internal.indexInt";
  c12_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c12_info[11].fileTimeLo = 1330608434U;
  c12_info[11].fileTimeHi = 0U;
  c12_info[11].mFileTimeLo = 0U;
  c12_info[11].mFileTimeHi = 0U;
  c12_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c12_info[12].name = "eml_index_class";
  c12_info[12].dominantType = "";
  c12_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c12_info[12].fileTimeLo = 1323170578U;
  c12_info[12].fileTimeHi = 0U;
  c12_info[12].mFileTimeLo = 0U;
  c12_info[12].mFileTimeHi = 0U;
  c12_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_scalar_bin_extremum";
  c12_info[13].name = "eml_scalar_eg";
  c12_info[13].dominantType = "coder.internal.indexInt";
  c12_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c12_info[13].fileTimeLo = 1286818796U;
  c12_info[13].fileTimeHi = 0U;
  c12_info[13].mFileTimeLo = 0U;
  c12_info[13].mFileTimeHi = 0U;
  c12_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[14].name = "eml_index_minus";
  c12_info[14].dominantType = "double";
  c12_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c12_info[14].fileTimeLo = 1286818778U;
  c12_info[14].fileTimeHi = 0U;
  c12_info[14].mFileTimeLo = 0U;
  c12_info[14].mFileTimeHi = 0U;
  c12_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c12_info[15].name = "eml_index_plus";
  c12_info[15].dominantType = "coder.internal.indexInt";
  c12_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c12_info[15].fileTimeLo = 1286818778U;
  c12_info[15].fileTimeHi = 0U;
  c12_info[15].mFileTimeLo = 0U;
  c12_info[15].mFileTimeHi = 0U;
}

static void c12_diag(SFc12_ControllerInstanceStruct *chartInstance, real_T
                     c12_v[9], real_T c12_d[3])
{
  int32_T c12_i40;
  int32_T c12_i41;
  c12_i40 = 0;
  for (c12_i41 = 0; c12_i41 < 3; c12_i41++) {
    c12_d[c12_i41] = c12_v[c12_i40];
    c12_i40 += 4;
  }
}

static const mxArray *c12_e_sf_marshallOut(void *chartInstanceVoid, void
  *c12_inData)
{
  const mxArray *c12_mxArrayOutData = NULL;
  int32_T c12_u;
  const mxArray *c12_y = NULL;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_mxArrayOutData = NULL;
  c12_u = *(int32_T *)c12_inData;
  c12_y = NULL;
  sf_mex_assign(&c12_y, sf_mex_create("y", &c12_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c12_mxArrayOutData, c12_y, FALSE);
  return c12_mxArrayOutData;
}

static int32_T c12_e_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId)
{
  int32_T c12_y;
  int32_T c12_i42;
  sf_mex_import(c12_parentId, sf_mex_dup(c12_u), &c12_i42, 1, 6, 0U, 0, 0U, 0);
  c12_y = c12_i42;
  sf_mex_destroy(&c12_u);
  return c12_y;
}

static void c12_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c12_mxArrayInData, const char_T *c12_varName, void *c12_outData)
{
  const mxArray *c12_b_sfEvent;
  const char_T *c12_identifier;
  emlrtMsgIdentifier c12_thisId;
  int32_T c12_y;
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)chartInstanceVoid;
  c12_b_sfEvent = sf_mex_dup(c12_mxArrayInData);
  c12_identifier = c12_varName;
  c12_thisId.fIdentifier = c12_identifier;
  c12_thisId.fParent = NULL;
  c12_y = c12_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c12_b_sfEvent),
    &c12_thisId);
  sf_mex_destroy(&c12_b_sfEvent);
  *(int32_T *)c12_outData = c12_y;
  sf_mex_destroy(&c12_mxArrayInData);
}

static uint8_T c12_f_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_b_is_active_c12_Controller, const char_T
  *c12_identifier)
{
  uint8_T c12_y;
  emlrtMsgIdentifier c12_thisId;
  c12_thisId.fIdentifier = c12_identifier;
  c12_thisId.fParent = NULL;
  c12_y = c12_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c12_b_is_active_c12_Controller), &c12_thisId);
  sf_mex_destroy(&c12_b_is_active_c12_Controller);
  return c12_y;
}

static uint8_T c12_g_emlrt_marshallIn(SFc12_ControllerInstanceStruct
  *chartInstance, const mxArray *c12_u, const emlrtMsgIdentifier *c12_parentId)
{
  uint8_T c12_y;
  uint8_T c12_u0;
  sf_mex_import(c12_parentId, sf_mex_dup(c12_u), &c12_u0, 1, 3, 0U, 0, 0U, 0);
  c12_y = c12_u0;
  sf_mex_destroy(&c12_u);
  return c12_y;
}

static void init_dsm_address_info(SFc12_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c12_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2386076371U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(317377464U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(934862695U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1790693731U);
}

mxArray *sf_c12_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("IJsXBtJdH5nBOQvD5N4N3B");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c12_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"theta_v_hat_out\",},{M[8],M[0],T\"is_active_c12_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c12_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc12_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc12_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           12,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"theta_v_hat_in");
          _SFD_SET_DATA_PROPS(1,2,0,1,"theta_v_hat_out");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,170);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 6;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c12_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c12_sf_marshallOut,(MexInFcnForType)
            c12_sf_marshallIn);
        }

        {
          real_T (*c12_theta_v_hat_in)[18];
          real_T (*c12_theta_v_hat_out)[6];
          c12_theta_v_hat_out = (real_T (*)[6])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c12_theta_v_hat_in = (real_T (*)[18])ssGetInputPortSignal
            (chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c12_theta_v_hat_in);
          _SFD_SET_DATA_VALUE_PTR(1U, *c12_theta_v_hat_out);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "Ytg3wnq0xFn0ttUCvNI2wH";
}

static void sf_opaque_initialize_c12_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc12_ControllerInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c12_Controller((SFc12_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c12_Controller((SFc12_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c12_Controller(void *chartInstanceVar)
{
  enable_c12_Controller((SFc12_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c12_Controller(void *chartInstanceVar)
{
  disable_c12_Controller((SFc12_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c12_Controller(void *chartInstanceVar)
{
  sf_c12_Controller((SFc12_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c12_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c12_Controller
    ((SFc12_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c12_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c12_Controller(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c12_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c12_Controller((SFc12_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c12_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c12_Controller(S);
}

static void sf_opaque_set_sim_state_c12_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c12_Controller(S, st);
}

static void sf_opaque_terminate_c12_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc12_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c12_Controller((SFc12_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc12_Controller((SFc12_ControllerInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c12_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c12_Controller((SFc12_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c12_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      12);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,12,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,12,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,12,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,12,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,12);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3420726559U));
  ssSetChecksum1(S,(3192542463U));
  ssSetChecksum2(S,(1510820631U));
  ssSetChecksum3(S,(2791015191U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c12_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c12_Controller(SimStruct *S)
{
  SFc12_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc12_ControllerInstanceStruct *)malloc(sizeof
    (SFc12_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc12_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c12_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c12_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c12_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c12_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c12_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c12_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c12_Controller;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c12_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c12_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c12_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c12_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c12_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c12_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c12_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c12_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c12_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
