/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c13_Controller.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c13_debug_family_names[6] = { "M_e", "D_e", "nargin",
  "nargout", "theta_e_hat_in", "theta_e_hat_out" };

/* Function Declarations */
static void initialize_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance);
static void enable_c13_Controller(SFc13_ControllerInstanceStruct *chartInstance);
static void disable_c13_Controller(SFc13_ControllerInstanceStruct *chartInstance);
static void c13_update_debugger_state_c13_Controller
  (SFc13_ControllerInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c13_Controller
  (SFc13_ControllerInstanceStruct *chartInstance);
static void set_sim_state_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_st);
static void finalize_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance);
static void sf_c13_Controller(SFc13_ControllerInstanceStruct *chartInstance);
static void initSimStructsc13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c13_machineNumber, uint32_T
  c13_chartNumber);
static const mxArray *c13_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static void c13_emlrt_marshallIn(SFc13_ControllerInstanceStruct *chartInstance,
  const mxArray *c13_theta_e_hat_out, const char_T *c13_identifier, real_T
  c13_y[6]);
static void c13_b_emlrt_marshallIn(SFc13_ControllerInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId, real_T c13_y[6]);
static void c13_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static const mxArray *c13_b_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static const mxArray *c13_c_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static real_T c13_c_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void c13_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static const mxArray *c13_d_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static void c13_d_emlrt_marshallIn(SFc13_ControllerInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId, real_T c13_y[9]);
static void c13_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static void c13_info_helper(c13_ResolvedFunctionInfo c13_info[16]);
static void c13_diag(SFc13_ControllerInstanceStruct *chartInstance, real_T
                     c13_v[9], real_T c13_d[3]);
static const mxArray *c13_e_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData);
static int32_T c13_e_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void c13_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData);
static uint8_T c13_f_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_b_is_active_c13_Controller, const char_T
  *c13_identifier);
static uint8_T c13_g_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId);
static void init_dsm_address_info(SFc13_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c13_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c13_is_active_c13_Controller = 0U;
}

static void initialize_params_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c13_Controller(SFc13_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c13_Controller(SFc13_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c13_update_debugger_state_c13_Controller
  (SFc13_ControllerInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c13_Controller
  (SFc13_ControllerInstanceStruct *chartInstance)
{
  const mxArray *c13_st;
  const mxArray *c13_y = NULL;
  int32_T c13_i0;
  real_T c13_u[6];
  const mxArray *c13_b_y = NULL;
  uint8_T c13_hoistedGlobal;
  uint8_T c13_b_u;
  const mxArray *c13_c_y = NULL;
  real_T (*c13_theta_e_hat_out)[6];
  c13_theta_e_hat_out = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c13_st = NULL;
  c13_st = NULL;
  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_createcellarray(2), FALSE);
  for (c13_i0 = 0; c13_i0 < 6; c13_i0++) {
    c13_u[c13_i0] = (*c13_theta_e_hat_out)[c13_i0];
  }

  c13_b_y = NULL;
  sf_mex_assign(&c13_b_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_setcell(c13_y, 0, c13_b_y);
  c13_hoistedGlobal = chartInstance->c13_is_active_c13_Controller;
  c13_b_u = c13_hoistedGlobal;
  c13_c_y = NULL;
  sf_mex_assign(&c13_c_y, sf_mex_create("y", &c13_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c13_y, 1, c13_c_y);
  sf_mex_assign(&c13_st, c13_y, FALSE);
  return c13_st;
}

static void set_sim_state_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_st)
{
  const mxArray *c13_u;
  real_T c13_dv0[6];
  int32_T c13_i1;
  real_T (*c13_theta_e_hat_out)[6];
  c13_theta_e_hat_out = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c13_doneDoubleBufferReInit = TRUE;
  c13_u = sf_mex_dup(c13_st);
  c13_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c13_u, 0)),
                       "theta_e_hat_out", c13_dv0);
  for (c13_i1 = 0; c13_i1 < 6; c13_i1++) {
    (*c13_theta_e_hat_out)[c13_i1] = c13_dv0[c13_i1];
  }

  chartInstance->c13_is_active_c13_Controller = c13_f_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c13_u, 1)),
     "is_active_c13_Controller");
  sf_mex_destroy(&c13_u);
  c13_update_debugger_state_c13_Controller(chartInstance);
  sf_mex_destroy(&c13_st);
}

static void finalize_c13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance)
{
}

static void sf_c13_Controller(SFc13_ControllerInstanceStruct *chartInstance)
{
  int32_T c13_i2;
  int32_T c13_i3;
  int32_T c13_i4;
  real_T c13_theta_e_hat_in[18];
  uint32_T c13_debug_family_var_map[6];
  real_T c13_M_e[9];
  real_T c13_D_e[9];
  real_T c13_nargin = 1.0;
  real_T c13_nargout = 1.0;
  real_T c13_theta_e_hat_out[6];
  int32_T c13_i5;
  int32_T c13_i6;
  int32_T c13_i7;
  int32_T c13_i8;
  int32_T c13_i9;
  int32_T c13_i10;
  int32_T c13_i11;
  real_T c13_b_M_e[9];
  real_T c13_dv1[3];
  int32_T c13_i12;
  real_T c13_b_D_e[9];
  real_T c13_dv2[3];
  int32_T c13_i13;
  real_T c13_dv3[6];
  int32_T c13_i14;
  int32_T c13_i15;
  int32_T c13_i16;
  real_T (*c13_b_theta_e_hat_out)[6];
  real_T (*c13_b_theta_e_hat_in)[18];
  c13_b_theta_e_hat_out = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S,
    1);
  c13_b_theta_e_hat_in = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S,
    0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 11U, chartInstance->c13_sfEvent);
  for (c13_i2 = 0; c13_i2 < 18; c13_i2++) {
    _SFD_DATA_RANGE_CHECK((*c13_b_theta_e_hat_in)[c13_i2], 0U);
  }

  for (c13_i3 = 0; c13_i3 < 6; c13_i3++) {
    _SFD_DATA_RANGE_CHECK((*c13_b_theta_e_hat_out)[c13_i3], 1U);
  }

  chartInstance->c13_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 11U, chartInstance->c13_sfEvent);
  for (c13_i4 = 0; c13_i4 < 18; c13_i4++) {
    c13_theta_e_hat_in[c13_i4] = (*c13_b_theta_e_hat_in)[c13_i4];
  }

  sf_debug_symbol_scope_push_eml(0U, 6U, 6U, c13_debug_family_names,
    c13_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c13_M_e, 0U, c13_d_sf_marshallOut,
    c13_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c13_D_e, 1U, c13_d_sf_marshallOut,
    c13_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c13_nargin, 2U, c13_c_sf_marshallOut,
    c13_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c13_nargout, 3U,
    c13_c_sf_marshallOut, c13_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c13_theta_e_hat_in, 4U, c13_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c13_theta_e_hat_out, 5U,
    c13_sf_marshallOut, c13_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 4);
  c13_i5 = 0;
  for (c13_i6 = 0; c13_i6 < 3; c13_i6++) {
    for (c13_i7 = 0; c13_i7 < 3; c13_i7++) {
      c13_M_e[c13_i7 + c13_i5] = c13_theta_e_hat_in[c13_i7 + c13_i5];
    }

    c13_i5 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 5);
  c13_i8 = 0;
  for (c13_i9 = 0; c13_i9 < 3; c13_i9++) {
    for (c13_i10 = 0; c13_i10 < 3; c13_i10++) {
      c13_D_e[c13_i10 + c13_i8] = c13_theta_e_hat_in[(c13_i10 + c13_i8) + 9];
    }

    c13_i8 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, 7);
  for (c13_i11 = 0; c13_i11 < 9; c13_i11++) {
    c13_b_M_e[c13_i11] = c13_M_e[c13_i11];
  }

  c13_diag(chartInstance, c13_b_M_e, c13_dv1);
  for (c13_i12 = 0; c13_i12 < 9; c13_i12++) {
    c13_b_D_e[c13_i12] = c13_D_e[c13_i12];
  }

  c13_diag(chartInstance, c13_b_D_e, c13_dv2);
  for (c13_i13 = 0; c13_i13 < 3; c13_i13++) {
    c13_dv3[c13_i13] = c13_dv1[c13_i13];
  }

  for (c13_i14 = 0; c13_i14 < 3; c13_i14++) {
    c13_dv3[c13_i14 + 3] = c13_dv2[c13_i14];
  }

  for (c13_i15 = 0; c13_i15 < 6; c13_i15++) {
    c13_theta_e_hat_out[c13_i15] = c13_dv3[c13_i15];
  }

  _SFD_EML_CALL(0U, chartInstance->c13_sfEvent, -7);
  sf_debug_symbol_scope_pop();
  for (c13_i16 = 0; c13_i16 < 6; c13_i16++) {
    (*c13_b_theta_e_hat_out)[c13_i16] = c13_theta_e_hat_out[c13_i16];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 11U, chartInstance->c13_sfEvent);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc13_Controller(SFc13_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c13_machineNumber, uint32_T
  c13_chartNumber)
{
}

static const mxArray *c13_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_i17;
  real_T c13_b_inData[6];
  int32_T c13_i18;
  real_T c13_u[6];
  const mxArray *c13_y = NULL;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  for (c13_i17 = 0; c13_i17 < 6; c13_i17++) {
    c13_b_inData[c13_i17] = (*(real_T (*)[6])c13_inData)[c13_i17];
  }

  for (c13_i18 = 0; c13_i18 < 6; c13_i18++) {
    c13_u[c13_i18] = c13_b_inData[c13_i18];
  }

  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static void c13_emlrt_marshallIn(SFc13_ControllerInstanceStruct *chartInstance,
  const mxArray *c13_theta_e_hat_out, const char_T *c13_identifier, real_T
  c13_y[6])
{
  emlrtMsgIdentifier c13_thisId;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_theta_e_hat_out),
    &c13_thisId, c13_y);
  sf_mex_destroy(&c13_theta_e_hat_out);
}

static void c13_b_emlrt_marshallIn(SFc13_ControllerInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId, real_T c13_y[6])
{
  real_T c13_dv4[6];
  int32_T c13_i19;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), c13_dv4, 1, 0, 0U, 1, 0U, 1, 6);
  for (c13_i19 = 0; c13_i19 < 6; c13_i19++) {
    c13_y[c13_i19] = c13_dv4[c13_i19];
  }

  sf_mex_destroy(&c13_u);
}

static void c13_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_theta_e_hat_out;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y[6];
  int32_T c13_i20;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_theta_e_hat_out = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_theta_e_hat_out),
    &c13_thisId, c13_y);
  sf_mex_destroy(&c13_theta_e_hat_out);
  for (c13_i20 = 0; c13_i20 < 6; c13_i20++) {
    (*(real_T (*)[6])c13_outData)[c13_i20] = c13_y[c13_i20];
  }

  sf_mex_destroy(&c13_mxArrayInData);
}

static const mxArray *c13_b_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_i21;
  int32_T c13_i22;
  int32_T c13_i23;
  real_T c13_b_inData[18];
  int32_T c13_i24;
  int32_T c13_i25;
  int32_T c13_i26;
  real_T c13_u[18];
  const mxArray *c13_y = NULL;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_i21 = 0;
  for (c13_i22 = 0; c13_i22 < 6; c13_i22++) {
    for (c13_i23 = 0; c13_i23 < 3; c13_i23++) {
      c13_b_inData[c13_i23 + c13_i21] = (*(real_T (*)[18])c13_inData)[c13_i23 +
        c13_i21];
    }

    c13_i21 += 3;
  }

  c13_i24 = 0;
  for (c13_i25 = 0; c13_i25 < 6; c13_i25++) {
    for (c13_i26 = 0; c13_i26 < 3; c13_i26++) {
      c13_u[c13_i26 + c13_i24] = c13_b_inData[c13_i26 + c13_i24];
    }

    c13_i24 += 3;
  }

  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 2, 3, 6), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static const mxArray *c13_c_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  real_T c13_u;
  const mxArray *c13_y = NULL;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_u = *(real_T *)c13_inData;
  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", &c13_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static real_T c13_c_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  real_T c13_y;
  real_T c13_d0;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_d0, 1, 0, 0U, 0, 0U, 0);
  c13_y = c13_d0;
  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void c13_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_nargout;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_nargout = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_nargout),
    &c13_thisId);
  sf_mex_destroy(&c13_nargout);
  *(real_T *)c13_outData = c13_y;
  sf_mex_destroy(&c13_mxArrayInData);
}

static const mxArray *c13_d_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_i27;
  int32_T c13_i28;
  int32_T c13_i29;
  real_T c13_b_inData[9];
  int32_T c13_i30;
  int32_T c13_i31;
  int32_T c13_i32;
  real_T c13_u[9];
  const mxArray *c13_y = NULL;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_i27 = 0;
  for (c13_i28 = 0; c13_i28 < 3; c13_i28++) {
    for (c13_i29 = 0; c13_i29 < 3; c13_i29++) {
      c13_b_inData[c13_i29 + c13_i27] = (*(real_T (*)[9])c13_inData)[c13_i29 +
        c13_i27];
    }

    c13_i27 += 3;
  }

  c13_i30 = 0;
  for (c13_i31 = 0; c13_i31 < 3; c13_i31++) {
    for (c13_i32 = 0; c13_i32 < 3; c13_i32++) {
      c13_u[c13_i32 + c13_i30] = c13_b_inData[c13_i32 + c13_i30];
    }

    c13_i30 += 3;
  }

  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", c13_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static void c13_d_emlrt_marshallIn(SFc13_ControllerInstanceStruct *chartInstance,
  const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId, real_T c13_y[9])
{
  real_T c13_dv5[9];
  int32_T c13_i33;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), c13_dv5, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c13_i33 = 0; c13_i33 < 9; c13_i33++) {
    c13_y[c13_i33] = c13_dv5[c13_i33];
  }

  sf_mex_destroy(&c13_u);
}

static void c13_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_D_e;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  real_T c13_y[9];
  int32_T c13_i34;
  int32_T c13_i35;
  int32_T c13_i36;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_D_e = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_D_e), &c13_thisId, c13_y);
  sf_mex_destroy(&c13_D_e);
  c13_i34 = 0;
  for (c13_i35 = 0; c13_i35 < 3; c13_i35++) {
    for (c13_i36 = 0; c13_i36 < 3; c13_i36++) {
      (*(real_T (*)[9])c13_outData)[c13_i36 + c13_i34] = c13_y[c13_i36 + c13_i34];
    }

    c13_i34 += 3;
  }

  sf_mex_destroy(&c13_mxArrayInData);
}

const mxArray *sf_c13_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c13_nameCaptureInfo;
  c13_ResolvedFunctionInfo c13_info[16];
  const mxArray *c13_m0 = NULL;
  int32_T c13_i37;
  c13_ResolvedFunctionInfo *c13_r0;
  c13_nameCaptureInfo = NULL;
  c13_nameCaptureInfo = NULL;
  c13_info_helper(c13_info);
  sf_mex_assign(&c13_m0, sf_mex_createstruct("nameCaptureInfo", 1, 16), FALSE);
  for (c13_i37 = 0; c13_i37 < 16; c13_i37++) {
    c13_r0 = &c13_info[c13_i37];
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", c13_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c13_r0->context)), "context", "nameCaptureInfo",
                    c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", c13_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c13_r0->name)), "name", "nameCaptureInfo",
                    c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo",
      c13_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c13_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", c13_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c13_r0->resolved)), "resolved",
                    "nameCaptureInfo", c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", &c13_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo", &c13_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo",
      &c13_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c13_i37);
    sf_mex_addfield(c13_m0, sf_mex_create("nameCaptureInfo",
      &c13_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c13_i37);
  }

  sf_mex_assign(&c13_nameCaptureInfo, c13_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c13_nameCaptureInfo);
  return c13_nameCaptureInfo;
}

static void c13_info_helper(c13_ResolvedFunctionInfo c13_info[16])
{
  c13_info[0].context = "";
  c13_info[0].name = "diag";
  c13_info[0].dominantType = "double";
  c13_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[0].fileTimeLo = 1286818686U;
  c13_info[0].fileTimeHi = 0U;
  c13_info[0].mFileTimeLo = 0U;
  c13_info[0].mFileTimeHi = 0U;
  c13_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[1].name = "eml_index_class";
  c13_info[1].dominantType = "";
  c13_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c13_info[1].fileTimeLo = 1323170578U;
  c13_info[1].fileTimeHi = 0U;
  c13_info[1].mFileTimeLo = 0U;
  c13_info[1].mFileTimeHi = 0U;
  c13_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[2].name = "eml_index_plus";
  c13_info[2].dominantType = "double";
  c13_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c13_info[2].fileTimeLo = 1286818778U;
  c13_info[2].fileTimeHi = 0U;
  c13_info[2].mFileTimeLo = 0U;
  c13_info[2].mFileTimeHi = 0U;
  c13_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c13_info[3].name = "eml_index_class";
  c13_info[3].dominantType = "";
  c13_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c13_info[3].fileTimeLo = 1323170578U;
  c13_info[3].fileTimeHi = 0U;
  c13_info[3].mFileTimeLo = 0U;
  c13_info[3].mFileTimeHi = 0U;
  c13_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[4].name = "eml_index_times";
  c13_info[4].dominantType = "coder.internal.indexInt";
  c13_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c13_info[4].fileTimeLo = 1286818780U;
  c13_info[4].fileTimeHi = 0U;
  c13_info[4].mFileTimeLo = 0U;
  c13_info[4].mFileTimeHi = 0U;
  c13_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c13_info[5].name = "eml_index_class";
  c13_info[5].dominantType = "";
  c13_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c13_info[5].fileTimeLo = 1323170578U;
  c13_info[5].fileTimeHi = 0U;
  c13_info[5].mFileTimeLo = 0U;
  c13_info[5].mFileTimeHi = 0U;
  c13_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[6].name = "eml_index_minus";
  c13_info[6].dominantType = "coder.internal.indexInt";
  c13_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c13_info[6].fileTimeLo = 1286818778U;
  c13_info[6].fileTimeHi = 0U;
  c13_info[6].mFileTimeLo = 0U;
  c13_info[6].mFileTimeHi = 0U;
  c13_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c13_info[7].name = "eml_index_class";
  c13_info[7].dominantType = "";
  c13_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c13_info[7].fileTimeLo = 1323170578U;
  c13_info[7].fileTimeHi = 0U;
  c13_info[7].mFileTimeLo = 0U;
  c13_info[7].mFileTimeHi = 0U;
  c13_info[8].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[8].name = "min";
  c13_info[8].dominantType = "coder.internal.indexInt";
  c13_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c13_info[8].fileTimeLo = 1311255318U;
  c13_info[8].fileTimeHi = 0U;
  c13_info[8].mFileTimeLo = 0U;
  c13_info[8].mFileTimeHi = 0U;
  c13_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/min.m";
  c13_info[9].name = "eml_min_or_max";
  c13_info[9].dominantType = "char";
  c13_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c13_info[9].fileTimeLo = 1334071490U;
  c13_info[9].fileTimeHi = 0U;
  c13_info[9].mFileTimeLo = 0U;
  c13_info[9].mFileTimeHi = 0U;
  c13_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c13_info[10].name = "eml_scalar_eg";
  c13_info[10].dominantType = "coder.internal.indexInt";
  c13_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c13_info[10].fileTimeLo = 1286818796U;
  c13_info[10].fileTimeHi = 0U;
  c13_info[10].mFileTimeLo = 0U;
  c13_info[10].mFileTimeHi = 0U;
  c13_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c13_info[11].name = "eml_scalexp_alloc";
  c13_info[11].dominantType = "coder.internal.indexInt";
  c13_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c13_info[11].fileTimeLo = 1330608434U;
  c13_info[11].fileTimeHi = 0U;
  c13_info[11].mFileTimeLo = 0U;
  c13_info[11].mFileTimeHi = 0U;
  c13_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c13_info[12].name = "eml_index_class";
  c13_info[12].dominantType = "";
  c13_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c13_info[12].fileTimeLo = 1323170578U;
  c13_info[12].fileTimeHi = 0U;
  c13_info[12].mFileTimeLo = 0U;
  c13_info[12].mFileTimeHi = 0U;
  c13_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_scalar_bin_extremum";
  c13_info[13].name = "eml_scalar_eg";
  c13_info[13].dominantType = "coder.internal.indexInt";
  c13_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c13_info[13].fileTimeLo = 1286818796U;
  c13_info[13].fileTimeHi = 0U;
  c13_info[13].mFileTimeLo = 0U;
  c13_info[13].mFileTimeHi = 0U;
  c13_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[14].name = "eml_index_minus";
  c13_info[14].dominantType = "double";
  c13_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c13_info[14].fileTimeLo = 1286818778U;
  c13_info[14].fileTimeHi = 0U;
  c13_info[14].mFileTimeLo = 0U;
  c13_info[14].mFileTimeHi = 0U;
  c13_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/diag.m";
  c13_info[15].name = "eml_index_plus";
  c13_info[15].dominantType = "coder.internal.indexInt";
  c13_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c13_info[15].fileTimeLo = 1286818778U;
  c13_info[15].fileTimeHi = 0U;
  c13_info[15].mFileTimeLo = 0U;
  c13_info[15].mFileTimeHi = 0U;
}

static void c13_diag(SFc13_ControllerInstanceStruct *chartInstance, real_T
                     c13_v[9], real_T c13_d[3])
{
  int32_T c13_i38;
  int32_T c13_i39;
  c13_i38 = 0;
  for (c13_i39 = 0; c13_i39 < 3; c13_i39++) {
    c13_d[c13_i39] = c13_v[c13_i38];
    c13_i38 += 4;
  }
}

static const mxArray *c13_e_sf_marshallOut(void *chartInstanceVoid, void
  *c13_inData)
{
  const mxArray *c13_mxArrayOutData = NULL;
  int32_T c13_u;
  const mxArray *c13_y = NULL;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_mxArrayOutData = NULL;
  c13_u = *(int32_T *)c13_inData;
  c13_y = NULL;
  sf_mex_assign(&c13_y, sf_mex_create("y", &c13_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c13_mxArrayOutData, c13_y, FALSE);
  return c13_mxArrayOutData;
}

static int32_T c13_e_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  int32_T c13_y;
  int32_T c13_i40;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_i40, 1, 6, 0U, 0, 0U, 0);
  c13_y = c13_i40;
  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void c13_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c13_mxArrayInData, const char_T *c13_varName, void *c13_outData)
{
  const mxArray *c13_b_sfEvent;
  const char_T *c13_identifier;
  emlrtMsgIdentifier c13_thisId;
  int32_T c13_y;
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)chartInstanceVoid;
  c13_b_sfEvent = sf_mex_dup(c13_mxArrayInData);
  c13_identifier = c13_varName;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c13_b_sfEvent),
    &c13_thisId);
  sf_mex_destroy(&c13_b_sfEvent);
  *(int32_T *)c13_outData = c13_y;
  sf_mex_destroy(&c13_mxArrayInData);
}

static uint8_T c13_f_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_b_is_active_c13_Controller, const char_T
  *c13_identifier)
{
  uint8_T c13_y;
  emlrtMsgIdentifier c13_thisId;
  c13_thisId.fIdentifier = c13_identifier;
  c13_thisId.fParent = NULL;
  c13_y = c13_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c13_b_is_active_c13_Controller), &c13_thisId);
  sf_mex_destroy(&c13_b_is_active_c13_Controller);
  return c13_y;
}

static uint8_T c13_g_emlrt_marshallIn(SFc13_ControllerInstanceStruct
  *chartInstance, const mxArray *c13_u, const emlrtMsgIdentifier *c13_parentId)
{
  uint8_T c13_y;
  uint8_T c13_u0;
  sf_mex_import(c13_parentId, sf_mex_dup(c13_u), &c13_u0, 1, 3, 0U, 0, 0U, 0);
  c13_y = c13_u0;
  sf_mex_destroy(&c13_u);
  return c13_y;
}

static void init_dsm_address_info(SFc13_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c13_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2833041486U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(507579891U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3078459451U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3858255808U);
}

mxArray *sf_c13_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("He2nHtIEgy5dZKbssSLUND");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(6);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c13_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"theta_e_hat_out\",},{M[8],M[0],T\"is_active_c13_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c13_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc13_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc13_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           13,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"theta_e_hat_in");
          _SFD_SET_DATA_PROPS(1,2,0,1,"theta_e_hat_out");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,178);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c13_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c13_sf_marshallOut,(MexInFcnForType)
            c13_sf_marshallIn);
        }

        {
          real_T (*c13_theta_e_hat_in)[18];
          real_T (*c13_theta_e_hat_out)[6];
          c13_theta_e_hat_out = (real_T (*)[6])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c13_theta_e_hat_in = (real_T (*)[18])ssGetInputPortSignal
            (chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c13_theta_e_hat_in);
          _SFD_SET_DATA_VALUE_PTR(1U, *c13_theta_e_hat_out);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "4KLY3Vs3UTnJN4zpQ2NEME";
}

static void sf_opaque_initialize_c13_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc13_ControllerInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c13_Controller((SFc13_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c13_Controller((SFc13_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c13_Controller(void *chartInstanceVar)
{
  enable_c13_Controller((SFc13_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c13_Controller(void *chartInstanceVar)
{
  disable_c13_Controller((SFc13_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c13_Controller(void *chartInstanceVar)
{
  sf_c13_Controller((SFc13_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c13_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c13_Controller
    ((SFc13_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c13_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c13_Controller(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c13_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c13_Controller((SFc13_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c13_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c13_Controller(S);
}

static void sf_opaque_set_sim_state_c13_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c13_Controller(S, st);
}

static void sf_opaque_terminate_c13_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc13_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c13_Controller((SFc13_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc13_Controller((SFc13_ControllerInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c13_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c13_Controller((SFc13_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c13_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      13);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,13,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,13,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,13,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,13,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,13);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1117993579U));
  ssSetChecksum1(S,(1237018320U));
  ssSetChecksum2(S,(4029688940U));
  ssSetChecksum3(S,(3604819883U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c13_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c13_Controller(SimStruct *S)
{
  SFc13_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc13_ControllerInstanceStruct *)malloc(sizeof
    (SFc13_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc13_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c13_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c13_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c13_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c13_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c13_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c13_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c13_Controller;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c13_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c13_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c13_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c13_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c13_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c13_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c13_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c13_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c13_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
