#ifndef __c14_Controller_h__
#define __c14_Controller_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c14_ResolvedFunctionInfo
#define typedef_c14_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c14_ResolvedFunctionInfo;

#endif                                 /*typedef_c14_ResolvedFunctionInfo*/

#ifndef typedef_SFc14_ControllerInstanceStruct
#define typedef_SFc14_ControllerInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c14_sfEvent;
  boolean_T c14_isStable;
  boolean_T c14_doneDoubleBufferReInit;
  uint8_T c14_is_active_c14_Controller;
  real_T c14_first;
  boolean_T c14_first_not_empty;
  real_T c14_delta_0;
  boolean_T c14_delta_0_not_empty;
  real_T c14_dphi01[6];
  boolean_T c14_dphi01_not_empty;
  real_T c14_dphi02[6];
  boolean_T c14_dphi02_not_empty;
  real_T c14_dphi03[6];
  boolean_T c14_dphi03_not_empty;
  real_T c14_dphi04[6];
  boolean_T c14_dphi04_not_empty;
  real_T c14_dphi05[6];
  boolean_T c14_dphi05_not_empty;
  real_T c14_z;
  boolean_T c14_z_not_empty;
  real_T c14_phi1[3];
  boolean_T c14_phi1_not_empty;
  real_T c14_phi2[3];
  boolean_T c14_phi2_not_empty;
  real_T c14_phi3[3];
  boolean_T c14_phi3_not_empty;
  real_T c14_phi4[3];
  boolean_T c14_phi4_not_empty;
  real_T c14_phi5[3];
  boolean_T c14_phi5_not_empty;
  real_T c14_phi_1[6];
  boolean_T c14_phi_1_not_empty;
  real_T c14_phi_2[6];
  boolean_T c14_phi_2_not_empty;
} SFc14_ControllerInstanceStruct;

#endif                                 /*typedef_SFc14_ControllerInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c14_Controller_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c14_Controller_get_check_sum(mxArray *plhs[]);
extern void c14_Controller_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
