/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c15_Controller.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c15_debug_family_names[28] = { "xm", "Fm", "zeta", "omega_0",
  "A_m", "B_m", "C_m", "nargin", "nargout", "y0", "F0", "r", "r_lp", "F_tol",
  "e_tol", "F_R", "F_C", "eta_p", "xm_dot", "Fm_dot", "ypm", "yFm", "Z_m", "R_m",
  "k_m_r", "frc_ctrl", "first", "flag" };

/* Function Declarations */
static void initialize_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance);
static void enable_c15_Controller(SFc15_ControllerInstanceStruct *chartInstance);
static void disable_c15_Controller(SFc15_ControllerInstanceStruct *chartInstance);
static void c15_update_debugger_state_c15_Controller
  (SFc15_ControllerInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c15_Controller
  (SFc15_ControllerInstanceStruct *chartInstance);
static void set_sim_state_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_st);
static void finalize_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance);
static void sf_c15_Controller(SFc15_ControllerInstanceStruct *chartInstance);
static void c15_chartstep_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance);
static void initSimStructsc15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c15_machineNumber, uint32_T
  c15_chartNumber);
static const mxArray *c15_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_b_flag, const char_T *c15_identifier, real_T c15_y[3]);
static void c15_b_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[3]);
static void c15_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_b_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static real_T c15_c_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_b_first, const char_T *c15_identifier);
static real_T c15_d_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_c_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_e_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_frc_ctrl, const char_T *c15_identifier, real_T c15_y[3]);
static void c15_f_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[3]);
static void c15_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_d_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_g_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_k_m_r, const char_T *c15_identifier, real_T c15_y[3]);
static void c15_h_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[3]);
static void c15_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_e_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_i_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_R_m, const char_T *c15_identifier, real_T c15_y[9]);
static void c15_j_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[9]);
static void c15_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_f_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_k_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_Fm_dot, const char_T *c15_identifier, real_T c15_y[6]);
static void c15_l_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[6]);
static void c15_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_g_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static real_T c15_m_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static const mxArray *c15_h_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static const mxArray *c15_i_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static const mxArray *c15_j_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static void c15_n_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[2]);
static void c15_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static void c15_info_helper(c15_ResolvedFunctionInfo c15_info[34]);
static real_T c15_abs(SFc15_ControllerInstanceStruct *chartInstance, real_T
                      c15_x);
static real_T c15_mpower(SFc15_ControllerInstanceStruct *chartInstance, real_T
  c15_a);
static void c15_eml_scalar_eg(SFc15_ControllerInstanceStruct *chartInstance);
static void c15_b_eml_scalar_eg(SFc15_ControllerInstanceStruct *chartInstance);
static void c15_check_forloop_overflow_error(SFc15_ControllerInstanceStruct
  *chartInstance);
static const mxArray *c15_k_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData);
static int32_T c15_o_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void c15_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData);
static uint8_T c15_p_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_b_is_active_c15_Controller, const char_T
  *c15_identifier);
static uint8_T c15_q_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId);
static void init_dsm_address_info(SFc15_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c15_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c15_first_not_empty = FALSE;
  chartInstance->c15_flag_not_empty = FALSE;
  chartInstance->c15_is_active_c15_Controller = 0U;
}

static void initialize_params_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c15_Controller(SFc15_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c15_Controller(SFc15_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c15_update_debugger_state_c15_Controller
  (SFc15_ControllerInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c15_Controller
  (SFc15_ControllerInstanceStruct *chartInstance)
{
  const mxArray *c15_st;
  const mxArray *c15_y = NULL;
  int32_T c15_i0;
  real_T c15_u[6];
  const mxArray *c15_b_y = NULL;
  int32_T c15_i1;
  real_T c15_b_u[9];
  const mxArray *c15_c_y = NULL;
  int32_T c15_i2;
  real_T c15_c_u[3];
  const mxArray *c15_d_y = NULL;
  int32_T c15_i3;
  real_T c15_d_u[3];
  const mxArray *c15_e_y = NULL;
  int32_T c15_i4;
  real_T c15_e_u[3];
  const mxArray *c15_f_y = NULL;
  int32_T c15_i5;
  real_T c15_f_u[6];
  const mxArray *c15_g_y = NULL;
  int32_T c15_i6;
  real_T c15_g_u[3];
  const mxArray *c15_h_y = NULL;
  int32_T c15_i7;
  real_T c15_h_u[3];
  const mxArray *c15_i_y = NULL;
  real_T c15_hoistedGlobal;
  real_T c15_i_u;
  const mxArray *c15_j_y = NULL;
  int32_T c15_i8;
  real_T c15_j_u[3];
  const mxArray *c15_k_y = NULL;
  uint8_T c15_b_hoistedGlobal;
  uint8_T c15_k_u;
  const mxArray *c15_l_y = NULL;
  real_T (*c15_ypm)[3];
  real_T (*c15_yFm)[3];
  real_T (*c15_xm_dot)[6];
  real_T (*c15_k_m_r)[3];
  real_T (*c15_frc_ctrl)[3];
  real_T (*c15_Z_m)[3];
  real_T (*c15_R_m)[9];
  real_T (*c15_Fm_dot)[6];
  c15_frc_ctrl = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c15_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c15_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 6);
  c15_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 5);
  c15_yFm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c15_ypm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c15_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c15_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  c15_st = NULL;
  c15_st = NULL;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_createcellarray(11), FALSE);
  for (c15_i0 = 0; c15_i0 < 6; c15_i0++) {
    c15_u[c15_i0] = (*c15_Fm_dot)[c15_i0];
  }

  c15_b_y = NULL;
  sf_mex_assign(&c15_b_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 2, 3),
                FALSE);
  sf_mex_setcell(c15_y, 0, c15_b_y);
  for (c15_i1 = 0; c15_i1 < 9; c15_i1++) {
    c15_b_u[c15_i1] = (*c15_R_m)[c15_i1];
  }

  c15_c_y = NULL;
  sf_mex_assign(&c15_c_y, sf_mex_create("y", c15_b_u, 0, 0U, 1U, 0U, 2, 3, 3),
                FALSE);
  sf_mex_setcell(c15_y, 1, c15_c_y);
  for (c15_i2 = 0; c15_i2 < 3; c15_i2++) {
    c15_c_u[c15_i2] = (*c15_Z_m)[c15_i2];
  }

  c15_d_y = NULL;
  sf_mex_assign(&c15_d_y, sf_mex_create("y", c15_c_u, 0, 0U, 1U, 0U, 1, 3),
                FALSE);
  sf_mex_setcell(c15_y, 2, c15_d_y);
  for (c15_i3 = 0; c15_i3 < 3; c15_i3++) {
    c15_d_u[c15_i3] = (*c15_frc_ctrl)[c15_i3];
  }

  c15_e_y = NULL;
  sf_mex_assign(&c15_e_y, sf_mex_create("y", c15_d_u, 0, 0U, 1U, 0U, 2, 1, 3),
                FALSE);
  sf_mex_setcell(c15_y, 3, c15_e_y);
  for (c15_i4 = 0; c15_i4 < 3; c15_i4++) {
    c15_e_u[c15_i4] = (*c15_k_m_r)[c15_i4];
  }

  c15_f_y = NULL;
  sf_mex_assign(&c15_f_y, sf_mex_create("y", c15_e_u, 0, 0U, 1U, 0U, 1, 3),
                FALSE);
  sf_mex_setcell(c15_y, 4, c15_f_y);
  for (c15_i5 = 0; c15_i5 < 6; c15_i5++) {
    c15_f_u[c15_i5] = (*c15_xm_dot)[c15_i5];
  }

  c15_g_y = NULL;
  sf_mex_assign(&c15_g_y, sf_mex_create("y", c15_f_u, 0, 0U, 1U, 0U, 2, 2, 3),
                FALSE);
  sf_mex_setcell(c15_y, 5, c15_g_y);
  for (c15_i6 = 0; c15_i6 < 3; c15_i6++) {
    c15_g_u[c15_i6] = (*c15_yFm)[c15_i6];
  }

  c15_h_y = NULL;
  sf_mex_assign(&c15_h_y, sf_mex_create("y", c15_g_u, 0, 0U, 1U, 0U, 1, 3),
                FALSE);
  sf_mex_setcell(c15_y, 6, c15_h_y);
  for (c15_i7 = 0; c15_i7 < 3; c15_i7++) {
    c15_h_u[c15_i7] = (*c15_ypm)[c15_i7];
  }

  c15_i_y = NULL;
  sf_mex_assign(&c15_i_y, sf_mex_create("y", c15_h_u, 0, 0U, 1U, 0U, 1, 3),
                FALSE);
  sf_mex_setcell(c15_y, 7, c15_i_y);
  c15_hoistedGlobal = chartInstance->c15_first;
  c15_i_u = c15_hoistedGlobal;
  c15_j_y = NULL;
  if (!chartInstance->c15_first_not_empty) {
    sf_mex_assign(&c15_j_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_j_y, sf_mex_create("y", &c15_i_u, 0, 0U, 0U, 0U, 0),
                  FALSE);
  }

  sf_mex_setcell(c15_y, 8, c15_j_y);
  for (c15_i8 = 0; c15_i8 < 3; c15_i8++) {
    c15_j_u[c15_i8] = chartInstance->c15_flag[c15_i8];
  }

  c15_k_y = NULL;
  if (!chartInstance->c15_flag_not_empty) {
    sf_mex_assign(&c15_k_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_k_y, sf_mex_create("y", c15_j_u, 0, 0U, 1U, 0U, 1, 3),
                  FALSE);
  }

  sf_mex_setcell(c15_y, 9, c15_k_y);
  c15_b_hoistedGlobal = chartInstance->c15_is_active_c15_Controller;
  c15_k_u = c15_b_hoistedGlobal;
  c15_l_y = NULL;
  sf_mex_assign(&c15_l_y, sf_mex_create("y", &c15_k_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c15_y, 10, c15_l_y);
  sf_mex_assign(&c15_st, c15_y, FALSE);
  return c15_st;
}

static void set_sim_state_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_st)
{
  const mxArray *c15_u;
  real_T c15_dv0[6];
  int32_T c15_i9;
  real_T c15_dv1[9];
  int32_T c15_i10;
  real_T c15_dv2[3];
  int32_T c15_i11;
  real_T c15_dv3[3];
  int32_T c15_i12;
  real_T c15_dv4[3];
  int32_T c15_i13;
  real_T c15_dv5[6];
  int32_T c15_i14;
  real_T c15_dv6[3];
  int32_T c15_i15;
  real_T c15_dv7[3];
  int32_T c15_i16;
  real_T c15_dv8[3];
  int32_T c15_i17;
  real_T (*c15_Fm_dot)[6];
  real_T (*c15_R_m)[9];
  real_T (*c15_Z_m)[3];
  real_T (*c15_k_m_r)[3];
  real_T (*c15_xm_dot)[6];
  real_T (*c15_yFm)[3];
  real_T (*c15_ypm)[3];
  real_T (*c15_frc_ctrl)[3];
  c15_frc_ctrl = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c15_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c15_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 6);
  c15_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 5);
  c15_yFm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c15_ypm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c15_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c15_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c15_doneDoubleBufferReInit = TRUE;
  c15_u = sf_mex_dup(c15_st);
  c15_k_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 0)),
    "Fm_dot", c15_dv0);
  for (c15_i9 = 0; c15_i9 < 6; c15_i9++) {
    (*c15_Fm_dot)[c15_i9] = c15_dv0[c15_i9];
  }

  c15_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 1)),
    "R_m", c15_dv1);
  for (c15_i10 = 0; c15_i10 < 9; c15_i10++) {
    (*c15_R_m)[c15_i10] = c15_dv1[c15_i10];
  }

  c15_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 2)),
    "Z_m", c15_dv2);
  for (c15_i11 = 0; c15_i11 < 3; c15_i11++) {
    (*c15_Z_m)[c15_i11] = c15_dv2[c15_i11];
  }

  c15_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 3)),
    "frc_ctrl", c15_dv3);
  for (c15_i12 = 0; c15_i12 < 3; c15_i12++) {
    (*c15_frc_ctrl)[c15_i12] = c15_dv3[c15_i12];
  }

  c15_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 4)),
    "k_m_r", c15_dv4);
  for (c15_i13 = 0; c15_i13 < 3; c15_i13++) {
    (*c15_k_m_r)[c15_i13] = c15_dv4[c15_i13];
  }

  c15_k_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 5)),
    "xm_dot", c15_dv5);
  for (c15_i14 = 0; c15_i14 < 6; c15_i14++) {
    (*c15_xm_dot)[c15_i14] = c15_dv5[c15_i14];
  }

  c15_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 6)),
    "yFm", c15_dv6);
  for (c15_i15 = 0; c15_i15 < 3; c15_i15++) {
    (*c15_yFm)[c15_i15] = c15_dv6[c15_i15];
  }

  c15_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 7)),
    "ypm", c15_dv7);
  for (c15_i16 = 0; c15_i16 < 3; c15_i16++) {
    (*c15_ypm)[c15_i16] = c15_dv7[c15_i16];
  }

  chartInstance->c15_first = c15_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c15_u, 8)), "first");
  c15_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 9)),
                       "flag", c15_dv8);
  for (c15_i17 = 0; c15_i17 < 3; c15_i17++) {
    chartInstance->c15_flag[c15_i17] = c15_dv8[c15_i17];
  }

  chartInstance->c15_is_active_c15_Controller = c15_p_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c15_u, 10)),
     "is_active_c15_Controller");
  sf_mex_destroy(&c15_u);
  c15_update_debugger_state_c15_Controller(chartInstance);
  sf_mex_destroy(&c15_st);
}

static void finalize_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance)
{
}

static void sf_c15_Controller(SFc15_ControllerInstanceStruct *chartInstance)
{
  int32_T c15_i18;
  int32_T c15_i19;
  int32_T c15_i20;
  int32_T c15_i21;
  int32_T c15_i22;
  int32_T c15_i23;
  int32_T c15_i24;
  int32_T c15_i25;
  int32_T c15_i26;
  int32_T c15_i27;
  int32_T c15_i28;
  int32_T c15_i29;
  int32_T c15_i30;
  int32_T c15_i31;
  int32_T c15_i32;
  int32_T c15_i33;
  int32_T c15_i34;
  real_T (*c15_frc_ctrl)[3];
  real_T (*c15_eta_p)[3];
  real_T (*c15_k_m_r)[3];
  real_T (*c15_R_m)[9];
  real_T (*c15_Z_m)[3];
  real_T (*c15_yFm)[3];
  real_T (*c15_ypm)[3];
  real_T (*c15_F_C)[3];
  real_T (*c15_F_R)[3];
  real_T (*c15_e_tol)[3];
  real_T (*c15_F_tol)[6];
  real_T (*c15_r_lp)[3];
  real_T (*c15_r)[3];
  real_T (*c15_F0)[6];
  real_T (*c15_y0)[6];
  real_T (*c15_Fm_dot)[6];
  real_T (*c15_xm_dot)[6];
  c15_frc_ctrl = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c15_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 8);
  c15_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c15_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 6);
  c15_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 5);
  c15_yFm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c15_ypm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c15_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 7);
  c15_F_R = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c15_e_tol = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c15_F_tol = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
  c15_r_lp = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c15_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c15_F0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c15_y0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  c15_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c15_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 13U, chartInstance->c15_sfEvent);
  for (c15_i18 = 0; c15_i18 < 6; c15_i18++) {
    _SFD_DATA_RANGE_CHECK((*c15_xm_dot)[c15_i18], 0U);
  }

  for (c15_i19 = 0; c15_i19 < 6; c15_i19++) {
    _SFD_DATA_RANGE_CHECK((*c15_Fm_dot)[c15_i19], 1U);
  }

  for (c15_i20 = 0; c15_i20 < 6; c15_i20++) {
    _SFD_DATA_RANGE_CHECK((*c15_y0)[c15_i20], 2U);
  }

  for (c15_i21 = 0; c15_i21 < 6; c15_i21++) {
    _SFD_DATA_RANGE_CHECK((*c15_F0)[c15_i21], 3U);
  }

  for (c15_i22 = 0; c15_i22 < 3; c15_i22++) {
    _SFD_DATA_RANGE_CHECK((*c15_r)[c15_i22], 4U);
  }

  for (c15_i23 = 0; c15_i23 < 3; c15_i23++) {
    _SFD_DATA_RANGE_CHECK((*c15_r_lp)[c15_i23], 5U);
  }

  for (c15_i24 = 0; c15_i24 < 6; c15_i24++) {
    _SFD_DATA_RANGE_CHECK((*c15_F_tol)[c15_i24], 6U);
  }

  for (c15_i25 = 0; c15_i25 < 3; c15_i25++) {
    _SFD_DATA_RANGE_CHECK((*c15_e_tol)[c15_i25], 7U);
  }

  for (c15_i26 = 0; c15_i26 < 3; c15_i26++) {
    _SFD_DATA_RANGE_CHECK((*c15_F_R)[c15_i26], 8U);
  }

  for (c15_i27 = 0; c15_i27 < 3; c15_i27++) {
    _SFD_DATA_RANGE_CHECK((*c15_F_C)[c15_i27], 9U);
  }

  for (c15_i28 = 0; c15_i28 < 3; c15_i28++) {
    _SFD_DATA_RANGE_CHECK((*c15_ypm)[c15_i28], 10U);
  }

  for (c15_i29 = 0; c15_i29 < 3; c15_i29++) {
    _SFD_DATA_RANGE_CHECK((*c15_yFm)[c15_i29], 11U);
  }

  for (c15_i30 = 0; c15_i30 < 3; c15_i30++) {
    _SFD_DATA_RANGE_CHECK((*c15_Z_m)[c15_i30], 12U);
  }

  for (c15_i31 = 0; c15_i31 < 9; c15_i31++) {
    _SFD_DATA_RANGE_CHECK((*c15_R_m)[c15_i31], 13U);
  }

  for (c15_i32 = 0; c15_i32 < 3; c15_i32++) {
    _SFD_DATA_RANGE_CHECK((*c15_k_m_r)[c15_i32], 14U);
  }

  for (c15_i33 = 0; c15_i33 < 3; c15_i33++) {
    _SFD_DATA_RANGE_CHECK((*c15_eta_p)[c15_i33], 15U);
  }

  for (c15_i34 = 0; c15_i34 < 3; c15_i34++) {
    _SFD_DATA_RANGE_CHECK((*c15_frc_ctrl)[c15_i34], 16U);
  }

  chartInstance->c15_sfEvent = CALL_EVENT;
  c15_chartstep_c15_Controller(chartInstance);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c15_chartstep_c15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance)
{
  int32_T c15_i35;
  real_T c15_y0[6];
  int32_T c15_i36;
  real_T c15_F0[6];
  int32_T c15_i37;
  real_T c15_r[3];
  int32_T c15_i38;
  real_T c15_r_lp[3];
  int32_T c15_i39;
  real_T c15_F_tol[6];
  int32_T c15_i40;
  real_T c15_e_tol[3];
  int32_T c15_i41;
  real_T c15_F_R[3];
  int32_T c15_i42;
  real_T c15_F_C[3];
  int32_T c15_i43;
  real_T c15_eta_p[3];
  uint32_T c15_debug_family_var_map[28];
  real_T c15_xm[2];
  real_T c15_Fm[2];
  real_T c15_zeta;
  real_T c15_omega_0;
  real_T c15_A_m[4];
  real_T c15_B_m[2];
  real_T c15_C_m[2];
  real_T c15_nargin = 9.0;
  real_T c15_nargout = 8.0;
  real_T c15_xm_dot[6];
  real_T c15_Fm_dot[6];
  real_T c15_ypm[3];
  real_T c15_yFm[3];
  real_T c15_Z_m[3];
  real_T c15_R_m[9];
  real_T c15_k_m_r[3];
  real_T c15_frc_ctrl[3];
  int32_T c15_i44;
  int32_T c15_i45;
  int32_T c15_i46;
  int32_T c15_i47;
  int32_T c15_i48;
  int32_T c15_i49;
  int32_T c15_i50;
  int32_T c15_i51;
  int32_T c15_i52;
  int32_T c15_i;
  real_T c15_b_i;
  int32_T c15_c_i;
  int32_T c15_i53;
  int32_T c15_d_i;
  int32_T c15_i54;
  int32_T c15_i55;
  static real_T c15_a[4] = { -1.9800000000000002, -1.2100000000000002, 1.0, 0.0
  };

  int32_T c15_i56;
  int32_T c15_i57;
  int32_T c15_i58;
  real_T c15_b[2];
  int32_T c15_i59;
  real_T c15_y[2];
  int32_T c15_i60;
  int32_T c15_i61;
  real_T c15_b_b;
  int32_T c15_i62;
  int32_T c15_e_i;
  int32_T c15_i63;
  int32_T c15_i64;
  real_T c15_b_y;
  int32_T c15_k;
  int32_T c15_b_k;
  int32_T c15_i65;
  int32_T c15_i66;
  int32_T c15_i67;
  int32_T c15_i68;
  int32_T c15_i69;
  int32_T c15_i70;
  int32_T c15_i71;
  real_T c15_c_b;
  int32_T c15_i72;
  int32_T c15_f_i;
  int32_T c15_i73;
  int32_T c15_i74;
  real_T c15_c_y;
  int32_T c15_c_k;
  int32_T c15_d_k;
  int32_T c15_i75;
  static real_T c15_b_a[4] = { -1.54, -0.48999999999999994, 1.0, 0.0 };

  int32_T c15_i76;
  int32_T c15_i77;
  int32_T c15_i78;
  int32_T c15_i79;
  int32_T c15_i80;
  int32_T c15_i81;
  real_T c15_d_b;
  int32_T c15_i82;
  int32_T c15_g_i;
  int32_T c15_i83;
  int32_T c15_i84;
  real_T c15_d_y;
  int32_T c15_e_k;
  int32_T c15_f_k;
  int32_T c15_i85;
  int32_T c15_i86;
  int32_T c15_i87;
  int32_T c15_i88;
  int32_T c15_i89;
  int32_T c15_i90;
  int32_T c15_i91;
  real_T c15_e_b;
  int32_T c15_i92;
  int32_T c15_h_i;
  int32_T c15_i93;
  int32_T c15_i94;
  real_T c15_e_y;
  int32_T c15_g_k;
  int32_T c15_h_k;
  int32_T c15_i95;
  int32_T c15_i96;
  int32_T c15_i97;
  int32_T c15_i98;
  int32_T c15_i99;
  int32_T c15_i100;
  int32_T c15_i101;
  real_T c15_f_b;
  int32_T c15_i102;
  int32_T c15_i_i;
  int32_T c15_i103;
  int32_T c15_i104;
  real_T c15_f_y;
  int32_T c15_i_k;
  int32_T c15_j_k;
  real_T c15_g_b;
  real_T c15_g_y;
  real_T c15_c_a;
  real_T c15_h_b;
  real_T c15_h_y;
  int32_T c15_j_i;
  real_T c15_d0;
  int32_T c15_i105;
  int32_T c15_i106;
  int32_T c15_i107;
  int32_T c15_i108;
  int32_T c15_i109;
  int32_T c15_i110;
  int32_T c15_i111;
  int32_T c15_i112;
  real_T (*c15_b_xm_dot)[6];
  real_T (*c15_b_Fm_dot)[6];
  real_T (*c15_b_ypm)[3];
  real_T (*c15_b_yFm)[3];
  real_T (*c15_b_Z_m)[3];
  real_T (*c15_b_R_m)[9];
  real_T (*c15_b_k_m_r)[3];
  real_T (*c15_b_frc_ctrl)[3];
  real_T (*c15_b_eta_p)[3];
  real_T (*c15_b_F_C)[3];
  real_T (*c15_b_F_R)[3];
  real_T (*c15_b_e_tol)[3];
  real_T (*c15_b_F_tol)[6];
  real_T (*c15_b_r_lp)[3];
  real_T (*c15_b_r)[3];
  real_T (*c15_b_F0)[6];
  real_T (*c15_b_y0)[6];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  c15_b_frc_ctrl = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 8);
  c15_b_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 8);
  c15_b_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
  c15_b_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 6);
  c15_b_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 5);
  c15_b_yFm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
  c15_b_ypm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
  c15_b_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 7);
  c15_b_F_R = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
  c15_b_e_tol = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c15_b_F_tol = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
  c15_b_r_lp = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c15_b_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c15_b_F0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
  c15_b_y0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  c15_b_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
  c15_b_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 13U, chartInstance->c15_sfEvent);
  for (c15_i35 = 0; c15_i35 < 6; c15_i35++) {
    c15_y0[c15_i35] = (*c15_b_y0)[c15_i35];
  }

  for (c15_i36 = 0; c15_i36 < 6; c15_i36++) {
    c15_F0[c15_i36] = (*c15_b_F0)[c15_i36];
  }

  for (c15_i37 = 0; c15_i37 < 3; c15_i37++) {
    c15_r[c15_i37] = (*c15_b_r)[c15_i37];
  }

  for (c15_i38 = 0; c15_i38 < 3; c15_i38++) {
    c15_r_lp[c15_i38] = (*c15_b_r_lp)[c15_i38];
  }

  for (c15_i39 = 0; c15_i39 < 6; c15_i39++) {
    c15_F_tol[c15_i39] = (*c15_b_F_tol)[c15_i39];
  }

  for (c15_i40 = 0; c15_i40 < 3; c15_i40++) {
    c15_e_tol[c15_i40] = (*c15_b_e_tol)[c15_i40];
  }

  for (c15_i41 = 0; c15_i41 < 3; c15_i41++) {
    c15_F_R[c15_i41] = (*c15_b_F_R)[c15_i41];
  }

  for (c15_i42 = 0; c15_i42 < 3; c15_i42++) {
    c15_F_C[c15_i42] = (*c15_b_F_C)[c15_i42];
  }

  for (c15_i43 = 0; c15_i43 < 3; c15_i43++) {
    c15_eta_p[c15_i43] = (*c15_b_eta_p)[c15_i43];
  }

  sf_debug_symbol_scope_push_eml(0U, 28U, 28U, c15_debug_family_names,
    c15_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c15_xm, 0U, c15_i_sf_marshallOut,
    c15_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_Fm, 1U, c15_i_sf_marshallOut,
    c15_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c15_zeta, 2U, c15_g_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c15_omega_0, 3U, c15_g_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_A_m, 4U, c15_j_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_B_m, 5U, c15_i_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_C_m, 6U, c15_h_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c15_nargin, 7U, c15_g_sf_marshallOut,
    c15_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c15_nargout, 8U,
    c15_g_sf_marshallOut, c15_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c15_y0, 9U, c15_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_F0, 10U, c15_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_r, 11U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_r_lp, 12U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_F_tol, 13U, c15_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_e_tol, 14U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_F_R, 15U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_F_C, 16U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c15_eta_p, 17U, c15_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c15_xm_dot, 18U, c15_f_sf_marshallOut,
    c15_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_Fm_dot, 19U, c15_f_sf_marshallOut,
    c15_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_ypm, 20U, c15_d_sf_marshallOut,
    c15_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_yFm, 21U, c15_d_sf_marshallOut,
    c15_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_Z_m, 22U, c15_d_sf_marshallOut,
    c15_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_R_m, 23U, c15_e_sf_marshallOut,
    c15_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_k_m_r, 24U, c15_d_sf_marshallOut,
    c15_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c15_frc_ctrl, 25U,
    c15_c_sf_marshallOut, c15_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c15_first, 26U,
    c15_b_sf_marshallOut, c15_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c15_flag, 27U,
    c15_sf_marshallOut, c15_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 7);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c15_first_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 9);
    chartInstance->c15_first = 0.0;
    chartInstance->c15_first_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 12);
    for (c15_i44 = 0; c15_i44 < 3; c15_i44++) {
      chartInstance->c15_flag[c15_i44] = 0.0;
    }

    chartInstance->c15_flag_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 17);
  for (c15_i45 = 0; c15_i45 < 3; c15_i45++) {
    c15_ypm[c15_i45] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 18);
  for (c15_i46 = 0; c15_i46 < 3; c15_i46++) {
    c15_yFm[c15_i46] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 19);
  for (c15_i47 = 0; c15_i47 < 6; c15_i47++) {
    c15_xm_dot[c15_i47] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 20);
  for (c15_i48 = 0; c15_i48 < 6; c15_i48++) {
    c15_Fm_dot[c15_i48] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 23);
  for (c15_i49 = 0; c15_i49 < 3; c15_i49++) {
    c15_Z_m[c15_i49] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 24);
  for (c15_i50 = 0; c15_i50 < 9; c15_i50++) {
    c15_R_m[c15_i50] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 25);
  for (c15_i51 = 0; c15_i51 < 3; c15_i51++) {
    c15_k_m_r[c15_i51] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 28);
  for (c15_i52 = 0; c15_i52 < 3; c15_i52++) {
    c15_frc_ctrl[c15_i52] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 31);
  c15_i = 0;
  while (c15_i < 3) {
    c15_b_i = 1.0 + (real_T)c15_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 33);
    c15_c_i = _SFD_EML_ARRAY_BOUNDS_CHECK("y0", (int32_T)_SFD_INTEGER_CHECK("i",
      c15_b_i), 1, 3, 2, 0) - 1;
    for (c15_i53 = 0; c15_i53 < 2; c15_i53++) {
      c15_xm[c15_i53] = c15_y0[c15_i53 + (c15_c_i << 1)];
    }

    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 34);
    c15_d_i = _SFD_EML_ARRAY_BOUNDS_CHECK("F0", (int32_T)_SFD_INTEGER_CHECK("i",
      c15_b_i), 1, 3, 2, 0) - 1;
    for (c15_i54 = 0; c15_i54 < 2; c15_i54++) {
      c15_Fm[c15_i54] = c15_F0[c15_i54 + (c15_d_i << 1)];
    }

    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 36);
    if (CV_EML_IF(0, 1, 1, c15_abs(chartInstance,
          c15_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)_SFD_INTEGER_CHECK("i",
            c15_b_i), 1, 3, 1, 0) - 1] - c15_eta_p[_SFD_EML_ARRAY_BOUNDS_CHECK(
           "eta_p", (int32_T)_SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1])
                  > c15_e_tol[_SFD_EML_ARRAY_BOUNDS_CHECK("e_tol", (int32_T)
          _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1])) {
      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 39);
      c15_zeta = 0.9;
      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 40);
      c15_omega_0 = 1.1;
      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 43);
      for (c15_i55 = 0; c15_i55 < 4; c15_i55++) {
        c15_A_m[c15_i55] = c15_a[c15_i55];
      }

      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 45);
      for (c15_i56 = 0; c15_i56 < 2; c15_i56++) {
        c15_B_m[c15_i56] = 1.2100000000000002 * (real_T)c15_i56;
      }

      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 46);
      for (c15_i57 = 0; c15_i57 < 2; c15_i57++) {
        c15_C_m[c15_i57] = 1.0 - (real_T)c15_i57;
      }

      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 50);
      for (c15_i58 = 0; c15_i58 < 2; c15_i58++) {
        c15_b[c15_i58] = c15_xm[c15_i58];
      }

      c15_eml_scalar_eg(chartInstance);
      c15_eml_scalar_eg(chartInstance);
      for (c15_i59 = 0; c15_i59 < 2; c15_i59++) {
        c15_y[c15_i59] = 0.0;
        c15_i60 = 0;
        for (c15_i61 = 0; c15_i61 < 2; c15_i61++) {
          c15_y[c15_i59] += c15_a[c15_i60 + c15_i59] * c15_b[c15_i61];
          c15_i60 += 2;
        }
      }

      c15_b_b = c15_r_lp[_SFD_EML_ARRAY_BOUNDS_CHECK("r_lp", (int32_T)
        _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1];
      for (c15_i62 = 0; c15_i62 < 2; c15_i62++) {
        c15_b[c15_i62] = 1.2100000000000002 * (real_T)c15_i62 * c15_b_b;
      }

      c15_e_i = _SFD_EML_ARRAY_BOUNDS_CHECK("xm_dot", (int32_T)
        _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1;
      for (c15_i63 = 0; c15_i63 < 2; c15_i63++) {
        c15_xm_dot[c15_i63 + (c15_e_i << 1)] = c15_y[c15_i63] + c15_b[c15_i63];
      }

      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 52);
      for (c15_i64 = 0; c15_i64 < 2; c15_i64++) {
        c15_b[c15_i64] = c15_xm[c15_i64];
      }

      c15_b_eml_scalar_eg(chartInstance);
      c15_b_eml_scalar_eg(chartInstance);
      c15_b_y = 0.0;
      c15_check_forloop_overflow_error(chartInstance);
      for (c15_k = 1; c15_k < 3; c15_k++) {
        c15_b_k = c15_k;
        c15_b_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c15_b_k), 1, 2, 1, 0) - 1)) *
          c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c15_b_k), 1, 2, 1, 0) - 1];
      }

      c15_ypm[_SFD_EML_ARRAY_BOUNDS_CHECK("ypm", (int32_T)_SFD_INTEGER_CHECK("i",
        c15_b_i), 1, 3, 1, 0) - 1] = c15_b_y;
      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 54);
      c15_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl", (int32_T)
        _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 0.0;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 57);
      guard1 = FALSE;
      if (CV_EML_COND(0, 1, 0, c15_abs(chartInstance,
            c15_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
             _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1]) > c15_F_tol
                      [(_SFD_EML_ARRAY_BOUNDS_CHECK("F_tol", (int32_T)
             _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1) << 1])) {
        if (CV_EML_COND(0, 1, 1, c15_abs(chartInstance,
              c15_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)_SFD_INTEGER_CHECK
               ("i", c15_b_i), 1, 3, 1, 0) - 1] -
              c15_eta_p[_SFD_EML_ARRAY_BOUNDS_CHECK("eta_p", (int32_T)
               _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1]) <
                        c15_e_tol[_SFD_EML_ARRAY_BOUNDS_CHECK("e_tol", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1])) {
          CV_EML_MCDC(0, 1, 0, TRUE);
          CV_EML_IF(0, 1, 2, TRUE);
          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 62);
          c15_zeta = 0.9;
          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 63);
          c15_omega_0 = 1.1;
          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 66);
          for (c15_i65 = 0; c15_i65 < 4; c15_i65++) {
            c15_A_m[c15_i65] = c15_a[c15_i65];
          }

          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 68);
          for (c15_i66 = 0; c15_i66 < 2; c15_i66++) {
            c15_B_m[c15_i66] = 1.2100000000000002 * (real_T)c15_i66;
          }

          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 69);
          for (c15_i67 = 0; c15_i67 < 2; c15_i67++) {
            c15_C_m[c15_i67] = 1.0 - (real_T)c15_i67;
          }

          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 71);
          for (c15_i68 = 0; c15_i68 < 2; c15_i68++) {
            c15_b[c15_i68] = c15_Fm[c15_i68];
          }

          c15_eml_scalar_eg(chartInstance);
          c15_eml_scalar_eg(chartInstance);
          for (c15_i69 = 0; c15_i69 < 2; c15_i69++) {
            c15_y[c15_i69] = 0.0;
            c15_i70 = 0;
            for (c15_i71 = 0; c15_i71 < 2; c15_i71++) {
              c15_y[c15_i69] += c15_a[c15_i70 + c15_i69] * c15_b[c15_i71];
              c15_i70 += 2;
            }
          }

          c15_c_b = c15_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
            _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1];
          for (c15_i72 = 0; c15_i72 < 2; c15_i72++) {
            c15_b[c15_i72] = 1.2100000000000002 * (real_T)c15_i72 * c15_c_b;
          }

          c15_f_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Fm_dot", (int32_T)
            _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1;
          for (c15_i73 = 0; c15_i73 < 2; c15_i73++) {
            c15_Fm_dot[c15_i73 + (c15_f_i << 1)] = c15_y[c15_i73] +
              c15_b[c15_i73];
          }

          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 73);
          for (c15_i74 = 0; c15_i74 < 2; c15_i74++) {
            c15_b[c15_i74] = c15_Fm[c15_i74];
          }

          c15_b_eml_scalar_eg(chartInstance);
          c15_b_eml_scalar_eg(chartInstance);
          c15_c_y = 0.0;
          c15_check_forloop_overflow_error(chartInstance);
          for (c15_c_k = 1; c15_c_k < 3; c15_c_k++) {
            c15_d_k = c15_c_k;
            c15_c_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
              _SFD_INTEGER_CHECK("", (real_T)c15_d_k), 1, 2, 1, 0) - 1)) *
              c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
              "", (real_T)c15_d_k), 1, 2, 1, 0) - 1];
          }

          c15_yFm[_SFD_EML_ARRAY_BOUNDS_CHECK("yFm", (int32_T)_SFD_INTEGER_CHECK
            ("i", c15_b_i), 1, 3, 1, 0) - 1] = c15_c_y;
          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 75);
          chartInstance->c15_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
            _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 1.0;
          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 76);
          c15_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl", (int32_T)
            _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 1.0;
        } else {
          guard1 = TRUE;
        }
      } else {
        guard1 = TRUE;
      }

      if (guard1 == TRUE) {
        CV_EML_MCDC(0, 1, 0, FALSE);
        CV_EML_IF(0, 1, 2, FALSE);
        _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 78);
        guard2 = FALSE;
        if (CV_EML_COND(0, 1, 2, c15_abs(chartInstance,
              c15_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
               _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1]) < c15_F_tol[1
                        + ((_SFD_EML_ARRAY_BOUNDS_CHECK("F_tol", (int32_T)
                _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1) << 1)])) {
          if (CV_EML_COND(0, 1, 3, chartInstance->
                          c15_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
                _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] == 1.0)) {
            CV_EML_MCDC(0, 1, 1, TRUE);
            CV_EML_IF(0, 1, 3, TRUE);
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 81);
            c15_zeta = 1.1;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 82);
            c15_omega_0 = 0.7;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 85);
            for (c15_i75 = 0; c15_i75 < 4; c15_i75++) {
              c15_A_m[c15_i75] = c15_b_a[c15_i75];
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 87);
            for (c15_i76 = 0; c15_i76 < 2; c15_i76++) {
              c15_B_m[c15_i76] = 0.48999999999999994 * (real_T)c15_i76;
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 88);
            for (c15_i77 = 0; c15_i77 < 2; c15_i77++) {
              c15_C_m[c15_i77] = 1.0 - (real_T)c15_i77;
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 91);
            for (c15_i78 = 0; c15_i78 < 2; c15_i78++) {
              c15_b[c15_i78] = c15_xm[c15_i78];
            }

            c15_eml_scalar_eg(chartInstance);
            c15_eml_scalar_eg(chartInstance);
            for (c15_i79 = 0; c15_i79 < 2; c15_i79++) {
              c15_y[c15_i79] = 0.0;
              c15_i80 = 0;
              for (c15_i81 = 0; c15_i81 < 2; c15_i81++) {
                c15_y[c15_i79] += c15_b_a[c15_i80 + c15_i79] * c15_b[c15_i81];
                c15_i80 += 2;
              }
            }

            c15_d_b = c15_r_lp[_SFD_EML_ARRAY_BOUNDS_CHECK("r_lp", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1];
            for (c15_i82 = 0; c15_i82 < 2; c15_i82++) {
              c15_b[c15_i82] = 0.48999999999999994 * (real_T)c15_i82 * c15_d_b;
            }

            c15_g_i = _SFD_EML_ARRAY_BOUNDS_CHECK("xm_dot", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1;
            for (c15_i83 = 0; c15_i83 < 2; c15_i83++) {
              c15_xm_dot[c15_i83 + (c15_g_i << 1)] = c15_y[c15_i83] +
                c15_b[c15_i83];
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 93);
            for (c15_i84 = 0; c15_i84 < 2; c15_i84++) {
              c15_b[c15_i84] = c15_xm[c15_i84];
            }

            c15_b_eml_scalar_eg(chartInstance);
            c15_b_eml_scalar_eg(chartInstance);
            c15_d_y = 0.0;
            c15_check_forloop_overflow_error(chartInstance);
            for (c15_e_k = 1; c15_e_k < 3; c15_e_k++) {
              c15_f_k = c15_e_k;
              c15_d_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("",
                (int32_T)_SFD_INTEGER_CHECK("", (real_T)c15_f_k), 1, 2, 1, 0) -
                1)) * c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                _SFD_INTEGER_CHECK("", (real_T)c15_f_k), 1, 2, 1, 0) - 1];
            }

            c15_ypm[_SFD_EML_ARRAY_BOUNDS_CHECK("ypm", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = c15_d_y;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 95);
            chartInstance->c15_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 0.0;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 96);
            c15_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 0.0;
          } else {
            guard2 = TRUE;
          }
        } else {
          guard2 = TRUE;
        }

        if (guard2 == TRUE) {
          CV_EML_MCDC(0, 1, 1, FALSE);
          CV_EML_IF(0, 1, 3, FALSE);
          _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 98);
          guard3 = FALSE;
          guard4 = FALSE;
          if (CV_EML_COND(0, 1, 4, c15_abs(chartInstance,
                c15_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
                 _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1]) <
                          c15_F_tol[(_SFD_EML_ARRAY_BOUNDS_CHECK("F_tol",
                 (int32_T)_SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1) <<
                          1])) {
            if (CV_EML_COND(0, 1, 5, chartInstance->
                            c15_flag[_SFD_EML_ARRAY_BOUNDS_CHECK("flag",
                  (int32_T)_SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] ==
                            1.0)) {
              if (CV_EML_COND(0, 1, 6, c15_abs(chartInstance,
                    c15_r[_SFD_EML_ARRAY_BOUNDS_CHECK("r", (int32_T)
                     _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] -
                    c15_eta_p[_SFD_EML_ARRAY_BOUNDS_CHECK("eta_p", (int32_T)
                     _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1]) <
                              c15_e_tol[_SFD_EML_ARRAY_BOUNDS_CHECK("e_tol",
                    (int32_T)_SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1]))
              {
                CV_EML_MCDC(0, 1, 2, TRUE);
                CV_EML_IF(0, 1, 4, TRUE);
                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 101);
                c15_zeta = 0.9;
                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 102);
                c15_omega_0 = 1.1;
                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 105);
                for (c15_i85 = 0; c15_i85 < 4; c15_i85++) {
                  c15_A_m[c15_i85] = c15_a[c15_i85];
                }

                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 107);
                for (c15_i86 = 0; c15_i86 < 2; c15_i86++) {
                  c15_B_m[c15_i86] = 1.2100000000000002 * (real_T)c15_i86;
                }

                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 108);
                for (c15_i87 = 0; c15_i87 < 2; c15_i87++) {
                  c15_C_m[c15_i87] = 1.0 - (real_T)c15_i87;
                }

                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 111);
                for (c15_i88 = 0; c15_i88 < 2; c15_i88++) {
                  c15_b[c15_i88] = c15_Fm[c15_i88];
                }

                c15_eml_scalar_eg(chartInstance);
                c15_eml_scalar_eg(chartInstance);
                for (c15_i89 = 0; c15_i89 < 2; c15_i89++) {
                  c15_y[c15_i89] = 0.0;
                  c15_i90 = 0;
                  for (c15_i91 = 0; c15_i91 < 2; c15_i91++) {
                    c15_y[c15_i89] += c15_a[c15_i90 + c15_i89] * c15_b[c15_i91];
                    c15_i90 += 2;
                  }
                }

                c15_e_b = c15_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
                  _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1];
                for (c15_i92 = 0; c15_i92 < 2; c15_i92++) {
                  c15_b[c15_i92] = 1.2100000000000002 * (real_T)c15_i92 *
                    c15_e_b;
                }

                c15_h_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Fm_dot", (int32_T)
                  _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1;
                for (c15_i93 = 0; c15_i93 < 2; c15_i93++) {
                  c15_Fm_dot[c15_i93 + (c15_h_i << 1)] = c15_y[c15_i93] +
                    c15_b[c15_i93];
                }

                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 113);
                for (c15_i94 = 0; c15_i94 < 2; c15_i94++) {
                  c15_b[c15_i94] = c15_Fm[c15_i94];
                }

                c15_b_eml_scalar_eg(chartInstance);
                c15_b_eml_scalar_eg(chartInstance);
                c15_e_y = 0.0;
                c15_check_forloop_overflow_error(chartInstance);
                for (c15_g_k = 1; c15_g_k < 3; c15_g_k++) {
                  c15_h_k = c15_g_k;
                  c15_e_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("",
                    (int32_T)_SFD_INTEGER_CHECK("", (real_T)c15_h_k), 1, 2, 1, 0)
                    - 1)) * c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                    _SFD_INTEGER_CHECK("", (real_T)c15_h_k), 1, 2, 1, 0) - 1];
                }

                c15_yFm[_SFD_EML_ARRAY_BOUNDS_CHECK("yFm", (int32_T)
                  _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = c15_e_y;
                _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 115);
                c15_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl", (int32_T)
                  _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 1.0;
              } else {
                guard3 = TRUE;
              }
            } else {
              guard4 = TRUE;
            }
          } else {
            guard4 = TRUE;
          }

          if (guard4 == TRUE) {
            guard3 = TRUE;
          }

          if (guard3 == TRUE) {
            CV_EML_MCDC(0, 1, 2, FALSE);
            CV_EML_IF(0, 1, 4, FALSE);
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 119);
            c15_zeta = 0.9;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 120);
            c15_omega_0 = 1.1;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 123);
            for (c15_i95 = 0; c15_i95 < 4; c15_i95++) {
              c15_A_m[c15_i95] = c15_a[c15_i95];
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 125);
            for (c15_i96 = 0; c15_i96 < 2; c15_i96++) {
              c15_B_m[c15_i96] = 1.2100000000000002 * (real_T)c15_i96;
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 126);
            for (c15_i97 = 0; c15_i97 < 2; c15_i97++) {
              c15_C_m[c15_i97] = 1.0 - (real_T)c15_i97;
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 130U);
            for (c15_i98 = 0; c15_i98 < 2; c15_i98++) {
              c15_b[c15_i98] = c15_xm[c15_i98];
            }

            c15_eml_scalar_eg(chartInstance);
            c15_eml_scalar_eg(chartInstance);
            for (c15_i99 = 0; c15_i99 < 2; c15_i99++) {
              c15_y[c15_i99] = 0.0;
              c15_i100 = 0;
              for (c15_i101 = 0; c15_i101 < 2; c15_i101++) {
                c15_y[c15_i99] += c15_a[c15_i100 + c15_i99] * c15_b[c15_i101];
                c15_i100 += 2;
              }
            }

            c15_f_b = c15_r_lp[_SFD_EML_ARRAY_BOUNDS_CHECK("r_lp", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1];
            for (c15_i102 = 0; c15_i102 < 2; c15_i102++) {
              c15_b[c15_i102] = 1.2100000000000002 * (real_T)c15_i102 * c15_f_b;
            }

            c15_i_i = _SFD_EML_ARRAY_BOUNDS_CHECK("xm_dot", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 2, 0) - 1;
            for (c15_i103 = 0; c15_i103 < 2; c15_i103++) {
              c15_xm_dot[c15_i103 + (c15_i_i << 1)] = c15_y[c15_i103] +
                c15_b[c15_i103];
            }

            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 132U);
            for (c15_i104 = 0; c15_i104 < 2; c15_i104++) {
              c15_b[c15_i104] = c15_xm[c15_i104];
            }

            c15_b_eml_scalar_eg(chartInstance);
            c15_b_eml_scalar_eg(chartInstance);
            c15_f_y = 0.0;
            c15_check_forloop_overflow_error(chartInstance);
            for (c15_i_k = 1; c15_i_k < 3; c15_i_k++) {
              c15_j_k = c15_i_k;
              c15_f_y += (1.0 - (real_T)(_SFD_EML_ARRAY_BOUNDS_CHECK("",
                (int32_T)_SFD_INTEGER_CHECK("", (real_T)c15_j_k), 1, 2, 1, 0) -
                1)) * c15_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
                _SFD_INTEGER_CHECK("", (real_T)c15_j_k), 1, 2, 1, 0) - 1];
            }

            c15_ypm[_SFD_EML_ARRAY_BOUNDS_CHECK("ypm", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = c15_f_y;
            _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 134U);
            c15_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl", (int32_T)
              _SFD_INTEGER_CHECK("i", c15_b_i), 1, 3, 1, 0) - 1] = 0.0;
          }
        }
      }
    }

    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 138U);
    c15_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m", (int32_T)_SFD_INTEGER_CHECK("i",
      c15_b_i), 1, 3, 1, 0) - 1] = 1.0;
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 139U);
    c15_g_b = c15_zeta;
    c15_g_y = 2.0 * c15_g_b;
    c15_c_a = c15_g_y;
    c15_h_b = c15_omega_0;
    c15_h_y = c15_c_a * c15_h_b;
    c15_j_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)_SFD_INTEGER_CHECK("i",
      c15_b_i), 1, 3, 1, 0) - 1;
    c15_d0 = c15_mpower(chartInstance, c15_omega_0);
    c15_R_m[c15_j_i] = 1.0;
    c15_R_m[3 + c15_j_i] = c15_h_y;
    c15_R_m[6 + c15_j_i] = c15_d0;
    _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, 140U);
    c15_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)_SFD_INTEGER_CHECK(
      "i", c15_b_i), 1, 3, 1, 0) - 1] = c15_mpower(chartInstance, c15_omega_0);
    c15_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c15_sfEvent, -140);
  sf_debug_symbol_scope_pop();
  for (c15_i105 = 0; c15_i105 < 6; c15_i105++) {
    (*c15_b_xm_dot)[c15_i105] = c15_xm_dot[c15_i105];
  }

  for (c15_i106 = 0; c15_i106 < 6; c15_i106++) {
    (*c15_b_Fm_dot)[c15_i106] = c15_Fm_dot[c15_i106];
  }

  for (c15_i107 = 0; c15_i107 < 3; c15_i107++) {
    (*c15_b_ypm)[c15_i107] = c15_ypm[c15_i107];
  }

  for (c15_i108 = 0; c15_i108 < 3; c15_i108++) {
    (*c15_b_yFm)[c15_i108] = c15_yFm[c15_i108];
  }

  for (c15_i109 = 0; c15_i109 < 3; c15_i109++) {
    (*c15_b_Z_m)[c15_i109] = c15_Z_m[c15_i109];
  }

  for (c15_i110 = 0; c15_i110 < 9; c15_i110++) {
    (*c15_b_R_m)[c15_i110] = c15_R_m[c15_i110];
  }

  for (c15_i111 = 0; c15_i111 < 3; c15_i111++) {
    (*c15_b_k_m_r)[c15_i111] = c15_k_m_r[c15_i111];
  }

  for (c15_i112 = 0; c15_i112 < 3; c15_i112++) {
    (*c15_b_frc_ctrl)[c15_i112] = c15_frc_ctrl[c15_i112];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 13U, chartInstance->c15_sfEvent);
}

static void initSimStructsc15_Controller(SFc15_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c15_machineNumber, uint32_T
  c15_chartNumber)
{
}

static const mxArray *c15_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i113;
  real_T c15_b_inData[3];
  int32_T c15_i114;
  real_T c15_u[3];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i113 = 0; c15_i113 < 3; c15_i113++) {
    c15_b_inData[c15_i113] = (*(real_T (*)[3])c15_inData)[c15_i113];
  }

  for (c15_i114 = 0; c15_i114 < 3; c15_i114++) {
    c15_u[c15_i114] = c15_b_inData[c15_i114];
  }

  c15_y = NULL;
  if (!chartInstance->c15_flag_not_empty) {
    sf_mex_assign(&c15_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  }

  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_b_flag, const char_T *c15_identifier, real_T c15_y[3])
{
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_flag), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_b_flag);
}

static void c15_b_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[3])
{
  real_T c15_dv9[3];
  int32_T c15_i115;
  if (mxIsEmpty(c15_u)) {
    chartInstance->c15_flag_not_empty = FALSE;
  } else {
    chartInstance->c15_flag_not_empty = TRUE;
    sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv9, 1, 0, 0U, 1, 0U, 1,
                  3);
    for (c15_i115 = 0; c15_i115 < 3; c15_i115++) {
      c15_y[c15_i115] = c15_dv9[c15_i115];
    }
  }

  sf_mex_destroy(&c15_u);
}

static void c15_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_b_flag;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[3];
  int32_T c15_i116;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_b_flag = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_flag), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_b_flag);
  for (c15_i116 = 0; c15_i116 < 3; c15_i116++) {
    (*(real_T (*)[3])c15_outData)[c15_i116] = c15_y[c15_i116];
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_b_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  real_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(real_T *)c15_inData;
  c15_y = NULL;
  if (!chartInstance->c15_first_not_empty) {
    sf_mex_assign(&c15_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static real_T c15_c_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_b_first, const char_T *c15_identifier)
{
  real_T c15_y;
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_first),
    &c15_thisId);
  sf_mex_destroy(&c15_b_first);
  return c15_y;
}

static real_T c15_d_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  real_T c15_y;
  real_T c15_d1;
  if (mxIsEmpty(c15_u)) {
    chartInstance->c15_first_not_empty = FALSE;
  } else {
    chartInstance->c15_first_not_empty = TRUE;
    sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_d1, 1, 0, 0U, 0, 0U, 0);
    c15_y = c15_d1;
  }

  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_b_first;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_b_first = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_first),
    &c15_thisId);
  sf_mex_destroy(&c15_b_first);
  *(real_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_c_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i117;
  real_T c15_b_inData[3];
  int32_T c15_i118;
  real_T c15_u[3];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i117 = 0; c15_i117 < 3; c15_i117++) {
    c15_b_inData[c15_i117] = (*(real_T (*)[3])c15_inData)[c15_i117];
  }

  for (c15_i118 = 0; c15_i118 < 3; c15_i118++) {
    c15_u[c15_i118] = c15_b_inData[c15_i118];
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_e_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_frc_ctrl, const char_T *c15_identifier, real_T c15_y[3])
{
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_frc_ctrl), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_frc_ctrl);
}

static void c15_f_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[3])
{
  real_T c15_dv10[3];
  int32_T c15_i119;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv10, 1, 0, 0U, 1, 0U, 2, 1,
                3);
  for (c15_i119 = 0; c15_i119 < 3; c15_i119++) {
    c15_y[c15_i119] = c15_dv10[c15_i119];
  }

  sf_mex_destroy(&c15_u);
}

static void c15_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_frc_ctrl;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[3];
  int32_T c15_i120;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_frc_ctrl = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_frc_ctrl), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_frc_ctrl);
  for (c15_i120 = 0; c15_i120 < 3; c15_i120++) {
    (*(real_T (*)[3])c15_outData)[c15_i120] = c15_y[c15_i120];
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_d_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i121;
  real_T c15_b_inData[3];
  int32_T c15_i122;
  real_T c15_u[3];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i121 = 0; c15_i121 < 3; c15_i121++) {
    c15_b_inData[c15_i121] = (*(real_T (*)[3])c15_inData)[c15_i121];
  }

  for (c15_i122 = 0; c15_i122 < 3; c15_i122++) {
    c15_u[c15_i122] = c15_b_inData[c15_i122];
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_g_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_k_m_r, const char_T *c15_identifier, real_T c15_y[3])
{
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_k_m_r), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_k_m_r);
}

static void c15_h_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[3])
{
  real_T c15_dv11[3];
  int32_T c15_i123;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv11, 1, 0, 0U, 1, 0U, 1, 3);
  for (c15_i123 = 0; c15_i123 < 3; c15_i123++) {
    c15_y[c15_i123] = c15_dv11[c15_i123];
  }

  sf_mex_destroy(&c15_u);
}

static void c15_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_k_m_r;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[3];
  int32_T c15_i124;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_k_m_r = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_k_m_r), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_k_m_r);
  for (c15_i124 = 0; c15_i124 < 3; c15_i124++) {
    (*(real_T (*)[3])c15_outData)[c15_i124] = c15_y[c15_i124];
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_e_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i125;
  int32_T c15_i126;
  int32_T c15_i127;
  real_T c15_b_inData[9];
  int32_T c15_i128;
  int32_T c15_i129;
  int32_T c15_i130;
  real_T c15_u[9];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_i125 = 0;
  for (c15_i126 = 0; c15_i126 < 3; c15_i126++) {
    for (c15_i127 = 0; c15_i127 < 3; c15_i127++) {
      c15_b_inData[c15_i127 + c15_i125] = (*(real_T (*)[9])c15_inData)[c15_i127
        + c15_i125];
    }

    c15_i125 += 3;
  }

  c15_i128 = 0;
  for (c15_i129 = 0; c15_i129 < 3; c15_i129++) {
    for (c15_i130 = 0; c15_i130 < 3; c15_i130++) {
      c15_u[c15_i130 + c15_i128] = c15_b_inData[c15_i130 + c15_i128];
    }

    c15_i128 += 3;
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_i_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_R_m, const char_T *c15_identifier, real_T c15_y[9])
{
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_R_m), &c15_thisId, c15_y);
  sf_mex_destroy(&c15_R_m);
}

static void c15_j_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[9])
{
  real_T c15_dv12[9];
  int32_T c15_i131;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv12, 1, 0, 0U, 1, 0U, 2, 3,
                3);
  for (c15_i131 = 0; c15_i131 < 9; c15_i131++) {
    c15_y[c15_i131] = c15_dv12[c15_i131];
  }

  sf_mex_destroy(&c15_u);
}

static void c15_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_R_m;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[9];
  int32_T c15_i132;
  int32_T c15_i133;
  int32_T c15_i134;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_R_m = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_R_m), &c15_thisId, c15_y);
  sf_mex_destroy(&c15_R_m);
  c15_i132 = 0;
  for (c15_i133 = 0; c15_i133 < 3; c15_i133++) {
    for (c15_i134 = 0; c15_i134 < 3; c15_i134++) {
      (*(real_T (*)[9])c15_outData)[c15_i134 + c15_i132] = c15_y[c15_i134 +
        c15_i132];
    }

    c15_i132 += 3;
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_f_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i135;
  int32_T c15_i136;
  int32_T c15_i137;
  real_T c15_b_inData[6];
  int32_T c15_i138;
  int32_T c15_i139;
  int32_T c15_i140;
  real_T c15_u[6];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_i135 = 0;
  for (c15_i136 = 0; c15_i136 < 3; c15_i136++) {
    for (c15_i137 = 0; c15_i137 < 2; c15_i137++) {
      c15_b_inData[c15_i137 + c15_i135] = (*(real_T (*)[6])c15_inData)[c15_i137
        + c15_i135];
    }

    c15_i135 += 2;
  }

  c15_i138 = 0;
  for (c15_i139 = 0; c15_i139 < 3; c15_i139++) {
    for (c15_i140 = 0; c15_i140 < 2; c15_i140++) {
      c15_u[c15_i140 + c15_i138] = c15_b_inData[c15_i140 + c15_i138];
    }

    c15_i138 += 2;
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 2, 3), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_k_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_Fm_dot, const char_T *c15_identifier, real_T c15_y[6])
{
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_Fm_dot), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_Fm_dot);
}

static void c15_l_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[6])
{
  real_T c15_dv13[6];
  int32_T c15_i141;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv13, 1, 0, 0U, 1, 0U, 2, 2,
                3);
  for (c15_i141 = 0; c15_i141 < 6; c15_i141++) {
    c15_y[c15_i141] = c15_dv13[c15_i141];
  }

  sf_mex_destroy(&c15_u);
}

static void c15_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_Fm_dot;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[6];
  int32_T c15_i142;
  int32_T c15_i143;
  int32_T c15_i144;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_Fm_dot = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_Fm_dot), &c15_thisId,
    c15_y);
  sf_mex_destroy(&c15_Fm_dot);
  c15_i142 = 0;
  for (c15_i143 = 0; c15_i143 < 3; c15_i143++) {
    for (c15_i144 = 0; c15_i144 < 2; c15_i144++) {
      (*(real_T (*)[6])c15_outData)[c15_i144 + c15_i142] = c15_y[c15_i144 +
        c15_i142];
    }

    c15_i142 += 2;
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_g_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  real_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(real_T *)c15_inData;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static real_T c15_m_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  real_T c15_y;
  real_T c15_d2;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_d2, 1, 0, 0U, 0, 0U, 0);
  c15_y = c15_d2;
  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_nargout;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_nargout = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_m_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_nargout),
    &c15_thisId);
  sf_mex_destroy(&c15_nargout);
  *(real_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

static const mxArray *c15_h_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i145;
  real_T c15_b_inData[2];
  int32_T c15_i146;
  real_T c15_u[2];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i145 = 0; c15_i145 < 2; c15_i145++) {
    c15_b_inData[c15_i145] = (*(real_T (*)[2])c15_inData)[c15_i145];
  }

  for (c15_i146 = 0; c15_i146 < 2; c15_i146++) {
    c15_u[c15_i146] = c15_b_inData[c15_i146];
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static const mxArray *c15_i_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i147;
  real_T c15_b_inData[2];
  int32_T c15_i148;
  real_T c15_u[2];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  for (c15_i147 = 0; c15_i147 < 2; c15_i147++) {
    c15_b_inData[c15_i147] = (*(real_T (*)[2])c15_inData)[c15_i147];
  }

  for (c15_i148 = 0; c15_i148 < 2; c15_i148++) {
    c15_u[c15_i148] = c15_b_inData[c15_i148];
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 1, 2), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static const mxArray *c15_j_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_i149;
  int32_T c15_i150;
  int32_T c15_i151;
  real_T c15_b_inData[4];
  int32_T c15_i152;
  int32_T c15_i153;
  int32_T c15_i154;
  real_T c15_u[4];
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_i149 = 0;
  for (c15_i150 = 0; c15_i150 < 2; c15_i150++) {
    for (c15_i151 = 0; c15_i151 < 2; c15_i151++) {
      c15_b_inData[c15_i151 + c15_i149] = (*(real_T (*)[4])c15_inData)[c15_i151
        + c15_i149];
    }

    c15_i149 += 2;
  }

  c15_i152 = 0;
  for (c15_i153 = 0; c15_i153 < 2; c15_i153++) {
    for (c15_i154 = 0; c15_i154 < 2; c15_i154++) {
      c15_u[c15_i154 + c15_i152] = c15_b_inData[c15_i154 + c15_i152];
    }

    c15_i152 += 2;
  }

  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", c15_u, 0, 0U, 1U, 0U, 2, 2, 2), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static void c15_n_emlrt_marshallIn(SFc15_ControllerInstanceStruct *chartInstance,
  const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId, real_T c15_y[2])
{
  real_T c15_dv14[2];
  int32_T c15_i155;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), c15_dv14, 1, 0, 0U, 1, 0U, 1, 2);
  for (c15_i155 = 0; c15_i155 < 2; c15_i155++) {
    c15_y[c15_i155] = c15_dv14[c15_i155];
  }

  sf_mex_destroy(&c15_u);
}

static void c15_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_Fm;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  real_T c15_y[2];
  int32_T c15_i156;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_Fm = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_Fm), &c15_thisId, c15_y);
  sf_mex_destroy(&c15_Fm);
  for (c15_i156 = 0; c15_i156 < 2; c15_i156++) {
    (*(real_T (*)[2])c15_outData)[c15_i156] = c15_y[c15_i156];
  }

  sf_mex_destroy(&c15_mxArrayInData);
}

const mxArray *sf_c15_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c15_nameCaptureInfo;
  c15_ResolvedFunctionInfo c15_info[34];
  const mxArray *c15_m0 = NULL;
  int32_T c15_i157;
  c15_ResolvedFunctionInfo *c15_r0;
  c15_nameCaptureInfo = NULL;
  c15_nameCaptureInfo = NULL;
  c15_info_helper(c15_info);
  sf_mex_assign(&c15_m0, sf_mex_createstruct("nameCaptureInfo", 1, 34), FALSE);
  for (c15_i157 = 0; c15_i157 < 34; c15_i157++) {
    c15_r0 = &c15_info[c15_i157];
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c15_r0->context)), "context", "nameCaptureInfo",
                    c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->name, 15,
      0U, 0U, 0U, 2, 1, strlen(c15_r0->name)), "name", "nameCaptureInfo",
                    c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      c15_r0->dominantType, 15, 0U, 0U, 0U, 2, 1, strlen(c15_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", c15_r0->resolved,
      15, 0U, 0U, 0U, 2, 1, strlen(c15_r0->resolved)), "resolved",
                    "nameCaptureInfo", c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo", &c15_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      &c15_r0->mFileTimeLo, 7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo",
                    c15_i157);
    sf_mex_addfield(c15_m0, sf_mex_create("nameCaptureInfo",
      &c15_r0->mFileTimeHi, 7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo",
                    c15_i157);
  }

  sf_mex_assign(&c15_nameCaptureInfo, c15_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c15_nameCaptureInfo);
  return c15_nameCaptureInfo;
}

static void c15_info_helper(c15_ResolvedFunctionInfo c15_info[34])
{
  c15_info[0].context = "";
  c15_info[0].name = "abs";
  c15_info[0].dominantType = "double";
  c15_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c15_info[0].fileTimeLo = 1286818694U;
  c15_info[0].fileTimeHi = 0U;
  c15_info[0].mFileTimeLo = 0U;
  c15_info[0].mFileTimeHi = 0U;
  c15_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c15_info[1].name = "eml_scalar_abs";
  c15_info[1].dominantType = "double";
  c15_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c15_info[1].fileTimeLo = 1286818712U;
  c15_info[1].fileTimeHi = 0U;
  c15_info[1].mFileTimeLo = 0U;
  c15_info[1].mFileTimeHi = 0U;
  c15_info[2].context = "";
  c15_info[2].name = "mtimes";
  c15_info[2].dominantType = "double";
  c15_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[2].fileTimeLo = 1289519692U;
  c15_info[2].fileTimeHi = 0U;
  c15_info[2].mFileTimeLo = 0U;
  c15_info[2].mFileTimeHi = 0U;
  c15_info[3].context = "";
  c15_info[3].name = "mpower";
  c15_info[3].dominantType = "double";
  c15_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c15_info[3].fileTimeLo = 1286818842U;
  c15_info[3].fileTimeHi = 0U;
  c15_info[3].mFileTimeLo = 0U;
  c15_info[3].mFileTimeHi = 0U;
  c15_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c15_info[4].name = "power";
  c15_info[4].dominantType = "double";
  c15_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c15_info[4].fileTimeLo = 1336522096U;
  c15_info[4].fileTimeHi = 0U;
  c15_info[4].mFileTimeLo = 0U;
  c15_info[4].mFileTimeHi = 0U;
  c15_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c15_info[5].name = "eml_scalar_eg";
  c15_info[5].dominantType = "double";
  c15_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c15_info[5].fileTimeLo = 1286818796U;
  c15_info[5].fileTimeHi = 0U;
  c15_info[5].mFileTimeLo = 0U;
  c15_info[5].mFileTimeHi = 0U;
  c15_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c15_info[6].name = "eml_scalexp_alloc";
  c15_info[6].dominantType = "double";
  c15_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c15_info[6].fileTimeLo = 1330608434U;
  c15_info[6].fileTimeHi = 0U;
  c15_info[6].mFileTimeLo = 0U;
  c15_info[6].mFileTimeHi = 0U;
  c15_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c15_info[7].name = "floor";
  c15_info[7].dominantType = "double";
  c15_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c15_info[7].fileTimeLo = 1286818742U;
  c15_info[7].fileTimeHi = 0U;
  c15_info[7].mFileTimeLo = 0U;
  c15_info[7].mFileTimeHi = 0U;
  c15_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c15_info[8].name = "eml_scalar_floor";
  c15_info[8].dominantType = "double";
  c15_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c15_info[8].fileTimeLo = 1286818726U;
  c15_info[8].fileTimeHi = 0U;
  c15_info[8].mFileTimeLo = 0U;
  c15_info[8].mFileTimeHi = 0U;
  c15_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[9].name = "eml_index_class";
  c15_info[9].dominantType = "";
  c15_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[9].fileTimeLo = 1323170578U;
  c15_info[9].fileTimeHi = 0U;
  c15_info[9].mFileTimeLo = 0U;
  c15_info[9].mFileTimeHi = 0U;
  c15_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[10].name = "eml_scalar_eg";
  c15_info[10].dominantType = "double";
  c15_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c15_info[10].fileTimeLo = 1286818796U;
  c15_info[10].fileTimeHi = 0U;
  c15_info[10].mFileTimeLo = 0U;
  c15_info[10].mFileTimeHi = 0U;
  c15_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[11].name = "eml_xgemm";
  c15_info[11].dominantType = "char";
  c15_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c15_info[11].fileTimeLo = 1299076772U;
  c15_info[11].fileTimeHi = 0U;
  c15_info[11].mFileTimeLo = 0U;
  c15_info[11].mFileTimeHi = 0U;
  c15_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xgemm.m";
  c15_info[12].name = "eml_blas_inline";
  c15_info[12].dominantType = "";
  c15_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c15_info[12].fileTimeLo = 1299076768U;
  c15_info[12].fileTimeHi = 0U;
  c15_info[12].mFileTimeLo = 0U;
  c15_info[12].mFileTimeHi = 0U;
  c15_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m!below_threshold";
  c15_info[13].name = "mtimes";
  c15_info[13].dominantType = "double";
  c15_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[13].fileTimeLo = 1289519692U;
  c15_info[13].fileTimeHi = 0U;
  c15_info[13].mFileTimeLo = 0U;
  c15_info[13].mFileTimeHi = 0U;
  c15_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c15_info[14].name = "eml_index_class";
  c15_info[14].dominantType = "";
  c15_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[14].fileTimeLo = 1323170578U;
  c15_info[14].fileTimeHi = 0U;
  c15_info[14].mFileTimeLo = 0U;
  c15_info[14].mFileTimeHi = 0U;
  c15_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c15_info[15].name = "eml_scalar_eg";
  c15_info[15].dominantType = "double";
  c15_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c15_info[15].fileTimeLo = 1286818796U;
  c15_info[15].fileTimeHi = 0U;
  c15_info[15].mFileTimeLo = 0U;
  c15_info[15].mFileTimeHi = 0U;
  c15_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xgemm.m";
  c15_info[16].name = "eml_refblas_xgemm";
  c15_info[16].dominantType = "char";
  c15_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xgemm.m";
  c15_info[16].fileTimeLo = 1299076774U;
  c15_info[16].fileTimeHi = 0U;
  c15_info[16].mFileTimeLo = 0U;
  c15_info[16].mFileTimeHi = 0U;
  c15_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c15_info[17].name = "eml_xdotu";
  c15_info[17].dominantType = "double";
  c15_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c15_info[17].fileTimeLo = 1299076772U;
  c15_info[17].fileTimeHi = 0U;
  c15_info[17].mFileTimeLo = 0U;
  c15_info[17].mFileTimeHi = 0U;
  c15_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c15_info[18].name = "eml_blas_inline";
  c15_info[18].dominantType = "";
  c15_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c15_info[18].fileTimeLo = 1299076768U;
  c15_info[18].fileTimeHi = 0U;
  c15_info[18].mFileTimeLo = 0U;
  c15_info[18].mFileTimeHi = 0U;
  c15_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c15_info[19].name = "eml_xdot";
  c15_info[19].dominantType = "double";
  c15_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c15_info[19].fileTimeLo = 1299076772U;
  c15_info[19].fileTimeHi = 0U;
  c15_info[19].mFileTimeLo = 0U;
  c15_info[19].mFileTimeHi = 0U;
  c15_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c15_info[20].name = "eml_blas_inline";
  c15_info[20].dominantType = "";
  c15_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c15_info[20].fileTimeLo = 1299076768U;
  c15_info[20].fileTimeHi = 0U;
  c15_info[20].mFileTimeLo = 0U;
  c15_info[20].mFileTimeHi = 0U;
  c15_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c15_info[21].name = "eml_index_class";
  c15_info[21].dominantType = "";
  c15_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[21].fileTimeLo = 1323170578U;
  c15_info[21].fileTimeHi = 0U;
  c15_info[21].mFileTimeLo = 0U;
  c15_info[21].mFileTimeHi = 0U;
  c15_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c15_info[22].name = "eml_refblas_xdot";
  c15_info[22].dominantType = "double";
  c15_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c15_info[22].fileTimeLo = 1299076772U;
  c15_info[22].fileTimeHi = 0U;
  c15_info[22].mFileTimeLo = 0U;
  c15_info[22].mFileTimeHi = 0U;
  c15_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c15_info[23].name = "eml_refblas_xdotx";
  c15_info[23].dominantType = "char";
  c15_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[23].fileTimeLo = 1299076774U;
  c15_info[23].fileTimeHi = 0U;
  c15_info[23].mFileTimeLo = 0U;
  c15_info[23].mFileTimeHi = 0U;
  c15_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[24].name = "eml_scalar_eg";
  c15_info[24].dominantType = "double";
  c15_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c15_info[24].fileTimeLo = 1286818796U;
  c15_info[24].fileTimeHi = 0U;
  c15_info[24].mFileTimeLo = 0U;
  c15_info[24].mFileTimeHi = 0U;
  c15_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[25].name = "eml_index_class";
  c15_info[25].dominantType = "";
  c15_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[25].fileTimeLo = 1323170578U;
  c15_info[25].fileTimeHi = 0U;
  c15_info[25].mFileTimeLo = 0U;
  c15_info[25].mFileTimeHi = 0U;
  c15_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[26].name = "eml_index_minus";
  c15_info[26].dominantType = "double";
  c15_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c15_info[26].fileTimeLo = 1286818778U;
  c15_info[26].fileTimeHi = 0U;
  c15_info[26].mFileTimeLo = 0U;
  c15_info[26].mFileTimeHi = 0U;
  c15_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c15_info[27].name = "eml_index_class";
  c15_info[27].dominantType = "";
  c15_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[27].fileTimeLo = 1323170578U;
  c15_info[27].fileTimeHi = 0U;
  c15_info[27].mFileTimeLo = 0U;
  c15_info[27].mFileTimeHi = 0U;
  c15_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[28].name = "eml_index_times";
  c15_info[28].dominantType = "coder.internal.indexInt";
  c15_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c15_info[28].fileTimeLo = 1286818780U;
  c15_info[28].fileTimeHi = 0U;
  c15_info[28].mFileTimeLo = 0U;
  c15_info[28].mFileTimeHi = 0U;
  c15_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c15_info[29].name = "eml_index_class";
  c15_info[29].dominantType = "";
  c15_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[29].fileTimeLo = 1323170578U;
  c15_info[29].fileTimeHi = 0U;
  c15_info[29].mFileTimeLo = 0U;
  c15_info[29].mFileTimeHi = 0U;
  c15_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[30].name = "eml_index_plus";
  c15_info[30].dominantType = "coder.internal.indexInt";
  c15_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c15_info[30].fileTimeLo = 1286818778U;
  c15_info[30].fileTimeHi = 0U;
  c15_info[30].mFileTimeLo = 0U;
  c15_info[30].mFileTimeHi = 0U;
  c15_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c15_info[31].name = "eml_index_class";
  c15_info[31].dominantType = "";
  c15_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c15_info[31].fileTimeLo = 1323170578U;
  c15_info[31].fileTimeHi = 0U;
  c15_info[31].mFileTimeLo = 0U;
  c15_info[31].mFileTimeHi = 0U;
  c15_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c15_info[32].name = "eml_int_forloop_overflow_check";
  c15_info[32].dominantType = "";
  c15_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c15_info[32].fileTimeLo = 1332168672U;
  c15_info[32].fileTimeHi = 0U;
  c15_info[32].mFileTimeLo = 0U;
  c15_info[32].mFileTimeHi = 0U;
  c15_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c15_info[33].name = "intmax";
  c15_info[33].dominantType = "char";
  c15_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c15_info[33].fileTimeLo = 1311255316U;
  c15_info[33].fileTimeHi = 0U;
  c15_info[33].mFileTimeLo = 0U;
  c15_info[33].mFileTimeHi = 0U;
}

static real_T c15_abs(SFc15_ControllerInstanceStruct *chartInstance, real_T
                      c15_x)
{
  real_T c15_b_x;
  c15_b_x = c15_x;
  return muDoubleScalarAbs(c15_b_x);
}

static real_T c15_mpower(SFc15_ControllerInstanceStruct *chartInstance, real_T
  c15_a)
{
  real_T c15_b_a;
  real_T c15_c_a;
  real_T c15_ak;
  c15_b_a = c15_a;
  c15_c_a = c15_b_a;
  c15_ak = c15_c_a;
  return muDoubleScalarPower(c15_ak, 2.0);
}

static void c15_eml_scalar_eg(SFc15_ControllerInstanceStruct *chartInstance)
{
}

static void c15_b_eml_scalar_eg(SFc15_ControllerInstanceStruct *chartInstance)
{
}

static void c15_check_forloop_overflow_error(SFc15_ControllerInstanceStruct
  *chartInstance)
{
}

static const mxArray *c15_k_sf_marshallOut(void *chartInstanceVoid, void
  *c15_inData)
{
  const mxArray *c15_mxArrayOutData = NULL;
  int32_T c15_u;
  const mxArray *c15_y = NULL;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_mxArrayOutData = NULL;
  c15_u = *(int32_T *)c15_inData;
  c15_y = NULL;
  sf_mex_assign(&c15_y, sf_mex_create("y", &c15_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c15_mxArrayOutData, c15_y, FALSE);
  return c15_mxArrayOutData;
}

static int32_T c15_o_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  int32_T c15_y;
  int32_T c15_i158;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_i158, 1, 6, 0U, 0, 0U, 0);
  c15_y = c15_i158;
  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void c15_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c15_mxArrayInData, const char_T *c15_varName, void *c15_outData)
{
  const mxArray *c15_b_sfEvent;
  const char_T *c15_identifier;
  emlrtMsgIdentifier c15_thisId;
  int32_T c15_y;
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)chartInstanceVoid;
  c15_b_sfEvent = sf_mex_dup(c15_mxArrayInData);
  c15_identifier = c15_varName;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_o_emlrt_marshallIn(chartInstance, sf_mex_dup(c15_b_sfEvent),
    &c15_thisId);
  sf_mex_destroy(&c15_b_sfEvent);
  *(int32_T *)c15_outData = c15_y;
  sf_mex_destroy(&c15_mxArrayInData);
}

static uint8_T c15_p_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_b_is_active_c15_Controller, const char_T
  *c15_identifier)
{
  uint8_T c15_y;
  emlrtMsgIdentifier c15_thisId;
  c15_thisId.fIdentifier = c15_identifier;
  c15_thisId.fParent = NULL;
  c15_y = c15_q_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c15_b_is_active_c15_Controller), &c15_thisId);
  sf_mex_destroy(&c15_b_is_active_c15_Controller);
  return c15_y;
}

static uint8_T c15_q_emlrt_marshallIn(SFc15_ControllerInstanceStruct
  *chartInstance, const mxArray *c15_u, const emlrtMsgIdentifier *c15_parentId)
{
  uint8_T c15_y;
  uint8_T c15_u0;
  sf_mex_import(c15_parentId, sf_mex_dup(c15_u), &c15_u0, 1, 3, 0U, 0, 0U, 0);
  c15_y = c15_u0;
  sf_mex_destroy(&c15_u);
  return c15_y;
}

static void init_dsm_address_info(SFc15_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c15_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1274575206U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3821407507U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3627584847U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2824811453U);
}

mxArray *sf_c15_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("JafjLdkuZVyC14ljOKEDiH");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,9,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }

    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,8,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,7,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }

    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c15_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x10'type','srcId','name','auxInfo'{{M[1],M[28],T\"Fm_dot\",},{M[1],M[18],T\"R_m\",},{M[1],M[17],T\"Z_m\",},{M[1],M[35],T\"frc_ctrl\",},{M[1],M[19],T\"k_m_r\",},{M[1],M[11],T\"xm_dot\",},{M[1],M[34],T\"yFm\",},{M[1],M[10],T\"ypm\",},{M[4],M[0],T\"first\",S'l','i','p'{{M1x2[158 163],M[0],}}},{M[4],M[0],T\"flag\",S'l','i','p'{{M1x2[164 168],M[0],}}}}",
    "100 S'type','srcId','name','auxInfo'{{M[8],M[0],T\"is_active_c15_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 11, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c15_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc15_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc15_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           15,
           1,
           1,
           17,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"xm_dot");
          _SFD_SET_DATA_PROPS(1,2,0,1,"Fm_dot");
          _SFD_SET_DATA_PROPS(2,1,1,0,"y0");
          _SFD_SET_DATA_PROPS(3,1,1,0,"F0");
          _SFD_SET_DATA_PROPS(4,1,1,0,"r");
          _SFD_SET_DATA_PROPS(5,1,1,0,"r_lp");
          _SFD_SET_DATA_PROPS(6,1,1,0,"F_tol");
          _SFD_SET_DATA_PROPS(7,1,1,0,"e_tol");
          _SFD_SET_DATA_PROPS(8,1,1,0,"F_R");
          _SFD_SET_DATA_PROPS(9,1,1,0,"F_C");
          _SFD_SET_DATA_PROPS(10,2,0,1,"ypm");
          _SFD_SET_DATA_PROPS(11,2,0,1,"yFm");
          _SFD_SET_DATA_PROPS(12,2,0,1,"Z_m");
          _SFD_SET_DATA_PROPS(13,2,0,1,"R_m");
          _SFD_SET_DATA_PROPS(14,2,0,1,"k_m_r");
          _SFD_SET_DATA_PROPS(15,1,1,0,"eta_p");
          _SFD_SET_DATA_PROPS(16,2,0,1,"frc_ctrl");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,5,0,0,0,1,0,7,3);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,4053);
        _SFD_CV_INIT_EML_IF(0,1,0,198,215,-1,337);
        _SFD_CV_INIT_EML_IF(0,1,1,787,819,1409,3923);
        _SFD_CV_INIT_EML_IF(0,1,2,1409,1473,2083,3923);
        _SFD_CV_INIT_EML_IF(0,1,3,2083,2130,2723,3923);
        _SFD_CV_INIT_EML_IF(0,1,4,2723,2803,3363,3923);
        _SFD_CV_INIT_EML_FOR(0,1,0,713,725,4048);

        {
          static int condStart[] = { 1416, 1444 };

          static int condEnd[] = { 1440, 1473 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,1416,1473,2,0,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 2090, 2118 };

          static int condEnd[] = { 2114, 2130 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,2090,2130,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 2730, 2758, 2774 };

          static int condEnd[] = { 2754, 2770, 2803 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,2730,2803,3,4,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_f_sf_marshallOut,(MexInFcnForType)
            c15_f_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_f_sf_marshallOut,(MexInFcnForType)
            c15_f_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(10,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)
            c15_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(11,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)
            c15_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(12,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)
            c15_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(13,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_e_sf_marshallOut,(MexInFcnForType)
            c15_e_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(14,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)
            c15_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(15,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(16,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c15_c_sf_marshallOut,(MexInFcnForType)
            c15_c_sf_marshallIn);
        }

        {
          real_T (*c15_xm_dot)[6];
          real_T (*c15_Fm_dot)[6];
          real_T (*c15_y0)[6];
          real_T (*c15_F0)[6];
          real_T (*c15_r)[3];
          real_T (*c15_r_lp)[3];
          real_T (*c15_F_tol)[6];
          real_T (*c15_e_tol)[3];
          real_T (*c15_F_R)[3];
          real_T (*c15_F_C)[3];
          real_T (*c15_ypm)[3];
          real_T (*c15_yFm)[3];
          real_T (*c15_Z_m)[3];
          real_T (*c15_R_m)[9];
          real_T (*c15_k_m_r)[3];
          real_T (*c15_eta_p)[3];
          real_T (*c15_frc_ctrl)[3];
          c15_frc_ctrl = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S,
            8);
          c15_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 8);
          c15_k_m_r = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 7);
          c15_R_m = (real_T (*)[9])ssGetOutputPortSignal(chartInstance->S, 6);
          c15_Z_m = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 5);
          c15_yFm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 4);
          c15_ypm = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 3);
          c15_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 7);
          c15_F_R = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 6);
          c15_e_tol = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
          c15_F_tol = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
          c15_r_lp = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c15_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
          c15_F0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 1);
          c15_y0 = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          c15_Fm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 2);
          c15_xm_dot = (real_T (*)[6])ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, *c15_xm_dot);
          _SFD_SET_DATA_VALUE_PTR(1U, *c15_Fm_dot);
          _SFD_SET_DATA_VALUE_PTR(2U, *c15_y0);
          _SFD_SET_DATA_VALUE_PTR(3U, *c15_F0);
          _SFD_SET_DATA_VALUE_PTR(4U, *c15_r);
          _SFD_SET_DATA_VALUE_PTR(5U, *c15_r_lp);
          _SFD_SET_DATA_VALUE_PTR(6U, *c15_F_tol);
          _SFD_SET_DATA_VALUE_PTR(7U, *c15_e_tol);
          _SFD_SET_DATA_VALUE_PTR(8U, *c15_F_R);
          _SFD_SET_DATA_VALUE_PTR(9U, *c15_F_C);
          _SFD_SET_DATA_VALUE_PTR(10U, *c15_ypm);
          _SFD_SET_DATA_VALUE_PTR(11U, *c15_yFm);
          _SFD_SET_DATA_VALUE_PTR(12U, *c15_Z_m);
          _SFD_SET_DATA_VALUE_PTR(13U, *c15_R_m);
          _SFD_SET_DATA_VALUE_PTR(14U, *c15_k_m_r);
          _SFD_SET_DATA_VALUE_PTR(15U, *c15_eta_p);
          _SFD_SET_DATA_VALUE_PTR(16U, *c15_frc_ctrl);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "ufwnyyZi5PflosNE3Hx4sC";
}

static void sf_opaque_initialize_c15_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc15_ControllerInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c15_Controller((SFc15_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c15_Controller((SFc15_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c15_Controller(void *chartInstanceVar)
{
  enable_c15_Controller((SFc15_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c15_Controller(void *chartInstanceVar)
{
  disable_c15_Controller((SFc15_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c15_Controller(void *chartInstanceVar)
{
  sf_c15_Controller((SFc15_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c15_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c15_Controller
    ((SFc15_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c15_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c15_Controller(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c15_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c15_Controller((SFc15_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c15_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c15_Controller(S);
}

static void sf_opaque_set_sim_state_c15_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c15_Controller(S, st);
}

static void sf_opaque_terminate_c15_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc15_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c15_Controller((SFc15_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc15_Controller((SFc15_ControllerInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c15_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c15_Controller((SFc15_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c15_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      15);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,15,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,15,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,15,9);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,15,8);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,15);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(807745589U));
  ssSetChecksum1(S,(1923297103U));
  ssSetChecksum2(S,(1416695296U));
  ssSetChecksum3(S,(269539023U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c15_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c15_Controller(SimStruct *S)
{
  SFc15_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc15_ControllerInstanceStruct *)malloc(sizeof
    (SFc15_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc15_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c15_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c15_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c15_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c15_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c15_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c15_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c15_Controller;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c15_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c15_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c15_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c15_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c15_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c15_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c15_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c15_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c15_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
