/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c3_Controller.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c3_debug_family_names[10] = { "nargin", "nargout", "limits",
  "eta_tilde", "time", "time_rst", "rst", "time_reset_x", "time_reset_y",
  "time_reset_psi" };

/* Function Declarations */
static void initialize_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance);
static void enable_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance);
static void disable_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance);
static void c3_update_debugger_state_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c3_Controller(SFc3_ControllerInstanceStruct *
  chartInstance);
static void set_sim_state_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_st);
static void finalize_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance);
static void sf_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance);
static void initSimStructsc3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber);
static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData);
static real_T c3_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_b_time_reset_psi, const char_T *c3_identifier);
static real_T c3_b_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static real_T c3_c_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_b_time_reset_y, const char_T *c3_identifier);
static real_T c3_d_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_c_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static real_T c3_e_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_b_time_reset_x, const char_T *c3_identifier);
static real_T c3_f_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_d_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static void c3_g_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_rst, const char_T *c3_identifier, real_T c3_y[3]);
static void c3_h_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[3]);
static void c3_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_e_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static const mxArray *c3_f_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static real_T c3_i_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_g_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static int32_T c3_j_emlrt_marshallIn(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static uint8_T c3_k_emlrt_marshallIn(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_b_is_active_c3_Controller, const char_T
  *c3_identifier);
static uint8_T c3_l_emlrt_marshallIn(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void init_dsm_address_info(SFc3_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c3_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c3_time_reset_x_not_empty = FALSE;
  chartInstance->c3_time_reset_y_not_empty = FALSE;
  chartInstance->c3_time_reset_psi_not_empty = FALSE;
  chartInstance->c3_is_active_c3_Controller = 0U;
}

static void initialize_params_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c3_update_debugger_state_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c3_Controller(SFc3_ControllerInstanceStruct *
  chartInstance)
{
  const mxArray *c3_st;
  const mxArray *c3_y = NULL;
  int32_T c3_i0;
  real_T c3_u[3];
  const mxArray *c3_b_y = NULL;
  real_T c3_hoistedGlobal;
  real_T c3_b_u;
  const mxArray *c3_c_y = NULL;
  real_T c3_b_hoistedGlobal;
  real_T c3_c_u;
  const mxArray *c3_d_y = NULL;
  real_T c3_c_hoistedGlobal;
  real_T c3_d_u;
  const mxArray *c3_e_y = NULL;
  uint8_T c3_d_hoistedGlobal;
  uint8_T c3_e_u;
  const mxArray *c3_f_y = NULL;
  real_T (*c3_rst)[3];
  c3_rst = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c3_st = NULL;
  c3_st = NULL;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_createcellarray(5), FALSE);
  for (c3_i0 = 0; c3_i0 < 3; c3_i0++) {
    c3_u[c3_i0] = (*c3_rst)[c3_i0];
  }

  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_setcell(c3_y, 0, c3_b_y);
  c3_hoistedGlobal = chartInstance->c3_time_reset_psi;
  c3_b_u = c3_hoistedGlobal;
  c3_c_y = NULL;
  if (!chartInstance->c3_time_reset_psi_not_empty) {
    sf_mex_assign(&c3_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c3_c_y, sf_mex_create("y", &c3_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c3_y, 1, c3_c_y);
  c3_b_hoistedGlobal = chartInstance->c3_time_reset_x;
  c3_c_u = c3_b_hoistedGlobal;
  c3_d_y = NULL;
  if (!chartInstance->c3_time_reset_x_not_empty) {
    sf_mex_assign(&c3_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c3_d_y, sf_mex_create("y", &c3_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c3_y, 2, c3_d_y);
  c3_c_hoistedGlobal = chartInstance->c3_time_reset_y;
  c3_d_u = c3_c_hoistedGlobal;
  c3_e_y = NULL;
  if (!chartInstance->c3_time_reset_y_not_empty) {
    sf_mex_assign(&c3_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c3_e_y, sf_mex_create("y", &c3_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c3_y, 3, c3_e_y);
  c3_d_hoistedGlobal = chartInstance->c3_is_active_c3_Controller;
  c3_e_u = c3_d_hoistedGlobal;
  c3_f_y = NULL;
  sf_mex_assign(&c3_f_y, sf_mex_create("y", &c3_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 4, c3_f_y);
  sf_mex_assign(&c3_st, c3_y, FALSE);
  return c3_st;
}

static void set_sim_state_c3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_st)
{
  const mxArray *c3_u;
  real_T c3_dv0[3];
  int32_T c3_i1;
  real_T (*c3_rst)[3];
  c3_rst = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c3_doneDoubleBufferReInit = TRUE;
  c3_u = sf_mex_dup(c3_st);
  c3_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 0)),
                        "rst", c3_dv0);
  for (c3_i1 = 0; c3_i1 < 3; c3_i1++) {
    (*c3_rst)[c3_i1] = c3_dv0[c3_i1];
  }

  chartInstance->c3_time_reset_psi = c3_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c3_u, 1)), "time_reset_psi");
  chartInstance->c3_time_reset_x = c3_e_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c3_u, 2)), "time_reset_x");
  chartInstance->c3_time_reset_y = c3_c_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c3_u, 3)), "time_reset_y");
  chartInstance->c3_is_active_c3_Controller = c3_k_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 4)),
     "is_active_c3_Controller");
  sf_mex_destroy(&c3_u);
  c3_update_debugger_state_c3_Controller(chartInstance);
  sf_mex_destroy(&c3_st);
}

static void finalize_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance)
{
}

static void sf_c3_Controller(SFc3_ControllerInstanceStruct *chartInstance)
{
  int32_T c3_i2;
  int32_T c3_i3;
  int32_T c3_i4;
  real_T c3_hoistedGlobal;
  real_T c3_b_hoistedGlobal;
  int32_T c3_i5;
  real_T c3_limits[3];
  int32_T c3_i6;
  real_T c3_eta_tilde[3];
  real_T c3_time;
  real_T c3_time_rst;
  uint32_T c3_debug_family_var_map[10];
  real_T c3_nargin = 4.0;
  real_T c3_nargout = 1.0;
  real_T c3_rst[3];
  int32_T c3_i7;
  real_T c3_x;
  real_T c3_b_x;
  real_T c3_y;
  real_T c3_c_x;
  real_T c3_d_x;
  real_T c3_b_y;
  real_T c3_e_x;
  real_T c3_f_x;
  real_T c3_c_y;
  int32_T c3_i8;
  real_T *c3_b_time;
  real_T *c3_b_time_rst;
  real_T (*c3_b_rst)[3];
  real_T (*c3_b_eta_tilde)[3];
  real_T (*c3_b_limits)[3];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  boolean_T guard5 = FALSE;
  boolean_T guard6 = FALSE;
  c3_b_time_rst = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c3_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c3_b_rst = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c3_b_eta_tilde = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c3_b_limits = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  for (c3_i2 = 0; c3_i2 < 3; c3_i2++) {
    _SFD_DATA_RANGE_CHECK((*c3_b_limits)[c3_i2], 0U);
  }

  for (c3_i3 = 0; c3_i3 < 3; c3_i3++) {
    _SFD_DATA_RANGE_CHECK((*c3_b_eta_tilde)[c3_i3], 1U);
  }

  for (c3_i4 = 0; c3_i4 < 3; c3_i4++) {
    _SFD_DATA_RANGE_CHECK((*c3_b_rst)[c3_i4], 2U);
  }

  _SFD_DATA_RANGE_CHECK(*c3_b_time, 3U);
  _SFD_DATA_RANGE_CHECK(*c3_b_time_rst, 4U);
  chartInstance->c3_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  c3_hoistedGlobal = *c3_b_time;
  c3_b_hoistedGlobal = *c3_b_time_rst;
  for (c3_i5 = 0; c3_i5 < 3; c3_i5++) {
    c3_limits[c3_i5] = (*c3_b_limits)[c3_i5];
  }

  for (c3_i6 = 0; c3_i6 < 3; c3_i6++) {
    c3_eta_tilde[c3_i6] = (*c3_b_eta_tilde)[c3_i6];
  }

  c3_time = c3_hoistedGlobal;
  c3_time_rst = c3_b_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c3_debug_family_names,
    c3_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargin, 0U, c3_e_sf_marshallOut,
    c3_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargout, 1U, c3_e_sf_marshallOut,
    c3_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c3_limits, 2U, c3_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c3_eta_tilde, 3U, c3_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_time, 4U, c3_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_time_rst, 5U, c3_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c3_rst, 6U, c3_d_sf_marshallOut,
    c3_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c3_time_reset_x, 7U,
    c3_c_sf_marshallOut, c3_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c3_time_reset_y, 8U,
    c3_b_sf_marshallOut, c3_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c3_time_reset_psi, 9U,
    c3_sf_marshallOut, c3_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 5);
  guard6 = FALSE;
  if (CV_EML_COND(0, 1, 0, !chartInstance->c3_time_reset_x_not_empty)) {
    guard6 = TRUE;
  } else if (CV_EML_COND(0, 1, 1, c3_time < 1.0)) {
    guard6 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
  }

  if (guard6 == TRUE) {
    CV_EML_MCDC(0, 1, 0, TRUE);
    CV_EML_IF(0, 1, 0, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 6);
    chartInstance->c3_time_reset_x = 0.0;
    chartInstance->c3_time_reset_x_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 9);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 10);
  guard5 = FALSE;
  if (CV_EML_COND(0, 1, 2, !chartInstance->c3_time_reset_y_not_empty)) {
    guard5 = TRUE;
  } else if (CV_EML_COND(0, 1, 3, c3_time < 1.0)) {
    guard5 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 1, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
  }

  if (guard5 == TRUE) {
    CV_EML_MCDC(0, 1, 1, TRUE);
    CV_EML_IF(0, 1, 1, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 11);
    chartInstance->c3_time_reset_y = 0.0;
    chartInstance->c3_time_reset_y_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 14);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 15);
  guard4 = FALSE;
  if (CV_EML_COND(0, 1, 4, !chartInstance->c3_time_reset_psi_not_empty)) {
    guard4 = TRUE;
  } else if (CV_EML_COND(0, 1, 5, c3_time < 1.0)) {
    guard4 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 2, FALSE);
    CV_EML_IF(0, 1, 2, FALSE);
  }

  if (guard4 == TRUE) {
    CV_EML_MCDC(0, 1, 2, TRUE);
    CV_EML_IF(0, 1, 2, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 16);
    chartInstance->c3_time_reset_psi = 0.0;
    chartInstance->c3_time_reset_psi_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 19);
  for (c3_i7 = 0; c3_i7 < 3; c3_i7++) {
    c3_rst[c3_i7] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 21);
  c3_x = c3_eta_tilde[0];
  c3_b_x = c3_x;
  c3_y = muDoubleScalarAbs(c3_b_x);
  guard3 = FALSE;
  if (CV_EML_COND(0, 1, 6, c3_y > c3_limits[0])) {
    if (CV_EML_COND(0, 1, 7, c3_time - chartInstance->c3_time_reset_x >
                    c3_time_rst)) {
      CV_EML_MCDC(0, 1, 3, TRUE);
      CV_EML_IF(0, 1, 3, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 22);
      c3_rst[0] = 1.0;
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 23);
      chartInstance->c3_time_reset_x = c3_time;
    } else {
      guard3 = TRUE;
    }
  } else {
    guard3 = TRUE;
  }

  if (guard3 == TRUE) {
    CV_EML_MCDC(0, 1, 3, FALSE);
    CV_EML_IF(0, 1, 3, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 24);
    CV_EML_IF(0, 1, 4, c3_time - chartInstance->c3_time_reset_x < 0.02);
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 28);
  c3_c_x = c3_eta_tilde[1];
  c3_d_x = c3_c_x;
  c3_b_y = muDoubleScalarAbs(c3_d_x);
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 8, c3_b_y > c3_limits[1])) {
    if (CV_EML_COND(0, 1, 9, c3_time - chartInstance->c3_time_reset_y >
                    c3_time_rst)) {
      CV_EML_MCDC(0, 1, 4, TRUE);
      CV_EML_IF(0, 1, 5, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 29);
      c3_rst[1] = 1.0;
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 30);
      chartInstance->c3_time_reset_y = c3_time;
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    CV_EML_MCDC(0, 1, 4, FALSE);
    CV_EML_IF(0, 1, 5, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 31);
    CV_EML_IF(0, 1, 6, c3_time - chartInstance->c3_time_reset_y < 0.02);
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 35);
  c3_e_x = c3_eta_tilde[2];
  c3_f_x = c3_e_x;
  c3_c_y = muDoubleScalarAbs(c3_f_x);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 10, c3_c_y > c3_limits[2])) {
    if (CV_EML_COND(0, 1, 11, c3_time - chartInstance->c3_time_reset_psi >
                    c3_time_rst)) {
      CV_EML_MCDC(0, 1, 5, TRUE);
      CV_EML_IF(0, 1, 7, TRUE);
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 36);
      c3_rst[2] = 1.0;
      _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 37);
      chartInstance->c3_time_reset_psi = c3_time;
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 5, FALSE);
    CV_EML_IF(0, 1, 7, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 38);
    CV_EML_IF(0, 1, 8, c3_time - chartInstance->c3_time_reset_psi < 0.02);
  }

  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, -38);
  sf_debug_symbol_scope_pop();
  for (c3_i8 = 0; c3_i8 < 3; c3_i8++) {
    (*c3_b_rst)[c3_i8] = c3_rst[c3_i8];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc3_Controller(SFc3_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber)
{
}

static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  if (!chartInstance->c3_time_reset_psi_not_empty) {
    sf_mex_assign(&c3_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_b_time_reset_psi, const char_T *c3_identifier)
{
  real_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_time_reset_psi),
    &c3_thisId);
  sf_mex_destroy(&c3_b_time_reset_psi);
  return c3_y;
}

static real_T c3_b_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d0;
  if (mxIsEmpty(c3_u)) {
    chartInstance->c3_time_reset_psi_not_empty = FALSE;
  } else {
    chartInstance->c3_time_reset_psi_not_empty = TRUE;
    sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d0, 1, 0, 0U, 0, 0U, 0);
    c3_y = c3_d0;
  }

  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_time_reset_psi;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_b_time_reset_psi = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_time_reset_psi),
    &c3_thisId);
  sf_mex_destroy(&c3_b_time_reset_psi);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  if (!chartInstance->c3_time_reset_y_not_empty) {
    sf_mex_assign(&c3_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_c_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_b_time_reset_y, const char_T *c3_identifier)
{
  real_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_time_reset_y),
    &c3_thisId);
  sf_mex_destroy(&c3_b_time_reset_y);
  return c3_y;
}

static real_T c3_d_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d1;
  if (mxIsEmpty(c3_u)) {
    chartInstance->c3_time_reset_y_not_empty = FALSE;
  } else {
    chartInstance->c3_time_reset_y_not_empty = TRUE;
    sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d1, 1, 0, 0U, 0, 0U, 0);
    c3_y = c3_d1;
  }

  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_time_reset_y;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_b_time_reset_y = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_time_reset_y),
    &c3_thisId);
  sf_mex_destroy(&c3_b_time_reset_y);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_c_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  if (!chartInstance->c3_time_reset_x_not_empty) {
    sf_mex_assign(&c3_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_e_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_b_time_reset_x, const char_T *c3_identifier)
{
  real_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_time_reset_x),
    &c3_thisId);
  sf_mex_destroy(&c3_b_time_reset_x);
  return c3_y;
}

static real_T c3_f_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d2;
  if (mxIsEmpty(c3_u)) {
    chartInstance->c3_time_reset_x_not_empty = FALSE;
  } else {
    chartInstance->c3_time_reset_x_not_empty = TRUE;
    sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d2, 1, 0, 0U, 0, 0U, 0);
    c3_y = c3_d2;
  }

  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_time_reset_x;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_b_time_reset_x = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_time_reset_x),
    &c3_thisId);
  sf_mex_destroy(&c3_b_time_reset_x);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_d_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i9;
  real_T c3_b_inData[3];
  int32_T c3_i10;
  real_T c3_u[3];
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  for (c3_i9 = 0; c3_i9 < 3; c3_i9++) {
    c3_b_inData[c3_i9] = (*(real_T (*)[3])c3_inData)[c3_i9];
  }

  for (c3_i10 = 0; c3_i10 < 3; c3_i10++) {
    c3_u[c3_i10] = c3_b_inData[c3_i10];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static void c3_g_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_rst, const char_T *c3_identifier, real_T c3_y[3])
{
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_rst), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_rst);
}

static void c3_h_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId, real_T c3_y[3])
{
  real_T c3_dv1[3];
  int32_T c3_i11;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), c3_dv1, 1, 0, 0U, 1, 0U, 2, 1, 3);
  for (c3_i11 = 0; c3_i11 < 3; c3_i11++) {
    c3_y[c3_i11] = c3_dv1[c3_i11];
  }

  sf_mex_destroy(&c3_u);
}

static void c3_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_rst;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y[3];
  int32_T c3_i12;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_rst = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_rst), &c3_thisId, c3_y);
  sf_mex_destroy(&c3_rst);
  for (c3_i12 = 0; c3_i12 < 3; c3_i12++) {
    (*(real_T (*)[3])c3_outData)[c3_i12] = c3_y[c3_i12];
  }

  sf_mex_destroy(&c3_mxArrayInData);
}

static const mxArray *c3_e_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static const mxArray *c3_f_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_i13;
  real_T c3_b_inData[3];
  int32_T c3_i14;
  real_T c3_u[3];
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  for (c3_i13 = 0; c3_i13 < 3; c3_i13++) {
    c3_b_inData[c3_i13] = (*(real_T (*)[3])c3_inData)[c3_i13];
  }

  for (c3_i14 = 0; c3_i14 < 3; c3_i14++) {
    c3_u[c3_i14] = c3_b_inData[c3_i14];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_i_emlrt_marshallIn(SFc3_ControllerInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d3;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d3, 1, 0, 0U, 0, 0U, 0);
  c3_y = c3_d3;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_nargout;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_nargout = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_i_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_nargout), &c3_thisId);
  sf_mex_destroy(&c3_nargout);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

const mxArray *sf_c3_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo;
  c3_ResolvedFunctionInfo c3_info[2];
  c3_ResolvedFunctionInfo (*c3_b_info)[2];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i15;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  c3_b_info = (c3_ResolvedFunctionInfo (*)[2])c3_info;
  (*c3_b_info)[0].context = "";
  (*c3_b_info)[0].name = "abs";
  (*c3_b_info)[0].dominantType = "double";
  (*c3_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c3_b_info)[0].fileTimeLo = 1286818694U;
  (*c3_b_info)[0].fileTimeHi = 0U;
  (*c3_b_info)[0].mFileTimeLo = 0U;
  (*c3_b_info)[0].mFileTimeHi = 0U;
  (*c3_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c3_b_info)[1].name = "eml_scalar_abs";
  (*c3_b_info)[1].dominantType = "double";
  (*c3_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c3_b_info)[1].fileTimeLo = 1286818712U;
  (*c3_b_info)[1].fileTimeHi = 0U;
  (*c3_b_info)[1].mFileTimeLo = 0U;
  (*c3_b_info)[1].mFileTimeHi = 0U;
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 2), FALSE);
  for (c3_i15 = 0; c3_i15 < 2; c3_i15++) {
    c3_r0 = &c3_info[c3_i15];
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->context)), "context", "nameCaptureInfo",
                    c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c3_r0->name)), "name", "nameCaptureInfo", c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved", "nameCaptureInfo",
                    c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c3_i15);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c3_i15);
  }

  sf_mex_assign(&c3_nameCaptureInfo, c3_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c3_nameCaptureInfo);
  return c3_nameCaptureInfo;
}

static const mxArray *c3_g_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(int32_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static int32_T c3_j_emlrt_marshallIn(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  int32_T c3_y;
  int32_T c3_i16;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_i16, 1, 6, 0U, 0, 0U, 0);
  c3_y = c3_i16;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_sfEvent;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  int32_T c3_y;
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)chartInstanceVoid;
  c3_b_sfEvent = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_sfEvent),
    &c3_thisId);
  sf_mex_destroy(&c3_b_sfEvent);
  *(int32_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static uint8_T c3_k_emlrt_marshallIn(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_b_is_active_c3_Controller, const char_T
  *c3_identifier)
{
  uint8_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_l_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c3_b_is_active_c3_Controller), &c3_thisId);
  sf_mex_destroy(&c3_b_is_active_c3_Controller);
  return c3_y;
}

static uint8_T c3_l_emlrt_marshallIn(SFc3_ControllerInstanceStruct
  *chartInstance, const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  uint8_T c3_y;
  uint8_T c3_u0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_u0, 1, 3, 0U, 0, 0U, 0);
  c3_y = c3_u0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void init_dsm_address_info(SFc3_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c3_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3069072229U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(864638925U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2223266220U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2653053565U);
}

mxArray *sf_c3_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("vzaOhbJifUTHS7MlmVy6rD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c3_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[5],T\"rst\",},{M[4],M[0],T\"time_reset_psi\",S'l','i','p'{{M1x2[251 265],M[0],}}},{M[4],M[0],T\"time_reset_x\",S'l','i','p'{{M1x2[73 85],M[0],}}},{M[4],M[0],T\"time_reset_y\",S'l','i','p'{{M1x2[162 174],M[0],}}},{M[8],M[0],T\"is_active_c3_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c3_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc3_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc3_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           3,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"limits");
          _SFD_SET_DATA_PROPS(1,1,1,0,"eta_tilde");
          _SFD_SET_DATA_PROPS(2,2,0,1,"rst");
          _SFD_SET_DATA_PROPS(3,1,1,0,"time");
          _SFD_SET_DATA_PROPS(4,1,1,0,"time_rst");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,9,0,0,0,0,0,12,6);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,836);
        _SFD_CV_INIT_EML_IF(0,1,0,87,123,-1,149);
        _SFD_CV_INIT_EML_IF(0,1,1,176,212,-1,238);
        _SFD_CV_INIT_EML_IF(0,1,2,268,306,-1,334);
        _SFD_CV_INIT_EML_IF(0,1,3,352,416,457,488);
        _SFD_CV_INIT_EML_IF(0,1,4,457,488,-1,488);
        _SFD_CV_INIT_EML_IF(0,1,5,512,576,617,648);
        _SFD_CV_INIT_EML_IF(0,1,6,617,648,-1,648);
        _SFD_CV_INIT_EML_IF(0,1,7,672,738,781,814);
        _SFD_CV_INIT_EML_IF(0,1,8,781,814,-1,814);

        {
          static int condStart[] = { 90, 115 };

          static int condEnd[] = { 111, 123 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,90,123,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        {
          static int condStart[] = { 179, 204 };

          static int condEnd[] = { 200, 212 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,179,212,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 271, 298 };

          static int condEnd[] = { 294, 306 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,271,306,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 355, 388 };

          static int condEnd[] = { 384, 416 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,3,355,416,2,6,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 515, 548 };

          static int condEnd[] = { 544, 576 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,4,515,576,2,8,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 675, 708 };

          static int condEnd[] = { 704, 738 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,5,675,738,2,10,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c3_d_sf_marshallOut,(MexInFcnForType)
            c3_d_sf_marshallIn);
        }

        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_e_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_e_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c3_time;
          real_T *c3_time_rst;
          real_T (*c3_limits)[3];
          real_T (*c3_eta_tilde)[3];
          real_T (*c3_rst)[3];
          c3_time_rst = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c3_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c3_rst = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c3_eta_tilde = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c3_limits = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c3_limits);
          _SFD_SET_DATA_VALUE_PTR(1U, *c3_eta_tilde);
          _SFD_SET_DATA_VALUE_PTR(2U, *c3_rst);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_time);
          _SFD_SET_DATA_VALUE_PTR(4U, c3_time_rst);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "YYTYZSZfXbgNVQuHHiQpsG";
}

static void sf_opaque_initialize_c3_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc3_ControllerInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c3_Controller((SFc3_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c3_Controller((SFc3_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c3_Controller(void *chartInstanceVar)
{
  enable_c3_Controller((SFc3_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c3_Controller(void *chartInstanceVar)
{
  disable_c3_Controller((SFc3_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c3_Controller(void *chartInstanceVar)
{
  sf_c3_Controller((SFc3_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c3_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c3_Controller
    ((SFc3_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c3_Controller(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c3_Controller((SFc3_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c3_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c3_Controller(S);
}

static void sf_opaque_set_sim_state_c3_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c3_Controller(S, st);
}

static void sf_opaque_terminate_c3_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc3_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c3_Controller((SFc3_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc3_Controller((SFc3_ControllerInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c3_Controller((SFc3_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c3_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,3,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,3,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,3,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,3,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1740330042U));
  ssSetChecksum1(S,(1876914731U));
  ssSetChecksum2(S,(1078390238U));
  ssSetChecksum3(S,(18606130U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c3_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_Controller(SimStruct *S)
{
  SFc3_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc3_ControllerInstanceStruct *)malloc(sizeof
    (SFc3_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc3_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c3_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c3_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c3_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c3_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c3_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c3_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c3_Controller;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c3_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c3_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c3_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c3_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c3_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
