#ifndef __c4_Controller_h__
#define __c4_Controller_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c4_ResolvedFunctionInfo
#define typedef_c4_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c4_ResolvedFunctionInfo;

#endif                                 /*typedef_c4_ResolvedFunctionInfo*/

#ifndef typedef_SFc4_ControllerInstanceStruct
#define typedef_SFc4_ControllerInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c4_sfEvent;
  boolean_T c4_isStable;
  boolean_T c4_doneDoubleBufferReInit;
  uint8_T c4_is_active_c4_Controller;
  real_T c4_d_x;
  boolean_T c4_d_x_not_empty;
  real_T c4_d_y;
  boolean_T c4_d_y_not_empty;
  real_T c4_d_psi;
  boolean_T c4_d_psi_not_empty;
} SFc4_ControllerInstanceStruct;

#endif                                 /*typedef_SFc4_ControllerInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c4_Controller_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c4_Controller_get_check_sum(mxArray *plhs[]);
extern void c4_Controller_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
