/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c5_Controller.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c5_debug_family_names[10] = { "nargin", "nargout", "gain",
  "eta_tilde", "rst", "time", "d_hybrid", "nu_x", "nu_y", "nu_psi" };

/* Function Declarations */
static void initialize_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance);
static void enable_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance);
static void disable_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance);
static void c5_update_debugger_state_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c5_Controller(SFc5_ControllerInstanceStruct *
  chartInstance);
static void set_sim_state_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_st);
static void finalize_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance);
static void sf_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance);
static void initSimStructsc5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber);
static const mxArray *c5_sf_marshallOut(void *chartInstanceVoid, void *c5_inData);
static real_T c5_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_b_nu_psi, const char_T *c5_identifier);
static real_T c5_b_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_b_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static real_T c5_c_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_b_nu_y, const char_T *c5_identifier);
static real_T c5_d_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_c_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static real_T c5_e_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_b_nu_x, const char_T *c5_identifier);
static real_T c5_f_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_d_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static void c5_g_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_d_hybrid, const char_T *c5_identifier, real_T c5_y[3]);
static void c5_h_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, real_T c5_y[3]);
static void c5_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_e_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static const mxArray *c5_f_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static real_T c5_i_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static const mxArray *c5_g_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static int32_T c5_j_emlrt_marshallIn(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static uint8_T c5_k_emlrt_marshallIn(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_b_is_active_c5_Controller, const char_T
  *c5_identifier);
static uint8_T c5_l_emlrt_marshallIn(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void init_dsm_address_info(SFc5_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c5_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c5_nu_x_not_empty = FALSE;
  chartInstance->c5_nu_y_not_empty = FALSE;
  chartInstance->c5_nu_psi_not_empty = FALSE;
  chartInstance->c5_is_active_c5_Controller = 0U;
}

static void initialize_params_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c5_update_debugger_state_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c5_Controller(SFc5_ControllerInstanceStruct *
  chartInstance)
{
  const mxArray *c5_st;
  const mxArray *c5_y = NULL;
  int32_T c5_i0;
  real_T c5_u[3];
  const mxArray *c5_b_y = NULL;
  real_T c5_hoistedGlobal;
  real_T c5_b_u;
  const mxArray *c5_c_y = NULL;
  real_T c5_b_hoistedGlobal;
  real_T c5_c_u;
  const mxArray *c5_d_y = NULL;
  real_T c5_c_hoistedGlobal;
  real_T c5_d_u;
  const mxArray *c5_e_y = NULL;
  uint8_T c5_d_hoistedGlobal;
  uint8_T c5_e_u;
  const mxArray *c5_f_y = NULL;
  real_T (*c5_d_hybrid)[3];
  c5_d_hybrid = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c5_st = NULL;
  c5_st = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createcellarray(5), FALSE);
  for (c5_i0 = 0; c5_i0 < 3; c5_i0++) {
    c5_u[c5_i0] = (*c5_d_hybrid)[c5_i0];
  }

  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", c5_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_setcell(c5_y, 0, c5_b_y);
  c5_hoistedGlobal = chartInstance->c5_nu_psi;
  c5_b_u = c5_hoistedGlobal;
  c5_c_y = NULL;
  if (!chartInstance->c5_nu_psi_not_empty) {
    sf_mex_assign(&c5_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c5_c_y, sf_mex_create("y", &c5_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c5_y, 1, c5_c_y);
  c5_b_hoistedGlobal = chartInstance->c5_nu_x;
  c5_c_u = c5_b_hoistedGlobal;
  c5_d_y = NULL;
  if (!chartInstance->c5_nu_x_not_empty) {
    sf_mex_assign(&c5_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c5_d_y, sf_mex_create("y", &c5_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c5_y, 2, c5_d_y);
  c5_c_hoistedGlobal = chartInstance->c5_nu_y;
  c5_d_u = c5_c_hoistedGlobal;
  c5_e_y = NULL;
  if (!chartInstance->c5_nu_y_not_empty) {
    sf_mex_assign(&c5_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c5_e_y, sf_mex_create("y", &c5_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c5_y, 3, c5_e_y);
  c5_d_hoistedGlobal = chartInstance->c5_is_active_c5_Controller;
  c5_e_u = c5_d_hoistedGlobal;
  c5_f_y = NULL;
  sf_mex_assign(&c5_f_y, sf_mex_create("y", &c5_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c5_y, 4, c5_f_y);
  sf_mex_assign(&c5_st, c5_y, FALSE);
  return c5_st;
}

static void set_sim_state_c5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_st)
{
  const mxArray *c5_u;
  real_T c5_dv0[3];
  int32_T c5_i1;
  real_T (*c5_d_hybrid)[3];
  c5_d_hybrid = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c5_doneDoubleBufferReInit = TRUE;
  c5_u = sf_mex_dup(c5_st);
  c5_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 0)),
                        "d_hybrid", c5_dv0);
  for (c5_i1 = 0; c5_i1 < 3; c5_i1++) {
    (*c5_d_hybrid)[c5_i1] = c5_dv0[c5_i1];
  }

  chartInstance->c5_nu_psi = c5_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c5_u, 1)), "nu_psi");
  chartInstance->c5_nu_x = c5_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c5_u, 2)), "nu_x");
  chartInstance->c5_nu_y = c5_c_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c5_u, 3)), "nu_y");
  chartInstance->c5_is_active_c5_Controller = c5_k_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 4)),
     "is_active_c5_Controller");
  sf_mex_destroy(&c5_u);
  c5_update_debugger_state_c5_Controller(chartInstance);
  sf_mex_destroy(&c5_st);
}

static void finalize_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance)
{
}

static void sf_c5_Controller(SFc5_ControllerInstanceStruct *chartInstance)
{
  int32_T c5_i2;
  int32_T c5_i3;
  int32_T c5_i4;
  int32_T c5_i5;
  real_T c5_hoistedGlobal;
  int32_T c5_i6;
  real_T c5_gain[3];
  int32_T c5_i7;
  real_T c5_eta_tilde[3];
  int32_T c5_i8;
  real_T c5_rst[3];
  real_T c5_time;
  uint32_T c5_debug_family_var_map[10];
  real_T c5_nargin = 4.0;
  real_T c5_nargout = 1.0;
  real_T c5_d_hybrid[3];
  real_T c5_b_hoistedGlobal;
  real_T c5_a;
  real_T c5_b;
  real_T c5_y;
  real_T c5_c_hoistedGlobal;
  real_T c5_b_a;
  real_T c5_b_b;
  real_T c5_b_y;
  real_T c5_d_hoistedGlobal;
  real_T c5_c_a;
  real_T c5_c_b;
  real_T c5_c_y;
  real_T c5_dv1[3];
  int32_T c5_i9;
  int32_T c5_i10;
  real_T *c5_b_time;
  real_T (*c5_b_d_hybrid)[3];
  real_T (*c5_b_rst)[3];
  real_T (*c5_b_eta_tilde)[3];
  real_T (*c5_b_gain)[3];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  c5_b_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c5_b_rst = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c5_b_eta_tilde = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
  c5_b_d_hybrid = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
  c5_b_gain = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 4U, chartInstance->c5_sfEvent);
  for (c5_i2 = 0; c5_i2 < 3; c5_i2++) {
    _SFD_DATA_RANGE_CHECK((*c5_b_gain)[c5_i2], 0U);
  }

  for (c5_i3 = 0; c5_i3 < 3; c5_i3++) {
    _SFD_DATA_RANGE_CHECK((*c5_b_d_hybrid)[c5_i3], 1U);
  }

  for (c5_i4 = 0; c5_i4 < 3; c5_i4++) {
    _SFD_DATA_RANGE_CHECK((*c5_b_eta_tilde)[c5_i4], 2U);
  }

  for (c5_i5 = 0; c5_i5 < 3; c5_i5++) {
    _SFD_DATA_RANGE_CHECK((*c5_b_rst)[c5_i5], 3U);
  }

  _SFD_DATA_RANGE_CHECK(*c5_b_time, 4U);
  chartInstance->c5_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 4U, chartInstance->c5_sfEvent);
  c5_hoistedGlobal = *c5_b_time;
  for (c5_i6 = 0; c5_i6 < 3; c5_i6++) {
    c5_gain[c5_i6] = (*c5_b_gain)[c5_i6];
  }

  for (c5_i7 = 0; c5_i7 < 3; c5_i7++) {
    c5_eta_tilde[c5_i7] = (*c5_b_eta_tilde)[c5_i7];
  }

  for (c5_i8 = 0; c5_i8 < 3; c5_i8++) {
    c5_rst[c5_i8] = (*c5_b_rst)[c5_i8];
  }

  c5_time = c5_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 10U, 10U, c5_debug_family_names,
    c5_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c5_nargin, 0U, c5_e_sf_marshallOut,
    c5_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c5_nargout, 1U, c5_e_sf_marshallOut,
    c5_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c5_gain, 2U, c5_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c5_eta_tilde, 3U, c5_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c5_rst, 4U, c5_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_time, 5U, c5_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c5_d_hybrid, 6U, c5_d_sf_marshallOut,
    c5_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c5_nu_x, 7U,
    c5_c_sf_marshallOut, c5_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c5_nu_y, 8U,
    c5_b_sf_marshallOut, c5_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c5_nu_psi, 9U,
    c5_sf_marshallOut, c5_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 5);
  guard3 = FALSE;
  if (CV_EML_COND(0, 1, 0, !chartInstance->c5_nu_x_not_empty)) {
    guard3 = TRUE;
  } else if (CV_EML_COND(0, 1, 1, c5_time < 1.0)) {
    guard3 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 0, FALSE);
  }

  if (guard3 == TRUE) {
    CV_EML_MCDC(0, 1, 0, TRUE);
    CV_EML_IF(0, 1, 0, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 6);
    chartInstance->c5_nu_x = 0.0;
    chartInstance->c5_nu_x_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 9);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 10);
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 2, !chartInstance->c5_nu_y_not_empty)) {
    guard2 = TRUE;
  } else if (CV_EML_COND(0, 1, 3, c5_time < 1.0)) {
    guard2 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 1, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
  }

  if (guard2 == TRUE) {
    CV_EML_MCDC(0, 1, 1, TRUE);
    CV_EML_IF(0, 1, 1, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 11);
    chartInstance->c5_nu_y = 0.0;
    chartInstance->c5_nu_y_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 14);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 15);
  guard1 = FALSE;
  if (CV_EML_COND(0, 1, 4, !chartInstance->c5_nu_psi_not_empty)) {
    guard1 = TRUE;
  } else if (CV_EML_COND(0, 1, 5, c5_time < 1.0)) {
    guard1 = TRUE;
  } else {
    CV_EML_MCDC(0, 1, 2, FALSE);
    CV_EML_IF(0, 1, 2, FALSE);
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 2, TRUE);
    CV_EML_IF(0, 1, 2, TRUE);
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 16);
    chartInstance->c5_nu_psi = 0.0;
    chartInstance->c5_nu_psi_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 21);
  if (CV_EML_IF(0, 1, 3, c5_rst[0] > 0.1)) {
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 22);
    c5_b_hoistedGlobal = chartInstance->c5_nu_x;
    c5_a = c5_gain[0];
    c5_b = c5_eta_tilde[0];
    c5_y = c5_a * c5_b;
    chartInstance->c5_nu_x = c5_b_hoistedGlobal + c5_y;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 25);
  if (CV_EML_IF(0, 1, 4, c5_rst[1] > 0.1)) {
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 26);
    c5_c_hoistedGlobal = chartInstance->c5_nu_y;
    c5_b_a = c5_gain[1];
    c5_b_b = c5_eta_tilde[1];
    c5_b_y = c5_b_a * c5_b_b;
    chartInstance->c5_nu_y = c5_c_hoistedGlobal + c5_b_y;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 29);
  if (CV_EML_IF(0, 1, 5, c5_rst[2] > 0.1)) {
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 30);
    c5_d_hoistedGlobal = chartInstance->c5_nu_psi;
    c5_c_a = c5_gain[2];
    c5_c_b = c5_eta_tilde[2];
    c5_c_y = c5_c_a * c5_c_b;
    chartInstance->c5_nu_psi = c5_d_hoistedGlobal + c5_c_y;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 33);
  c5_dv1[0] = chartInstance->c5_nu_x;
  c5_dv1[1] = chartInstance->c5_nu_y;
  c5_dv1[2] = chartInstance->c5_nu_psi;
  for (c5_i9 = 0; c5_i9 < 3; c5_i9++) {
    c5_d_hybrid[c5_i9] = c5_dv1[c5_i9];
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, -33);
  sf_debug_symbol_scope_pop();
  for (c5_i10 = 0; c5_i10 < 3; c5_i10++) {
    (*c5_b_d_hybrid)[c5_i10] = c5_d_hybrid[c5_i10];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 4U, chartInstance->c5_sfEvent);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc5_Controller(SFc5_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber)
{
}

static const mxArray *c5_sf_marshallOut(void *chartInstanceVoid, void *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  real_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(real_T *)c5_inData;
  c5_y = NULL;
  if (!chartInstance->c5_nu_psi_not_empty) {
    sf_mex_assign(&c5_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static real_T c5_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_b_nu_psi, const char_T *c5_identifier)
{
  real_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_nu_psi),
    &c5_thisId);
  sf_mex_destroy(&c5_b_nu_psi);
  return c5_y;
}

static real_T c5_b_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  real_T c5_y;
  real_T c5_d0;
  if (mxIsEmpty(c5_u)) {
    chartInstance->c5_nu_psi_not_empty = FALSE;
  } else {
    chartInstance->c5_nu_psi_not_empty = TRUE;
    sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_d0, 1, 0, 0U, 0, 0U, 0);
    c5_y = c5_d0;
  }

  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_nu_psi;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_b_nu_psi = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_nu_psi),
    &c5_thisId);
  sf_mex_destroy(&c5_b_nu_psi);
  *(real_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_b_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  real_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(real_T *)c5_inData;
  c5_y = NULL;
  if (!chartInstance->c5_nu_y_not_empty) {
    sf_mex_assign(&c5_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static real_T c5_c_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_b_nu_y, const char_T *c5_identifier)
{
  real_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_nu_y), &c5_thisId);
  sf_mex_destroy(&c5_b_nu_y);
  return c5_y;
}

static real_T c5_d_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  real_T c5_y;
  real_T c5_d1;
  if (mxIsEmpty(c5_u)) {
    chartInstance->c5_nu_y_not_empty = FALSE;
  } else {
    chartInstance->c5_nu_y_not_empty = TRUE;
    sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_d1, 1, 0, 0U, 0, 0U, 0);
    c5_y = c5_d1;
  }

  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_nu_y;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_b_nu_y = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_nu_y), &c5_thisId);
  sf_mex_destroy(&c5_b_nu_y);
  *(real_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_c_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  real_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(real_T *)c5_inData;
  c5_y = NULL;
  if (!chartInstance->c5_nu_x_not_empty) {
    sf_mex_assign(&c5_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static real_T c5_e_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_b_nu_x, const char_T *c5_identifier)
{
  real_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_nu_x), &c5_thisId);
  sf_mex_destroy(&c5_b_nu_x);
  return c5_y;
}

static real_T c5_f_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  real_T c5_y;
  real_T c5_d2;
  if (mxIsEmpty(c5_u)) {
    chartInstance->c5_nu_x_not_empty = FALSE;
  } else {
    chartInstance->c5_nu_x_not_empty = TRUE;
    sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_d2, 1, 0, 0U, 0, 0U, 0);
    c5_y = c5_d2;
  }

  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_nu_x;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_b_nu_x = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_nu_x), &c5_thisId);
  sf_mex_destroy(&c5_b_nu_x);
  *(real_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_d_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i11;
  real_T c5_b_inData[3];
  int32_T c5_i12;
  real_T c5_u[3];
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  for (c5_i11 = 0; c5_i11 < 3; c5_i11++) {
    c5_b_inData[c5_i11] = (*(real_T (*)[3])c5_inData)[c5_i11];
  }

  for (c5_i12 = 0; c5_i12 < 3; c5_i12++) {
    c5_u[c5_i12] = c5_b_inData[c5_i12];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static void c5_g_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_d_hybrid, const char_T *c5_identifier, real_T c5_y[3])
{
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_d_hybrid), &c5_thisId, c5_y);
  sf_mex_destroy(&c5_d_hybrid);
}

static void c5_h_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId, real_T c5_y[3])
{
  real_T c5_dv2[3];
  int32_T c5_i13;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), c5_dv2, 1, 0, 0U, 1, 0U, 1, 3);
  for (c5_i13 = 0; c5_i13 < 3; c5_i13++) {
    c5_y[c5_i13] = c5_dv2[c5_i13];
  }

  sf_mex_destroy(&c5_u);
}

static void c5_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_d_hybrid;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y[3];
  int32_T c5_i14;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_d_hybrid = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_d_hybrid), &c5_thisId, c5_y);
  sf_mex_destroy(&c5_d_hybrid);
  for (c5_i14 = 0; c5_i14 < 3; c5_i14++) {
    (*(real_T (*)[3])c5_outData)[c5_i14] = c5_y[c5_i14];
  }

  sf_mex_destroy(&c5_mxArrayInData);
}

static const mxArray *c5_e_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  real_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(real_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static const mxArray *c5_f_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_i15;
  real_T c5_b_inData[3];
  int32_T c5_i16;
  real_T c5_u[3];
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  for (c5_i15 = 0; c5_i15 < 3; c5_i15++) {
    c5_b_inData[c5_i15] = (*(real_T (*)[3])c5_inData)[c5_i15];
  }

  for (c5_i16 = 0; c5_i16 < 3; c5_i16++) {
    c5_u[c5_i16] = c5_b_inData[c5_i16];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static real_T c5_i_emlrt_marshallIn(SFc5_ControllerInstanceStruct *chartInstance,
  const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  real_T c5_y;
  real_T c5_d3;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_d3, 1, 0, 0U, 0, 0U, 0);
  c5_y = c5_d3;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_nargout;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_nargout = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_i_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_nargout), &c5_thisId);
  sf_mex_destroy(&c5_nargout);
  *(real_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

const mxArray *sf_c5_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c5_nameCaptureInfo;
  c5_ResolvedFunctionInfo c5_info[1];
  c5_ResolvedFunctionInfo (*c5_b_info)[1];
  const mxArray *c5_m0 = NULL;
  int32_T c5_i17;
  c5_ResolvedFunctionInfo *c5_r0;
  c5_nameCaptureInfo = NULL;
  c5_nameCaptureInfo = NULL;
  c5_b_info = (c5_ResolvedFunctionInfo (*)[1])c5_info;
  (*c5_b_info)[0].context = "";
  (*c5_b_info)[0].name = "mtimes";
  (*c5_b_info)[0].dominantType = "double";
  (*c5_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c5_b_info)[0].fileTimeLo = 1289519692U;
  (*c5_b_info)[0].fileTimeHi = 0U;
  (*c5_b_info)[0].mFileTimeLo = 0U;
  (*c5_b_info)[0].mFileTimeHi = 0U;
  sf_mex_assign(&c5_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1), FALSE);
  for (c5_i17 = 0; c5_i17 < 1; c5_i17++) {
    c5_r0 = &c5_info[c5_i17];
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->context)), "context", "nameCaptureInfo",
                    c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c5_r0->name)), "name", "nameCaptureInfo", c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c5_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->resolved)), "resolved", "nameCaptureInfo",
                    c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c5_i17);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c5_i17);
  }

  sf_mex_assign(&c5_nameCaptureInfo, c5_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c5_nameCaptureInfo);
  return c5_nameCaptureInfo;
}

static const mxArray *c5_g_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(int32_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static int32_T c5_j_emlrt_marshallIn(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  int32_T c5_y;
  int32_T c5_i18;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_i18, 1, 6, 0U, 0, 0U, 0);
  c5_y = c5_i18;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_sfEvent;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  int32_T c5_y;
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)chartInstanceVoid;
  c5_b_sfEvent = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_sfEvent),
    &c5_thisId);
  sf_mex_destroy(&c5_b_sfEvent);
  *(int32_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static uint8_T c5_k_emlrt_marshallIn(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_b_is_active_c5_Controller, const char_T
  *c5_identifier)
{
  uint8_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_l_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c5_b_is_active_c5_Controller), &c5_thisId);
  sf_mex_destroy(&c5_b_is_active_c5_Controller);
  return c5_y;
}

static uint8_T c5_l_emlrt_marshallIn(SFc5_ControllerInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  uint8_T c5_y;
  uint8_T c5_u0;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_u0, 1, 3, 0U, 0, 0U, 0);
  c5_y = c5_u0;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void init_dsm_address_info(SFc5_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c5_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1415079226U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3600766609U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(425204294U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(12460208U);
}

mxArray *sf_c5_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("QON1a20g4vPkyhJp0SIkuD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c5_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[5],T\"d_hybrid\",},{M[4],M[0],T\"nu_psi\",S'l','i','p'{{M1x2[201 207],M[0],}}},{M[4],M[0],T\"nu_x\",S'l','i','p'{{M1x2[71 75],M[0],}}},{M[4],M[0],T\"nu_y\",S'l','i','p'{{M1x2[136 140],M[0],}}},{M[8],M[0],T\"is_active_c5_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c5_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc5_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc5_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           5,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"gain");
          _SFD_SET_DATA_PROPS(1,2,0,1,"d_hybrid");
          _SFD_SET_DATA_PROPS(2,1,1,0,"eta_tilde");
          _SFD_SET_DATA_PROPS(3,1,1,0,"rst");
          _SFD_SET_DATA_PROPS(4,1,1,0,"time");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,6,0,0,0,0,0,6,3);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,482);
        _SFD_CV_INIT_EML_IF(0,1,0,77,105,-1,123);
        _SFD_CV_INIT_EML_IF(0,1,1,142,170,-1,188);
        _SFD_CV_INIT_EML_IF(0,1,2,209,239,-1,259);
        _SFD_CV_INIT_EML_IF(0,1,3,264,279,-1,323);
        _SFD_CV_INIT_EML_IF(0,1,4,325,340,-1,384);
        _SFD_CV_INIT_EML_IF(0,1,5,386,401,-1,449);

        {
          static int condStart[] = { 80, 97 };

          static int condEnd[] = { 93, 105 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,80,105,2,0,&(condStart[0]),&(condEnd[0]),3,
                                &(pfixExpr[0]));
        }

        {
          static int condStart[] = { 145, 162 };

          static int condEnd[] = { 158, 170 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,1,145,170,2,2,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 212, 231 };

          static int condEnd[] = { 227, 239 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_EML_MCDC(0,1,2,212,239,2,4,&(condStart[0]),&(condEnd[0]),
                                3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_d_sf_marshallOut,(MexInFcnForType)
            c5_d_sf_marshallIn);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c5_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_e_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c5_time;
          real_T (*c5_gain)[3];
          real_T (*c5_d_hybrid)[3];
          real_T (*c5_eta_tilde)[3];
          real_T (*c5_rst)[3];
          c5_time = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c5_rst = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
          c5_eta_tilde = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 1);
          c5_d_hybrid = (real_T (*)[3])ssGetOutputPortSignal(chartInstance->S, 1);
          c5_gain = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c5_gain);
          _SFD_SET_DATA_VALUE_PTR(1U, *c5_d_hybrid);
          _SFD_SET_DATA_VALUE_PTR(2U, *c5_eta_tilde);
          _SFD_SET_DATA_VALUE_PTR(3U, *c5_rst);
          _SFD_SET_DATA_VALUE_PTR(4U, c5_time);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "kANBvh4mxNHmaI8hObwIY";
}

static void sf_opaque_initialize_c5_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc5_ControllerInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c5_Controller((SFc5_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c5_Controller((SFc5_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c5_Controller(void *chartInstanceVar)
{
  enable_c5_Controller((SFc5_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c5_Controller(void *chartInstanceVar)
{
  disable_c5_Controller((SFc5_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c5_Controller(void *chartInstanceVar)
{
  sf_c5_Controller((SFc5_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c5_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c5_Controller
    ((SFc5_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c5_Controller(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c5_Controller((SFc5_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c5_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c5_Controller(S);
}

static void sf_opaque_set_sim_state_c5_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c5_Controller(S, st);
}

static void sf_opaque_terminate_c5_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc5_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c5_Controller((SFc5_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc5_Controller((SFc5_ControllerInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c5_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c5_Controller((SFc5_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c5_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      5);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,5,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,5,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,5,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,5,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,5);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(1752581481U));
  ssSetChecksum1(S,(1711809505U));
  ssSetChecksum2(S,(1337203905U));
  ssSetChecksum3(S,(713246850U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c5_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c5_Controller(SimStruct *S)
{
  SFc5_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc5_ControllerInstanceStruct *)malloc(sizeof
    (SFc5_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc5_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c5_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c5_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c5_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c5_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c5_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c5_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c5_Controller;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c5_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c5_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c5_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c5_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c5_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c5_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c5_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c5_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c5_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
