/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c7_Controller.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c7_debug_family_names[17] = { "kp", "p21", "p22", "Me_hat",
  "De_hat", "M_hat", "D_hat", "k_value", "nargin", "nargout", "eta_p",
  "theta_ves_hat", "theta_e_hat", "F_C", "F_tol", "frc_ctrl", "mrac_theta_p" };

/* Function Declarations */
static void initialize_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance);
static void enable_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance);
static void disable_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance);
static void c7_update_debugger_state_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c7_Controller(SFc7_ControllerInstanceStruct *
  chartInstance);
static void set_sim_state_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_st);
static void finalize_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance);
static void sf_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance);
static void initSimStructsc7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber);
static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData);
static void c7_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_mrac_theta_p, const char_T *c7_identifier, real_T c7_y[36]);
static void c7_b_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[36]);
static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_e_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_f_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static const mxArray *c7_g_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static real_T c7_c_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_h_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static void c7_d_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[9]);
static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static const mxArray *c7_i_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData);
static int32_T c7_e_emlrt_marshallIn(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void c7_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData);
static uint8_T c7_f_emlrt_marshallIn(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_b_is_active_c7_Controller, const char_T
  *c7_identifier);
static uint8_T c7_g_emlrt_marshallIn(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId);
static void init_dsm_address_info(SFc7_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c7_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c7_is_active_c7_Controller = 0U;
}

static void initialize_params_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c7_update_debugger_state_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c7_Controller(SFc7_ControllerInstanceStruct *
  chartInstance)
{
  const mxArray *c7_st;
  const mxArray *c7_y = NULL;
  int32_T c7_i0;
  real_T c7_u[36];
  const mxArray *c7_b_y = NULL;
  uint8_T c7_hoistedGlobal;
  uint8_T c7_b_u;
  const mxArray *c7_c_y = NULL;
  real_T (*c7_mrac_theta_p)[36];
  c7_mrac_theta_p = (real_T (*)[36])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_st = NULL;
  c7_st = NULL;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_createcellarray(2), FALSE);
  for (c7_i0 = 0; c7_i0 < 36; c7_i0++) {
    c7_u[c7_i0] = (*c7_mrac_theta_p)[c7_i0];
  }

  c7_b_y = NULL;
  sf_mex_assign(&c7_b_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 12, 3),
                FALSE);
  sf_mex_setcell(c7_y, 0, c7_b_y);
  c7_hoistedGlobal = chartInstance->c7_is_active_c7_Controller;
  c7_b_u = c7_hoistedGlobal;
  c7_c_y = NULL;
  sf_mex_assign(&c7_c_y, sf_mex_create("y", &c7_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c7_y, 1, c7_c_y);
  sf_mex_assign(&c7_st, c7_y, FALSE);
  return c7_st;
}

static void set_sim_state_c7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_st)
{
  const mxArray *c7_u;
  real_T c7_dv0[36];
  int32_T c7_i1;
  real_T (*c7_mrac_theta_p)[36];
  c7_mrac_theta_p = (real_T (*)[36])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c7_doneDoubleBufferReInit = TRUE;
  c7_u = sf_mex_dup(c7_st);
  c7_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 0)),
                      "mrac_theta_p", c7_dv0);
  for (c7_i1 = 0; c7_i1 < 36; c7_i1++) {
    (*c7_mrac_theta_p)[c7_i1] = c7_dv0[c7_i1];
  }

  chartInstance->c7_is_active_c7_Controller = c7_f_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c7_u, 1)),
     "is_active_c7_Controller");
  sf_mex_destroy(&c7_u);
  c7_update_debugger_state_c7_Controller(chartInstance);
  sf_mex_destroy(&c7_st);
}

static void finalize_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance)
{
}

static void sf_c7_Controller(SFc7_ControllerInstanceStruct *chartInstance)
{
  int32_T c7_i2;
  int32_T c7_i3;
  int32_T c7_i4;
  int32_T c7_i5;
  int32_T c7_i6;
  int32_T c7_i7;
  int32_T c7_i8;
  int32_T c7_i9;
  real_T c7_eta_p[3];
  int32_T c7_i10;
  real_T c7_theta_ves_hat[18];
  int32_T c7_i11;
  real_T c7_theta_e_hat[18];
  int32_T c7_i12;
  real_T c7_F_C[3];
  int32_T c7_i13;
  real_T c7_F_tol[6];
  int32_T c7_i14;
  real_T c7_frc_ctrl[3];
  uint32_T c7_debug_family_var_map[17];
  real_T c7_kp[9];
  real_T c7_p21[9];
  real_T c7_p22[9];
  real_T c7_Me_hat[9];
  real_T c7_De_hat[9];
  real_T c7_M_hat[9];
  real_T c7_D_hat[9];
  real_T c7_k_value;
  real_T c7_nargin = 6.0;
  real_T c7_nargout = 1.0;
  real_T c7_mrac_theta_p[36];
  int32_T c7_i15;
  int32_T c7_i16;
  int32_T c7_i17;
  int32_T c7_i18;
  int32_T c7_i19;
  int32_T c7_i20;
  int32_T c7_i21;
  int32_T c7_i22;
  int32_T c7_i23;
  int32_T c7_i24;
  int32_T c7_i25;
  int32_T c7_i26;
  int32_T c7_i27;
  int32_T c7_i28;
  int32_T c7_i29;
  int32_T c7_i30;
  int32_T c7_i31;
  int32_T c7_i;
  real_T c7_b_i;
  real_T c7_x;
  real_T c7_b_x;
  real_T c7_y;
  real_T c7_c_x;
  real_T c7_d_x;
  real_T c7_b_y;
  real_T c7_A;
  real_T c7_B;
  real_T c7_e_x;
  real_T c7_c_y;
  real_T c7_f_x;
  real_T c7_d_y;
  real_T c7_b_A;
  real_T c7_b_B;
  real_T c7_g_x;
  real_T c7_e_y;
  real_T c7_h_x;
  real_T c7_f_y;
  real_T c7_g_y;
  real_T c7_c_A;
  real_T c7_c_B;
  real_T c7_i_x;
  real_T c7_h_y;
  real_T c7_j_x;
  real_T c7_i_y;
  real_T c7_j_y;
  real_T c7_d_A;
  real_T c7_d_B;
  real_T c7_k_x;
  real_T c7_k_y;
  real_T c7_l_x;
  real_T c7_l_y;
  real_T c7_m_y;
  real_T c7_e_B;
  real_T c7_n_y;
  real_T c7_o_y;
  real_T c7_p_y;
  real_T c7_a;
  real_T c7_b;
  real_T c7_q_y;
  int32_T c7_i32;
  int32_T c7_i33;
  int32_T c7_i34;
  int32_T c7_i35;
  int32_T c7_i36;
  int32_T c7_i37;
  int32_T c7_i38;
  int32_T c7_i39;
  int32_T c7_i40;
  int32_T c7_i41;
  int32_T c7_i42;
  int32_T c7_i43;
  int32_T c7_i44;
  int32_T c7_i45;
  int32_T c7_i46;
  int32_T c7_i47;
  real_T (*c7_b_mrac_theta_p)[36];
  real_T (*c7_b_frc_ctrl)[3];
  real_T (*c7_b_F_tol)[6];
  real_T (*c7_b_F_C)[3];
  real_T (*c7_b_theta_e_hat)[18];
  real_T (*c7_b_theta_ves_hat)[18];
  real_T (*c7_b_eta_p)[3];
  c7_b_frc_ctrl = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
  c7_b_F_tol = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
  c7_b_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
  c7_b_theta_e_hat = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S, 2);
  c7_b_mrac_theta_p = (real_T (*)[36])ssGetOutputPortSignal(chartInstance->S, 1);
  c7_b_theta_ves_hat = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S, 1);
  c7_b_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 6U, chartInstance->c7_sfEvent);
  for (c7_i2 = 0; c7_i2 < 3; c7_i2++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_eta_p)[c7_i2], 0U);
  }

  for (c7_i3 = 0; c7_i3 < 18; c7_i3++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_theta_ves_hat)[c7_i3], 1U);
  }

  for (c7_i4 = 0; c7_i4 < 36; c7_i4++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_mrac_theta_p)[c7_i4], 2U);
  }

  for (c7_i5 = 0; c7_i5 < 18; c7_i5++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_theta_e_hat)[c7_i5], 3U);
  }

  for (c7_i6 = 0; c7_i6 < 3; c7_i6++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_F_C)[c7_i6], 4U);
  }

  for (c7_i7 = 0; c7_i7 < 6; c7_i7++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_F_tol)[c7_i7], 5U);
  }

  for (c7_i8 = 0; c7_i8 < 3; c7_i8++) {
    _SFD_DATA_RANGE_CHECK((*c7_b_frc_ctrl)[c7_i8], 6U);
  }

  chartInstance->c7_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 6U, chartInstance->c7_sfEvent);
  for (c7_i9 = 0; c7_i9 < 3; c7_i9++) {
    c7_eta_p[c7_i9] = (*c7_b_eta_p)[c7_i9];
  }

  for (c7_i10 = 0; c7_i10 < 18; c7_i10++) {
    c7_theta_ves_hat[c7_i10] = (*c7_b_theta_ves_hat)[c7_i10];
  }

  for (c7_i11 = 0; c7_i11 < 18; c7_i11++) {
    c7_theta_e_hat[c7_i11] = (*c7_b_theta_e_hat)[c7_i11];
  }

  for (c7_i12 = 0; c7_i12 < 3; c7_i12++) {
    c7_F_C[c7_i12] = (*c7_b_F_C)[c7_i12];
  }

  for (c7_i13 = 0; c7_i13 < 6; c7_i13++) {
    c7_F_tol[c7_i13] = (*c7_b_F_tol)[c7_i13];
  }

  for (c7_i14 = 0; c7_i14 < 3; c7_i14++) {
    c7_frc_ctrl[c7_i14] = (*c7_b_frc_ctrl)[c7_i14];
  }

  sf_debug_symbol_scope_push_eml(0U, 17U, 17U, c7_debug_family_names,
    c7_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c7_kp, 0U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_p21, 1U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_p22, 2U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_Me_hat, 3U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_De_hat, 4U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_M_hat, 5U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c7_D_hat, 6U, c7_h_sf_marshallOut,
    c7_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_k_value, 7U, c7_g_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargin, 8U, c7_g_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c7_nargout, 9U, c7_g_sf_marshallOut,
    c7_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c7_eta_p, 10U, c7_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c7_theta_ves_hat, 11U, c7_f_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c7_theta_e_hat, 12U, c7_e_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c7_F_C, 13U, c7_d_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c7_F_tol, 14U, c7_c_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c7_frc_ctrl, 15U, c7_b_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c7_mrac_theta_p, 16U,
    c7_sf_marshallOut, c7_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 3);
  for (c7_i15 = 0; c7_i15 < 9; c7_i15++) {
    c7_kp[c7_i15] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 4);
  for (c7_i16 = 0; c7_i16 < 9; c7_i16++) {
    c7_p21[c7_i16] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 5);
  for (c7_i17 = 0; c7_i17 < 9; c7_i17++) {
    c7_p22[c7_i17] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 7);
  c7_i18 = 0;
  for (c7_i19 = 0; c7_i19 < 3; c7_i19++) {
    for (c7_i20 = 0; c7_i20 < 3; c7_i20++) {
      c7_Me_hat[c7_i20 + c7_i18] = c7_theta_e_hat[c7_i20 + c7_i18];
    }

    c7_i18 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 8);
  c7_i21 = 0;
  for (c7_i22 = 0; c7_i22 < 3; c7_i22++) {
    for (c7_i23 = 0; c7_i23 < 3; c7_i23++) {
      c7_De_hat[c7_i23 + c7_i21] = c7_theta_e_hat[(c7_i23 + c7_i21) + 9];
    }

    c7_i21 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 10);
  c7_i24 = 0;
  c7_i25 = 0;
  for (c7_i26 = 0; c7_i26 < 3; c7_i26++) {
    for (c7_i27 = 0; c7_i27 < 3; c7_i27++) {
      c7_M_hat[c7_i27 + c7_i24] = c7_theta_ves_hat[c7_i27 + c7_i25];
    }

    c7_i24 += 3;
    c7_i25 += 6;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 11);
  c7_i28 = 0;
  c7_i29 = 0;
  for (c7_i30 = 0; c7_i30 < 3; c7_i30++) {
    for (c7_i31 = 0; c7_i31 < 3; c7_i31++) {
      c7_D_hat[c7_i31 + c7_i28] = c7_theta_ves_hat[(c7_i31 + c7_i29) + 3];
    }

    c7_i28 += 3;
    c7_i29 += 6;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 13);
  c7_i = 0;
  while (c7_i < 3) {
    c7_b_i = 1.0 + (real_T)c7_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 15);
    if (CV_EML_IF(0, 1, 0, c7_frc_ctrl[_SFD_EML_ARRAY_BOUNDS_CHECK("frc_ctrl",
          (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) - 1] == 1.0)) {
      _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 16);
      c7_x = c7_F_C[_SFD_EML_ARRAY_BOUNDS_CHECK("F_C", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) - 1];
      c7_b_x = c7_x;
      c7_y = muDoubleScalarAbs(c7_b_x);
      c7_c_x = c7_eta_p[1];
      c7_d_x = c7_c_x;
      c7_b_y = muDoubleScalarAbs(c7_d_x);
      c7_A = c7_y;
      c7_B = 4.0 - c7_b_y;
      c7_e_x = c7_A;
      c7_c_y = c7_B;
      c7_f_x = c7_e_x;
      c7_d_y = c7_c_y;
      c7_k_value = c7_f_x / c7_d_y;
      _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 18);
      c7_b_A = c7_k_value;
      c7_b_B = c7_M_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_g_x = c7_b_A;
      c7_e_y = c7_b_B;
      c7_h_x = c7_g_x;
      c7_f_y = c7_e_y;
      c7_g_y = c7_h_x / c7_f_y;
      c7_kp[(_SFD_EML_ARRAY_BOUNDS_CHECK("kp", (int32_T)_SFD_INTEGER_CHECK("i",
               c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("kp",
               (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1] =
        c7_g_y;
      _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 19);
      c7_c_A = c7_D_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("D_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("D_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_c_B = c7_M_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_i_x = c7_c_A;
      c7_h_y = c7_c_B;
      c7_j_x = c7_i_x;
      c7_i_y = c7_h_y;
      c7_j_y = c7_j_x / c7_i_y;
      c7_p21[(_SFD_EML_ARRAY_BOUNDS_CHECK("p21", (int32_T)_SFD_INTEGER_CHECK("i",
                c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("p21",
                (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1]
        = c7_j_y;
      _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 20);
      c7_d_A = c7_k_value;
      c7_d_B = c7_M_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_k_x = c7_d_A;
      c7_k_y = c7_d_B;
      c7_l_x = c7_k_x;
      c7_l_y = c7_k_y;
      c7_m_y = c7_l_x / c7_l_y;
      c7_p22[(_SFD_EML_ARRAY_BOUNDS_CHECK("p22", (int32_T)_SFD_INTEGER_CHECK("i",
                c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("p22",
                (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1]
        = c7_m_y;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 22);
      c7_e_B = c7_M_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("M_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1] + c7_Me_hat
        [(_SFD_EML_ARRAY_BOUNDS_CHECK("Me_hat", (int32_T)_SFD_INTEGER_CHECK("i",
            c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("Me_hat",
            (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_n_y = c7_e_B;
      c7_o_y = c7_n_y;
      c7_p_y = 1.0 / c7_o_y;
      c7_kp[(_SFD_EML_ARRAY_BOUNDS_CHECK("kp", (int32_T)_SFD_INTEGER_CHECK("i",
               c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("kp",
               (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1] =
        c7_p_y;
      _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 23);
      c7_a = c7_kp[(_SFD_EML_ARRAY_BOUNDS_CHECK("kp", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                    (_SFD_EML_ARRAY_BOUNDS_CHECK("kp", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_b = c7_D_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("D_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 1, 0) + 3 *
                       (_SFD_EML_ARRAY_BOUNDS_CHECK("D_hat", (int32_T)
        _SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1] + c7_De_hat
        [(_SFD_EML_ARRAY_BOUNDS_CHECK("De_hat", (int32_T)_SFD_INTEGER_CHECK("i",
            c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("De_hat",
            (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1];
      c7_q_y = c7_a * c7_b;
      c7_p21[(_SFD_EML_ARRAY_BOUNDS_CHECK("p21", (int32_T)_SFD_INTEGER_CHECK("i",
                c7_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("p21",
                (int32_T)_SFD_INTEGER_CHECK("i", c7_b_i), 1, 3, 2, 0) - 1)) - 1]
        = c7_q_y;
    }

    c7_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, 27);
  c7_i32 = 0;
  for (c7_i33 = 0; c7_i33 < 3; c7_i33++) {
    for (c7_i34 = 0; c7_i34 < 3; c7_i34++) {
      c7_mrac_theta_p[c7_i34 + c7_i32] = 0.0;
    }

    c7_i32 += 12;
  }

  c7_i35 = 0;
  c7_i36 = 0;
  for (c7_i37 = 0; c7_i37 < 3; c7_i37++) {
    for (c7_i38 = 0; c7_i38 < 3; c7_i38++) {
      c7_mrac_theta_p[(c7_i38 + c7_i35) + 3] = c7_kp[c7_i38 + c7_i36];
    }

    c7_i35 += 12;
    c7_i36 += 3;
  }

  c7_i39 = 0;
  c7_i40 = 0;
  for (c7_i41 = 0; c7_i41 < 3; c7_i41++) {
    for (c7_i42 = 0; c7_i42 < 3; c7_i42++) {
      c7_mrac_theta_p[(c7_i42 + c7_i39) + 6] = c7_p21[c7_i42 + c7_i40];
    }

    c7_i39 += 12;
    c7_i40 += 3;
  }

  c7_i43 = 0;
  c7_i44 = 0;
  for (c7_i45 = 0; c7_i45 < 3; c7_i45++) {
    for (c7_i46 = 0; c7_i46 < 3; c7_i46++) {
      c7_mrac_theta_p[(c7_i46 + c7_i43) + 9] = c7_p22[c7_i46 + c7_i44];
    }

    c7_i43 += 12;
    c7_i44 += 3;
  }

  _SFD_EML_CALL(0U, chartInstance->c7_sfEvent, -27);
  sf_debug_symbol_scope_pop();
  for (c7_i47 = 0; c7_i47 < 36; c7_i47++) {
    (*c7_b_mrac_theta_p)[c7_i47] = c7_mrac_theta_p[c7_i47];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 6U, chartInstance->c7_sfEvent);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc7_Controller(SFc7_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c7_machineNumber, uint32_T
  c7_chartNumber)
{
}

static const mxArray *c7_sf_marshallOut(void *chartInstanceVoid, void *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i48;
  int32_T c7_i49;
  int32_T c7_i50;
  real_T c7_b_inData[36];
  int32_T c7_i51;
  int32_T c7_i52;
  int32_T c7_i53;
  real_T c7_u[36];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i48 = 0;
  for (c7_i49 = 0; c7_i49 < 3; c7_i49++) {
    for (c7_i50 = 0; c7_i50 < 12; c7_i50++) {
      c7_b_inData[c7_i50 + c7_i48] = (*(real_T (*)[36])c7_inData)[c7_i50 +
        c7_i48];
    }

    c7_i48 += 12;
  }

  c7_i51 = 0;
  for (c7_i52 = 0; c7_i52 < 3; c7_i52++) {
    for (c7_i53 = 0; c7_i53 < 12; c7_i53++) {
      c7_u[c7_i53 + c7_i51] = c7_b_inData[c7_i53 + c7_i51];
    }

    c7_i51 += 12;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 12, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_mrac_theta_p, const char_T *c7_identifier, real_T c7_y[36])
{
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_mrac_theta_p), &c7_thisId,
                        c7_y);
  sf_mex_destroy(&c7_mrac_theta_p);
}

static void c7_b_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[36])
{
  real_T c7_dv1[36];
  int32_T c7_i54;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv1, 1, 0, 0U, 1, 0U, 2, 12, 3);
  for (c7_i54 = 0; c7_i54 < 36; c7_i54++) {
    c7_y[c7_i54] = c7_dv1[c7_i54];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_mrac_theta_p;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[36];
  int32_T c7_i55;
  int32_T c7_i56;
  int32_T c7_i57;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mrac_theta_p = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_mrac_theta_p), &c7_thisId,
                        c7_y);
  sf_mex_destroy(&c7_mrac_theta_p);
  c7_i55 = 0;
  for (c7_i56 = 0; c7_i56 < 3; c7_i56++) {
    for (c7_i57 = 0; c7_i57 < 12; c7_i57++) {
      (*(real_T (*)[36])c7_outData)[c7_i57 + c7_i55] = c7_y[c7_i57 + c7_i55];
    }

    c7_i55 += 12;
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_b_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i58;
  real_T c7_b_inData[3];
  int32_T c7_i59;
  real_T c7_u[3];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i58 = 0; c7_i58 < 3; c7_i58++) {
    c7_b_inData[c7_i58] = (*(real_T (*)[3])c7_inData)[c7_i58];
  }

  for (c7_i59 = 0; c7_i59 < 3; c7_i59++) {
    c7_u[c7_i59] = c7_b_inData[c7_i59];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 1, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static const mxArray *c7_c_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i60;
  int32_T c7_i61;
  int32_T c7_i62;
  real_T c7_b_inData[6];
  int32_T c7_i63;
  int32_T c7_i64;
  int32_T c7_i65;
  real_T c7_u[6];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i60 = 0;
  for (c7_i61 = 0; c7_i61 < 3; c7_i61++) {
    for (c7_i62 = 0; c7_i62 < 2; c7_i62++) {
      c7_b_inData[c7_i62 + c7_i60] = (*(real_T (*)[6])c7_inData)[c7_i62 + c7_i60];
    }

    c7_i60 += 2;
  }

  c7_i63 = 0;
  for (c7_i64 = 0; c7_i64 < 3; c7_i64++) {
    for (c7_i65 = 0; c7_i65 < 2; c7_i65++) {
      c7_u[c7_i65 + c7_i63] = c7_b_inData[c7_i65 + c7_i63];
    }

    c7_i63 += 2;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 2, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static const mxArray *c7_d_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i66;
  real_T c7_b_inData[3];
  int32_T c7_i67;
  real_T c7_u[3];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  for (c7_i66 = 0; c7_i66 < 3; c7_i66++) {
    c7_b_inData[c7_i66] = (*(real_T (*)[3])c7_inData)[c7_i66];
  }

  for (c7_i67 = 0; c7_i67 < 3; c7_i67++) {
    c7_u[c7_i67] = c7_b_inData[c7_i67];
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static const mxArray *c7_e_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i68;
  int32_T c7_i69;
  int32_T c7_i70;
  real_T c7_b_inData[18];
  int32_T c7_i71;
  int32_T c7_i72;
  int32_T c7_i73;
  real_T c7_u[18];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i68 = 0;
  for (c7_i69 = 0; c7_i69 < 6; c7_i69++) {
    for (c7_i70 = 0; c7_i70 < 3; c7_i70++) {
      c7_b_inData[c7_i70 + c7_i68] = (*(real_T (*)[18])c7_inData)[c7_i70 +
        c7_i68];
    }

    c7_i68 += 3;
  }

  c7_i71 = 0;
  for (c7_i72 = 0; c7_i72 < 6; c7_i72++) {
    for (c7_i73 = 0; c7_i73 < 3; c7_i73++) {
      c7_u[c7_i73 + c7_i71] = c7_b_inData[c7_i73 + c7_i71];
    }

    c7_i71 += 3;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 3, 6), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static const mxArray *c7_f_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i74;
  int32_T c7_i75;
  int32_T c7_i76;
  real_T c7_b_inData[18];
  int32_T c7_i77;
  int32_T c7_i78;
  int32_T c7_i79;
  real_T c7_u[18];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i74 = 0;
  for (c7_i75 = 0; c7_i75 < 3; c7_i75++) {
    for (c7_i76 = 0; c7_i76 < 6; c7_i76++) {
      c7_b_inData[c7_i76 + c7_i74] = (*(real_T (*)[18])c7_inData)[c7_i76 +
        c7_i74];
    }

    c7_i74 += 6;
  }

  c7_i77 = 0;
  for (c7_i78 = 0; c7_i78 < 3; c7_i78++) {
    for (c7_i79 = 0; c7_i79 < 6; c7_i79++) {
      c7_u[c7_i79 + c7_i77] = c7_b_inData[c7_i79 + c7_i77];
    }

    c7_i77 += 6;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 6, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static const mxArray *c7_g_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  real_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(real_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static real_T c7_c_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  real_T c7_y;
  real_T c7_d0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_d0, 1, 0, 0U, 0, 0U, 0);
  c7_y = c7_d0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_nargout;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_nargout = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_nargout), &c7_thisId);
  sf_mex_destroy(&c7_nargout);
  *(real_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static const mxArray *c7_h_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_i80;
  int32_T c7_i81;
  int32_T c7_i82;
  real_T c7_b_inData[9];
  int32_T c7_i83;
  int32_T c7_i84;
  int32_T c7_i85;
  real_T c7_u[9];
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_i80 = 0;
  for (c7_i81 = 0; c7_i81 < 3; c7_i81++) {
    for (c7_i82 = 0; c7_i82 < 3; c7_i82++) {
      c7_b_inData[c7_i82 + c7_i80] = (*(real_T (*)[9])c7_inData)[c7_i82 + c7_i80];
    }

    c7_i80 += 3;
  }

  c7_i83 = 0;
  for (c7_i84 = 0; c7_i84 < 3; c7_i84++) {
    for (c7_i85 = 0; c7_i85 < 3; c7_i85++) {
      c7_u[c7_i85 + c7_i83] = c7_b_inData[c7_i85 + c7_i83];
    }

    c7_i83 += 3;
  }

  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", c7_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static void c7_d_emlrt_marshallIn(SFc7_ControllerInstanceStruct *chartInstance,
  const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId, real_T c7_y[9])
{
  real_T c7_dv2[9];
  int32_T c7_i86;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), c7_dv2, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c7_i86 = 0; c7_i86 < 9; c7_i86++) {
    c7_y[c7_i86] = c7_dv2[c7_i86];
  }

  sf_mex_destroy(&c7_u);
}

static void c7_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_D_hat;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  real_T c7_y[9];
  int32_T c7_i87;
  int32_T c7_i88;
  int32_T c7_i89;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_D_hat = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_D_hat), &c7_thisId, c7_y);
  sf_mex_destroy(&c7_D_hat);
  c7_i87 = 0;
  for (c7_i88 = 0; c7_i88 < 3; c7_i88++) {
    for (c7_i89 = 0; c7_i89 < 3; c7_i89++) {
      (*(real_T (*)[9])c7_outData)[c7_i89 + c7_i87] = c7_y[c7_i89 + c7_i87];
    }

    c7_i87 += 3;
  }

  sf_mex_destroy(&c7_mxArrayInData);
}

const mxArray *sf_c7_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c7_nameCaptureInfo;
  c7_ResolvedFunctionInfo c7_info[6];
  c7_ResolvedFunctionInfo (*c7_b_info)[6];
  const mxArray *c7_m0 = NULL;
  int32_T c7_i90;
  c7_ResolvedFunctionInfo *c7_r0;
  c7_nameCaptureInfo = NULL;
  c7_nameCaptureInfo = NULL;
  c7_b_info = (c7_ResolvedFunctionInfo (*)[6])c7_info;
  (*c7_b_info)[0].context = "";
  (*c7_b_info)[0].name = "abs";
  (*c7_b_info)[0].dominantType = "double";
  (*c7_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c7_b_info)[0].fileTimeLo = 1286818694U;
  (*c7_b_info)[0].fileTimeHi = 0U;
  (*c7_b_info)[0].mFileTimeLo = 0U;
  (*c7_b_info)[0].mFileTimeHi = 0U;
  (*c7_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  (*c7_b_info)[1].name = "eml_scalar_abs";
  (*c7_b_info)[1].dominantType = "double";
  (*c7_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  (*c7_b_info)[1].fileTimeLo = 1286818712U;
  (*c7_b_info)[1].fileTimeHi = 0U;
  (*c7_b_info)[1].mFileTimeLo = 0U;
  (*c7_b_info)[1].mFileTimeHi = 0U;
  (*c7_b_info)[2].context = "";
  (*c7_b_info)[2].name = "mrdivide";
  (*c7_b_info)[2].dominantType = "double";
  (*c7_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c7_b_info)[2].fileTimeLo = 1342810944U;
  (*c7_b_info)[2].fileTimeHi = 0U;
  (*c7_b_info)[2].mFileTimeLo = 1319729966U;
  (*c7_b_info)[2].mFileTimeHi = 0U;
  (*c7_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c7_b_info)[3].name = "rdivide";
  (*c7_b_info)[3].dominantType = "double";
  (*c7_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c7_b_info)[3].fileTimeLo = 1286818844U;
  (*c7_b_info)[3].fileTimeHi = 0U;
  (*c7_b_info)[3].mFileTimeLo = 0U;
  (*c7_b_info)[3].mFileTimeHi = 0U;
  (*c7_b_info)[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c7_b_info)[4].name = "eml_div";
  (*c7_b_info)[4].dominantType = "double";
  (*c7_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c7_b_info)[4].fileTimeLo = 1313347810U;
  (*c7_b_info)[4].fileTimeHi = 0U;
  (*c7_b_info)[4].mFileTimeLo = 0U;
  (*c7_b_info)[4].mFileTimeHi = 0U;
  (*c7_b_info)[5].context = "";
  (*c7_b_info)[5].name = "mtimes";
  (*c7_b_info)[5].dominantType = "double";
  (*c7_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c7_b_info)[5].fileTimeLo = 1289519692U;
  (*c7_b_info)[5].fileTimeHi = 0U;
  (*c7_b_info)[5].mFileTimeLo = 0U;
  (*c7_b_info)[5].mFileTimeHi = 0U;
  sf_mex_assign(&c7_m0, sf_mex_createstruct("nameCaptureInfo", 1, 6), FALSE);
  for (c7_i90 = 0; c7_i90 < 6; c7_i90++) {
    c7_r0 = &c7_info[c7_i90];
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->context)), "context", "nameCaptureInfo",
                    c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c7_r0->name)), "name", "nameCaptureInfo", c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c7_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", c7_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c7_r0->resolved)), "resolved", "nameCaptureInfo",
                    c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c7_i90);
    sf_mex_addfield(c7_m0, sf_mex_create("nameCaptureInfo", &c7_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c7_i90);
  }

  sf_mex_assign(&c7_nameCaptureInfo, c7_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c7_nameCaptureInfo);
  return c7_nameCaptureInfo;
}

static const mxArray *c7_i_sf_marshallOut(void *chartInstanceVoid, void
  *c7_inData)
{
  const mxArray *c7_mxArrayOutData = NULL;
  int32_T c7_u;
  const mxArray *c7_y = NULL;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_mxArrayOutData = NULL;
  c7_u = *(int32_T *)c7_inData;
  c7_y = NULL;
  sf_mex_assign(&c7_y, sf_mex_create("y", &c7_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c7_mxArrayOutData, c7_y, FALSE);
  return c7_mxArrayOutData;
}

static int32_T c7_e_emlrt_marshallIn(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  int32_T c7_y;
  int32_T c7_i91;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_i91, 1, 6, 0U, 0, 0U, 0);
  c7_y = c7_i91;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void c7_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c7_mxArrayInData, const char_T *c7_varName, void *c7_outData)
{
  const mxArray *c7_b_sfEvent;
  const char_T *c7_identifier;
  emlrtMsgIdentifier c7_thisId;
  int32_T c7_y;
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)chartInstanceVoid;
  c7_b_sfEvent = sf_mex_dup(c7_mxArrayInData);
  c7_identifier = c7_varName;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c7_b_sfEvent),
    &c7_thisId);
  sf_mex_destroy(&c7_b_sfEvent);
  *(int32_T *)c7_outData = c7_y;
  sf_mex_destroy(&c7_mxArrayInData);
}

static uint8_T c7_f_emlrt_marshallIn(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_b_is_active_c7_Controller, const char_T
  *c7_identifier)
{
  uint8_T c7_y;
  emlrtMsgIdentifier c7_thisId;
  c7_thisId.fIdentifier = c7_identifier;
  c7_thisId.fParent = NULL;
  c7_y = c7_g_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c7_b_is_active_c7_Controller), &c7_thisId);
  sf_mex_destroy(&c7_b_is_active_c7_Controller);
  return c7_y;
}

static uint8_T c7_g_emlrt_marshallIn(SFc7_ControllerInstanceStruct
  *chartInstance, const mxArray *c7_u, const emlrtMsgIdentifier *c7_parentId)
{
  uint8_T c7_y;
  uint8_T c7_u0;
  sf_mex_import(c7_parentId, sf_mex_dup(c7_u), &c7_u0, 1, 3, 0U, 0, 0U, 0);
  c7_y = c7_u0;
  sf_mex_destroy(&c7_u);
  return c7_y;
}

static void init_dsm_address_info(SFc7_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c7_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3760454241U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3660707692U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(994227414U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1448514816U);
}

mxArray *sf_c7_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("Y4wicLLPkoc58zEvcO1uS");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(6);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(2);
      pr[1] = (double)(3);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(3);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(12);
      pr[1] = (double)(3);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c7_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"mrac_theta_p\",},{M[8],M[0],T\"is_active_c7_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c7_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc7_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc7_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           7,
           1,
           1,
           7,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"eta_p");
          _SFD_SET_DATA_PROPS(1,1,1,0,"theta_ves_hat");
          _SFD_SET_DATA_PROPS(2,2,0,1,"mrac_theta_p");
          _SFD_SET_DATA_PROPS(3,1,1,0,"theta_e_hat");
          _SFD_SET_DATA_PROPS(4,1,1,0,"F_C");
          _SFD_SET_DATA_PROPS(5,1,1,0,"F_tol");
          _SFD_SET_DATA_PROPS(6,1,1,0,"frc_ctrl");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,755);
        _SFD_CV_INIT_EML_IF(0,1,0,341,360,568,695);
        _SFD_CV_INIT_EML_FOR(0,1,0,312,322,703);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 6;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_f_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 12;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_sf_marshallOut,(MexInFcnForType)
            c7_sf_marshallIn);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 6;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_e_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_d_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 2;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_c_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 1;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c7_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          real_T (*c7_eta_p)[3];
          real_T (*c7_theta_ves_hat)[18];
          real_T (*c7_mrac_theta_p)[36];
          real_T (*c7_theta_e_hat)[18];
          real_T (*c7_F_C)[3];
          real_T (*c7_F_tol)[6];
          real_T (*c7_frc_ctrl)[3];
          c7_frc_ctrl = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 5);
          c7_F_tol = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 4);
          c7_F_C = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 3);
          c7_theta_e_hat = (real_T (*)[18])ssGetInputPortSignal(chartInstance->S,
            2);
          c7_mrac_theta_p = (real_T (*)[36])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c7_theta_ves_hat = (real_T (*)[18])ssGetInputPortSignal
            (chartInstance->S, 1);
          c7_eta_p = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c7_eta_p);
          _SFD_SET_DATA_VALUE_PTR(1U, *c7_theta_ves_hat);
          _SFD_SET_DATA_VALUE_PTR(2U, *c7_mrac_theta_p);
          _SFD_SET_DATA_VALUE_PTR(3U, *c7_theta_e_hat);
          _SFD_SET_DATA_VALUE_PTR(4U, *c7_F_C);
          _SFD_SET_DATA_VALUE_PTR(5U, *c7_F_tol);
          _SFD_SET_DATA_VALUE_PTR(6U, *c7_frc_ctrl);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "XDAhSqWBexXOp8zzn4fwYC";
}

static void sf_opaque_initialize_c7_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc7_ControllerInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c7_Controller((SFc7_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c7_Controller((SFc7_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c7_Controller(void *chartInstanceVar)
{
  enable_c7_Controller((SFc7_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c7_Controller(void *chartInstanceVar)
{
  disable_c7_Controller((SFc7_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c7_Controller(void *chartInstanceVar)
{
  sf_c7_Controller((SFc7_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c7_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c7_Controller
    ((SFc7_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c7_Controller(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c7_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c7_Controller((SFc7_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c7_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c7_Controller(S);
}

static void sf_opaque_set_sim_state_c7_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c7_Controller(S, st);
}

static void sf_opaque_terminate_c7_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc7_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c7_Controller((SFc7_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc7_Controller((SFc7_ControllerInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c7_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c7_Controller((SFc7_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c7_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      7);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,7,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,7,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,7,6);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,7,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,7);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4066759964U));
  ssSetChecksum1(S,(3837972138U));
  ssSetChecksum2(S,(2784788214U));
  ssSetChecksum3(S,(2443688435U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c7_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c7_Controller(SimStruct *S)
{
  SFc7_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc7_ControllerInstanceStruct *)malloc(sizeof
    (SFc7_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc7_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c7_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c7_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c7_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c7_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c7_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c7_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c7_Controller;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c7_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c7_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c7_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c7_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c7_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c7_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c7_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c7_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c7_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
