/* Include files */

#include "blascompat32.h"
#include "Controller_sfun.h"
#include "c8_Controller.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Controller_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c8_debug_family_names[24] = { "c_0", "theta_1", "theta_2",
  "theta_3", "k_p_hat", "p21", "p22", "Lambda", "R", "theta_1_poly",
  "diophantine_eq", "nargin", "nargout", "k_m_r", "R_m", "Z_m", "mrac_theta_p",
  "theta_ctrl_hat", "first", "Z_p_hat", "Z_p_bar_hat", "R_p_hat", "Lambda_0",
  "Q" };

/* Function Declarations */
static void initialize_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance);
static void initialize_params_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance);
static void enable_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance);
static void disable_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance);
static void c8_update_debugger_state_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c8_Controller(SFc8_ControllerInstanceStruct *
  chartInstance);
static void set_sim_state_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_st);
static void finalize_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance);
static void sf_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance);
static void c8_chartstep_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance);
static void initSimStructsc8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber);
static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData);
static void c8_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Q, const char_T *c8_identifier, real_T c8_y[6]);
static void c8_b_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[6]);
static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_c_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Lambda_0, const char_T *c8_identifier, real_T c8_y[2]);
static void c8_d_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[2]);
static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_e_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_R_p_hat, const char_T *c8_identifier, real_T c8_y[9]);
static void c8_f_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[9]);
static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_g_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Z_p_bar_hat, const char_T *c8_identifier, real_T c8_y[3]);
static void c8_h_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3]);
static void c8_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_e_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_i_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Z_p_hat, const char_T *c8_identifier, real_T c8_y[3]);
static void c8_j_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3]);
static void c8_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_f_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static real_T c8_k_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_first, const char_T *c8_identifier);
static real_T c8_l_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_g_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_m_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_theta_ctrl_hat, const char_T *c8_identifier, real_T c8_y[12]);
static void c8_n_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[12]);
static void c8_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_h_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static const mxArray *c8_i_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static const mxArray *c8_j_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static const mxArray *c8_k_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static real_T c8_o_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_l_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_p_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[4]);
static void c8_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static const mxArray *c8_m_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static void c8_q_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[2]);
static void c8_j_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static void c8_r_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[9]);
static void c8_k_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static void c8_s_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3]);
static void c8_l_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[39]);
static void c8_conv(SFc8_ControllerInstanceStruct *chartInstance, real_T c8_A[2],
                    real_T c8_B, real_T c8_C[2]);
static void c8_eml_scalar_eg(SFc8_ControllerInstanceStruct *chartInstance);
static void c8_check_forloop_overflow_error(SFc8_ControllerInstanceStruct
  *chartInstance);
static void c8_b_check_forloop_overflow_error(SFc8_ControllerInstanceStruct
  *chartInstance, boolean_T c8_overflow);
static void c8_b_conv(SFc8_ControllerInstanceStruct *chartInstance, real_T c8_A
                      [2], real_T c8_B[3], real_T c8_C[4]);
static void c8_eml_error(SFc8_ControllerInstanceStruct *chartInstance);
static void c8_b_eml_scalar_eg(SFc8_ControllerInstanceStruct *chartInstance);
static void c8_filter(SFc8_ControllerInstanceStruct *chartInstance, real_T c8_b
                      [4], real_T c8_a[3], real_T c8_x[2], real_T c8_y[2],
                      real_T c8_zf[3]);
static void c8_b_eml_error(SFc8_ControllerInstanceStruct *chartInstance);
static void c8_c_eml_error(SFc8_ControllerInstanceStruct *chartInstance);
static const mxArray *c8_n_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData);
static int32_T c8_t_emlrt_marshallIn(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void c8_m_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData);
static uint8_T c8_u_emlrt_marshallIn(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_b_is_active_c8_Controller, const char_T
  *c8_identifier);
static uint8_T c8_v_emlrt_marshallIn(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId);
static void init_dsm_address_info(SFc8_ControllerInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance)
{
  chartInstance->c8_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c8_first_not_empty = FALSE;
  chartInstance->c8_Z_p_hat_not_empty = FALSE;
  chartInstance->c8_Z_p_bar_hat_not_empty = FALSE;
  chartInstance->c8_R_p_hat_not_empty = FALSE;
  chartInstance->c8_Lambda_0_not_empty = FALSE;
  chartInstance->c8_Q_not_empty = FALSE;
  chartInstance->c8_is_active_c8_Controller = 0U;
}

static void initialize_params_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance)
{
}

static void enable_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c8_update_debugger_state_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c8_Controller(SFc8_ControllerInstanceStruct *
  chartInstance)
{
  const mxArray *c8_st;
  const mxArray *c8_y = NULL;
  int32_T c8_i0;
  real_T c8_u[12];
  const mxArray *c8_b_y = NULL;
  int32_T c8_i1;
  real_T c8_b_u[2];
  const mxArray *c8_c_y = NULL;
  int32_T c8_i2;
  real_T c8_c_u[6];
  const mxArray *c8_d_y = NULL;
  int32_T c8_i3;
  real_T c8_d_u[9];
  const mxArray *c8_e_y = NULL;
  int32_T c8_i4;
  real_T c8_e_u[3];
  const mxArray *c8_f_y = NULL;
  int32_T c8_i5;
  real_T c8_f_u[3];
  const mxArray *c8_g_y = NULL;
  real_T c8_hoistedGlobal;
  real_T c8_g_u;
  const mxArray *c8_h_y = NULL;
  uint8_T c8_b_hoistedGlobal;
  uint8_T c8_h_u;
  const mxArray *c8_i_y = NULL;
  real_T (*c8_theta_ctrl_hat)[12];
  c8_theta_ctrl_hat = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_st = NULL;
  c8_st = NULL;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_createcellarray(8), FALSE);
  for (c8_i0 = 0; c8_i0 < 12; c8_i0++) {
    c8_u[c8_i0] = (*c8_theta_ctrl_hat)[c8_i0];
  }

  c8_b_y = NULL;
  sf_mex_assign(&c8_b_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_setcell(c8_y, 0, c8_b_y);
  for (c8_i1 = 0; c8_i1 < 2; c8_i1++) {
    c8_b_u[c8_i1] = chartInstance->c8_Lambda_0[c8_i1];
  }

  c8_c_y = NULL;
  if (!chartInstance->c8_Lambda_0_not_empty) {
    sf_mex_assign(&c8_c_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c8_c_y, sf_mex_create("y", c8_b_u, 0, 0U, 1U, 0U, 2, 1, 2),
                  FALSE);
  }

  sf_mex_setcell(c8_y, 1, c8_c_y);
  for (c8_i2 = 0; c8_i2 < 6; c8_i2++) {
    c8_c_u[c8_i2] = chartInstance->c8_Q[c8_i2];
  }

  c8_d_y = NULL;
  if (!chartInstance->c8_Q_not_empty) {
    sf_mex_assign(&c8_d_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c8_d_y, sf_mex_create("y", c8_c_u, 0, 0U, 1U, 0U, 2, 3, 2),
                  FALSE);
  }

  sf_mex_setcell(c8_y, 2, c8_d_y);
  for (c8_i3 = 0; c8_i3 < 9; c8_i3++) {
    c8_d_u[c8_i3] = chartInstance->c8_R_p_hat[c8_i3];
  }

  c8_e_y = NULL;
  if (!chartInstance->c8_R_p_hat_not_empty) {
    sf_mex_assign(&c8_e_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c8_e_y, sf_mex_create("y", c8_d_u, 0, 0U, 1U, 0U, 2, 3, 3),
                  FALSE);
  }

  sf_mex_setcell(c8_y, 3, c8_e_y);
  for (c8_i4 = 0; c8_i4 < 3; c8_i4++) {
    c8_e_u[c8_i4] = chartInstance->c8_Z_p_bar_hat[c8_i4];
  }

  c8_f_y = NULL;
  if (!chartInstance->c8_Z_p_bar_hat_not_empty) {
    sf_mex_assign(&c8_f_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c8_f_y, sf_mex_create("y", c8_e_u, 0, 0U, 1U, 0U, 1, 3),
                  FALSE);
  }

  sf_mex_setcell(c8_y, 4, c8_f_y);
  for (c8_i5 = 0; c8_i5 < 3; c8_i5++) {
    c8_f_u[c8_i5] = chartInstance->c8_Z_p_hat[c8_i5];
  }

  c8_g_y = NULL;
  if (!chartInstance->c8_Z_p_hat_not_empty) {
    sf_mex_assign(&c8_g_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c8_g_y, sf_mex_create("y", c8_f_u, 0, 0U, 1U, 0U, 1, 3),
                  FALSE);
  }

  sf_mex_setcell(c8_y, 5, c8_g_y);
  c8_hoistedGlobal = chartInstance->c8_first;
  c8_g_u = c8_hoistedGlobal;
  c8_h_y = NULL;
  if (!chartInstance->c8_first_not_empty) {
    sf_mex_assign(&c8_h_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0),
                  FALSE);
  } else {
    sf_mex_assign(&c8_h_y, sf_mex_create("y", &c8_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_setcell(c8_y, 6, c8_h_y);
  c8_b_hoistedGlobal = chartInstance->c8_is_active_c8_Controller;
  c8_h_u = c8_b_hoistedGlobal;
  c8_i_y = NULL;
  sf_mex_assign(&c8_i_y, sf_mex_create("y", &c8_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c8_y, 7, c8_i_y);
  sf_mex_assign(&c8_st, c8_y, FALSE);
  return c8_st;
}

static void set_sim_state_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_st)
{
  const mxArray *c8_u;
  real_T c8_dv0[12];
  int32_T c8_i6;
  real_T c8_dv1[2];
  int32_T c8_i7;
  real_T c8_dv2[6];
  int32_T c8_i8;
  real_T c8_dv3[9];
  int32_T c8_i9;
  real_T c8_dv4[3];
  int32_T c8_i10;
  real_T c8_dv5[3];
  int32_T c8_i11;
  real_T (*c8_theta_ctrl_hat)[12];
  c8_theta_ctrl_hat = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c8_doneDoubleBufferReInit = TRUE;
  c8_u = sf_mex_dup(c8_st);
  c8_m_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 0)),
                        "theta_ctrl_hat", c8_dv0);
  for (c8_i6 = 0; c8_i6 < 12; c8_i6++) {
    (*c8_theta_ctrl_hat)[c8_i6] = c8_dv0[c8_i6];
  }

  c8_c_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 1)),
                        "Lambda_0", c8_dv1);
  for (c8_i7 = 0; c8_i7 < 2; c8_i7++) {
    chartInstance->c8_Lambda_0[c8_i7] = c8_dv1[c8_i7];
  }

  c8_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 2)), "Q",
                      c8_dv2);
  for (c8_i8 = 0; c8_i8 < 6; c8_i8++) {
    chartInstance->c8_Q[c8_i8] = c8_dv2[c8_i8];
  }

  c8_e_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 3)),
                        "R_p_hat", c8_dv3);
  for (c8_i9 = 0; c8_i9 < 9; c8_i9++) {
    chartInstance->c8_R_p_hat[c8_i9] = c8_dv3[c8_i9];
  }

  c8_g_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 4)),
                        "Z_p_bar_hat", c8_dv4);
  for (c8_i10 = 0; c8_i10 < 3; c8_i10++) {
    chartInstance->c8_Z_p_bar_hat[c8_i10] = c8_dv4[c8_i10];
  }

  c8_i_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 5)),
                        "Z_p_hat", c8_dv5);
  for (c8_i11 = 0; c8_i11 < 3; c8_i11++) {
    chartInstance->c8_Z_p_hat[c8_i11] = c8_dv5[c8_i11];
  }

  chartInstance->c8_first = c8_k_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c8_u, 6)), "first");
  chartInstance->c8_is_active_c8_Controller = c8_u_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c8_u, 7)),
     "is_active_c8_Controller");
  sf_mex_destroy(&c8_u);
  c8_update_debugger_state_c8_Controller(chartInstance);
  sf_mex_destroy(&c8_st);
}

static void finalize_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance)
{
}

static void sf_c8_Controller(SFc8_ControllerInstanceStruct *chartInstance)
{
  int32_T c8_i12;
  int32_T c8_i13;
  int32_T c8_i14;
  int32_T c8_i15;
  int32_T c8_i16;
  real_T (*c8_theta_ctrl_hat)[12];
  real_T (*c8_mrac_theta_p)[36];
  real_T (*c8_Z_m)[3];
  real_T (*c8_R_m)[9];
  real_T (*c8_k_m_r)[3];
  c8_theta_ctrl_hat = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S, 1);
  c8_mrac_theta_p = (real_T (*)[36])ssGetInputPortSignal(chartInstance->S, 3);
  c8_Z_m = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c8_R_m = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 1);
  c8_k_m_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  for (c8_i12 = 0; c8_i12 < 3; c8_i12++) {
    _SFD_DATA_RANGE_CHECK((*c8_k_m_r)[c8_i12], 0U);
  }

  for (c8_i13 = 0; c8_i13 < 9; c8_i13++) {
    _SFD_DATA_RANGE_CHECK((*c8_R_m)[c8_i13], 1U);
  }

  for (c8_i14 = 0; c8_i14 < 3; c8_i14++) {
    _SFD_DATA_RANGE_CHECK((*c8_Z_m)[c8_i14], 2U);
  }

  for (c8_i15 = 0; c8_i15 < 36; c8_i15++) {
    _SFD_DATA_RANGE_CHECK((*c8_mrac_theta_p)[c8_i15], 3U);
  }

  for (c8_i16 = 0; c8_i16 < 12; c8_i16++) {
    _SFD_DATA_RANGE_CHECK((*c8_theta_ctrl_hat)[c8_i16], 4U);
  }

  chartInstance->c8_sfEvent = CALL_EVENT;
  c8_chartstep_c8_Controller(chartInstance);
  sf_debug_check_for_state_inconsistency(_ControllerMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c8_chartstep_c8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance)
{
  int32_T c8_i17;
  real_T c8_k_m_r[3];
  int32_T c8_i18;
  real_T c8_R_m[9];
  int32_T c8_i19;
  real_T c8_Z_m[3];
  int32_T c8_i20;
  real_T c8_mrac_theta_p[36];
  uint32_T c8_debug_family_var_map[24];
  real_T c8_c_0[3];
  real_T c8_theta_1[3];
  real_T c8_theta_2[3];
  real_T c8_theta_3[3];
  real_T c8_k_p_hat[9];
  real_T c8_p21[9];
  real_T c8_p22[9];
  real_T c8_Lambda[2];
  real_T c8_R[4];
  real_T c8_theta_1_poly[2];
  real_T c8_diophantine_eq[4];
  real_T c8_nargin = 4.0;
  real_T c8_nargout = 1.0;
  real_T c8_theta_ctrl_hat[12];
  int32_T c8_i21;
  int32_T c8_i22;
  int32_T c8_i23;
  int32_T c8_i24;
  int32_T c8_i25;
  int32_T c8_i26;
  int32_T c8_i27;
  int32_T c8_i28;
  int32_T c8_i29;
  int32_T c8_i30;
  int32_T c8_i31;
  int32_T c8_i32;
  int32_T c8_i33;
  int32_T c8_i34;
  int32_T c8_i35;
  int32_T c8_i36;
  int32_T c8_i37;
  int32_T c8_i38;
  int32_T c8_i39;
  int32_T c8_i40;
  int32_T c8_i41;
  int32_T c8_i;
  real_T c8_b_i;
  int32_T c8_i42;
  real_T c8_dv6[2];
  real_T c8_dv7[2];
  int32_T c8_i43;
  int32_T c8_c_i;
  int32_T c8_i44;
  real_T c8_hoistedGlobal[2];
  int32_T c8_i45;
  real_T c8_b_hoistedGlobal[9];
  int32_T c8_i46;
  real_T c8_c_hoistedGlobal[2];
  int32_T c8_d_i;
  int32_T c8_i47;
  real_T c8_b_R_m[3];
  real_T c8_b[4];
  int32_T c8_e_i;
  int32_T c8_i48;
  real_T c8_a[3];
  int32_T c8_i49;
  real_T c8_b_b[4];
  int32_T c8_i50;
  real_T c8_b_a[3];
  int32_T c8_i51;
  real_T c8_dv8[2];
  real_T c8_zf[3];
  int32_T c8_k;
  real_T c8_b_k;
  int32_T c8_c_k;
  real_T c8_c_a;
  real_T c8_c_b;
  real_T c8_y;
  int32_T c8_f_i;
  int32_T c8_i52;
  int32_T c8_i53;
  int32_T c8_i54;
  int32_T c8_i55;
  real_T c8_d_hoistedGlobal[6];
  real_T c8_A;
  int32_T c8_g_i;
  int32_T c8_i56;
  int32_T c8_jC;
  int32_T c8_b_jC;
  int32_T c8_d_a;
  int32_T c8_j;
  int32_T c8_e_a;
  int32_T c8_jp1;
  int32_T c8_f_a;
  int32_T c8_jA1;
  int32_T c8_jA2;
  real_T c8_s;
  int32_T c8_b_jA1;
  int32_T c8_b_jA2;
  int32_T c8_g_a;
  int32_T c8_d_b;
  int32_T c8_h_a;
  int32_T c8_e_b;
  boolean_T c8_overflow;
  int32_T c8_d_k;
  int32_T c8_e_k;
  int32_T c8_i_a;
  int32_T c8_f_b;
  int32_T c8_c;
  real_T c8_j_a;
  real_T c8_g_b;
  real_T c8_b_y;
  real_T c8_C[2];
  real_T c8_B;
  real_T c8_c_y;
  real_T c8_d_y;
  int32_T c8_i57;
  int32_T c8_i58;
  real_T c8_b_B;
  real_T c8_e_y;
  real_T c8_f_y;
  real_T c8_g_y;
  int32_T c8_i59;
  int32_T c8_i60;
  int32_T c8_i61;
  real_T c8_k_a;
  int32_T c8_i62;
  real_T c8_e_hoistedGlobal[2];
  int32_T c8_h_i;
  int32_T c8_i63;
  real_T c8_c_R_m[3];
  real_T c8_dv9[4];
  int32_T c8_i_i;
  int32_T c8_i64;
  real_T c8_f_hoistedGlobal[2];
  int32_T c8_j_i;
  int32_T c8_i65;
  real_T c8_g_hoistedGlobal[3];
  int32_T c8_i66;
  int32_T c8_i67;
  real_T c8_b_A;
  real_T c8_c_B;
  real_T c8_x;
  real_T c8_h_y;
  real_T c8_b_x;
  real_T c8_i_y;
  real_T c8_j_y;
  int32_T c8_i68;
  int32_T c8_i69;
  int32_T c8_i70;
  int32_T c8_i71;
  int32_T c8_i72;
  real_T (*c8_b_theta_ctrl_hat)[12];
  real_T (*c8_b_mrac_theta_p)[36];
  real_T (*c8_b_Z_m)[3];
  real_T (*c8_d_R_m)[9];
  real_T (*c8_b_k_m_r)[3];
  c8_b_theta_ctrl_hat = (real_T (*)[12])ssGetOutputPortSignal(chartInstance->S,
    1);
  c8_b_mrac_theta_p = (real_T (*)[36])ssGetInputPortSignal(chartInstance->S, 3);
  c8_b_Z_m = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
  c8_d_R_m = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 1);
  c8_b_k_m_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
  for (c8_i17 = 0; c8_i17 < 3; c8_i17++) {
    c8_k_m_r[c8_i17] = (*c8_b_k_m_r)[c8_i17];
  }

  for (c8_i18 = 0; c8_i18 < 9; c8_i18++) {
    c8_R_m[c8_i18] = (*c8_d_R_m)[c8_i18];
  }

  for (c8_i19 = 0; c8_i19 < 3; c8_i19++) {
    c8_Z_m[c8_i19] = (*c8_b_Z_m)[c8_i19];
  }

  for (c8_i20 = 0; c8_i20 < 36; c8_i20++) {
    c8_mrac_theta_p[c8_i20] = (*c8_b_mrac_theta_p)[c8_i20];
  }

  sf_debug_symbol_scope_push_eml(0U, 24U, 24U, c8_debug_family_names,
    c8_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(c8_c_0, 0U, c8_i_sf_marshallOut,
    c8_l_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_theta_1, 1U, c8_i_sf_marshallOut,
    c8_l_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_theta_2, 2U, c8_i_sf_marshallOut,
    c8_l_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_theta_3, 3U, c8_i_sf_marshallOut,
    c8_l_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_k_p_hat, 4U, c8_j_sf_marshallOut,
    c8_k_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_p21, 5U, c8_j_sf_marshallOut,
    c8_k_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_p22, 6U, c8_j_sf_marshallOut,
    c8_k_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_Lambda, 7U, c8_m_sf_marshallOut,
    c8_j_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_R, 8U, c8_l_sf_marshallOut,
    c8_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_theta_1_poly, 9U,
    c8_m_sf_marshallOut, c8_j_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(c8_diophantine_eq, 10U,
    c8_l_sf_marshallOut, c8_i_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_nargin, 11U, c8_k_sf_marshallOut,
    c8_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c8_nargout, 12U, c8_k_sf_marshallOut,
    c8_h_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(c8_k_m_r, 13U, c8_i_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c8_R_m, 14U, c8_j_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c8_Z_m, 15U, c8_i_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(c8_mrac_theta_p, 16U, c8_h_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(c8_theta_ctrl_hat, 17U,
    c8_g_sf_marshallOut, c8_g_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&chartInstance->c8_first, 18U,
    c8_f_sf_marshallOut, c8_f_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c8_Z_p_hat, 19U,
    c8_e_sf_marshallOut, c8_e_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c8_Z_p_bar_hat, 20U,
    c8_d_sf_marshallOut, c8_d_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c8_R_p_hat, 21U,
    c8_c_sf_marshallOut, c8_c_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c8_Lambda_0, 22U,
    c8_b_sf_marshallOut, c8_b_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(chartInstance->c8_Q, 23U,
    c8_sf_marshallOut, c8_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 4);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 9);
  if (CV_EML_IF(0, 1, 0, !chartInstance->c8_first_not_empty)) {
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 11);
    chartInstance->c8_first = 0.0;
    chartInstance->c8_first_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 13);
    for (c8_i21 = 0; c8_i21 < 2; c8_i21++) {
      chartInstance->c8_Lambda_0[c8_i21] = 1.0;
    }

    chartInstance->c8_Lambda_0_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 16);
    for (c8_i22 = 0; c8_i22 < 3; c8_i22++) {
      chartInstance->c8_Z_p_hat[c8_i22] = 1.0;
    }

    chartInstance->c8_Z_p_hat_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 17);
    for (c8_i23 = 0; c8_i23 < 3; c8_i23++) {
      chartInstance->c8_Z_p_bar_hat[c8_i23] = 0.0;
    }

    chartInstance->c8_Z_p_bar_hat_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 18);
    for (c8_i24 = 0; c8_i24 < 9; c8_i24++) {
      chartInstance->c8_R_p_hat[c8_i24] = 0.0;
    }

    chartInstance->c8_R_p_hat_not_empty = TRUE;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 19);
    for (c8_i25 = 0; c8_i25 < 6; c8_i25++) {
      chartInstance->c8_Q[c8_i25] = 0.0;
    }

    chartInstance->c8_Q_not_empty = TRUE;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 24);
  for (c8_i26 = 0; c8_i26 < 3; c8_i26++) {
    c8_c_0[c8_i26] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 25);
  for (c8_i27 = 0; c8_i27 < 3; c8_i27++) {
    c8_theta_1[c8_i27] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 26);
  for (c8_i28 = 0; c8_i28 < 3; c8_i28++) {
    c8_theta_2[c8_i28] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 27);
  for (c8_i29 = 0; c8_i29 < 3; c8_i29++) {
    c8_theta_3[c8_i29] = 0.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 30);
  c8_i30 = 0;
  c8_i31 = 0;
  for (c8_i32 = 0; c8_i32 < 3; c8_i32++) {
    for (c8_i33 = 0; c8_i33 < 3; c8_i33++) {
      c8_k_p_hat[c8_i33 + c8_i30] = c8_mrac_theta_p[(c8_i33 + c8_i31) + 3];
    }

    c8_i30 += 3;
    c8_i31 += 12;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 31);
  c8_i34 = 0;
  c8_i35 = 0;
  for (c8_i36 = 0; c8_i36 < 3; c8_i36++) {
    for (c8_i37 = 0; c8_i37 < 3; c8_i37++) {
      c8_p21[c8_i37 + c8_i34] = c8_mrac_theta_p[(c8_i37 + c8_i35) + 6];
    }

    c8_i34 += 3;
    c8_i35 += 12;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 32);
  c8_i38 = 0;
  c8_i39 = 0;
  for (c8_i40 = 0; c8_i40 < 3; c8_i40++) {
    for (c8_i41 = 0; c8_i41 < 3; c8_i41++) {
      c8_p22[c8_i41 + c8_i38] = c8_mrac_theta_p[(c8_i41 + c8_i39) + 9];
    }

    c8_i38 += 3;
    c8_i39 += 12;
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 34);
  c8_i = 0;
  while (c8_i < 3) {
    c8_b_i = 1.0 + (real_T)c8_i;
    CV_EML_FOR(0, 1, 0, 1);
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 36);
    for (c8_i42 = 0; c8_i42 < 2; c8_i42++) {
      c8_dv6[c8_i42] = chartInstance->c8_Lambda_0[c8_i42];
    }

    c8_conv(chartInstance, c8_dv6, c8_Z_m[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_m",
             (int32_T)_SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1], c8_dv7);
    for (c8_i43 = 0; c8_i43 < 2; c8_i43++) {
      c8_Lambda[c8_i43] = c8_dv7[c8_i43];
    }

    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 39);
    c8_c_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_p_hat", (int32_T)_SFD_INTEGER_CHECK(
      "i", c8_b_i), 1, 3, 1, 0) - 1;
    chartInstance->c8_R_p_hat[c8_c_i] = 1.0;
    chartInstance->c8_R_p_hat[3 + c8_c_i] = c8_p21[(_SFD_EML_ARRAY_BOUNDS_CHECK(
      "p21", (int32_T)_SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) + 3 *
      (_SFD_EML_ARRAY_BOUNDS_CHECK("p21", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 2, 0) - 1)) - 1];
    chartInstance->c8_R_p_hat[6 + c8_c_i] = c8_p22[(_SFD_EML_ARRAY_BOUNDS_CHECK(
      "p22", (int32_T)_SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) + 3 *
      (_SFD_EML_ARRAY_BOUNDS_CHECK("p22", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 2, 0) - 1)) - 1];
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 40);
    chartInstance->c8_Z_p_bar_hat[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_p_bar_hat",
      (int32_T)_SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1] = c8_k_p_hat
      [(_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)_SFD_INTEGER_CHECK("i",
          c8_b_i), 1, 3, 1, 0) + 3 * (_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat",
          (int32_T)_SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 2, 0) - 1)) - 1];
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 41);
    for (c8_i44 = 0; c8_i44 < 2; c8_i44++) {
      c8_hoistedGlobal[c8_i44] = chartInstance->c8_Lambda_0[c8_i44];
    }

    for (c8_i45 = 0; c8_i45 < 9; c8_i45++) {
      c8_b_hoistedGlobal[c8_i45] = chartInstance->c8_R_p_hat[c8_i45];
    }

    for (c8_i46 = 0; c8_i46 < 2; c8_i46++) {
      c8_c_hoistedGlobal[c8_i46] = c8_hoistedGlobal[c8_i46];
    }

    c8_d_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i47 = 0; c8_i47 < 3; c8_i47++) {
      c8_b_R_m[c8_i47] = c8_R_m[c8_d_i + 3 * c8_i47];
    }

    c8_b_conv(chartInstance, c8_c_hoistedGlobal, c8_b_R_m, c8_b);
    c8_e_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_p_hat", (int32_T)_SFD_INTEGER_CHECK(
      "i", c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i48 = 0; c8_i48 < 3; c8_i48++) {
      c8_a[c8_i48] = c8_b_hoistedGlobal[c8_e_i + 3 * c8_i48];
    }

    if (c8_a[0] == 0.0) {
      c8_eml_error(chartInstance);
    }

    c8_b_eml_scalar_eg(chartInstance);
    for (c8_i49 = 0; c8_i49 < 4; c8_i49++) {
      c8_b_b[c8_i49] = c8_b[c8_i49];
    }

    for (c8_i50 = 0; c8_i50 < 3; c8_i50++) {
      c8_b_a[c8_i50] = c8_a[c8_i50];
    }

    for (c8_i51 = 0; c8_i51 < 2; c8_i51++) {
      c8_dv8[c8_i51] = 1.0 - (real_T)c8_i51;
    }

    c8_filter(chartInstance, c8_b_b, c8_b_a, c8_dv8, c8_hoistedGlobal, c8_zf);
    for (c8_k = 0; c8_k < 2; c8_k++) {
      c8_b_k = 1.0 + (real_T)c8_k;
      c8_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        c8_b_k), 1, 4, 1, 0) - 1] = 0.0;
    }

    for (c8_c_k = 0; c8_c_k < 2; c8_c_k++) {
      c8_b_k = 3.0 + (real_T)c8_c_k;
      c8_c_a = c8_a[0];
      c8_c_b = c8_zf[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK
        ("", c8_b_k - 2.0), 1, 3, 1, 0) - 1];
      c8_y = c8_c_a * c8_c_b;
      c8_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        c8_b_k), 1, 4, 1, 0) - 1] = c8_y;
    }

    c8_f_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Q", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i52 = 0; c8_i52 < 2; c8_i52++) {
      chartInstance->c8_Q[c8_f_i + 3 * c8_i52] = c8_hoistedGlobal[c8_i52];
    }

    for (c8_i53 = 0; c8_i53 < 4; c8_i53++) {
      c8_R[c8_i53] = c8_b[c8_i53];
    }

    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 44);
    for (c8_i54 = 0; c8_i54 < 3; c8_i54++) {
      c8_zf[c8_i54] = chartInstance->c8_Z_p_bar_hat[c8_i54];
    }

    for (c8_i55 = 0; c8_i55 < 6; c8_i55++) {
      c8_d_hoistedGlobal[c8_i55] = chartInstance->c8_Q[c8_i55];
    }

    c8_A = c8_zf[_SFD_EML_ARRAY_BOUNDS_CHECK("Z_p_bar_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1];
    c8_g_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Q", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i56 = 0; c8_i56 < 2; c8_i56++) {
      c8_hoistedGlobal[c8_i56] = c8_d_hoistedGlobal[c8_g_i + 3 * c8_i56];
    }

    c8_check_forloop_overflow_error(chartInstance);
    for (c8_jC = 1; c8_jC < 3; c8_jC++) {
      c8_b_jC = c8_jC;
      c8_d_a = c8_b_jC;
      c8_j = c8_d_a;
      c8_e_a = c8_j + 1;
      c8_jp1 = c8_e_a;
      if (2 < c8_jp1) {
        c8_f_a = c8_jp1 - 2;
        c8_jA1 = c8_f_a;
      } else {
        c8_jA1 = 1;
      }

      c8_jA2 = (int32_T)sf_MIN(1, c8_j);
      c8_s = 0.0;
      c8_b_jA1 = c8_jA1;
      c8_b_jA2 = c8_jA2;
      c8_g_a = c8_b_jA1;
      c8_d_b = c8_b_jA2;
      c8_h_a = c8_g_a;
      c8_e_b = c8_d_b;
      if (c8_h_a > c8_e_b) {
        c8_overflow = FALSE;
      } else {
        c8_overflow = (c8_e_b > 2147483646);
      }

      c8_b_check_forloop_overflow_error(chartInstance, c8_overflow);
      for (c8_d_k = c8_b_jA1; c8_d_k <= c8_b_jA2; c8_d_k++) {
        c8_e_k = c8_d_k;
        _SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
          c8_e_k), 1, 1, 1, 0);
        c8_i_a = c8_jp1;
        c8_f_b = c8_e_k;
        c8_c = c8_i_a - c8_f_b;
        c8_j_a = c8_A;
        c8_g_b = c8_hoistedGlobal[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c8_c), 1, 2, 1, 0) - 1];
        c8_b_y = c8_j_a * c8_g_b;
        c8_s += c8_b_y;
      }

      c8_C[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c8_b_jC), 1, 2, 1, 0) - 1] = c8_s;
    }

    c8_B = c8_k_p_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) + 3 *
                       (_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 2, 0) - 1)) - 1];
    c8_c_y = c8_B;
    c8_d_y = c8_c_y;
    for (c8_i57 = 0; c8_i57 < 2; c8_i57++) {
      c8_C[c8_i57] /= c8_d_y;
    }

    for (c8_i58 = 0; c8_i58 < 2; c8_i58++) {
      c8_theta_1_poly[c8_i58] = c8_Lambda[c8_i58] - c8_C[c8_i58];
    }

    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 48);
    c8_b_B = c8_k_p_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 2, 0) - 1)) - 1];
    c8_e_y = c8_b_B;
    c8_f_y = c8_e_y;
    c8_g_y = 1.0 / c8_f_y;
    for (c8_i59 = 0; c8_i59 < 6; c8_i59++) {
      c8_d_hoistedGlobal[c8_i59] = chartInstance->c8_Q[c8_i59];
    }

    for (c8_i60 = 0; c8_i60 < 9; c8_i60++) {
      c8_b_hoistedGlobal[c8_i60] = chartInstance->c8_R_p_hat[c8_i60];
    }

    for (c8_i61 = 0; c8_i61 < 2; c8_i61++) {
      c8_hoistedGlobal[c8_i61] = chartInstance->c8_Lambda_0[c8_i61];
    }

    c8_k_a = c8_g_y;
    for (c8_i62 = 0; c8_i62 < 2; c8_i62++) {
      c8_e_hoistedGlobal[c8_i62] = c8_hoistedGlobal[c8_i62];
    }

    c8_h_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_m", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i63 = 0; c8_i63 < 3; c8_i63++) {
      c8_c_R_m[c8_i63] = c8_R_m[c8_h_i + 3 * c8_i63];
    }

    c8_b_conv(chartInstance, c8_e_hoistedGlobal, c8_c_R_m, c8_dv9);
    c8_i_i = _SFD_EML_ARRAY_BOUNDS_CHECK("Q", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i64 = 0; c8_i64 < 2; c8_i64++) {
      c8_f_hoistedGlobal[c8_i64] = c8_d_hoistedGlobal[c8_i_i + 3 * c8_i64];
    }

    c8_j_i = _SFD_EML_ARRAY_BOUNDS_CHECK("R_p_hat", (int32_T)_SFD_INTEGER_CHECK(
      "i", c8_b_i), 1, 3, 1, 0) - 1;
    for (c8_i65 = 0; c8_i65 < 3; c8_i65++) {
      c8_g_hoistedGlobal[c8_i65] = c8_b_hoistedGlobal[c8_j_i + 3 * c8_i65];
    }

    c8_b_conv(chartInstance, c8_f_hoistedGlobal, c8_g_hoistedGlobal, c8_b);
    for (c8_i66 = 0; c8_i66 < 4; c8_i66++) {
      c8_b[c8_i66] -= c8_dv9[c8_i66];
    }

    for (c8_i67 = 0; c8_i67 < 4; c8_i67++) {
      c8_diophantine_eq[c8_i67] = c8_k_a * c8_b[c8_i67];
    }

    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 51);
    c8_b_A = c8_k_m_r[_SFD_EML_ARRAY_BOUNDS_CHECK("k_m_r", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1];
    c8_c_B = c8_k_p_hat[(_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) + 3 *
                         (_SFD_EML_ARRAY_BOUNDS_CHECK("k_p_hat", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 2, 0) - 1)) - 1];
    c8_x = c8_b_A;
    c8_h_y = c8_c_B;
    c8_b_x = c8_x;
    c8_i_y = c8_h_y;
    c8_j_y = c8_b_x / c8_i_y;
    c8_c_0[_SFD_EML_ARRAY_BOUNDS_CHECK("c_0", (int32_T)_SFD_INTEGER_CHECK("i",
      c8_b_i), 1, 3, 1, 0) - 1] = c8_j_y;
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 52);
    c8_theta_1[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_1", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1] = c8_theta_1_poly[1];
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 53);
    c8_theta_2[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_2", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1] = c8_diophantine_eq[3] -
      c8_diophantine_eq[2];
    _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 54);
    c8_theta_3[_SFD_EML_ARRAY_BOUNDS_CHECK("theta_3", (int32_T)
      _SFD_INTEGER_CHECK("i", c8_b_i), 1, 3, 1, 0) - 1] = c8_diophantine_eq[2];
    c8_i++;
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  CV_EML_FOR(0, 1, 0, 0);
  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, 58);
  for (c8_i68 = 0; c8_i68 < 3; c8_i68++) {
    c8_theta_ctrl_hat[c8_i68] = c8_theta_1[c8_i68];
  }

  for (c8_i69 = 0; c8_i69 < 3; c8_i69++) {
    c8_theta_ctrl_hat[c8_i69 + 3] = c8_theta_2[c8_i69];
  }

  for (c8_i70 = 0; c8_i70 < 3; c8_i70++) {
    c8_theta_ctrl_hat[c8_i70 + 6] = c8_theta_3[c8_i70];
  }

  for (c8_i71 = 0; c8_i71 < 3; c8_i71++) {
    c8_theta_ctrl_hat[c8_i71 + 9] = c8_c_0[c8_i71];
  }

  _SFD_EML_CALL(0U, chartInstance->c8_sfEvent, -58);
  sf_debug_symbol_scope_pop();
  for (c8_i72 = 0; c8_i72 < 12; c8_i72++) {
    (*c8_b_theta_ctrl_hat)[c8_i72] = c8_theta_ctrl_hat[c8_i72];
  }

  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 7U, chartInstance->c8_sfEvent);
}

static void initSimStructsc8_Controller(SFc8_ControllerInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c8_machineNumber, uint32_T
  c8_chartNumber)
{
}

static const mxArray *c8_sf_marshallOut(void *chartInstanceVoid, void *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i73;
  int32_T c8_i74;
  int32_T c8_i75;
  real_T c8_b_inData[6];
  int32_T c8_i76;
  int32_T c8_i77;
  int32_T c8_i78;
  real_T c8_u[6];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i73 = 0;
  for (c8_i74 = 0; c8_i74 < 2; c8_i74++) {
    for (c8_i75 = 0; c8_i75 < 3; c8_i75++) {
      c8_b_inData[c8_i75 + c8_i73] = (*(real_T (*)[6])c8_inData)[c8_i75 + c8_i73];
    }

    c8_i73 += 3;
  }

  c8_i76 = 0;
  for (c8_i77 = 0; c8_i77 < 2; c8_i77++) {
    for (c8_i78 = 0; c8_i78 < 3; c8_i78++) {
      c8_u[c8_i78 + c8_i76] = c8_b_inData[c8_i78 + c8_i76];
    }

    c8_i76 += 3;
  }

  c8_y = NULL;
  if (!chartInstance->c8_Q_not_empty) {
    sf_mex_assign(&c8_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 2), FALSE);
  }

  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Q, const char_T *c8_identifier, real_T c8_y[6])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Q), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_b_Q);
}

static void c8_b_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[6])
{
  real_T c8_dv10[6];
  int32_T c8_i79;
  if (mxIsEmpty(c8_u)) {
    chartInstance->c8_Q_not_empty = FALSE;
  } else {
    chartInstance->c8_Q_not_empty = TRUE;
    sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv10, 1, 0, 0U, 1, 0U, 2, 3,
                  2);
    for (c8_i79 = 0; c8_i79 < 6; c8_i79++) {
      c8_y[c8_i79] = c8_dv10[c8_i79];
    }
  }

  sf_mex_destroy(&c8_u);
}

static void c8_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_Q;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[6];
  int32_T c8_i80;
  int32_T c8_i81;
  int32_T c8_i82;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_Q = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Q), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_b_Q);
  c8_i80 = 0;
  for (c8_i81 = 0; c8_i81 < 2; c8_i81++) {
    for (c8_i82 = 0; c8_i82 < 3; c8_i82++) {
      (*(real_T (*)[6])c8_outData)[c8_i82 + c8_i80] = c8_y[c8_i82 + c8_i80];
    }

    c8_i80 += 3;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_b_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i83;
  real_T c8_b_inData[2];
  int32_T c8_i84;
  real_T c8_u[2];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i83 = 0; c8_i83 < 2; c8_i83++) {
    c8_b_inData[c8_i83] = (*(real_T (*)[2])c8_inData)[c8_i83];
  }

  for (c8_i84 = 0; c8_i84 < 2; c8_i84++) {
    c8_u[c8_i84] = c8_b_inData[c8_i84];
  }

  c8_y = NULL;
  if (!chartInstance->c8_Lambda_0_not_empty) {
    sf_mex_assign(&c8_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  }

  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_c_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Lambda_0, const char_T *c8_identifier, real_T c8_y[2])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Lambda_0), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_Lambda_0);
}

static void c8_d_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[2])
{
  real_T c8_dv11[2];
  int32_T c8_i85;
  if (mxIsEmpty(c8_u)) {
    chartInstance->c8_Lambda_0_not_empty = FALSE;
  } else {
    chartInstance->c8_Lambda_0_not_empty = TRUE;
    sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv11, 1, 0, 0U, 1, 0U, 2, 1,
                  2);
    for (c8_i85 = 0; c8_i85 < 2; c8_i85++) {
      c8_y[c8_i85] = c8_dv11[c8_i85];
    }
  }

  sf_mex_destroy(&c8_u);
}

static void c8_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_Lambda_0;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[2];
  int32_T c8_i86;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_Lambda_0 = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Lambda_0), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_Lambda_0);
  for (c8_i86 = 0; c8_i86 < 2; c8_i86++) {
    (*(real_T (*)[2])c8_outData)[c8_i86] = c8_y[c8_i86];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_c_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i87;
  int32_T c8_i88;
  int32_T c8_i89;
  real_T c8_b_inData[9];
  int32_T c8_i90;
  int32_T c8_i91;
  int32_T c8_i92;
  real_T c8_u[9];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i87 = 0;
  for (c8_i88 = 0; c8_i88 < 3; c8_i88++) {
    for (c8_i89 = 0; c8_i89 < 3; c8_i89++) {
      c8_b_inData[c8_i89 + c8_i87] = (*(real_T (*)[9])c8_inData)[c8_i89 + c8_i87];
    }

    c8_i87 += 3;
  }

  c8_i90 = 0;
  for (c8_i91 = 0; c8_i91 < 3; c8_i91++) {
    for (c8_i92 = 0; c8_i92 < 3; c8_i92++) {
      c8_u[c8_i92 + c8_i90] = c8_b_inData[c8_i92 + c8_i90];
    }

    c8_i90 += 3;
  }

  c8_y = NULL;
  if (!chartInstance->c8_R_p_hat_not_empty) {
    sf_mex_assign(&c8_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  }

  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_e_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_R_p_hat, const char_T *c8_identifier, real_T c8_y[9])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_R_p_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_R_p_hat);
}

static void c8_f_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[9])
{
  real_T c8_dv12[9];
  int32_T c8_i93;
  if (mxIsEmpty(c8_u)) {
    chartInstance->c8_R_p_hat_not_empty = FALSE;
  } else {
    chartInstance->c8_R_p_hat_not_empty = TRUE;
    sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv12, 1, 0, 0U, 1, 0U, 2, 3,
                  3);
    for (c8_i93 = 0; c8_i93 < 9; c8_i93++) {
      c8_y[c8_i93] = c8_dv12[c8_i93];
    }
  }

  sf_mex_destroy(&c8_u);
}

static void c8_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_R_p_hat;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[9];
  int32_T c8_i94;
  int32_T c8_i95;
  int32_T c8_i96;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_R_p_hat = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_R_p_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_R_p_hat);
  c8_i94 = 0;
  for (c8_i95 = 0; c8_i95 < 3; c8_i95++) {
    for (c8_i96 = 0; c8_i96 < 3; c8_i96++) {
      (*(real_T (*)[9])c8_outData)[c8_i96 + c8_i94] = c8_y[c8_i96 + c8_i94];
    }

    c8_i94 += 3;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_d_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i97;
  real_T c8_b_inData[3];
  int32_T c8_i98;
  real_T c8_u[3];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i97 = 0; c8_i97 < 3; c8_i97++) {
    c8_b_inData[c8_i97] = (*(real_T (*)[3])c8_inData)[c8_i97];
  }

  for (c8_i98 = 0; c8_i98 < 3; c8_i98++) {
    c8_u[c8_i98] = c8_b_inData[c8_i98];
  }

  c8_y = NULL;
  if (!chartInstance->c8_Z_p_bar_hat_not_empty) {
    sf_mex_assign(&c8_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  }

  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_g_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Z_p_bar_hat, const char_T *c8_identifier, real_T c8_y[3])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Z_p_bar_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_Z_p_bar_hat);
}

static void c8_h_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3])
{
  real_T c8_dv13[3];
  int32_T c8_i99;
  if (mxIsEmpty(c8_u)) {
    chartInstance->c8_Z_p_bar_hat_not_empty = FALSE;
  } else {
    chartInstance->c8_Z_p_bar_hat_not_empty = TRUE;
    sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv13, 1, 0, 0U, 1, 0U, 1, 3);
    for (c8_i99 = 0; c8_i99 < 3; c8_i99++) {
      c8_y[c8_i99] = c8_dv13[c8_i99];
    }
  }

  sf_mex_destroy(&c8_u);
}

static void c8_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_Z_p_bar_hat;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[3];
  int32_T c8_i100;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_Z_p_bar_hat = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_h_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Z_p_bar_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_Z_p_bar_hat);
  for (c8_i100 = 0; c8_i100 < 3; c8_i100++) {
    (*(real_T (*)[3])c8_outData)[c8_i100] = c8_y[c8_i100];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_e_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i101;
  real_T c8_b_inData[3];
  int32_T c8_i102;
  real_T c8_u[3];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i101 = 0; c8_i101 < 3; c8_i101++) {
    c8_b_inData[c8_i101] = (*(real_T (*)[3])c8_inData)[c8_i101];
  }

  for (c8_i102 = 0; c8_i102 < 3; c8_i102++) {
    c8_u[c8_i102] = c8_b_inData[c8_i102];
  }

  c8_y = NULL;
  if (!chartInstance->c8_Z_p_hat_not_empty) {
    sf_mex_assign(&c8_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  }

  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_i_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_Z_p_hat, const char_T *c8_identifier, real_T c8_y[3])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Z_p_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_Z_p_hat);
}

static void c8_j_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3])
{
  real_T c8_dv14[3];
  int32_T c8_i103;
  if (mxIsEmpty(c8_u)) {
    chartInstance->c8_Z_p_hat_not_empty = FALSE;
  } else {
    chartInstance->c8_Z_p_hat_not_empty = TRUE;
    sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv14, 1, 0, 0U, 1, 0U, 1, 3);
    for (c8_i103 = 0; c8_i103 < 3; c8_i103++) {
      c8_y[c8_i103] = c8_dv14[c8_i103];
    }
  }

  sf_mex_destroy(&c8_u);
}

static void c8_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_Z_p_hat;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[3];
  int32_T c8_i104;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_Z_p_hat = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_j_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_Z_p_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_b_Z_p_hat);
  for (c8_i104 = 0; c8_i104 < 3; c8_i104++) {
    (*(real_T (*)[3])c8_outData)[c8_i104] = c8_y[c8_i104];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_f_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(real_T *)c8_inData;
  c8_y = NULL;
  if (!chartInstance->c8_first_not_empty) {
    sf_mex_assign(&c8_y, sf_mex_create("y", NULL, 0, 0U, 1U, 0U, 2, 0, 0), FALSE);
  } else {
    sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  }

  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static real_T c8_k_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_b_first, const char_T *c8_identifier)
{
  real_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_first), &c8_thisId);
  sf_mex_destroy(&c8_b_first);
  return c8_y;
}

static real_T c8_l_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  real_T c8_y;
  real_T c8_d0;
  if (mxIsEmpty(c8_u)) {
    chartInstance->c8_first_not_empty = FALSE;
  } else {
    chartInstance->c8_first_not_empty = TRUE;
    sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_d0, 1, 0, 0U, 0, 0U, 0);
    c8_y = c8_d0;
  }

  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_first;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_first = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_l_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_first), &c8_thisId);
  sf_mex_destroy(&c8_b_first);
  *(real_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_g_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i105;
  int32_T c8_i106;
  int32_T c8_i107;
  real_T c8_b_inData[12];
  int32_T c8_i108;
  int32_T c8_i109;
  int32_T c8_i110;
  real_T c8_u[12];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i105 = 0;
  for (c8_i106 = 0; c8_i106 < 4; c8_i106++) {
    for (c8_i107 = 0; c8_i107 < 3; c8_i107++) {
      c8_b_inData[c8_i107 + c8_i105] = (*(real_T (*)[12])c8_inData)[c8_i107 +
        c8_i105];
    }

    c8_i105 += 3;
  }

  c8_i108 = 0;
  for (c8_i109 = 0; c8_i109 < 4; c8_i109++) {
    for (c8_i110 = 0; c8_i110 < 3; c8_i110++) {
      c8_u[c8_i110 + c8_i108] = c8_b_inData[c8_i110 + c8_i108];
    }

    c8_i108 += 3;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 4), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_m_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_theta_ctrl_hat, const char_T *c8_identifier, real_T c8_y[12])
{
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_theta_ctrl_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_theta_ctrl_hat);
}

static void c8_n_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[12])
{
  real_T c8_dv15[12];
  int32_T c8_i111;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv15, 1, 0, 0U, 1, 0U, 2, 3, 4);
  for (c8_i111 = 0; c8_i111 < 12; c8_i111++) {
    c8_y[c8_i111] = c8_dv15[c8_i111];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_g_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_theta_ctrl_hat;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[12];
  int32_T c8_i112;
  int32_T c8_i113;
  int32_T c8_i114;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_theta_ctrl_hat = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_n_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_theta_ctrl_hat), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_theta_ctrl_hat);
  c8_i112 = 0;
  for (c8_i113 = 0; c8_i113 < 4; c8_i113++) {
    for (c8_i114 = 0; c8_i114 < 3; c8_i114++) {
      (*(real_T (*)[12])c8_outData)[c8_i114 + c8_i112] = c8_y[c8_i114 + c8_i112];
    }

    c8_i112 += 3;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_h_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i115;
  int32_T c8_i116;
  int32_T c8_i117;
  real_T c8_b_inData[36];
  int32_T c8_i118;
  int32_T c8_i119;
  int32_T c8_i120;
  real_T c8_u[36];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i115 = 0;
  for (c8_i116 = 0; c8_i116 < 3; c8_i116++) {
    for (c8_i117 = 0; c8_i117 < 12; c8_i117++) {
      c8_b_inData[c8_i117 + c8_i115] = (*(real_T (*)[36])c8_inData)[c8_i117 +
        c8_i115];
    }

    c8_i115 += 12;
  }

  c8_i118 = 0;
  for (c8_i119 = 0; c8_i119 < 3; c8_i119++) {
    for (c8_i120 = 0; c8_i120 < 12; c8_i120++) {
      c8_u[c8_i120 + c8_i118] = c8_b_inData[c8_i120 + c8_i118];
    }

    c8_i118 += 12;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 12, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static const mxArray *c8_i_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i121;
  real_T c8_b_inData[3];
  int32_T c8_i122;
  real_T c8_u[3];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i121 = 0; c8_i121 < 3; c8_i121++) {
    c8_b_inData[c8_i121] = (*(real_T (*)[3])c8_inData)[c8_i121];
  }

  for (c8_i122 = 0; c8_i122 < 3; c8_i122++) {
    c8_u[c8_i122] = c8_b_inData[c8_i122];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 1, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static const mxArray *c8_j_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i123;
  int32_T c8_i124;
  int32_T c8_i125;
  real_T c8_b_inData[9];
  int32_T c8_i126;
  int32_T c8_i127;
  int32_T c8_i128;
  real_T c8_u[9];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_i123 = 0;
  for (c8_i124 = 0; c8_i124 < 3; c8_i124++) {
    for (c8_i125 = 0; c8_i125 < 3; c8_i125++) {
      c8_b_inData[c8_i125 + c8_i123] = (*(real_T (*)[9])c8_inData)[c8_i125 +
        c8_i123];
    }

    c8_i123 += 3;
  }

  c8_i126 = 0;
  for (c8_i127 = 0; c8_i127 < 3; c8_i127++) {
    for (c8_i128 = 0; c8_i128 < 3; c8_i128++) {
      c8_u[c8_i128 + c8_i126] = c8_b_inData[c8_i128 + c8_i126];
    }

    c8_i126 += 3;
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 3, 3), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static const mxArray *c8_k_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  real_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(real_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static real_T c8_o_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  real_T c8_y;
  real_T c8_d1;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_d1, 1, 0, 0U, 0, 0U, 0);
  c8_y = c8_d1;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_h_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_nargout;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_nargout = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_o_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_nargout), &c8_thisId);
  sf_mex_destroy(&c8_nargout);
  *(real_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_l_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i129;
  real_T c8_b_inData[4];
  int32_T c8_i130;
  real_T c8_u[4];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i129 = 0; c8_i129 < 4; c8_i129++) {
    c8_b_inData[c8_i129] = (*(real_T (*)[4])c8_inData)[c8_i129];
  }

  for (c8_i130 = 0; c8_i130 < 4; c8_i130++) {
    c8_u[c8_i130] = c8_b_inData[c8_i130];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 1, 4), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_p_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[4])
{
  real_T c8_dv16[4];
  int32_T c8_i131;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv16, 1, 0, 0U, 1, 0U, 2, 1, 4);
  for (c8_i131 = 0; c8_i131 < 4; c8_i131++) {
    c8_y[c8_i131] = c8_dv16[c8_i131];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_i_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_diophantine_eq;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[4];
  int32_T c8_i132;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_diophantine_eq = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_p_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_diophantine_eq), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_diophantine_eq);
  for (c8_i132 = 0; c8_i132 < 4; c8_i132++) {
    (*(real_T (*)[4])c8_outData)[c8_i132] = c8_y[c8_i132];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static const mxArray *c8_m_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_i133;
  real_T c8_b_inData[2];
  int32_T c8_i134;
  real_T c8_u[2];
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  for (c8_i133 = 0; c8_i133 < 2; c8_i133++) {
    c8_b_inData[c8_i133] = (*(real_T (*)[2])c8_inData)[c8_i133];
  }

  for (c8_i134 = 0; c8_i134 < 2; c8_i134++) {
    c8_u[c8_i134] = c8_b_inData[c8_i134];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static void c8_q_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[2])
{
  real_T c8_dv17[2];
  int32_T c8_i135;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv17, 1, 0, 0U, 1, 0U, 2, 1, 2);
  for (c8_i135 = 0; c8_i135 < 2; c8_i135++) {
    c8_y[c8_i135] = c8_dv17[c8_i135];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_j_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_theta_1_poly;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[2];
  int32_T c8_i136;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_theta_1_poly = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_q_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_theta_1_poly), &c8_thisId,
                        c8_y);
  sf_mex_destroy(&c8_theta_1_poly);
  for (c8_i136 = 0; c8_i136 < 2; c8_i136++) {
    (*(real_T (*)[2])c8_outData)[c8_i136] = c8_y[c8_i136];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static void c8_r_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[9])
{
  real_T c8_dv18[9];
  int32_T c8_i137;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv18, 1, 0, 0U, 1, 0U, 2, 3, 3);
  for (c8_i137 = 0; c8_i137 < 9; c8_i137++) {
    c8_y[c8_i137] = c8_dv18[c8_i137];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_k_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_p22;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[9];
  int32_T c8_i138;
  int32_T c8_i139;
  int32_T c8_i140;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_p22 = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_r_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_p22), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_p22);
  c8_i138 = 0;
  for (c8_i139 = 0; c8_i139 < 3; c8_i139++) {
    for (c8_i140 = 0; c8_i140 < 3; c8_i140++) {
      (*(real_T (*)[9])c8_outData)[c8_i140 + c8_i138] = c8_y[c8_i140 + c8_i138];
    }

    c8_i138 += 3;
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

static void c8_s_emlrt_marshallIn(SFc8_ControllerInstanceStruct *chartInstance,
  const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId, real_T c8_y[3])
{
  real_T c8_dv19[3];
  int32_T c8_i141;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), c8_dv19, 1, 0, 0U, 1, 0U, 1, 3);
  for (c8_i141 = 0; c8_i141 < 3; c8_i141++) {
    c8_y[c8_i141] = c8_dv19[c8_i141];
  }

  sf_mex_destroy(&c8_u);
}

static void c8_l_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_theta_3;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  real_T c8_y[3];
  int32_T c8_i142;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_theta_3 = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_s_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_theta_3), &c8_thisId, c8_y);
  sf_mex_destroy(&c8_theta_3);
  for (c8_i142 = 0; c8_i142 < 3; c8_i142++) {
    (*(real_T (*)[3])c8_outData)[c8_i142] = c8_y[c8_i142];
  }

  sf_mex_destroy(&c8_mxArrayInData);
}

const mxArray *sf_c8_Controller_get_eml_resolved_functions_info(void)
{
  const mxArray *c8_nameCaptureInfo;
  c8_ResolvedFunctionInfo c8_info[39];
  const mxArray *c8_m0 = NULL;
  int32_T c8_i143;
  c8_ResolvedFunctionInfo *c8_r0;
  c8_nameCaptureInfo = NULL;
  c8_nameCaptureInfo = NULL;
  c8_info_helper(c8_info);
  sf_mex_assign(&c8_m0, sf_mex_createstruct("nameCaptureInfo", 1, 39), FALSE);
  for (c8_i143 = 0; c8_i143 < 39; c8_i143++) {
    c8_r0 = &c8_info[c8_i143];
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->context)), "context", "nameCaptureInfo",
                    c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c8_r0->name)), "name", "nameCaptureInfo", c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c8_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", c8_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c8_r0->resolved)), "resolved", "nameCaptureInfo",
                    c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c8_i143);
    sf_mex_addfield(c8_m0, sf_mex_create("nameCaptureInfo", &c8_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c8_i143);
  }

  sf_mex_assign(&c8_nameCaptureInfo, c8_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c8_nameCaptureInfo);
  return c8_nameCaptureInfo;
}

static void c8_info_helper(c8_ResolvedFunctionInfo c8_info[39])
{
  c8_info[0].context = "";
  c8_info[0].name = "conv";
  c8_info[0].dominantType = "double";
  c8_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[0].fileTimeLo = 1323170576U;
  c8_info[0].fileTimeHi = 0U;
  c8_info[0].mFileTimeLo = 0U;
  c8_info[0].mFileTimeHi = 0U;
  c8_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[1].name = "eml_index_class";
  c8_info[1].dominantType = "";
  c8_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[1].fileTimeLo = 1323170578U;
  c8_info[1].fileTimeHi = 0U;
  c8_info[1].mFileTimeLo = 0U;
  c8_info[1].mFileTimeHi = 0U;
  c8_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[2].name = "eml_index_plus";
  c8_info[2].dominantType = "coder.internal.indexInt";
  c8_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c8_info[2].fileTimeLo = 1286818778U;
  c8_info[2].fileTimeHi = 0U;
  c8_info[2].mFileTimeLo = 0U;
  c8_info[2].mFileTimeHi = 0U;
  c8_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c8_info[3].name = "eml_index_class";
  c8_info[3].dominantType = "";
  c8_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[3].fileTimeLo = 1323170578U;
  c8_info[3].fileTimeHi = 0U;
  c8_info[3].mFileTimeLo = 0U;
  c8_info[3].mFileTimeHi = 0U;
  c8_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[4].name = "eml_index_minus";
  c8_info[4].dominantType = "coder.internal.indexInt";
  c8_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c8_info[4].fileTimeLo = 1286818778U;
  c8_info[4].fileTimeHi = 0U;
  c8_info[4].mFileTimeLo = 0U;
  c8_info[4].mFileTimeHi = 0U;
  c8_info[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c8_info[5].name = "eml_index_class";
  c8_info[5].dominantType = "";
  c8_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[5].fileTimeLo = 1323170578U;
  c8_info[5].fileTimeHi = 0U;
  c8_info[5].mFileTimeLo = 0U;
  c8_info[5].mFileTimeHi = 0U;
  c8_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[6].name = "eml_scalar_eg";
  c8_info[6].dominantType = "double";
  c8_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[6].fileTimeLo = 1286818796U;
  c8_info[6].fileTimeHi = 0U;
  c8_info[6].mFileTimeLo = 0U;
  c8_info[6].mFileTimeHi = 0U;
  c8_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[7].name = "eml_int_forloop_overflow_check";
  c8_info[7].dominantType = "";
  c8_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c8_info[7].fileTimeLo = 1332168672U;
  c8_info[7].fileTimeHi = 0U;
  c8_info[7].mFileTimeLo = 0U;
  c8_info[7].mFileTimeHi = 0U;
  c8_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c8_info[8].name = "intmax";
  c8_info[8].dominantType = "char";
  c8_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c8_info[8].fileTimeLo = 1311255316U;
  c8_info[8].fileTimeHi = 0U;
  c8_info[8].mFileTimeLo = 0U;
  c8_info[8].mFileTimeHi = 0U;
  c8_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/conv.m";
  c8_info[9].name = "mtimes";
  c8_info[9].dominantType = "double";
  c8_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[9].fileTimeLo = 1289519692U;
  c8_info[9].fileTimeHi = 0U;
  c8_info[9].mFileTimeLo = 0U;
  c8_info[9].mFileTimeHi = 0U;
  c8_info[10].context = "";
  c8_info[10].name = "deconv";
  c8_info[10].dominantType = "double";
  c8_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/deconv.m";
  c8_info[10].fileTimeLo = 1286818686U;
  c8_info[10].fileTimeHi = 0U;
  c8_info[10].mFileTimeLo = 0U;
  c8_info[10].mFileTimeHi = 0U;
  c8_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/deconv.m";
  c8_info[11].name = "eml_error";
  c8_info[11].dominantType = "char";
  c8_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c8_info[11].fileTimeLo = 1305318000U;
  c8_info[11].fileTimeHi = 0U;
  c8_info[11].mFileTimeLo = 0U;
  c8_info[11].mFileTimeHi = 0U;
  c8_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/deconv.m";
  c8_info[12].name = "eml_scalar_eg";
  c8_info[12].dominantType = "double";
  c8_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[12].fileTimeLo = 1286818796U;
  c8_info[12].fileTimeHi = 0U;
  c8_info[12].mFileTimeLo = 0U;
  c8_info[12].mFileTimeHi = 0U;
  c8_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/deconv.m";
  c8_info[13].name = "filter";
  c8_info[13].dominantType = "double";
  c8_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[13].fileTimeLo = 1309451194U;
  c8_info[13].fileTimeHi = 0U;
  c8_info[13].mFileTimeLo = 0U;
  c8_info[13].mFileTimeHi = 0U;
  c8_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[14].name = "eml_index_class";
  c8_info[14].dominantType = "";
  c8_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[14].fileTimeLo = 1323170578U;
  c8_info[14].fileTimeHi = 0U;
  c8_info[14].mFileTimeLo = 0U;
  c8_info[14].mFileTimeHi = 0U;
  c8_info[15].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[15].name = "eml_index_minus";
  c8_info[15].dominantType = "double";
  c8_info[15].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c8_info[15].fileTimeLo = 1286818778U;
  c8_info[15].fileTimeHi = 0U;
  c8_info[15].mFileTimeLo = 0U;
  c8_info[15].mFileTimeHi = 0U;
  c8_info[16].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[16].name = "max";
  c8_info[16].dominantType = "coder.internal.indexInt";
  c8_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c8_info[16].fileTimeLo = 1311255316U;
  c8_info[16].fileTimeHi = 0U;
  c8_info[16].mFileTimeLo = 0U;
  c8_info[16].mFileTimeHi = 0U;
  c8_info[17].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/max.m";
  c8_info[17].name = "eml_min_or_max";
  c8_info[17].dominantType = "char";
  c8_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m";
  c8_info[17].fileTimeLo = 1334071490U;
  c8_info[17].fileTimeHi = 0U;
  c8_info[17].mFileTimeLo = 0U;
  c8_info[17].mFileTimeHi = 0U;
  c8_info[18].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c8_info[18].name = "eml_scalar_eg";
  c8_info[18].dominantType = "coder.internal.indexInt";
  c8_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[18].fileTimeLo = 1286818796U;
  c8_info[18].fileTimeHi = 0U;
  c8_info[18].mFileTimeLo = 0U;
  c8_info[18].mFileTimeHi = 0U;
  c8_info[19].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c8_info[19].name = "eml_scalexp_alloc";
  c8_info[19].dominantType = "coder.internal.indexInt";
  c8_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c8_info[19].fileTimeLo = 1330608434U;
  c8_info[19].fileTimeHi = 0U;
  c8_info[19].mFileTimeLo = 0U;
  c8_info[19].mFileTimeHi = 0U;
  c8_info[20].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_bin_extremum";
  c8_info[20].name = "eml_index_class";
  c8_info[20].dominantType = "";
  c8_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c8_info[20].fileTimeLo = 1323170578U;
  c8_info[20].fileTimeHi = 0U;
  c8_info[20].mFileTimeLo = 0U;
  c8_info[20].mFileTimeHi = 0U;
  c8_info[21].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_min_or_max.m!eml_scalar_bin_extremum";
  c8_info[21].name = "eml_scalar_eg";
  c8_info[21].dominantType = "coder.internal.indexInt";
  c8_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[21].fileTimeLo = 1286818796U;
  c8_info[21].fileTimeHi = 0U;
  c8_info[21].mFileTimeLo = 0U;
  c8_info[21].mFileTimeHi = 0U;
  c8_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[22].name = "eml_const_nonsingleton_dim";
  c8_info[22].dominantType = "double";
  c8_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_const_nonsingleton_dim.m";
  c8_info[22].fileTimeLo = 1286818696U;
  c8_info[22].fileTimeHi = 0U;
  c8_info[22].mFileTimeLo = 0U;
  c8_info[22].mFileTimeHi = 0U;
  c8_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[23].name = "eml_scalar_eg";
  c8_info[23].dominantType = "double";
  c8_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c8_info[23].fileTimeLo = 1286818796U;
  c8_info[23].fileTimeHi = 0U;
  c8_info[23].mFileTimeLo = 0U;
  c8_info[23].mFileTimeHi = 0U;
  c8_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[24].name = "isfinite";
  c8_info[24].dominantType = "double";
  c8_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c8_info[24].fileTimeLo = 1286818758U;
  c8_info[24].fileTimeHi = 0U;
  c8_info[24].mFileTimeLo = 0U;
  c8_info[24].mFileTimeHi = 0U;
  c8_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c8_info[25].name = "isinf";
  c8_info[25].dominantType = "double";
  c8_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isinf.m";
  c8_info[25].fileTimeLo = 1286818760U;
  c8_info[25].fileTimeHi = 0U;
  c8_info[25].mFileTimeLo = 0U;
  c8_info[25].mFileTimeHi = 0U;
  c8_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isfinite.m";
  c8_info[26].name = "isnan";
  c8_info[26].dominantType = "double";
  c8_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/isnan.m";
  c8_info[26].fileTimeLo = 1286818760U;
  c8_info[26].fileTimeHi = 0U;
  c8_info[26].mFileTimeLo = 0U;
  c8_info[26].mFileTimeHi = 0U;
  c8_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[27].name = "eml_error";
  c8_info[27].dominantType = "char";
  c8_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c8_info[27].fileTimeLo = 1305318000U;
  c8_info[27].fileTimeHi = 0U;
  c8_info[27].mFileTimeLo = 0U;
  c8_info[27].mFileTimeHi = 0U;
  c8_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[28].name = "eml_int_forloop_overflow_check";
  c8_info[28].dominantType = "";
  c8_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c8_info[28].fileTimeLo = 1332168672U;
  c8_info[28].fileTimeHi = 0U;
  c8_info[28].mFileTimeLo = 0U;
  c8_info[28].mFileTimeHi = 0U;
  c8_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[29].name = "rdivide";
  c8_info[29].dominantType = "double";
  c8_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[29].fileTimeLo = 1286818844U;
  c8_info[29].fileTimeHi = 0U;
  c8_info[29].mFileTimeLo = 0U;
  c8_info[29].mFileTimeHi = 0U;
  c8_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[30].name = "eml_div";
  c8_info[30].dominantType = "double";
  c8_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c8_info[30].fileTimeLo = 1313347810U;
  c8_info[30].fileTimeHi = 0U;
  c8_info[30].mFileTimeLo = 0U;
  c8_info[30].mFileTimeHi = 0U;
  c8_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[31].name = "eml_prodsize_except_dim";
  c8_info[31].dominantType = "double";
  c8_info[31].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_prodsize_except_dim.m";
  c8_info[31].fileTimeLo = 1318941982U;
  c8_info[31].fileTimeHi = 0U;
  c8_info[31].mFileTimeLo = 0U;
  c8_info[31].mFileTimeHi = 0U;
  c8_info[32].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[32].name = "eml_index_plus";
  c8_info[32].dominantType = "coder.internal.indexInt";
  c8_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c8_info[32].fileTimeLo = 1286818778U;
  c8_info[32].fileTimeHi = 0U;
  c8_info[32].mFileTimeLo = 0U;
  c8_info[32].mFileTimeHi = 0U;
  c8_info[33].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[33].name = "eml_index_plus";
  c8_info[33].dominantType = "double";
  c8_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c8_info[33].fileTimeLo = 1286818778U;
  c8_info[33].fileTimeHi = 0U;
  c8_info[33].mFileTimeLo = 0U;
  c8_info[33].mFileTimeHi = 0U;
  c8_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/filter.m";
  c8_info[34].name = "mtimes";
  c8_info[34].dominantType = "double";
  c8_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[34].fileTimeLo = 1289519692U;
  c8_info[34].fileTimeHi = 0U;
  c8_info[34].mFileTimeLo = 0U;
  c8_info[34].mFileTimeHi = 0U;
  c8_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/datafun/deconv.m";
  c8_info[35].name = "mtimes";
  c8_info[35].dominantType = "double";
  c8_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[35].fileTimeLo = 1289519692U;
  c8_info[35].fileTimeHi = 0U;
  c8_info[35].mFileTimeLo = 0U;
  c8_info[35].mFileTimeHi = 0U;
  c8_info[36].context = "";
  c8_info[36].name = "mrdivide";
  c8_info[36].dominantType = "double";
  c8_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[36].fileTimeLo = 1342810944U;
  c8_info[36].fileTimeHi = 0U;
  c8_info[36].mFileTimeLo = 1319729966U;
  c8_info[36].mFileTimeHi = 0U;
  c8_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c8_info[37].name = "rdivide";
  c8_info[37].dominantType = "double";
  c8_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c8_info[37].fileTimeLo = 1286818844U;
  c8_info[37].fileTimeHi = 0U;
  c8_info[37].mFileTimeLo = 0U;
  c8_info[37].mFileTimeHi = 0U;
  c8_info[38].context = "";
  c8_info[38].name = "mtimes";
  c8_info[38].dominantType = "double";
  c8_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c8_info[38].fileTimeLo = 1289519692U;
  c8_info[38].fileTimeHi = 0U;
  c8_info[38].mFileTimeLo = 0U;
  c8_info[38].mFileTimeHi = 0U;
}

static void c8_conv(SFc8_ControllerInstanceStruct *chartInstance, real_T c8_A[2],
                    real_T c8_B, real_T c8_C[2])
{
  int32_T c8_jC;
  int32_T c8_b_jC;
  int32_T c8_a;
  int32_T c8_j;
  int32_T c8_b_a;
  int32_T c8_jp1;
  int32_T c8_c_a;
  int32_T c8_jA1;
  int32_T c8_jA2;
  real_T c8_s;
  int32_T c8_b_jA1;
  int32_T c8_b_jA2;
  int32_T c8_d_a;
  int32_T c8_b;
  int32_T c8_e_a;
  int32_T c8_b_b;
  boolean_T c8_overflow;
  int32_T c8_k;
  int32_T c8_b_k;
  int32_T c8_f_a;
  int32_T c8_c_b;
  int32_T c8_c;
  real_T c8_g_a;
  real_T c8_d_b;
  real_T c8_y;
  c8_eml_scalar_eg(chartInstance);
  c8_check_forloop_overflow_error(chartInstance);
  for (c8_jC = 1; c8_jC < 3; c8_jC++) {
    c8_b_jC = c8_jC;
    c8_a = c8_b_jC;
    c8_j = c8_a;
    c8_b_a = c8_j + 1;
    c8_jp1 = c8_b_a;
    if (1 < c8_jp1) {
      c8_c_a = c8_jp1;
      c8_jA1 = c8_c_a;
    } else {
      c8_jA1 = 2;
    }

    c8_jA2 = (int32_T)sf_MIN(2, c8_j);
    c8_s = 0.0;
    c8_b_jA1 = c8_jA1 - 1;
    c8_b_jA2 = c8_jA2;
    c8_d_a = c8_b_jA1;
    c8_b = c8_b_jA2;
    c8_e_a = c8_d_a;
    c8_b_b = c8_b;
    if (c8_e_a > c8_b_b) {
      c8_overflow = FALSE;
    } else {
      c8_overflow = (c8_b_b > 2147483646);
    }

    c8_b_check_forloop_overflow_error(chartInstance, c8_overflow);
    for (c8_k = c8_b_jA1; c8_k <= c8_b_jA2; c8_k++) {
      c8_b_k = c8_k;
      c8_f_a = c8_jp1;
      c8_c_b = c8_b_k;
      c8_c = c8_f_a - c8_c_b;
      _SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
        c8_c), 1, 1, 1, 0);
      c8_g_a = c8_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_k), 1, 2, 1, 0) - 1];
      c8_d_b = c8_B;
      c8_y = c8_g_a * c8_d_b;
      c8_s += c8_y;
    }

    c8_C[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
      c8_b_jC), 1, 2, 1, 0) - 1] = c8_s;
  }
}

static void c8_eml_scalar_eg(SFc8_ControllerInstanceStruct *chartInstance)
{
}

static void c8_check_forloop_overflow_error(SFc8_ControllerInstanceStruct
  *chartInstance)
{
}

static void c8_b_check_forloop_overflow_error(SFc8_ControllerInstanceStruct
  *chartInstance, boolean_T c8_overflow)
{
  int32_T c8_i144;
  static char_T c8_cv0[34] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o', 'o', 'l',
    'b', 'o', 'x', ':', 'i', 'n', 't', '_', 'f', 'o', 'r', 'l', 'o', 'o', 'p',
    '_', 'o', 'v', 'e', 'r', 'f', 'l', 'o', 'w' };

  char_T c8_u[34];
  const mxArray *c8_y = NULL;
  int32_T c8_i145;
  static char_T c8_cv1[23] = { 'c', 'o', 'd', 'e', 'r', '.', 'i', 'n', 't', 'e',
    'r', 'n', 'a', 'l', '.', 'i', 'n', 'd', 'e', 'x', 'I', 'n', 't' };

  char_T c8_b_u[23];
  const mxArray *c8_b_y = NULL;
  if (!c8_overflow) {
  } else {
    for (c8_i144 = 0; c8_i144 < 34; c8_i144++) {
      c8_u[c8_i144] = c8_cv0[c8_i144];
    }

    c8_y = NULL;
    sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 10, 0U, 1U, 0U, 2, 1, 34),
                  FALSE);
    for (c8_i145 = 0; c8_i145 < 23; c8_i145++) {
      c8_b_u[c8_i145] = c8_cv1[c8_i145];
    }

    c8_b_y = NULL;
    sf_mex_assign(&c8_b_y, sf_mex_create("y", c8_b_u, 10, 0U, 1U, 0U, 2, 1, 23),
                  FALSE);
    sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 2U,
      14, c8_y, 14, c8_b_y));
  }
}

static void c8_b_conv(SFc8_ControllerInstanceStruct *chartInstance, real_T c8_A
                      [2], real_T c8_B[3], real_T c8_C[4])
{
  int32_T c8_jC;
  int32_T c8_b_jC;
  int32_T c8_a;
  int32_T c8_j;
  int32_T c8_b_a;
  int32_T c8_jp1;
  int32_T c8_c_a;
  int32_T c8_jA1;
  int32_T c8_jA2;
  real_T c8_s;
  int32_T c8_b_jA1;
  int32_T c8_b_jA2;
  int32_T c8_d_a;
  int32_T c8_b;
  int32_T c8_e_a;
  int32_T c8_b_b;
  boolean_T c8_overflow;
  int32_T c8_k;
  int32_T c8_b_k;
  int32_T c8_f_a;
  int32_T c8_c_b;
  int32_T c8_c;
  real_T c8_g_a;
  real_T c8_d_b;
  real_T c8_y;
  c8_b_check_forloop_overflow_error(chartInstance, FALSE);
  for (c8_jC = 1; c8_jC < 5; c8_jC++) {
    c8_b_jC = c8_jC;
    c8_a = c8_b_jC;
    c8_j = c8_a;
    c8_b_a = c8_j + 1;
    c8_jp1 = c8_b_a;
    if (3 < c8_jp1) {
      c8_c_a = c8_jp1 - 3;
      c8_jA1 = c8_c_a;
    } else {
      c8_jA1 = 1;
    }

    c8_jA2 = (int32_T)sf_MIN(2, c8_j);
    c8_s = 0.0;
    c8_b_jA1 = c8_jA1;
    c8_b_jA2 = c8_jA2;
    c8_d_a = c8_b_jA1;
    c8_b = c8_b_jA2;
    c8_e_a = c8_d_a;
    c8_b_b = c8_b;
    if (c8_e_a > c8_b_b) {
      c8_overflow = FALSE;
    } else {
      c8_overflow = (c8_b_b > 2147483646);
    }

    c8_b_check_forloop_overflow_error(chartInstance, c8_overflow);
    for (c8_k = c8_b_jA1; c8_k <= c8_b_jA2; c8_k++) {
      c8_b_k = c8_k;
      c8_f_a = c8_jp1;
      c8_c_b = c8_b_k;
      c8_c = c8_f_a - c8_c_b;
      c8_g_a = c8_A[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_k), 1, 2, 1, 0) - 1];
      c8_d_b = c8_B[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_c), 1, 3, 1, 0) - 1];
      c8_y = c8_g_a * c8_d_b;
      c8_s += c8_y;
    }

    c8_C[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
      c8_b_jC), 1, 4, 1, 0) - 1] = c8_s;
  }
}

static void c8_eml_error(SFc8_ControllerInstanceStruct *chartInstance)
{
  int32_T c8_i146;
  static char_T c8_varargin_1[23] = { 'M', 'A', 'T', 'L', 'A', 'B', ':', 'd',
    'e', 'c', 'o', 'n', 'v', ':', 'Z', 'e', 'r', 'o', 'C', 'o', 'e', 'f', '1' };

  char_T c8_u[23];
  const mxArray *c8_y = NULL;
  for (c8_i146 = 0; c8_i146 < 23; c8_i146++) {
    c8_u[c8_i146] = c8_varargin_1[c8_i146];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 10, 0U, 1U, 0U, 2, 1, 23), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c8_y));
}

static void c8_b_eml_scalar_eg(SFc8_ControllerInstanceStruct *chartInstance)
{
}

static void c8_filter(SFc8_ControllerInstanceStruct *chartInstance, real_T c8_b
                      [4], real_T c8_a[3], real_T c8_x[2], real_T c8_y[2],
                      real_T c8_zf[3])
{
  real_T c8_a1;
  real_T c8_b_x;
  real_T c8_c_x;
  boolean_T c8_b_b;
  boolean_T c8_b0;
  real_T c8_d_x;
  boolean_T c8_c_b;
  boolean_T c8_b1;
  boolean_T c8_d_b;
  int32_T c8_k;
  int32_T c8_b_k;
  real_T c8_e_x;
  real_T c8_b_y;
  real_T c8_f_x;
  real_T c8_c_y;
  real_T c8_z;
  int32_T c8_c_k;
  real_T c8_g_x;
  real_T c8_d_y;
  real_T c8_h_x;
  real_T c8_e_y;
  real_T c8_b_z;
  int32_T c8_d_k;
  int32_T c8_b_a;
  int32_T c8_c;
  real_T c8_dbuffer[4];
  int32_T c8_j;
  int32_T c8_b_j;
  int32_T c8_c_a;
  int32_T c8_jp;
  int32_T c8_e_k;
  int32_T c8_d_a;
  int32_T c8_b_c;
  int32_T c8_f_k;
  real_T c8_e_a;
  real_T c8_e_b;
  real_T c8_f_y;
  int32_T c8_g_k;
  real_T c8_f_a;
  real_T c8_f_b;
  real_T c8_g_y;
  int32_T c8_h_k;
  int32_T c8_g_a;
  int32_T c8_c_c;
  c8_b_eml_scalar_eg(chartInstance);
  c8_a1 = c8_a[0];
  c8_b_x = c8_a1;
  c8_c_x = c8_b_x;
  c8_b_b = muDoubleScalarIsInf(c8_c_x);
  c8_b0 = !c8_b_b;
  c8_d_x = c8_b_x;
  c8_c_b = muDoubleScalarIsNaN(c8_d_x);
  c8_b1 = !c8_c_b;
  c8_d_b = (c8_b0 && c8_b1);
  if (!c8_d_b) {
    c8_b_eml_error(chartInstance);
  } else if (c8_a1 == 0.0) {
    c8_c_eml_error(chartInstance);
  } else {
    if (c8_a1 != 1.0) {
      c8_b_check_forloop_overflow_error(chartInstance, FALSE);
      for (c8_k = 1; c8_k < 5; c8_k++) {
        c8_b_k = c8_k;
        c8_e_x = c8_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c8_b_k), 1, 4, 1, 0) - 1];
        c8_b_y = c8_a1;
        c8_f_x = c8_e_x;
        c8_c_y = c8_b_y;
        c8_z = c8_f_x / c8_c_y;
        c8_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c8_b_k), 1, 4, 1, 0) - 1] = c8_z;
      }

      c8_b_check_forloop_overflow_error(chartInstance, FALSE);
      for (c8_c_k = 2; c8_c_k < 4; c8_c_k++) {
        c8_b_k = c8_c_k;
        c8_g_x = c8_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
          _SFD_INTEGER_CHECK("", (real_T)c8_b_k), 1, 3, 1, 0) - 1];
        c8_d_y = c8_a1;
        c8_h_x = c8_g_x;
        c8_e_y = c8_d_y;
        c8_b_z = c8_h_x / c8_e_y;
        c8_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
          (real_T)c8_b_k), 1, 3, 1, 0) - 1] = c8_b_z;
      }

      c8_a[0] = 1.0;
    }
  }

  c8_eml_scalar_eg(chartInstance);
  c8_b_check_forloop_overflow_error(chartInstance, FALSE);
  for (c8_d_k = 1; c8_d_k < 4; c8_d_k++) {
    c8_b_k = c8_d_k;
    c8_b_a = c8_b_k + 1;
    c8_c = c8_b_a;
    c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c8_c), 1, 4, 1, 0) - 1] = 0.0;
  }

  c8_check_forloop_overflow_error(chartInstance);
  for (c8_j = 1; c8_j < 3; c8_j++) {
    c8_b_j = c8_j;
    c8_c_a = c8_b_j;
    c8_jp = c8_c_a;
    c8_b_check_forloop_overflow_error(chartInstance, FALSE);
    for (c8_e_k = 1; c8_e_k < 4; c8_e_k++) {
      c8_b_k = c8_e_k;
      c8_d_a = c8_b_k + 1;
      c8_b_c = c8_d_a;
      c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c8_b_k), 1, 4, 1, 0) - 1] =
        c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_c), 1, 4, 1, 0) - 1];
    }

    c8_dbuffer[3] = 0.0;
    _SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
      c8_jp), 1, 2, 1, 0);
    c8_b_check_forloop_overflow_error(chartInstance, FALSE);
    for (c8_f_k = 1; c8_f_k < 5; c8_f_k++) {
      c8_b_k = c8_f_k;
      c8_e_a = c8_x[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_jp), 1, 2, 1, 0) - 1];
      c8_e_b = c8_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_k), 1, 4, 1, 0) - 1];
      c8_f_y = c8_e_a * c8_e_b;
      c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c8_b_k), 1, 4, 1, 0) - 1] =
        c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_k), 1, 4, 1, 0) - 1] + c8_f_y;
    }

    c8_b_check_forloop_overflow_error(chartInstance, FALSE);
    for (c8_g_k = 2; c8_g_k < 4; c8_g_k++) {
      c8_b_k = c8_g_k;
      c8_f_a = c8_dbuffer[0];
      c8_f_b = c8_a[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_k), 1, 3, 1, 0) - 1];
      c8_g_y = c8_f_a * c8_f_b;
      c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
        (real_T)c8_b_k), 1, 4, 1, 0) - 1] =
        c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
        "", (real_T)c8_b_k), 1, 4, 1, 0) - 1] - c8_g_y;
    }

    c8_y[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)
      c8_jp), 1, 2, 1, 0) - 1] = c8_dbuffer[0];
  }

  c8_b_check_forloop_overflow_error(chartInstance, FALSE);
  for (c8_h_k = 1; c8_h_k < 4; c8_h_k++) {
    c8_b_k = c8_h_k;
    c8_g_a = c8_b_k + 1;
    c8_c_c = c8_g_a;
    c8_zf[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK("",
      (real_T)c8_b_k), 1, 3, 1, 0) - 1] = c8_dbuffer[_SFD_EML_ARRAY_BOUNDS_CHECK
      ("", (int32_T)_SFD_INTEGER_CHECK("", (real_T)c8_c_c), 1, 4, 1, 0) - 1];
  }
}

static void c8_b_eml_error(SFc8_ControllerInstanceStruct *chartInstance)
{
  int32_T c8_i147;
  static char_T c8_varargin_1[60] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 'f', 'i', 'l', 't', 'e', 'r', '_', 'f', 'i', 'r',
    's', 't', 'E', 'l', 'e', 'm', 'e', 'n', 't', 'O', 'f', 'D', 'e', 'n', 'o',
    'm', 'i', 'n', 'a', 't', 'o', 'r', 'F', 'i', 'l', 't', 'e', 'r', 'N', 'o',
    't', 'F', 'i', 'n', 'i', 't', 'e' };

  char_T c8_u[60];
  const mxArray *c8_y = NULL;
  for (c8_i147 = 0; c8_i147 < 60; c8_i147++) {
    c8_u[c8_i147] = c8_varargin_1[c8_i147];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 10, 0U, 1U, 0U, 2, 1, 60), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c8_y));
}

static void c8_c_eml_error(SFc8_ControllerInstanceStruct *chartInstance)
{
  int32_T c8_i148;
  static char_T c8_varargin_1[55] = { 'C', 'o', 'd', 'e', 'r', ':', 'M', 'A',
    'T', 'L', 'A', 'B', ':', 'f', 'i', 'l', 't', 'e', 'r', '_', 'f', 'i', 'r',
    's', 't', 'E', 'l', 'e', 'm', 'e', 'n', 't', 'O', 'f', 'D', 'e', 'n', 'o',
    'm', 'i', 'n', 'a', 't', 'o', 'r', 'F', 'i', 'l', 't', 'e', 'r', 'Z', 'e',
    'r', 'o' };

  char_T c8_u[55];
  const mxArray *c8_y = NULL;
  for (c8_i148 = 0; c8_i148 < 55; c8_i148++) {
    c8_u[c8_i148] = c8_varargin_1[c8_i148];
  }

  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", c8_u, 10, 0U, 1U, 0U, 2, 1, 55), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c8_y));
}

static const mxArray *c8_n_sf_marshallOut(void *chartInstanceVoid, void
  *c8_inData)
{
  const mxArray *c8_mxArrayOutData = NULL;
  int32_T c8_u;
  const mxArray *c8_y = NULL;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_mxArrayOutData = NULL;
  c8_u = *(int32_T *)c8_inData;
  c8_y = NULL;
  sf_mex_assign(&c8_y, sf_mex_create("y", &c8_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c8_mxArrayOutData, c8_y, FALSE);
  return c8_mxArrayOutData;
}

static int32_T c8_t_emlrt_marshallIn(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  int32_T c8_y;
  int32_T c8_i149;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_i149, 1, 6, 0U, 0, 0U, 0);
  c8_y = c8_i149;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void c8_m_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c8_mxArrayInData, const char_T *c8_varName, void *c8_outData)
{
  const mxArray *c8_b_sfEvent;
  const char_T *c8_identifier;
  emlrtMsgIdentifier c8_thisId;
  int32_T c8_y;
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)chartInstanceVoid;
  c8_b_sfEvent = sf_mex_dup(c8_mxArrayInData);
  c8_identifier = c8_varName;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_t_emlrt_marshallIn(chartInstance, sf_mex_dup(c8_b_sfEvent),
    &c8_thisId);
  sf_mex_destroy(&c8_b_sfEvent);
  *(int32_T *)c8_outData = c8_y;
  sf_mex_destroy(&c8_mxArrayInData);
}

static uint8_T c8_u_emlrt_marshallIn(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_b_is_active_c8_Controller, const char_T
  *c8_identifier)
{
  uint8_T c8_y;
  emlrtMsgIdentifier c8_thisId;
  c8_thisId.fIdentifier = c8_identifier;
  c8_thisId.fParent = NULL;
  c8_y = c8_v_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c8_b_is_active_c8_Controller), &c8_thisId);
  sf_mex_destroy(&c8_b_is_active_c8_Controller);
  return c8_y;
}

static uint8_T c8_v_emlrt_marshallIn(SFc8_ControllerInstanceStruct
  *chartInstance, const mxArray *c8_u, const emlrtMsgIdentifier *c8_parentId)
{
  uint8_T c8_y;
  uint8_T c8_u0;
  sf_mex_import(c8_parentId, sf_mex_dup(c8_u), &c8_u0, 1, 3, 0U, 0, 0U, 0);
  c8_y = c8_u0;
  sf_mex_destroy(&c8_u);
  return c8_y;
}

static void init_dsm_address_info(SFc8_ControllerInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c8_Controller_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(220058635U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3944124932U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1179419574U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2567955860U);
}

mxArray *sf_c8_Controller_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("noi9AecG9NOJrAZoks2VmG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(3);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(12);
      pr[1] = (double)(3);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(4);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c8_Controller(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[5],T\"theta_ctrl_hat\",},{M[4],M[0],T\"Lambda_0\",S'l','i','p'{{M1x2[131 139],M[0],}}},{M[4],M[0],T\"Q\",S'l','i','p'{{M1x2[140 141],M[0],}}},{M[4],M[0],T\"R_p_hat\",S'l','i','p'{{M1x2[123 130],M[0],}}},{M[4],M[0],T\"Z_p_bar_hat\",S'l','i','p'{{M1x2[111 122],M[0],}}},{M[4],M[0],T\"Z_p_hat\",S'l','i','p'{{M1x2[103 110],M[0],}}},{M[4],M[0],T\"first\",S'l','i','p'{{M1x2[97 102],M[0],}}},{M[8],M[0],T\"is_active_c8_Controller\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c8_Controller_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc8_ControllerInstanceStruct *chartInstance;
    chartInstance = (SFc8_ControllerInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_ControllerMachineNumber_,
           8,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_ControllerMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_ControllerMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_ControllerMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"k_m_r");
          _SFD_SET_DATA_PROPS(1,1,1,0,"R_m");
          _SFD_SET_DATA_PROPS(2,1,1,0,"Z_m");
          _SFD_SET_DATA_PROPS(3,1,1,0,"mrac_theta_p");
          _SFD_SET_DATA_PROPS(4,2,0,1,"theta_ctrl_hat");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1715);
        _SFD_CV_INIT_EML_IF(0,1,0,248,265,-1,536);
        _SFD_CV_INIT_EML_FOR(0,1,0,824,834,1666);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_i_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_j_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[1];
          dimVector[0]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_i_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 12;
          dimVector[1]= 3;
          _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_h_sf_marshallOut,(MexInFcnForType)NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 3;
          dimVector[1]= 4;
          _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c8_g_sf_marshallOut,(MexInFcnForType)
            c8_g_sf_marshallIn);
        }

        {
          real_T (*c8_k_m_r)[3];
          real_T (*c8_R_m)[9];
          real_T (*c8_Z_m)[3];
          real_T (*c8_mrac_theta_p)[36];
          real_T (*c8_theta_ctrl_hat)[12];
          c8_theta_ctrl_hat = (real_T (*)[12])ssGetOutputPortSignal
            (chartInstance->S, 1);
          c8_mrac_theta_p = (real_T (*)[36])ssGetInputPortSignal
            (chartInstance->S, 3);
          c8_Z_m = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 2);
          c8_R_m = (real_T (*)[9])ssGetInputPortSignal(chartInstance->S, 1);
          c8_k_m_r = (real_T (*)[3])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c8_k_m_r);
          _SFD_SET_DATA_VALUE_PTR(1U, *c8_R_m);
          _SFD_SET_DATA_VALUE_PTR(2U, *c8_Z_m);
          _SFD_SET_DATA_VALUE_PTR(3U, *c8_mrac_theta_p);
          _SFD_SET_DATA_VALUE_PTR(4U, *c8_theta_ctrl_hat);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_ControllerMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "zsDc8R2b438zQrqT0DLiID";
}

static void sf_opaque_initialize_c8_Controller(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc8_ControllerInstanceStruct*) chartInstanceVar
    )->S,0);
  initialize_params_c8_Controller((SFc8_ControllerInstanceStruct*)
    chartInstanceVar);
  initialize_c8_Controller((SFc8_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c8_Controller(void *chartInstanceVar)
{
  enable_c8_Controller((SFc8_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c8_Controller(void *chartInstanceVar)
{
  disable_c8_Controller((SFc8_ControllerInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c8_Controller(void *chartInstanceVar)
{
  sf_c8_Controller((SFc8_ControllerInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c8_Controller(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c8_Controller
    ((SFc8_ControllerInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c8_Controller(SimStruct* S, const mxArray *
  st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c8_Controller();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c8_Controller((SFc8_ControllerInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c8_Controller(SimStruct* S)
{
  return sf_internal_get_sim_state_c8_Controller(S);
}

static void sf_opaque_set_sim_state_c8_Controller(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c8_Controller(S, st);
}

static void sf_opaque_terminate_c8_Controller(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc8_ControllerInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c8_Controller((SFc8_ControllerInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Controller_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc8_Controller((SFc8_ControllerInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c8_Controller(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c8_Controller((SFc8_ControllerInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c8_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Controller_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      8);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,8,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,8,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,8,4);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,8,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,8);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(4271306768U));
  ssSetChecksum1(S,(2576690319U));
  ssSetChecksum2(S,(762990927U));
  ssSetChecksum3(S,(4090024368U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c8_Controller(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c8_Controller(SimStruct *S)
{
  SFc8_ControllerInstanceStruct *chartInstance;
  chartInstance = (SFc8_ControllerInstanceStruct *)malloc(sizeof
    (SFc8_ControllerInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc8_ControllerInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c8_Controller;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c8_Controller;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c8_Controller;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c8_Controller;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c8_Controller;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c8_Controller;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c8_Controller;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c8_Controller;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c8_Controller;
  chartInstance->chartInfo.mdlStart = mdlStart_c8_Controller;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c8_Controller;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c8_Controller_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c8_Controller(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c8_Controller(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c8_Controller(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c8_Controller_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
