#ifndef __c8_Controller_h__
#define __c8_Controller_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"
#include "rtwtypes.h"

/* Type Definitions */
#ifndef typedef_c8_ResolvedFunctionInfo
#define typedef_c8_ResolvedFunctionInfo

typedef struct {
  const char * context;
  const char * name;
  const char * dominantType;
  const char * resolved;
  uint32_T fileTimeLo;
  uint32_T fileTimeHi;
  uint32_T mFileTimeLo;
  uint32_T mFileTimeHi;
} c8_ResolvedFunctionInfo;

#endif                                 /*typedef_c8_ResolvedFunctionInfo*/

#ifndef typedef_SFc8_ControllerInstanceStruct
#define typedef_SFc8_ControllerInstanceStruct

typedef struct {
  SimStruct *S;
  ChartInfoStruct chartInfo;
  uint32_T chartNumber;
  uint32_T instanceNumber;
  int32_T c8_sfEvent;
  boolean_T c8_isStable;
  boolean_T c8_doneDoubleBufferReInit;
  uint8_T c8_is_active_c8_Controller;
  real_T c8_first;
  boolean_T c8_first_not_empty;
  real_T c8_Z_p_hat[3];
  boolean_T c8_Z_p_hat_not_empty;
  real_T c8_Z_p_bar_hat[3];
  boolean_T c8_Z_p_bar_hat_not_empty;
  real_T c8_R_p_hat[9];
  boolean_T c8_R_p_hat_not_empty;
  real_T c8_Lambda_0[2];
  boolean_T c8_Lambda_0_not_empty;
  real_T c8_Q[6];
  boolean_T c8_Q_not_empty;
} SFc8_ControllerInstanceStruct;

#endif                                 /*typedef_SFc8_ControllerInstanceStruct*/

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
extern const mxArray *sf_c8_Controller_get_eml_resolved_functions_info(void);

/* Function Definitions */
extern void sf_c8_Controller_get_check_sum(mxArray *plhs[]);
extern void c8_Controller_method_dispatcher(SimStruct *S, int_T method, void
  *data);

#endif
